# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# Updates the model from a lifeline making sure that 
# all model elements exists and are bound.
# If the lifeline has a name, but no matching attribute, an attribute
# is created in the same scope as the owner of the interaction. The name
# of the attribute is identical to the name of the lifeline.
# If the lifeline has a type, but it is not bound, a new class is
# created using the name of the type.
# All messagelines with the lifeline as source or destination, are updated
# All timer symbols and states attached to the lifeline are updated.
#
# Known limitations: Qualifiers in lifeline names and unbound types are
# not considered when creating new elements. The qualifers are treated 
# as a part of the new name rather than the owner or context.
#
proc UpdateModelLifeLineSymbol { llSymbol } {	

	if {0 == $llSymbol} {
		return
	}

	if ![u2::IsKindOf $llSymbol LifeLineSymbol] {
		error "Element $llSymbol is a '[Class $llSymbol]', but should be a 'LifeLineSymbol'"
	}

	set diagram [u2::GetEntity $llSymbol Diagram]
	if {0 == $diagram} {
		return
	}

	set interaction [u2::GetEntity $diagram Owner]
	if {0 == $interaction} {
		return
	}

	set usecase [u2::GetEntity $interaction Owner]
	if {0 == $usecase} {
		return
	}

	set context [u2::GetEntity $usecase Owner]

	set lifeLine [u2::GetEntity $llSymbol Lifeline]
	if {0 == $lifeLine} {
		return
	}

	set selector [u2::GetEntity $lifeLine Selector]
	set lifelineType [u2::GetEntity $lifeLine Type]

	set contextAttr 0

	set selectorName ""

	# If lifeline has a name, make sure there is a matching attribute
	if { $selector != 0} {
		set selectorName [u2::GetValue $selector Name]
		set lifelineAttr [u2::GetEntity $lifeLine Attribute]
		if { $lifelineAttr == 0 } {
			set contextAttr [u2::Create $context Attribute]
			u2::SetValue $contextAttr Name $selectorName
			u2::SetValue $contextAttr Aggregation AkComposite
			if { 0 != $lifelineType } {
				u2::SetEntity $contextAttr Type $lifelineType
			}
			AMReport $contextAttr "Create" "Created '$selectorName' in [Class $context] '[u2::GetValue $context Name]'"
		}
	}

	# Create type based on lifeline symbol text
	if { $lifelineType == 0 } {
		set typeNameRef [u2::GetValue $lifeLine Type]
		set lifelineType [u2::Create $context Class]
		set typeName ""

		if {$typeNameRef == ""} {
			if { $selectorName != "" } {
				set typeName "${selectorName}Class"
			} else {
				set typeName [u2::GetValue $lifelineType Name]
			}
		} else {
			regsub "ref:(.*)" $typeNameRef {\1} typeName
		}

		u2::SetValue $lifelineType Name $typeName
	
		AMReport $lifelineType "Create" "Created class '$typeName' in [Class $context] '[u2::GetValue $context Name]'"
 
		# Update symbol label with new type
		u2::SetValue $lifeLine Type ref:\'$typeName\'

		# If the lifeline represents a new attribute, set its type
		if { 0 != $contextAttr  } {
			u2::SetValue $contextAttr Type ref:\'$typeName\'
		}
	}

	# Update type of attribute represented by lifeline
	set lifelineAttr [u2::GetEntity $lifeLine Attribute]
	if  { $lifelineAttr != 0 } { 
		if { $lifelineType != [u2::GetEntity $lifelineAttr Type] } {
			set lifelifeTypeName [u2::GetValue $lifelineType Name]
			u2::SetEntity $lifelineAttr Type $lifelineType
			AMReport $lifelineAttr "Change" "Changed type to '$lifelifeTypeName'"
		}
	}

	# Update MesageLines with this lifeline as source or destination
	set messages [u2::GetReferringEntities $llSymbol Src]
	set messages [concat $messages [u2::GetReferringEntities $llSymbol Dst]]
	foreach elem $messages {
		if {0 == $elem} {
			continue
		}
		UpdateModel $elem
	}
	
	# Update all states and timers on the lifeline
	set actions [u2::GetEntities $llSymbol ActionOccurrenceSymbol]
	foreach action $actions {
		if {0 == $action} {
			continue
		}
		UpdateModel $action
	}

}
