# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# Updates the model from a messageline by finding or creating
# a corresponding signal and updates types, ports and interface
# accordingly.

proc UpdateModelMessageLine { messageLine } {
	if ![u2::IsKindOf $messageLine MessageLine] {
		error "Element $messageLine is a '[Class $messageLine]', but should be a 'MessageLine'"
	}

	# Setup context and other variables
	set message [u2::GetEntity $messageLine ModelElement]
	if {0 == $message} {
	    return
	}
	
	set diagram [u2::GetEntity $messageLine Owner]
	if {0 == $diagram} {
	    return
	}
	
	set interaction [u2::GetEntity $diagram Owner]
	if {0 == $interaction} {
	    return
	}
	
	set operation [u2::GetEntity $interaction Specification]
	if { $operation == 0 } {
		set operation [u2::GetEntity $interaction ImplementedSignature]
	}
	set interface 0

	set signal [u2::GetEntity [u2::GetEntity $message Data] InstanceOf]
	if { $signal != 0 } {
		set owner [u2::GetEntity $signal Owner]
		if [u2::IsKindOf $owner Interface] {
			set interface $owner
		}
	} else {
		global sigName foundSignal
		set sigName [GetText $messageLine]
		regsub {( *)[(](.*)[)]} $sigName "" sigName
		set foundSignal ""
		MetaVisit [GetSession $messageLine] Find Signal
		if {$foundSignal != ""} {
			set signal $foundSignal
			set owner [u2::GetEntity $signal Owner]
			if [u2::IsKindOf $owner Interface] {
				set interface $owner
			}
		} else {
			# create signal
			set sigContext [u2::GetEntity $operation Owner]

        		set model [u2::GetEntity $sigContext Session]
		        set signal [u2::New $model "Signal"]
		

			if { $sigName != "" } {
				u2::SetValue $signal Name $sigName
			} else {
				# Update messageline
				SetText $messageLine [u2::GetValue $signal Name]
			}

		        
			u2::SetEntity $sigContext "OwnedMember" $signal	
			AMReport $signal "Create" "Created signal '[u2::GetValue $signal Name]' in [Class $sigContext] '[u2::GetValue $sigContext Name]'"
			set data [u2::GetEntity $message Data]
			set paramCount 1	
			foreach expr [u2::GetEntities $data Expression] {
				if {0 == $expr} {
					continue
				}

				set newParam [u2::Create $signal Parameter]
				set paramType [u2::GetEntity $expr Type]
				if { $paramType != 0 } {
					u2::SetValue $newParam Type ref:\'[u2::GetValue $paramType Name]\'
				} else {
					u2::SetValue $newParam Type ref:Any
					set variable [u2::Create $interaction Attribute]
					u2::SetValue $variable Type ref:Any
					u2::SetValue $variable Name [u2::GetValue $expr Name]
					AMReport $variable "Create" "Created variable '[u2::GetValue $variable Name]' of type 'Any' in diagram '[u2::GetValue $diagram Name]'"
				}
				u2::SetValue $newParam Name p${paramCount}
				incr paramCount
			}
		}
	}

	# Get source and type of source
	set src [u2::GetEntity $messageLine Src]
	if {$src != 0} {
		set srcType [u2::GetEntity [u2::GetEntity [u2::GetEntity $messageLine Src] Lifeline] Type]
	} else {
		set srcType 0
	}

	# Get destination and type of destination
	set dst [u2::GetEntity $messageLine Dst]
	if {$dst != 0} {
		set dstType [u2::GetEntity [u2::GetEntity [u2::GetEntity $messageLine Dst] Lifeline] Type]
	} else {
		set dstType 0
	}

	# Look for an existing interface to reuse
	if {$interface == 0} {
		set interface [FindInterfaceThroughTypes $srcType $dstType]
	}
	if {$interface == 0} {
		set interface [FindInterfaceThroughMessages $messageLine]
	}

	# No interface found, create new one
	if {$interface == 0} {
		if {$srcType != 0} {
			set interfaceContext [u2::GetEntity $srcType Owner]
			set interfaceName [u2::GetValue $srcType Name]Required
		} elseif {$dstType != 0} {
			set interfaceContext [u2::GetEntity $dstType Owner]
			set interfaceName [u2::GetValue $dstType Name]Realized
		} else {
			set interfaceContext [u2::GetEntity $operation Owner]
			set interfaceName ""
		}
		set interfaceName [GetUniqueSignatureName Interface $interfaceContext $interfaceName]
		set interface [u2::Create $interfaceContext Interface]
		u2::SetValue $interface Name $interfaceName
		AMReport $interface "Create" "Created interface '[u2::GetValue $interface Name]' in '[u2::GetValue $interfaceContext Name]'"
	}

	set interfaceName [u2::GetValue $interface Name]

	if {($interface != 0) && ([u2::GetEntity $signal Owner] != $interface)} {
		u2::UnlinkFromOwner $signal
		u2::SetEntity $interface "OwnedMember" $signal

		AMReport $signal "Move" "Moved signal '[u2::GetValue $signal Name]' to interface '$interfaceName'"
	}

	if {$srcType != 0} {
		SetActiveAndCreatePort $srcType
		set port [lindex [u2::GetEntities $srcType Port] 0]
		set portU2 [u2::Unparse $port]
		set out ""
		regexp {out with(.*)} $portU2 dummy out
		regsub {in with(.*)} $out "" out
		if {[string last $interfaceName $out] == -1} {
			u2::SetValue $port Required  ref:\'$interfaceName\'
			AMReport $port "Change" "Made interface '$interfaceName' a required interface of port '[u2::GetValue $port Name]'"
		}
	}
	if {$dstType != 0} {
		SetActiveAndCreatePort $dstType
		set port [lindex [u2::GetEntities $dstType Port] 0]
		set portU2 [Unparse $port]
		set in ""
		regexp {in with(.*)} $portU2 dummy in
		regsub {out with(.*)} $in "" in
		if {[string last $interfaceName $in] == -1} {
			u2::SetValue $port Realized  ref:\'$interfaceName\'
			AMReport $port "Change" "Made interface '$interfaceName' a realized interface of port '[u2::GetValue $port Name]'"
		}
	}

    u2::Bind $message

}

proc IsMessageBound { messageLine } {
	if {[u2::GetEntity [u2::GetEntity [u2::GetEntity $messageLine ModelElement] Data] InstanceOf] != 0} {
		return 1
	}
	return 0
}

proc SetActiveAndCreatePort { class } {
	if [u2::IsKindOf $class Class] {
		if {[u2::GetValue $class IsActive] == "false"} {
			u2::SetValue $class IsActive true
			AMReport $class "Change" "Made class '[u2::GetValue $class Name]' active"
		}
		set ports [u2::GetEntities $class Port]
		if {[llength $ports] == 0} {
			set newPort [u2::Create $class Port]
			u2::SetValue $newPort Name [GetUniqueSignatureName Port $class p]
			u2::SetValue $newPort IsBehaviorPort true
			AMReport $newPort "Create" "Created port '[u2::GetValue $newPort Name]' in class '[u2::GetValue $class Name]'"
		}
	}
}

proc FindSignal { sig } {
	global sigName foundSignal
	if { [u2::GetValue $sig Name] == $sigName } {
		set foundSignal $sig
	}
}

# Looks for a common interface between two types, i.e. if there is
# an interface that is required by the source and realized by the destination
proc FindInterfaceThroughTypes { srcClass dstClass } {
	if {($srcClass == 0) || ($dstClass == 0)} {
		return 0
	}
 	if {(![u2::IsKindOf $srcClass Class]) || (![u2::IsKindOf $dstClass Class])} {
		return 0
	}
	set required ""
	foreach srcPort [u2::GetEntities $srcClass Port] {
		foreach reqInterface [u2::GetEntities $srcPort Required] {
			if {($reqInterface != 0) && ([u2::IsKindOf $reqInterface Interface])} {
				lappend required $reqInterface
			}
		}
	}
	set realized ""
	foreach dstPort [u2::GetEntities $dstClass Port] {
		foreach relInterface [u2::GetEntities $dstPort Realized] {
			if {($relInterface != 0) &&([u2::IsKindOf $relInterface Interface])} {
				lappend realized $relInterface
			}
		}
	}
	foreach int $required {
		if {[lsearch -exact $realized $int] != -1} {
			return $int
		}
	}
	
	return 0
}

# Looks for an interface by looking if other messages between the
# same lifelines belong to an interface
proc FindInterfaceThroughMessages { messageLine } {
	set src [u2::GetEntity $messageLine Src]
	set dst [u2::GetEntity $messageLine Dst]
    
    # Skip message line without destination
    if { $dst == 0 } {
        return 0
    }
    
	set toDst [u2::GetReferringEntities $dst Dst]
	foreach elem $toDst {
		if {0 == $elem} {
			continue
		}

		if { $elem == $messageLine } {
			continue
		}
		
		set elemSrc [u2::GetEntity $elem Src]
		if { $elemSrc != $src } {
			continue
		}
		set elemSignal [u2::GetEntity [u2::GetEntity [u2::GetEntity $elem ModelElement] Data] InstanceOf]
		if { $elemSignal != 0 } {
			set elemOwner [u2::GetEntity $elemSignal Owner]
			if [u2::IsKindOf $elemOwner Interface] {
				return $elemOwner
			}
		}
	}
	return 0
}
