# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# Checks if the operation has a return value and creates one if not.
# The type is derived from the value of the reply line.
# If there already is a return parameter and its type is different
# from the type of the supplied value, an error is generated.
#
# Known limitation: Works only if the operation is bound.
proc UpdateModelMethodReplyLine { replyMessageLine } {

	if ![IsKindOf $replyMessageLine MethodReplyLine] {
		error "Element $messageLine is a '[Class $messageLine]', but should be a 'MethodReplyLine'"
	}

	set replyMessage [GetA $replyMessageLine ModelElement]
	set replyData [GetA $replyMessage Data]
	if {$replyData == 0} {
		return 
	}
	set operation [GetA $replyData InstanceOf]
	if { $operation == 0 } {
		return
	}
	set returnValue [GetA $replyMessage ReturnValue]
	if {$returnValue == 0} {
		return
	}
	set returnType [GetA $returnValue Type]
	set returnParam [GetA $operation Return]
	if {$returnParam != 0} {
		set returnParamType [GetA $returnParam Type]
		if {$returnParamType != $returnType} {
			AMReport $replyMessageLine "Error" "Return type '[GetA $returnType Name]' different from declaration of '[GetA $operation Name]': '[GetA $returnParamType Name]'"
		}
	} else {
		set returnParam [Create [GetSession $replyMessageLine] Parameter]
		SetA $returnParam Direction DkReturn
		SetA $returnParam Type [GetA $returnType Name]
		AddA $operation Parameter $returnParam
		AMReport $returnParam "Create" "Created return parameter in operation '[GetA $operation Name]'"
	}

}
