# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# Updates the model from a NextStateActionOccurrenceSymbol
# Creates a state in the statemachine of the class typing
# the lifeline. If the lifeline is not typed, an error is given
# and the model is left untouched.
#
# If the class is passive, it is made active.
# If there is no statemachine, a new one is created.
# If there is no statemachine implementation, a new one is created.
# If there already is a state with the same name, nothing happens.
#
proc UpdateModelNextStateActionOccurrenceSymbol { stateSymbol } {

	if ![IsKindOf $stateSymbol NextStateActionOccurrenceSymbol] {
		error "Element $stateSymbol is a '[Class $stateSymbol]', but should be a 'NextStateActionOccurrenceSymbol'"
	}

	# Do nothing if state name is already bound
	set me [GetA $stateSymbol ModelElement]
	if {[GetA $me State] != 0} {
		return
	}

	set stateName [string trim [GetA $stateSymbol Text] ']
	set lifelineSymbol [GetA $stateSymbol Owner]
	set lifeline [GetA $lifelineSymbol Lifeline]

	set type [GetA $lifeline Type]
	if {$type == 0} {
		AMReport $lifeline "Error" "Lifeline has no type, unable to create state '$stateName'"
		return
	}

	if {[GetA $type IsActive] == "false"} {
		SetA $type IsActive true
		AMReport $type "Change" "Made class '[GetA $type Name]' active"
	}

	set constructors [GetA $type Constructor]
	if {[llength $constructors] == 0}  {
		set stateMachine [CreateIn $type StateMachine]
		AMReport $stateMachine "Create" "Created statemachine in class '[GetA $type Name]'"
	} else {
		set stateMachine [lindex $constructors 0]
	}

	set smImplementation [GetA $stateMachine InlineMethod]
	if {$smImplementation == 0} {
		set smImplementation [CreateIn $stateMachine SimpleStateMachine]
	}

	# TODO: Should look for statemachine diagrams only
	set diagrams [GetA $smImplementation Diagram]
	if {[llength $diagrams] == 0} {
		CreateIn $smImplementation StatechartDiagram
	}

	set existingStates [GetA $smImplementation State]
	foreach state $existingStates {
		if {[GetA $state Name] == $stateName} {
			return
		}	
	}
	
	set newState [CreateIn $smImplementation State]
	if { $stateName != ""} {
		SetA $newState Name $stateName
	} else {
		SetText $stateSymbol [GetA $newState Name]
	}

	set actionOccurrence [GetA $stateSymbol ActionOccurrence]
	if {$actionOccurrence != 0} {
		set actionState [GetA $actionOccurrence State]
		if {$actionState == 0} {
			SetA $actionOccurrence State $newState
		}
	}

	AMReport $newState "Create" "Created state '[GetA $newState Name]' in statemachine of '[GetA $type Name]'"

}
