# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# Updates the model from a TimerSetSymbol
# If the lifeline is typed, a timer is created in that type, if not
# an error is reported and the model is left untouched.
# The name of the timer is the same as the text on the timer symbol.
# If no name is given the default name is used.
proc UpdateModelTimerSetSymbol { timerSetSymbol } {

	if ![IsKindOf $timerSetSymbol TimerSetSymbol] {
		error "Element $timerSetSymbol is a '[Class $timerSetSymbol]', but should be a 'TimerSetSymbol'"
	}
	CreateTimer $timerSetSymbol
}

# Updates the model from a TimerTimeoutSymbol
# If the lifeline is typed, a timer is created in that type, if not
# an error is reported and the model is left untouched.
# The name of the timer is the same as the text on the timer symbol.
# If no name is given the default name is used.
proc UpdateModelTimerTimeoutSymbol { timerTimeoutSymbol } {

	if ![IsKindOf $timerTimeoutSymbol TimerTimeoutSymbol] {
		error "Element $timerTimeoutSymbol is a '[Class $timerTimeoutSymbol]', but should be a 'TimerTimeoutSymbol'"
	}
	CreateTimer $timerTimeoutSymbol
}

# Updates the model from a TimerResetSymbol
# If the lifeline is typed, a timer is created in that type, if not
# an error is reported and the model is left untouched.
# The name of the timer is the same as the text on the timer symbol.
# If no name is given the default name is used.
proc UpdateModelTimerResetSymbol { timerResetSymbol } {

	if ![IsKindOf $timerResetSymbol TimerResetSymbol] {
		error "Element $timerResetSymbol is a '[Class $timerResetSymbol]', but should be a 'TimerResetSymbol'"
	}
	CreateTimer $timerResetSymbol
}

proc CreateTimer { timerSymbol } {
	set timerName [GetA $timerSymbol Text]
	regsub {( *)[(](.*)[)]} $timerName "" timerName
	set timerName [string trim $timerName ']
	set lifelineSymbol [GetA $timerSymbol Owner]
	set lifeline [GetA $lifelineSymbol Lifeline]

	set type [GetA $lifeline Type]
	if {$type == 0} {
		AMReport $lifeline "Error" "Lifeline has no type, unable to create timer '$timerName''"
		return
	}

	foreach signature [GetA $type Signature] {
		if {	[IsKindOf $signature Timer] && 
			[string equal [GetA $signature Name] $timerName] } {
			return		 
		}
	}

	set newTimer [CreateIn $type Timer]
	if { $timerName != "" } {
		SetA $newTimer Name $timerName
	} else {
		SetText $timerSymbol [GetA $newTimer Name]
	}

	AMReport $newTimer "Create" "Created timer '[GetA $newTimer Name]' in [Class $type] '[GetA $type Name]'"
}
