/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torDispatchable_h__
#define __torDispatchable_h__ (1)

#include "torPlatform.h"

#include "torContainers.h"
#include "torInstanceManager.h"

namespace tor
{
    class Event;
    class EventQueue;
    class Dispatcher;

    // Interface capturing the ability to execute events.
    class TOR_EXT_DEF EventExecutor
    {
    public:
        EventExecutor() : m_executorId(0)
        {
            m_executorId = InstanceManager::instance().addExecutor(this);
        }
        virtual ~EventExecutor() 
        {
            InstanceManager::instance().removeExecutor(m_executorId);
        }

        enum EventAction 
        {
            NoMatch,      // Event was not handled by receiver
            Defer,        // Event was saved by receiver
            Consumed      // Event was consumed by receiver      
        };

        // Executes the supplied event and returns the status to indicate 
        // how event was handled.
        virtual EventAction execute(Event *event) = 0;

    private:
        InstanceManager::ObjectId m_executorId;
    };
    
    // Interface capturing the ability to receive events.
    class TOR_EXT_DEF EventReceiver 
    {
    public:
        EventReceiver() : m_receiverId(0)
        {
            m_receiverId = InstanceManager::instance().addReceiver(this);
        }
        virtual ~EventReceiver()
        {
            InstanceManager::instance().removeReceiver(m_receiverId);
        }

        // Receive the specified event.
        virtual bool receive(Event *e) = 0;

    private:
        InstanceManager::ObjectId m_receiverId;
    };

    class TOR_EXT_DEF Dispatchable : public virtual EventExecutor, virtual public EventReceiver 
    {
    public:
        Dispatchable(); 
        virtual ~Dispatchable();

        // Will add the 'dispachable' to the current dispatcher.
        void addToCurrentDispatcher(Dispatchable *dispatchable);

        // The event queue associated with this dispatchable. The event queue
        // is normally owned by the associated dispatcher.
        EventQueue *m_eventQueue;

        // The event currently being processed.
        Event *m_currentEvent;

        // The dispatcher associated with this dispatchable
        Dispatcher*	m_dispatcher;
    };


    // Will add 'n' dispatchables to the current dispatcher.
    // If 'n' is negative all in the string are added.
    
    template <class D> 
    inline void addToDispatcher(Dispatchable *d, String<D> &ds, int n = -1)
    {
        int size = static_cast<int>(ds.size());
        unsigned int nMax = (n < 0 || n > size) ? size : n;
        for (unsigned int i = 1 /* indexOffset */; i < nMax + 1 /* indexOffset */; ++i)
        {
            if (ds[i])
                d->addToCurrentDispatcher(ds[i]);
        }
    }
}

#endif  // __torDispatchable_h__

