// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#include "torPlatform.h"

#include "torDispatcher.h"
#include "torDispatchable.h"
#include "torEvent.h"
#include "torEventQueue.h"

tor::Dispatcher::Dispatcher()
  : m_eventQueue(0),
    m_timerQueue()
{}

tor::Dispatcher::Dispatcher(EventQueue *eq)
  : m_eventQueue(eq),
    m_timerQueue()
{}

tor::Dispatcher::~Dispatcher()
{
    // Notify all dispatched dispatchables that this dispatcher has
    // been destructed!

    List::const_iterator it = m_dispatchables.begin();
    while (it != m_dispatchables.end())
    {
        Dispatchable *d = *it++;
        if (d == 0)
            continue;

        d->m_eventQueue = 0;
        d->m_dispatcher = 0;
    }

    m_timerQueue.clear();
}

void tor::Dispatcher::add(Dispatchable *d)
{
    m_dispatchables.push_back(d);
    d->m_eventQueue = m_eventQueue;
    d->m_dispatcher = this;
}

bool tor::Dispatcher::remove(Dispatchable *d)
{
    if (d == 0 || d->m_dispatcher != this)
        return false;

    m_dispatchables.remove(d);
    d->m_eventQueue = 0;
    d->m_dispatcher = 0;
    return true;
}

void tor::Dispatcher::run()
{
    if (m_eventQueue == 0)
        return;

    while (!m_eventQueue->empty() || !m_timerQueue.empty())
        step();
}

void tor::Dispatcher::step()
{
    if (m_eventQueue == 0)
        return;

    os::Time now, time;
    while (true)
    {
        Event *event;
        if (!m_timerQueue.empty())
        {
            now.setNow();
            time.set(m_timerQueue.getTime());

            while (time <= now)
            {
                TimerObject *timerObject = m_timerQueue.get();
                if (timerObject != 0)
                    m_eventQueue->insert(timerObject->event());

                if (m_timerQueue.empty())
                    break;

	            time.set(m_timerQueue.getTime());
            }

            if (m_eventQueue->empty())
            {
                event = m_eventQueue->get(time);
                if (event == 0)
                    continue;
            }
            else
            {
                event = m_eventQueue->get();
                if (event == 0)
                    break;
            }
        }
        else
        {
            event = m_eventQueue->get();
            if (event == 0)
                break;
        }

        if (InstanceManager::instance().isValidExecutor(event->m_receiver))
        {
            EventExecutor *executor = InstanceManager::instance().getExecutorFromId(event->m_receiver);
            Dispatchable::EventAction ea = executor->execute(event);
            if (ea == Dispatchable::NoMatch) // Event was not handled by receiver
                delete event;
        }
        else
            // TODO: Dispatcher should handle the event
            delete event;
        break;
    }
}

