/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torDispatcher_h__
#define __torDispatcher_h__ (1)

#include "torPlatform.h"

#include "torTimer.h"
#include <list>

namespace tor {

    class Dispatchable;
    class EventQueue;
    class TimerQueue;

    class TOR_EXT_DEF Dispatcher {
    public:
        Dispatcher();
        Dispatcher(EventQueue*);
        virtual ~Dispatcher();

        // Associates a dispatchable with this dispatcher to make the dispatchable
        // receive events in the event queue of this dispatcher.
        void add(Dispatchable*);

        // Removes the association between a dispatchable and this dispatcher.
        // The dispatchable will no longer receive events from this dispatcher,
        // and events in the queue addressed to the dispatchable are removed.
        bool remove(Dispatchable*);

        // As long as the event queue is not empty, retrieves events from the 
        // queue and executes them in their receivers. Returns when the queue is
        // empty.
        void run();

        // Retrieves one event from the queue and executes it in the receiver
        // stored in the event.
        void step();

        inline TimerQueue *getTimerQueue() {return &m_timerQueue;}
        inline void setEventQueue(EventQueue *eventQueue) {m_eventQueue = eventQueue;}
        inline EventQueue *getEventQueue() {return m_eventQueue;}

    protected:
    
        // The Timer queue of this dispatcher.
        TimerQueue m_timerQueue;

        // The event queue of this dispatcher.
        EventQueue *m_eventQueue;

        // The list of dispatchables managed by this dispatcher.
        typedef std::list< Dispatchable* >	List;
        List m_dispatchables;
    };

} // tor namespace

#endif  // __torDispatcher_h__

