/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torDispatcherThread_h
#define __torDispatcherThread_h

#include "torPlatform.h"

#include "torOs.h"
#include "torThreadSafeEventQueue.h"
#include "torDispatcher.h"

namespace tor
{
    // Data that is shared between the calling and spawned threads of a
    // ThreadedDispatcher. It is protected by a Thread::Data wrapper.

    class TOR_EXT_DEF DispatcherData
    {
    public:
        DispatcherData();
        ~DispatcherData() {}

        // ThreadedDispatcher calls these
        void stepDispatcher();

        bool endThread();
        bool endThread(os::Time timeout);

        void addDispatchable(Dispatchable *d);
        void removeDispatchable(Dispatchable *d);

        // DispatcherBehaviour calls these
        bool threadShallEnd();
        void threadIsDone();

        void setBehaviourId();

    protected:
        void postEndThread();

    private:
        Dispatcher m_dispatcher;
        ThreadSafeEventQueue m_queue;

        os::Mutex m_mutex;
        os::Semaphore m_threadDone;

        bool m_threadShallEnd;
        bool m_useSemaphore;

        unsigned long m_behaviourId;
    };

    // Implements the threaded behavior of a threaded dispatcher

    class TOR_EXT_DEF DispatcherBehaviour : public os::Thread::Behaviour
    {
    public:
        DispatcherBehaviour(os::Thread::Data<DispatcherData> &data);
        virtual ~DispatcherBehaviour() {}

        virtual int execute();

    private:
        os::Thread::Data<DispatcherData> m_data;
    };

    // A threaded dispatcher. It starts a thread that handles the
    // behavior.

    class TOR_EXT_DEF ThreadedDispatcher
    {
    public:
        class dispatcher_thread_exception {};

        ThreadedDispatcher();
        ~ThreadedDispatcher();

        void launch();

        // synchronous
        bool endThread();
        bool endThread(os::Time timeout);

        void add(Dispatchable *d);
        void remove(Dispatchable *d);

        // synchronous
        void processAllPendingEvents();

    private:
        ThreadedDispatcher(const ThreadedDispatcher &);            // do not use!
        ThreadedDispatcher &operator=(const ThreadedDispatcher &); // do not use!

    private:
        os::Thread::Data<DispatcherData> m_data;
    };

    typedef ThreadedDispatcher DispatcherThread; // deprecated!, added for backwards compatibility
}

#endif

