// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#include "tor.h"
#include "torContainers.h"
#include "torEventManager.h"
#include "torEventManagerImpl.h"
#include "torEventMedia.h"
#include "torHostDebuggerProxy.h"
#include "torMetaEvents.h"
#include "torTypes.h"

namespace tor {
    namespace meta {
        class EventManagerImpl_initialize: virtual public tor::StateMachine, public tor::TopRegion {
        public:
            class WaitForHostCommand;
            class WaitForEvent;
            typedef tor::StateMachine theStateMachine;
            typedef tor::TopRegion theTopRegion;
            EventManagerImpl *m_owner;
            virtual tor::StateMachine *getStateMachine();
            EventManagerImpl_initialize(EventManagerImpl *owner);
            virtual ~EventManagerImpl_initialize();
            virtual void init();
            virtual tor::DispatchableClass *getDispatchableClass() const;
            tor::Charstring actionGuid;
            tor::String<BreakpointInfo> breakpoints;
            friend class EventManager;
            class WaitForEvent: public tor::State {
                typedef tor::State theState;
            public:
                EventManagerImpl_initialize *m_owner;
                WaitForEvent(tor::Region *region, EventManagerImpl_initialize *owner);
                tor::Dispatchable::EventAction execute(tor::Event *e);
            };
        protected:
            WaitForEvent *m_s_WaitForEvent;
            friend class WaitForEvent;
        public:
            void trans_WaitForEvent_Event(tor::Event *theEvent);
            void trans_WaitForEvent_Exit(tor::Event *theEvent);
            virtual void initialTransition();
            class WaitForHostCommand: public tor::State {
                typedef tor::State theState;
            public:
                EventManagerImpl_initialize *m_owner;
                WaitForHostCommand(tor::Region *region, EventManagerImpl_initialize *owner);
                tor::Dispatchable::EventAction execute(tor::Event *e);
            };
        protected:
            WaitForHostCommand *m_s_WaitForHostCommand;
            friend class WaitForHostCommand;
        public:
            void trans_WaitForEvent_BreakpointHit_Charstring(tor::Event *theEvent);
            void trans_WaitForHostCommand_Step(tor::Event *theEvent);
            void trans_WaitForHostCommand_Go(tor::Event *theEvent);
            void trans_WaitForHostCommand_StepOut(tor::Event *theEvent);
            void trans_WaitForHostCommand_StepIn(tor::Event *theEvent);
            void trans_WaitForHostCommand_RunTo_Charstring(tor::Event *theEvent);
            void trans_WaitForEvent_Break(tor::Event *theEvent);
            void trans_SetBreakpoints();
            void trans_WaitForHostCommand_SetBreakpoints_BreakpointInfo(tor::Event *theEvent);
            void trans_RemoveBreakpoints();
            void trans_WaitForHostCommand_RemoveBreakpoints_BreakpointInfo(tor::Event *theEvent);
            void trans_WaitForEvent_SetBreakpoints_BreakpointInfo(tor::Event *theEvent);
            void trans_WaitForEvent_RemoveBreakpoints_BreakpointInfo(tor::Event *theEvent);
            void trans_WaitForEvent_Attach(tor::Event *theEvent);
            void trans_WaitForHostCommand_Attach(tor::Event *theEvent);
        };

        EventManagerImpl_initialize::WaitForHostCommand::WaitForHostCommand(tor::Region *region, EventManagerImpl_initialize *owner) : tor::State(region), m_owner(owner) {

        }

        tor::Dispatchable::EventAction EventManagerImpl_initialize::WaitForHostCommand::execute(tor::Event *e) {
            if (Attach::isTypeOf(e))
            {
                leave();
                m_owner -> trans_WaitForHostCommand_Attach(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (RemoveBreakpoints_BreakpointInfo::isTypeOf(e))
            {
                m_owner -> breakpoints = tor::cast<RemoveBreakpoints_BreakpointInfo *>(e) -> breakpoints;
                leave();
                m_owner -> trans_WaitForHostCommand_RemoveBreakpoints_BreakpointInfo(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (SetBreakpoints_BreakpointInfo::isTypeOf(e))
            {
                m_owner -> breakpoints = tor::cast<SetBreakpoints_BreakpointInfo *>(e) -> breakpoints;
                leave();
                m_owner -> trans_WaitForHostCommand_SetBreakpoints_BreakpointInfo(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (RunTo_Charstring::isTypeOf(e))
            {
                m_owner -> actionGuid = tor::cast<RunTo_Charstring *>(e) -> actionGuid;
                leave();
                m_owner -> trans_WaitForHostCommand_RunTo_Charstring(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (StepIn::isTypeOf(e))
            {
                leave();
                m_owner -> trans_WaitForHostCommand_StepIn(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (StepOut::isTypeOf(e))
            {
                leave();
                m_owner -> trans_WaitForHostCommand_StepOut(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (Go::isTypeOf(e))
            {
                leave();
                m_owner -> trans_WaitForHostCommand_Go(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (Step::isTypeOf(e))
            {
                leave();
                m_owner -> trans_WaitForHostCommand_Step(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            {
                return tor::Dispatchable::NoMatch;
            }
        }

        EventManagerImpl::~EventManagerImpl() {
            tor::SingleDeleter<TauHostDebuggerProxy> deleter_tauHostDebugger(tauHostDebugger);
            tor::MultiDeleter<EventMedia> deleter_media(media);
            tor::sendTo(new Exit, this);
            {
                {
                    sem_finished.get();
                }
            }
            thread.remove(this);
            return;
        }

        EventManagerImpl::EventManagerImpl() : tauHostDebugger(0), p_in(this, tor::Port::InPort), p(this, tor::Port::OutPort) {
            {
                {
                    sem_finished.init(0);
                    thread.add(this);
                    this -> init();
                    this -> start();
                    tor::Charstring host;
                    tor::Natural port;
                    tor::Boolean bShouldWaitForAttach = EventManager::shouldWaitForAttach(host, port);
                    if ((host.length() > 0) && (port != 0))
                    {
                        try
                        {
                            tauHostDebugger = new TauHostDebuggerProxy(host, port);
                        }
                        catch (...)
                        {
                            // Could be caused by socket problems... Possible memory leak not to delete.
                            tauHostDebugger = 0;;
                        }
                    }
                    if (bShouldWaitForAttach)
                        EventManager::onBreak();
                    thread.launch();
                }
            }
            return;
        }

        bool EventManagerImpl::receive(tor::Event *e) {
            return theDispatchableClass::receive(e);
        }

        void EventManagerImpl::init() {
            m_sm = new EventManagerImpl_initialize(this);
            theDispatchableClass::init();
        }

        tor::StateMachine *EventManagerImpl::getClassifierBehavior() {
            return m_sm;
        }

        void EventManagerImpl::start() {
            theDispatchableClass::start();
        }

        void EventManagerImpl::disconnect() {
            p.disconnect();
            p_in.disconnect();
        }

        tor::StateMachine *EventManagerImpl_initialize::getStateMachine() {
            return this;
        }

        EventManagerImpl_initialize::EventManagerImpl_initialize(EventManagerImpl *owner) : m_owner(owner) {

        }

        EventManagerImpl_initialize::~EventManagerImpl_initialize() {
            {
                if (m_s_WaitForEvent)
                    delete m_s_WaitForEvent;
            }
            {
                if (m_s_WaitForHostCommand)
                    delete m_s_WaitForHostCommand;
            }
        }

        void EventManagerImpl_initialize::init() {
            theStateMachine::addRegion(this);
            {
                m_s_WaitForEvent = new WaitForEvent(this, this);
            }
            m_s_WaitForEvent -> init();
            {
                m_s_WaitForHostCommand = new WaitForHostCommand(this, this);
            }
            m_s_WaitForHostCommand -> init();
        }

        tor::DispatchableClass *EventManagerImpl_initialize::getDispatchableClass() const {
            {
                return m_owner;
            }
        }

        EventManagerImpl_initialize::WaitForEvent::WaitForEvent(tor::Region *region, EventManagerImpl_initialize *owner) : tor::State(region), m_owner(owner) {

        }

        tor::Dispatchable::EventAction EventManagerImpl_initialize::WaitForEvent::execute(tor::Event *e) {
            if (Attach::isTypeOf(e))
            {
                leave();
                m_owner -> trans_WaitForEvent_Attach(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (RemoveBreakpoints_BreakpointInfo::isTypeOf(e))
            {
                m_owner -> breakpoints = tor::cast<RemoveBreakpoints_BreakpointInfo *>(e) -> breakpoints;
                leave();
                m_owner -> trans_WaitForEvent_RemoveBreakpoints_BreakpointInfo(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (SetBreakpoints_BreakpointInfo::isTypeOf(e))
            {
                m_owner -> breakpoints = tor::cast<SetBreakpoints_BreakpointInfo *>(e) -> breakpoints;
                leave();
                m_owner -> trans_WaitForEvent_SetBreakpoints_BreakpointInfo(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (Break::isTypeOf(e))
            {
                leave();
                m_owner -> trans_WaitForEvent_Break(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (BreakpointHit_Charstring::isTypeOf(e))
            {
                m_owner -> actionGuid = tor::cast<BreakpointHit_Charstring *>(e) -> actionGuid;
                leave();
                m_owner -> trans_WaitForEvent_BreakpointHit_Charstring(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (Exit::isTypeOf(e))
            {
                leave();
                m_owner -> trans_WaitForEvent_Exit(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            if (Event::isTypeOf(e))
            {
                leave();
                m_owner -> trans_WaitForEvent_Event(e);
                delete e;
                return tor::Dispatchable::Consumed;
            }
            {
                return tor::Dispatchable::NoMatch;
            }
        }

        void EventManagerImpl_initialize::trans_WaitForEvent_Event(tor::Event *theEvent) {
            {
                {
                    EventManager::emitToMedia(tor::cast<Event*>(theEvent));
                    EventManager::continueApplication(theEvent);
                }
            }
            theTopRegion::enterHistory();
        }

        void EventManagerImpl_initialize::trans_WaitForEvent_Exit(tor::Event *theEvent) {
            {
                {
                    m_owner -> sem_finished.put();
                }
            }
            theTopRegion::enterHistory();
        }

        void EventManagerImpl_initialize::initialTransition() {
            m_s_WaitForEvent -> enter();
        }

        void EventManagerImpl_initialize::trans_WaitForEvent_BreakpointHit_Charstring(tor::Event *theEvent) {
            {
                {
                    EventManager::removeAllPseudoBreakpoints();
                }
            }
            tor::sendTo(new ExecutionHalted_Charstring(actionGuid), m_owner -> tauHostDebugger);
            m_s_WaitForHostCommand -> enter();
        }

        void EventManagerImpl_initialize::trans_WaitForHostCommand_Step(tor::Event *theEvent) {
            {
                {
                    EventManager::onStep();
                }
            }
            {
                {
                    EventManager::continueApplication(theEvent);
                }
            }
            m_s_WaitForEvent -> enter();
        }

        void EventManagerImpl_initialize::trans_WaitForHostCommand_Go(tor::Event *theEvent) {
            {
                {
                    EventManager::continueApplication(theEvent);
                }
            }
            m_s_WaitForEvent -> enter();
        }

        void EventManagerImpl_initialize::trans_WaitForHostCommand_StepOut(tor::Event *theEvent) {
            {
                {
                    EventManager::onStepOut();
                }
            }
            {
                {
                    EventManager::continueApplication(theEvent);
                }
            }
            m_s_WaitForEvent -> enter();
        }

        void EventManagerImpl_initialize::trans_WaitForHostCommand_StepIn(tor::Event *theEvent) {
            {
                {
                    EventManager::onStepIn();
                }
            }
            {
                {
                    EventManager::continueApplication(theEvent);
                }
            }
            m_s_WaitForEvent -> enter();
        }

        void EventManagerImpl_initialize::trans_WaitForHostCommand_RunTo_Charstring(tor::Event *theEvent) {
            {
                {
                    EventManager::onRunTo(actionGuid);
                }
            }
            {
                {
                    EventManager::continueApplication(theEvent);
                }
            }
            m_s_WaitForEvent -> enter();
        }

        void EventManagerImpl_initialize::trans_WaitForEvent_Break(tor::Event *theEvent) {
            {
                {
                    EventManager::onBreak();
                }
            }
            theTopRegion::enterHistory();
        }

        void EventManagerImpl_initialize::trans_SetBreakpoints() {
SetBreakpoints:;
               {
                   {
                       EventManager::setBreakpoints(breakpoints);
                   }
               }
               theTopRegion::enterHistory();
        }

        void EventManagerImpl_initialize::trans_WaitForHostCommand_SetBreakpoints_BreakpointInfo(tor::Event *theEvent) {
            trans_SetBreakpoints();
            return;
        }

        void EventManagerImpl_initialize::trans_RemoveBreakpoints() {
RemoveBreakpoints:;
                  {
                      {
                          EventManager::removeBreakpoints(breakpoints);
                      }
                  }
                  theTopRegion::enterHistory();
        }

        void EventManagerImpl_initialize::trans_WaitForHostCommand_RemoveBreakpoints_BreakpointInfo(tor::Event *theEvent) {
            trans_RemoveBreakpoints();
            return;
        }

        void EventManagerImpl_initialize::trans_WaitForEvent_SetBreakpoints_BreakpointInfo(tor::Event *theEvent) {
            trans_SetBreakpoints();
            return;
        }

        void EventManagerImpl_initialize::trans_WaitForEvent_RemoveBreakpoints_BreakpointInfo(tor::Event *theEvent) {
            trans_RemoveBreakpoints();
            return;
        }

        void EventManagerImpl_initialize::trans_WaitForEvent_Attach(tor::Event *theEvent) {
            tor::sendTo(new Attached_AppInfo(EventManager::getAppInfo()), m_owner -> tauHostDebugger);
            theTopRegion::enterHistory();
        }

        void EventManagerImpl_initialize::trans_WaitForHostCommand_Attach(tor::Event *theEvent) {
            tor::sendTo(new Attached_AppInfo(EventManager::getAppInfo()), m_owner -> tauHostDebugger);
            tor::sendTo(new ExecutionHalted_Charstring(EventManager::getCurrentExecutionPoint()), m_owner -> tauHostDebugger);
            theTopRegion::enterHistory();
        }


    }   // namespace meta
}    // namespace tor
