// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#ifdef TOR_USE_INSTRUMENTATION

#include "torPlatform.h"

#include "torHostDebuggerProxy.h"
#include "torMetaEvents.h"
#include "torEventManager.h"

namespace tor
{
    namespace meta
    {
        class TauHostDebuggerBehaviour : public TextServerBehaviour
        {
        public:
            TauHostDebuggerBehaviour(unsigned int port) 
              : TextServerBehaviour(port)
            {}

            // TextServerBehaviour interface realization
            // Called when a message has been received from the Tau host. 
            // The message is translated to an appropriate debugger event 
            // and is sent to the EventManager.
            void onReceivedMessage(const Charstring &message) 
            {
#ifndef TOR_NO_EVENTMANAGER
                // Decode event to the corresponding meta signal.
                Event *event = Event::decode(message);
                if (event != 0) 
                    sendTo(event, EventManager::GetInstance());
#endif
            }

        protected:
            virtual void onDisconnect(SOCKET s)
            {
#ifndef TOR_NO_EVENTMANAGER
                if (s == getClient())
                {
                    // The Tau MV++ is disconnecting from this target executable.
                    // Clear all breakpoints and go as fast as we can. Wroom!
                    tor::String<tor::meta::BreakpointInfo> breakpoints;
                    sendTo(new RemoveBreakpoints_BreakpointInfo(breakpoints), EventManager::GetInstance());
                    sendTo(new Go(), EventManager::GetInstance());
                }
#endif
                TextServerBehaviour::onDisconnect(s);
            }
        };

        TauHostDebuggerProxy::TauHostDebuggerProxy(const Charstring &host, Natural port) 
          : TextServer(new TauHostDebuggerBehaviour(port))
        {}

        bool TauHostDebuggerProxy::receive(tor::Event *event) 
        {
            Event *metaEvent = cast<Event *>(event);
            if (metaEvent == 0) 
                // Can only transmit meta events to the host debugger!
                return false; 

            // Encode event
            U2P_Coder coder;
            metaEvent->encode(&coder);

            // Send encoded string over TCP/IP media to TauHostDebugger
            sendMessage(metaEvent->encodedInfo);

            return true; // Consumed event!
        }
    }
}
#endif 

