/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torOsRep_h
#define __torOsRep_h

#include "torPlatform.h"

#include "torTypes.h"
#include <vector>
#include <string>

extern "C" 
{
    typedef int (*ThreadFunc)(void*);
}

#ifndef TSTRING
typedef tor::Charstring::StringRepType tstring;
#define TSTRING
#endif // TSTRING

namespace tor
{
    namespace os
    {
        enum TOR_EXT_DEF Status 
        {
            StatusOK,      // Operation successful
            StatusFAIL,    // Operation failed
            StatusTIMEOUT  // Operation failed, timeout.
        };



        class TOR_EXT_DEF ProcessRepCommon
        {
        public:
            ProcessRepCommon();

            void setOptions(int options);
            
        protected:
            int m_options;
        };
    }
}

#include "torExceptions.h"

#if (TGTOS == OS_USER)
#  include "torOs_user.h"
#elif (TGTOS == OS_WIN32)
#  include "torOs_win32.h"
#elif (TGTOS == OS_LINUX)
#  include "torOs_linux.h"
#elif (TGTOS == OS_SOLARIS)
#  include "torOs_solaris.h"
#else
#  error "Invalid TGTOS value" TGTOS
#endif

namespace tor
{
    namespace os
    {
        // OS dependent part of the tor::os::Thread interface.
        // The implementations of these methods are located 
        // in the os-specific 'torOs_<OS>.cpp' file.

        namespace Thread
        {
            // Creates a thread that calls the given function ptr with the
            // given arg as argument.
            TOR_EXT_DEF bool createThread(ThreadFunc behaviour, void *arg);

            // Suspends the current thread until the indicated timeout has been reached
            TOR_EXT_DEF void suspend(Time timeout);

            // Returns the id of the calling thread
            TOR_EXT_DEF unsigned long id();
        }

        // Returns the PID of the current process
        TOR_EXT_DEF PID GetCurrentPID();
    }
}

#endif

