// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#include "torPlatform.h"

#include "torPort.h"

#include "tor.h"
#include "torTypes.h"


tor::Port::Port(DispatchableClass *pOwner, PortKind portKind) : targetBehavior(0)
{
    if (pOwner != 0)
    {
        if (portKind == InPort)
            targetBehavior = pOwner;
        else
            pOwner->addOutPort(this);
    }
}

void tor::Port::attach(Port *port, Connector *connector) 
{
    portList.push_back(port); // Add port to portlist
}

bool tor::Port::send(tor::Event *event, bool deleteEvent) 
{
    // Note: We do not support more than one connected connector/port
    bool result = false;

    // If port list is not empty, send the event through the 
    // first port in the port list.
    if (!portList.empty()) 
    {    
        Port *p = portList.front();
        result = p->send(event, deleteEvent);
    }
    else if (targetBehavior != 0) 
    {
        // Otherwise send the event to the target behavior
        result = targetBehavior->receive(event);
    }

    // Delete the event if necessary.
    if (deleteEvent && (!result && event != 0))
        delete event;

    return result;
}

void tor::Port::disconnect()
{
    // Not yet implemented
}

