/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __Process_h
#define __Process_h

#include "torPlatform.h"

#include "torTypes.h"
#include "torSync.h"
#include "torThread.h"
#include "torOsRep.h"
#include <vector>

namespace tor
{
    namespace os
    {
        class TOR_EXT_DEF Process
        {
        public:
            typedef void (*OnExit)();

            typedef std::pair<std::string, std::string> ENV_var;
            typedef std::vector<ENV_var> ENV;

            Process();
            ~Process();

            bool launch(const tstring &cmd, const std::vector<tstring> &argv, const ENV &env)
            {
                tstring dir = _T("");
                return launch(cmd, argv, env, dir);
            }
            bool launch(const tstring &cmd, const std::vector<tstring> &argv, const ENV &env, const tstring &dir);
            bool terminate() { return m_impl.terminate(); }

            PID getPID() const {return m_impl.getPID(); }

            // Options (may be platform specific)
            static const int NO_CONSOLE = 1; // Launch process without visible console

            void setOptions(int options);

            // Determines if the process has terminated. If so, terminationValue is set up to the value with which the process terminated.
            bool isTerminated(int& terminationValue);

        protected:
            bool m_bTerminateOnDelete; // Set this to false to prevent launched process to terminate when the Process object is deleted.

        private:
            Process(const Process &);            // don't use!
            Process &operator=(const Process &); // don't use!

        private:
            ProcessRep m_impl;
        };
    }
}

#endif

