/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torTime_h
#define __torTime_h

#include "torPlatform.h"

#include "torOsRep.h"

namespace tor
{
    namespace os
    {
        class TOR_EXT_DEF Time 
        {
        public:
            Time() : m_rep() {}
            Time(int s, int ns) : m_rep(s, ns) {}
            explicit Time(double d) : m_rep() { set(d); }
            Time(const Time &a, const Time &b) : m_rep(a.m_rep, b.m_rep) {} // a - b
            Time(const Time &x) : m_rep(x.m_rep) {} 
            ~Time() {}

            // Assignment functions.
            Time &zero() { m_rep.zero(); return *this; }
            Time &setNow() { m_rep.setNow(); return *this; }

            Time &set(const Time &x) { m_rep.set(x.m_rep); return *this; }
            Time &set(int s, int ns) { m_rep.set(s, ns); return *this; }
            Time &set(double d) { m_rep.set(d); return *this; }

            Time &operator=(Time &x) { return set(x); }
            Time &operator=(double d) { return set(d); }

            // Algebraic functions
            Time &add(const Time &x) { m_rep.add(x.m_rep); return *this; }
            Time &add(int s, int ns) { m_rep.add(s, ns); return *this; }
            Time &add(double d) { add(Time(d)); return *this; }

            Time &sub(const Time &x) { m_rep.sub(x.m_rep); return *this; }
            Time &sub(int s, int ns) {m_rep.sub(s, ns); return *this; }
            Time &sub(double d) { sub(Time(d)); return *this; }
            Time &sub(const Time &a, const Time &b) {m_rep.sub(a.m_rep, b.m_rep); return *this; } // = a - b

            Time &operator+=(const Time &x) { return add(x); }
            Time &operator+=(double d) { return add(d); }

            Time &operator-=(const Time &x) { return sub(x); }
            Time &operator-=(double d) { return sub(d); }

            int cmp(const Time &x) const { return m_rep.cmp(x.m_rep); }

            double to_double() const { return m_rep.to_double(); }
            unsigned long to_ms() const { return m_rep.to_ms(); }

#if TOR_USE_OSTREAM
            std::ostream &print(std::ostream &os) const { return m_rep.print(os); }
#endif

            static double setUnit(double new_unit) { return TimeRep::setUnit(new_unit); }

            static Time now() { return Time().setNow(); }

        private:
            TimeRep m_rep;
        };
    }
}

#if TOR_USE_OSTREAM
inline std::ostream &operator<<(std::ostream &os, const tor::os::Time &t) 
{
    return t.print(os);
}
#endif

inline int operator==(const tor::os::Time &x, const tor::os::Time &y) 
{
    return x.cmp(y) == 0;
}

inline int operator!=(const tor::os::Time &x, const tor::os::Time &y) 
{
    return x.cmp(y) != 0;
}

inline int operator<(const tor::os::Time &x, const tor::os::Time &y) 
{
    return x.cmp(y) < 0;
}

inline int operator<=(const tor::os::Time &x, const tor::os::Time &y) 
{
    return x.cmp(y) <= 0;
}

inline int operator>(const tor::os::Time &x, const tor::os::Time &y) 
{
    return x.cmp(y) > 0;
}

inline int operator>=(const tor::os::Time &x, const tor::os::Time &y) 
{
    return x.cmp(y) >= 0;
}

inline tor::os::Time operator+(const tor::os::Time &x, const tor::os::Time &y) 
{
    tor::os::Time rv(x);
    rv.add(y);
    return rv;
}

inline tor::os::Time operator-(const tor::os::Time &x, const tor::os::Time &y) 
{
    tor::os::Time rv(x);
    rv.sub(y);
    return rv;
}


inline tor::os::Time operator+(const tor::os::Time &x, double d) 
{
    tor::os::Time rv(x);
    rv.add(d);
    return rv;
}

inline tor::os::Time operator-(const tor::os::Time &x, double d) 
{
    tor::os::Time rv(x);
    rv.sub(d);
    return rv;
}


inline tor::os::Time operator+(double d, const tor::os::Time &x) 
{
    tor::os::Time rv(x);
    rv.add(d);
    return rv;
}

inline tor::os::Time operator-(double d, const tor::os::Time &x) 
{
    tor::os::Time rv(d);
    rv.sub(x);
    return rv;
}

#endif

