/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torTimer_h__
#define __torTimer_h__ (1)

#include "torPlatform.h"

#include "torOs.h"
#include "torEvent.h"
#include <list>

namespace tor {

    class TimerObject;
    class TimerQueue;
    class Dispatchable;

    class TOR_EXT_DEF TimerEvent : public Event {
        friend class TimerObject;
    public:
        virtual ~TimerEvent();
        TimerEvent();

        virtual void received();

    protected:
        TimerObject*	m_pTimer;
    };

    class TOR_EXT_DEF TimerObject {
        friend class TimerEvent;
        friend class TimerQueue;
    public:
        virtual	~TimerObject();
        TimerObject( Dispatchable& rOwner );

        void	set( const os::Time& t, TimerEvent* pE );
        void	reset();
        bool	isActive() const { return m_pTimerEvent != 0; }

        TimerEvent*	event() { return m_pTimerEvent; }

    protected:
        bool	softReset();		// Used by TimerEvent::~TimerEvent()

    protected:
        Dispatchable&	m_rOwner;
        TimerEvent*		m_pTimerEvent;
        TimerQueue*		m_pTimerQueue;
        os::Time		m_t;

    // Illegals
    private:
        TimerObject();
        TimerObject( const TimerObject& );
        TimerObject& operator= ( const TimerObject& );
    };

    class TOR_EXT_DEF TimerQueue {
    public:
        virtual	~TimerQueue();
        TimerQueue();

        virtual void clear();
        virtual void insert( TimerObject* pT );
        virtual void remove( TimerObject* pT );

        virtual TimerObject* get();
        virtual const os::Time& getTime() const	{ return m_t; }
        virtual bool	empty() const		{ return m_list.empty(); }

    private:
        typedef std::list< TimerObject* > List;

        List	m_list;
        os::Time	m_t;

        // Illegals
    private:
        TimerQueue( const TimerQueue& );
        TimerQueue& operator= (const TimerQueue&);
    };

} // namespace tor

#endif // __torTimer_h__

