// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#include "torPlatform.h"

#include "torTopRegion.h"

#include "torExitPoint.h"
#include "torState.h"
#include "torStateMachine.h"
#include "torDispatchableClass.h"
#include "torEvent.h"
#include "torMetaEvents.h"
#include "torUtilities.h"

namespace tor {
    // Event corresponding to a request to run the initial transition of a top region
    class RunInitialTransition : public InternalEvent {
    public:
        static bool isTypeOf(const Event *event)
        { 
            return (tor::cast<const RunInitialTransition*>(event) != 0); 
        }
    };
}

tor::Dispatchable::EventAction tor::TopRegion::execute(tor::Event* e)
{
    // Handle RunInitialTransition event
    if (RunInitialTransition::isTypeOf(e)) {
        initialTransition();
        delete e;
        return Dispatchable::Consumed;
    }

    return Region::execute(e);
}

void tor::TopRegion::callInitialTransition()
{
    // Special case for the TopRegion of the top statemachine of a dispatchable class:
    // Post a request for calling the initialTransition rather than doing it immediately.
    // This is because the start transition should be executed in the context of the 
    // dispatcher rather than in the context of the caller of 'start'.
    StateMachine* sm = getStateMachine();
    if (sm) {
        DispatchableClass* dc = sm->getDispatchableClass();
        if (dc && (dc->getClassifierBehavior() == sm)) {
            sendTo(new RunInitialTransition(), dc);
            return;
        }
    }

    // For all other cases, fallback to the inherited implementation.
    Region::callInitialTransition();
}

void 
tor::TopRegion::finish(ExitPoint* ep /* = 0 */)
{
  if (ep && (ep->m_owner == this)) {
    // If a valid exit point was passed, leave the owning statemachine 
    // through that exit point.
    StateMachine* sm = getStateMachine();
    if (sm)
      sm->leave(ep);
  } else {
    // Otherwise, mark this region as finished, and if all top level
    // regions are finished, finish the statemachine.
    m_finished = true;
    StateMachine* sm = getStateMachine();
    if (sm && !sm->isSubStateMachine() && sm->isFinished()) {
      sm->finish();
    }
  }  
}

