/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
///////////////////////////////////////////////////////////////////////////////
// torTypes.h
// ----------
// C++ implementations of predefined UML2 types
///////////////////////////////////////////////////////////////////////////////

#ifndef __TOR_TYPES__H__
#define __TOR_TYPES__H__

#include "torPlatform.h"

#ifndef TOR_CHARSTRING
#include <string>
#endif

// Unicode macros
#   ifndef _T
#	ifdef _UNICODE
#	    define _T(X)	L##X
#	else
#	    define _T(X)	X
#	endif
#   endif

#   ifndef _TCHAR_DEFINED
#	ifdef _UNICODE
typedef wchar_t TCHAR;
#	else
typedef char TCHAR;
#	endif
#   define _TCHAR_DEFINED
#   endif

#include <stdexcept>

// Type definitions
namespace tor {

#ifndef TOR_BOOLEAN
    typedef bool Boolean;
#else
    typedef TOR_BOOLEAN Boolean;
#endif // TOR_BOOLEAN

#ifndef TOR_CHARACTER
    typedef TCHAR Character;
#else
    typedef TOR_CHARACTER Character;
#endif // TOR_CHARACTER

#ifndef TOR_INTEGER
    typedef int Integer;
#else
    typedef TOR_INTEGER Integer;
#endif // TOR_INTEGER

#ifndef TOR_NATURAL
    typedef unsigned long Natural;
#else
    typedef TOR_NATURAL Natural;
#endif // TOR_NATURAL

#ifndef TOR_REAL
    typedef double Real;
#else
    typedef TOR_REAL Real;
#endif // TOR_REAL

#ifndef TOR_ANY
    class TOR_EXT_DEF Any {

    };
#else
    typedef TOR_ANY Any;
#endif

    // Representation of a reference to any operation
    typedef void* OperationReference;

};

#include "torExceptions.h"

namespace tor {

#ifndef TOR_CHARSTRING
    // A string of characters. Index starts at 1.
    class TOR_EXT_DEF Charstring 
    {
    public:
#   ifdef _UNICODE
        typedef std::wstring StringRepType;
#   else
        typedef std::string StringRepType;
#   endif        
        StringRepType stringRep;

        // Construction
        Charstring() : stringRep(_T("")) {}
        Charstring(const TCHAR* pc) : stringRep(pc ? pc : _T("")) {}

#if TOR_USE_WSTRING
        // Conversion utilities
        static std::string getNarrowString(const wchar_t* s) {
#if defined(WIN32) && !defined(MAINWIN)
            // remove the deprecated warning 4996
            size_t size,t;
            wcstombs_s(&size, NULL, 0, s, _TRUNCATE); // calculate length, includes 0
            char* pszTmp = new char[size]; 
            wcstombs_s(&t,pszTmp, size, s, _TRUNCATE);
#else
            size_t size = wcstombs(NULL, s, wcslen(s));
            char* pszTmp = new char[size + 1]; 
            size_t t = wcstombs(pszTmp, s, size + 1);

#endif
            std::string buf = pszTmp;
            delete [] pszTmp;
            return buf;
        }
#endif

#if TOR_USE_WSTRING
        static std::wstring getWideString(const char* s) {
#if defined(WIN32) && !defined(MAINWIN)
            // remove the deprecated warning 4996
            size_t nMbs = strlen(s);
            size_t nWs;
            mbstowcs_s(&nWs, NULL, 0, s, nMbs);
            wchar_t* pszTmp = new wchar_t[nWs];
            mbstowcs_s(&nMbs, pszTmp, nWs, s, nMbs);
#else
            size_t nMbs = strlen(s) + 1;
            size_t nWs = mbstowcs(NULL, s, nMbs);
            wchar_t* pszTmp = new wchar_t[nWs + 1];
            mbstowcs(pszTmp, s, nMbs);
#endif
            std::wstring buf = pszTmp;
            delete [] pszTmp;
            return buf;
        }
#endif

        // Construction from narrow string
        Charstring(const std::string& s) {
#ifdef _UNICODE
            stringRep = getWideString(s.c_str());
#else
            stringRep = s;
#endif
        }


#if TOR_USE_WSTRING
        // Construction from wide string
        Charstring(const std::wstring& s) {
#ifdef _UNICODE
            stringRep = s;
#else
            stringRep = getNarrowString(s.c_str());
#endif
        }
#endif

        Charstring& operator=(const TCHAR* s) {
            stringRep.operator=(s ? s : _T(""));
            return *this;
        }

        Charstring& operator=(const StringRepType& s) {
            stringRep = s;
            return *this;
        }

        bool operator==(const Charstring& s) const {
            return stringRep == s.stringRep;
        }

        bool operator==(const TCHAR* s) const {
            return operator==(Charstring(s));
        }

        bool operator!=(const Charstring& s) const {
            return stringRep != s.stringRep;
        }

        bool operator!=(const TCHAR* s) const {
            return operator!=(Charstring(s));
        }

        // To allow STL containers of Charstrings 
        // we must have 'less-than' defined
        bool operator<(const Charstring& s) const {
            return stringRep < s.stringRep;
        }

        static Charstring mkstring(Character c) {
            Charstring s;
            s.append(c);
            return s;
        }

        Natural length() const { 
            return static_cast<Natural>(stringRep.size());
        }

        Character first() const throw(EOutOfRange) { 
            try {
                return stringRep.at(0); // operator[] is faster, but without range checks!
            }
            catch (std::out_of_range&){
                throw EOutOfRange();
            }
        }

        Character last() const {
            try {
                return stringRep.at(length() - 1); // operator[] is faster, but without range checks!
            }
            catch (std::out_of_range&){
                throw EOutOfRange();
            }
        }

        void append(Character c) { 
            stringRep.append(1, c); 
        }

        static void append(Charstring& s, Character c) { 
            s.append(c); 
        }

        void insert(Character c, Natural i) {
            StringRepType::iterator it = (stringRep.begin() + (i - 1) /* indexOffset */);
            stringRep.insert(it, c);
        }

        static void insert(Charstring& s, Character c, Natural i) {
            s.insert(c, i);
        }

        static Charstring substring(Charstring& s, Natural from, Natural to) {
            return s.stringRep.substr(from - 1 /* indexOffset */, to + 1 - 1 /* indexOffset */).c_str();
        }

        void remove(Natural index) {
            stringRep.erase(index - 1 /* indexOffset */, index - 1 /* indexOffset */ + 1);
        }

        static void remove(Charstring& s, Natural index) {
            s.remove(index);
        }

        void erase() {
            stringRep.erase();
        }

        static void erase(Charstring& s) {
            s.erase();
        }

        Charstring operator+(const Charstring& s) const { 
            Charstring result( *this );
            result.stringRep.append(s.stringRep.c_str());
            return result;
        }

        Charstring& operator+=(const Charstring& s) {
            stringRep.append(s.stringRep.c_str());
            return *this;
        }

        Character operator[](Natural n) const throw(EOutOfRange) {
            try {
                return stringRep.at(n - 1 /* indexOffset */); // operator[] is faster, but without range checks!
            }
            catch (std::out_of_range&){
                throw EOutOfRange();
            }	    
        }

        Character& operator[](Natural n) throw(EOutOfRange) {
            try {
                return stringRep.at(n - 1 /* indexOffset */); // operator[] is faster, but without range checks!
            }
            catch (std::out_of_range&){
                throw EOutOfRange();
            }	    
        }

        Character operator[](int n) const throw(EOutOfRange) {
            if (n < 1)
                throw EOutOfRange();

            return operator[](static_cast<tor::Natural>(n));
        }

        Character& operator[](int n) throw(EOutOfRange) {
            if (n < 1)
                throw EOutOfRange();

            return operator[](static_cast<tor::Natural>(n));
        }

        operator const TCHAR*() const { 
            return stringRep.c_str();
        }

        const TCHAR* c_str() const {
            return stringRep.c_str();
        }

        // Returns the string as a narrow (single byte) string,
        // converting it from a wide string if necessary.
        std::string getNarrowString() const {
#ifdef _UNICODE	    
            return getNarrowString(stringRep.c_str());
#else
            return stringRep;
#endif
        }

#if TOR_USE_WSTRING

        // Returns the string as a wide (double byte) string,
        // converting it from a narrow string if necessary.
        std::wstring getWideString() const {
#ifdef _UNICODE
            return stringRep;
#else 
            return getWideString(stringRep.c_str());
#endif
        }
#endif

    };  // tor::Charstring

#else
    typedef TOR_CHARSTRING Charstring;
#endif

    // Deleter class used for implementing part semantics for an attribute
    // with single multiplicity.
    template <class T> struct SingleDeleter {
        SingleDeleter(T* t) : m_t(t) {}

        ~SingleDeleter() {
            if (m_t)
                delete m_t;
        }

        T* m_t;
    };

}

inline bool operator==(const TCHAR* a, const tor::Charstring& s)
{
    return (s == a);
}

inline bool operator!=(const TCHAR* a, const tor::Charstring& s)
{
    return !(a == s);
}
inline bool operator==(const tor::Charstring::StringRepType& a, const tor::Charstring& s)
{
    return (s == a.c_str());
}

inline bool operator!=(const tor::Charstring::StringRepType& a, const tor::Charstring& s)
{
    return (s != a.c_str());
}

inline bool operator<(const TCHAR* a, const tor::Charstring& s)
{
    tor::Charstring sa(a);
    return (sa < s);
}

inline bool operator<(const tor::Charstring::StringRepType& a, const tor::Charstring& s)
{
    return (a < s.stringRep);
}


// Inline string-related utility functions
namespace tor
{
    inline int stprintf_address(TCHAR* buffer, const void* addr)
    {
#if defined(WIN32) && !defined(MAINWIN)
        // remove the deprecated warning 4996
#ifdef _UNICODE
        return swprintf_s(buffer, 16, _T("\"%10p\""), addr);	
#else
        return sprintf_s(buffer, 16, _T("\"%10p\""), addr);
#endif // _UNICODE

#else

#ifdef _UNICODE
        return swprintf(buffer, 16, _T("\"0x%x\""), addr);	
#else
        return sprintf(buffer, _T("\"0x%x\""), addr);
#endif // _UNICODE

#endif
    }

    inline int stprintf_number(TCHAR* buffer, int number)
    {
#if defined(WIN32) && !defined(MAINWIN)
        // remove the deprecated warning 4996
#ifdef _UNICODE
        return swprintf_s(buffer, 16, _T("\"%d\""), number);	
#else
        return sprintf_s(buffer, 16, _T("\"%d\""), number);
#endif // _UNICODE

#else

#ifdef _UNICODE
        return swprintf(buffer, 16, _T("\"%d\""), number);	
#else
        return sprintf(buffer, _T("\"%d\""), number);
#endif // _UNICODE

#endif
    }
}


#endif // __TOR_TYPES__H__

