/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
#ifndef __torUtilities_h__
#define __torUtilities_h__

#include "torPlatform.h"

#include "torMetaData.h"
#include "torInstanceManager.h"

TOR_EXT_DEF std::ostream &operator<< (std::ostream &os,  const tor::Charstring &str);

TOR_EXT_DEF std::wostream &operator<<(std::wostream &os, const tor::Charstring &str);

namespace tor {
  
    // Initializes the TOR library. Use this function to explicitly initialize the library.
    // If the library already is initialized nothing will be done.
    TOR_EXT_DEF void initializeLibrary();

    // Finalizes the TOR library. Use this function to explicitly finalize the library.
    // If the library already is finalized nothing will be done.
    TOR_EXT_DEF void finalizeLibrary();

    class Port;
    class Event;
    class EventReceiver;
  
    TOR_EXT_DEF bool sendTo(Event *event, InstanceManager::ObjectId receiverId);

    // Sends an event to a receiver (realizing the EventReceiver interface).
    // Returns true if the event was consumed by the receiver, false otherwise.
    // Afterwards the caller is no longer responsible for the event (i.e. it
    // will be deleted if not consumed).  
    TOR_EXT_DEF bool sendTo(Event* e, EventReceiver* receiver);

#if defined(TOR_USE_INSTRUMENTATION) && !defined(TOR_NO_EVENTMANAGER)
    // Instrumented version of the above
    TOR_EXT_DEF bool sendTo(Event* e, EventReceiver* receiver, const Entity& sender, meta::Type* eventMetaType);
#endif

    // Sends an event via a port.
    // Returns true if the event was consumed by the receiver, false otherwise.
    // Afterwards the caller is no longer responsible for the event (i.e. it
    // will be deleted if not consumed).
    TOR_EXT_DEF bool sendTo(Event* e, Port* pp);

#if defined(TOR_USE_INSTRUMENTATION) && !defined(TOR_NO_EVENTMANAGER)
    // Instrumented version of the above
    TOR_EXT_DEF bool sendTo(Event* e, Port* pp, const Entity& sender, meta::Type* eventMetaType);
#endif

    // Dynamic cast of an event to a specific event type T.
    // If the cast fails, NULL is returned.
    template <class T> 
    inline T cast(const Event* e) {
        return dynamic_cast<T>(e);
    }

    template <class T> 
    inline T cast(Event* e) {
        return dynamic_cast<T>(e);
    }
  
    // Sets the unit of time to be used by the run-time library.
    // The time unit is specified in seconds. 
    // Example: To specify a time unit of 1 millisecond, call 
    // setTimeUnit(0.001)
    TOR_EXT_DEF void setTimeUnit(double seconds);

#if defined(TOR_USE_INSTRUMENTATION) && !defined(TOR_NO_EVENTMANAGER)
    // Break into the Tau Debugger at the action with the specified GUID.
    // Use this function to "compile" a breakpoint into the application.
    TOR_EXT_DEF void debugBreak(const Charstring& strGuid);
#endif

} // tor namespace


#endif // __torUtilities_h__

