package com.telelogic.tau.tor;

import java.util.LinkedList;
import com.telelogic.tau.tor.os.*;

public class EventQueue
{
    public void insert(Event event)
    {
        if (event == null)
            return;

        m_list.add(event);    	
    }
    
    public boolean remove(Event event)
    {
        if (event == null)
            return false;

        return m_list.remove(event);
    }

    // Get the first event off the event queue.
    // Returns null if there are no events in the queue.
    public Event get()
    {
        if (m_list.isEmpty())
            return null;

        Event event = m_list.poll();

        return event;    	
    }
    
    // Get the first event off the event queue.
    // If the queue is empty we wait for the specified time and then return null.
    public Event get(Time timeout)
    {
    	if (empty())
    	{
    		com.telelogic.tau.tor.os.thread.Utilities.suspend(timeout);
    		return null;
    	}
    	else
    		return get();
    }
    
    public boolean empty()
    {
    	return m_list.isEmpty();
    }

    ///////////////////////////////////////////////////////////////////////////////////////////7
    
    protected LinkedList<Event> m_list = new LinkedList<Event>();
}
