package com.telelogic.tau.tor;

import java.util.PriorityQueue;
import com.telelogic.tau.tor.os.*;

public class TimerQueue
{
    void clear()
    {
    	TimerObject to = get();
    	while (to != null) 
    	{
    		to.reset();
    		to = get();
    	}
    	m_t.zero();	
    }
    
    void insert(TimerObject to)
    {
        if (to == null)
            return;

        to.m_timerQueue = this;
        m_list.add(to);

        m_t = m_list.peek().m_t;    	
    }
    
    void remove(TimerObject to)
    {
    	m_list.remove(to);
    	to.m_timerQueue = null;
    	if (!m_list.isEmpty())
    		m_t = m_list.peek().m_t;
    	else
    		m_t.zero();
    }

    TimerObject get()
    {
    	if (m_list.isEmpty())
    		return null;
    	
    	TimerObject to = m_list.poll();
    	if (!m_list.isEmpty())
    		m_t = m_list.peek().m_t;
    	else
    		m_t.zero();
    	
    	return to;
    }
    
    Time getTime()
    {
    	return m_t;
    }
    
    boolean	empty() 
    { 
    	return m_list.isEmpty(); 
    }
	
	////////////////////////////////////////////////////////////////////
	
	protected PriorityQueue<TimerObject> m_list = new PriorityQueue<TimerObject>();
	
	protected Time m_t; // Time for next timer object in the queue to expire.
}
