package com.telelogic.tau.tor.os.thread;

import com.telelogic.tau.tor.os.Time;

public abstract class Utilities
{
	// Suspends the current thread until the indicated timeout has been reached
	public static void suspend(Time timeout)
	{
		try
		{
			Time now = Time.now();
			if (now.compareTo(timeout) >= 0) // now >= timout
				return; // timeout time has already passed
			
			Time diff = new Time(timeout.to_double() - now.to_double());
			
			Thread.sleep(diff.to_ms());
		}
		catch (InterruptedException e)
		{
			// We were interrupted!
		}		
	}
	
	// Returns the ID of the currently executing thread.
	public static long getCurrentThreadId()
	{
		return java.lang.Thread.currentThread().getId();
	}
}
