# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# Utilities for manipulating names of model elements

# Returns the fully qualified name of an element, e.g. X::Y::Z
proc GetQualifiedName { element {asList 0} } {
	set result ""
	set current $element
	while {![u2::IsKindOf $current Session]} {
		set result [linsert $result 0 [GetQuotedString [u2::GetValue $current Name]]]
		set current [u2::GetEntity $current Owner]
	}
	if $asList {
		return $result
	} else {
		return [join $result ::]
	}
}

# Returns relative qualified name of element in scope
proc GetRelativeName { scope element } {
	set scopeName [GetQualifiedName $scope 1]
	set elementName [GetQualifiedName $element 1]
	set result ""
	set elemLength [llength $elementName]
	set scopeLength [llength $scopeName]
	for {set i 0} {($i < $elemLength) || ($i > $scopeLength)} {incr i} {
		if {[lindex $scopeName $i] != [lindex $elementName $i]} {
			break
		}		
	}
	set result [join [lrange $elementName $i end] ::]
	return $result
}

# Returns quoted string if needed
proc GetQuotedString { s } {
	if {![string is alnum $s] && ![regexp {'(.*)'} $s]} {
		return '$s'
	} else {
		return $s
	}
}

# Check if the ref is a Guid (uid:) reference 
proc IsGuidBound { ref } {
	return [regexp {uid:(.*)} $ref]
}

# Bind featureName of element with name instead of GUID.
# Normally the fully qualified name is used. Set fullQualifier to 0
# is a relative qualifier is desired.
proc BindByName { element featureName {fullQualifier 1} } {
 	set nameRef [u2::GetValue $element $featureName]
	set guidRef [u2::GetEntity $element $featureName]
	if {(0 != $guidRef) && [IsGuidBound $nameRef]} {
		if $fullQualifier {
			set refName [GetQualifiedName $guidRef]
		} else {
			set scope [u2::GetEntity $element Owner]
			set refName [GetRelativeName $scope $guidRef]
		}
		SetA $element $featureName $refName
		return 1			
	} else {
		return 0
	}
}

proc CleanUpCombinedRef { nameRefString } {
	if {[regexp {ref:#(.*)#} $nameRefString] != 1} {
		return $nameRefString
	}
	regsub {ref:(.*)} $nameRefString {\1} nameRefString
	set nameRefString [string map {:: :} $nameRefString]
	set combinedList [split $nameRefString :]
	set nameList ""
	foreach elem $combinedList {
		set name ""
		regsub {#(.*)#(.*)#} $elem {\2} name
		lappend nameList $name
	}
	return ref:[join $nameList ::]
}
