# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# Most of the code here is moved from "ModelBrowser.tcl"

package require dialogs

# addin parameters
namespace eval addin {
    # add-in name
    variable name ModelBrowser

    # add-in installation path
    variable path [file join [GetInstallationDirectory] addins $name] 

    # etc dir
    variable etc Etc
    variable images [file join $etc images]
    variable templates [file join $etc templates]
    # script dir
    variable script script
    # generated html dir
    variable html html    
    # u2ignore for generated dir
    variable htmlignore $html.u2ignore
    # generation directory
    variable dst

    # current root element
    variable roots

    proc IsRoot {el} {
        variable roots
        return [expr [lsearch $roots $el] != -1]
    }
    
}


proc transvisibility1 { vis } {
        return $vis
}

proc xsize { sym } {
    return [lindex [u2::GetValue $sym Size] 0]
}

proc ysize { sym } {
    return [lindex [u2::GetValue $sym Size] 1]
}

proc xleft { sym } {
        return [lindex [u2::GetValue $sym Position] 0]
}

proc ytop { sym } {
        return [lindex [u2::GetValue $sym Position] 1]
}

proc xright { sym } {
        return [expr [lindex [u2::GetValue $sym Position] 0] + [lindex [u2::GetValue $sym Size] 0]]
}

proc ybottom { sym } {
        return [expr [lindex [u2::GetValue $sym Position] 1] + [lindex [u2::GetValue $sym Size] 1]]
}

proc GetCenter { pside psymbol } {
        set Position [u2::GetValue $psymbol Position]
        set Size [u2::GetValue $psymbol Size]
        
        scan $Position "%d%d" x y
        scan $Size "%d%d" dx dy
        
        set rx [expr $x]
        set ry [expr $y]
        
        if { "$pside" == "top" } { set rx [expr $x + $dx / 2] }
        if { "$pside" == "center" } { set rx [expr $x + $dx / 2] }
        if { "$pside" == "left" } { set ry [expr $ry + $dy / 2] }
        if { "$pside" == "center" } { set ry [expr $y + $dy / 2] }
        if { "$pside" == "right" } { 
                set ry [expr $ry + $dy / 2]
                set rx [expr $rx + $dx]
        }
        if { "$pside" == "bottom" } {
                set rx [expr $x + $dx / 2]
                set ry [expr $ry + $dy]
        }
        
        return "$rx $ry"
}

# Determine if there is a first diagram node under the current
# entity and if so add a "diagram link" to the current node. 
# To be called from within the expression for "nodeText" inside
# tree::StartNode.
    proc InsertLinkToOwnedDiagram { el bFromDiagram } {
        if { $el == 0 } return
	if { [catch {set eld [u2::GetEntity $el Diagram] } res] } {
	    #   This is not an error condition. Metamodel doesn't allow
	    #   diagrams here. 

	    # uspibe June 26, 2008
	    # Special cases
	    # Could be incomplete
	    if [u2::IsKindOf $el Attribute] {
	    	set el [u2::GetEntity $el Type]
        	return [InsertLinkToOwnedDiagram  $el $bFromDiagram]
	    }
            if [u2::IsKindOf $el Operation] {
	    	set el [u2::GetEntity $el InlineMethod]
        	return [InsertLinkToOwnedDiagram  $el $bFromDiagram]
	    }
            if [u2::IsKindOf $el ActionNode] {
	    	set el [u2::GetEntity $el Activity]
        	return [InsertLinkToOwnedDiagram  $el $bFromDiagram]
	    }

	    # No link generated.
	    return
	} else {
	    if { $eld == 0 } {
		# Diagram allowed but not present. No link generated.
		return
	    }
	    set Path "."
	    if { $bFromDiagram } {
		set Path ".."
	    }
	    set Path "$Path/[nodes::GetDir $eld]/[nodes::GetIdD $eld].html"
	    # Diagram(s) present. Link generated.
	    return "onclick=\"javascript:window.open('$Path','Diagram')\""
	}
    }


proc html_map_start { id } {
        write "<MAP id =\"$id\" name=\"$id\">\n"
}

#
# e.g. RECT 0,0,100,100 link1 content "Definition of Class1"
#
proc html_map_area { shape coords href targetframe alt mel } {
        write "<AREA SHAPE=\"$shape\" COORDS=\"$coords\" HREF=\"$href\" TARGET=\"$targetframe\" ALT=\"$alt\" [InsertLinkToOwnedDiagram $mel 1] />\n"
}

proc html_map_end { } {
        write "</MAP>\n"
}

proc html_image1 { src width map } {
        if { $width == "" } {
                if { $map == "" } {
                        # No width parameter is given
                        write "<IMG SRC=\"$src\" style=\"border: none\"/>"
                } else {
                        write "<IMG SRC=\"$src\" USEMAP=\"$map\" style=\"border: none\"/>"
                }
        } else {
                if { $map == "" } {
                        # Use given width parameter
                        write "<IMG SRC=\"$src\" WIDTH=$width/>"
                } else {
                        write "<IMG SRC=\"$src\" WIDTH=$width USEMAP=\"$map\"/>"
                }
        };#end_if no width is given
};#end_html_image

namespace eval dbg {
    # debugging flag
    variable debug 0
    # set filename to desired output file
    variable filename
    variable file
    
    proc Output str {
        variable debug
        if { $debug } { 
            if { [info exists file] } {
                puts -nonewline $file $str
                flush $file
            } else {
                std::Output $str 
            }
        }
    }

    if $debug {
        # create default debug file name if not exists
        if { [info exists filename] && $filename != "" } {
            if { [catch { file mkdir [file dirname $filename] } err] || [catch {set file [open $filename w]} err] } {
                Output $err
            }
        }
    }

}

namespace eval progress {

    variable width 80
    variable curwidth 0
    variable total 0
    variable processed 0

    proc Dot {} {
        variable width
        variable curwidth
        variable processed
        if { $curwidth > $width } {
            set curwidth 0
            std::Output "\n"
        }
        Progress
        std::Output "."
        incr curwidth
        incr processed
    }

    proc Err msg {
        variable width
        variable curwidth
        variable processed
        set curwidth 0
        std::Output "\nError: $msg\n"
        Progress
        incr processed
    }

    proc Reset { msg {t 0} } {
        variable curwidth
        variable total
        variable processed
        set curwidth 0
        set total $t
        set processed 0
        std::Output "\n$msg...\n"
        Progress
        incr processed
   }

    proc Done {} {
        std::Output "\nDone.\n"
    }

    proc Progress {} {
        variable curwidth
        variable total
        variable processed
        if { $curwidth == 0 } {
            if { $total != 0 } {
                set str "$processed of $total "
            } else {
                set str ""
            }
            std::Output $str
            incr curwidth [string length $str]
        }
    }

}


proc SetNamingScheme roots {

    set ns GuidBased
    if { [llength $roots] > 0 } {
        set model [u2::GetEntity [lindex $roots 0] Session]
        if { [set nsv [u2::GetTaggedValue $model {ModelBrowserSettings(.namingScheme.)}]] != 0 } {
            set ns [u2::GetValue $nsv Name]
        }
    }

    set gns {
        variable charmap {
            *   -
            /   -
            \\  -
            :   -
            ;   -
            ?   -
        }
        variable cache

        # mangles guid to be used as file name
        proc mangle id {
            variable charmap
            string map $charmap $id
        }

        proc GetFile id {
            variable cache
            set cache($id) [mangle $id]
        }

        proc GetId el {
            u2::GetValue $el Guid
        }

        proc GetIdI el {
            return "i[GetIdF $el]"
        }

        proc GetIdD el {
            return "d[GetIdF $el]"
        }

        proc Check {} {
            variable cache
            foreach id [array names cache] {
                set fid [mangle $cache($id)]
                if { $::tcl_platform(platform) == "windows" } {
                    set fid [string tolower $fid]
                }
                if { [info exists n($fid)] } {
                    std::Output "Warning: Filename collisions are encountered during generation. Your report is incomplete."
                    return
                }
                set n($fid) 1
            }
        }
    }

    set sns {
        variable cache
        variable num -1

        proc GetFile id {
            return $id
        }

        proc get key {
            variable cache
            variable num
            if { [info exists cache($key)] } { return $cache($key) }
            return [set cache($key) [format "%0.4d" [incr num]]]
        }

        proc GetId el {
            get [u2::GetValue $el Guid]
        }

        proc GetIdI el {
            return "info-[GetIdF $el]"
        }

        proc GetIdD el {
            return "diag-[GetIdF $el]"
        }

        proc Check {} {
        }
    }

    set ons {
        variable num

        variable charmap {
            {$} {$d}
            *   {$s}
            /   {$a}
            \\  {$b}
            ^   {$u}
            _   {$l}
            { } {$p}
            :   {$c}
            ;   {$e}
            {@} {$t}
        }
        foreach ch [split "abcdefghijklmnopqrstuvwxyz" {}] {
            lappend charmap $ch _$ch [string toupper $ch] ^$ch
        }

        # mangles guid to be used as file name
        proc GetFile id {
            variable charmap
            string map $charmap $id
        }

        proc GetId el {
            u2::GetValue $el Guid
        }

        proc GetIdI el {
            return "info-[GetIdF $el]"
        }

        proc GetIdD el {
            return "diag-[GetIdF $el]"
        }

        proc Check {} {
        }
    }

    set cns {
        # returns ID mangled for filesystem
        proc GetIdF el {
            GetFile [GetId $el]
        }

        proc GetDir el {
            set owner [u2::GetOwner $el]
            if { $owner == 0 } { set owner $el }
            GetIdF $owner
        }
    }

    switch $ns GuidBased { set uns $gns } Simple { set uns $sns } default { set uns $ons }

    if { [ namespace exists nodes] } { namespace delete nodes }
    namespace eval nodes $uns
    namespace eval nodes $cns
}

# read a template file and return its contents as a string
namespace eval tmpl {
    variable cache
    proc read { name } {
        variable cache
        if { [info exists cache($name)] } { return $cache($name) }
        if { [catch {set infile [open [file join $addin::path $addin::templates "$name.tmpl" ] ] } res] } {
                dbg::Output "\nCannot open $name: $res\n"
                return ""
        } else {
                # Read and process the file
                set text [::read $infile]
                # then close it ...
                close $infile
                return [set cache($name) $text]
        }        
    }
}


# use like: lsort -command ElementNameCompare $list
proc ElementNameCompare {a b} {
    set aname [GetElementName $a]
    set bname [GetElementName $b]
    set res [string compare -nocase $aname $bname]
    return $res
}

proc GetReference { el {mc 0} } {
    if { $el == 0 } return ""
    set text ""

    if { [tree::NodeExists $el] } {
        if { $mc } {
            set text "<A href=\"../[nodes::GetDir $el]/[nodes::GetIdI $el].html\" target=\"Info\">[ElementText $el]</A>"
        } else {
            set text "<A href=\"../[nodes::GetDir $el]/[nodes::GetIdI $el].html\" target=\"Info\">[CorrectForHTML [GetElementName $el]]</A>"
        }
    } elseif { [u2::IsKindOf $el Definition] } {
        if { $mc } {
            set text [ElementText $el]
        } else {
            set text [CorrectForHTML [GetElementName $el]]
        }
    } elseif { [u2::IsKindOf $el Ident] } {
        set text [CorrectForHTML [u2::GetValue $el Name]]
    } elseif { [u2::IsKindOf $el Session] } {
        set text Model
    }

    return $text
}

proc AppendMFChildren { lst el mc mf } {
    upvar $lst l
    if { [u2::IsKindOf $el $mc] } {
        foreach le [lsort -command ElementNameCompare [u2::GetEntities $el $mf]] {
            lappend l $le
        }
    }
}

proc getChildren { el } {

    if { $el == "" || $el == 0 } { return [list] }
    set res [list]

    #diagrams...
    AppendMFChildren res $el DiagramContainingScope Diagram
    
    # OwnedMember
    AppendMFChildren res $el Namespace OwnedMember
    
    
    # nodes of ActivityImplementation
    AppendMFChildren res $el ActivityImplementation Node

    # inline activity
    AppendMFChildren res $el ActivityContainer InlineActivity

    AppendMFChildren res $el Operation InlineMethod
    
    #inline type
    AppendMFChildren res $el Typed InlineType

    # internals
    AppendMFChildren res $el ImplementationContainer Implementation

    # states
    AppendMFChildren res $el SimpleStateMachine State

    #
    AppendMFChildren res $el GenericState InlineStateMachine

    AppendMFChildren res $el PerformanceContainer Performance


    set res1 [list]
    foreach e $res {
        if { [HasInfo $e] } {
            lappend res1 $e
        }
    }
    return $res1
}

proc ReportPresentations { el headingLevel } {

    set dlist {}
    foreach de [u2::GetReferingEntities $el Definition] {
        if ![u2::IsKindOf $de DiagramElement] continue
        set diagram [u2::GetEntity $de Diagram]
        if { 0 != $diagram && [tree::DiagramExists $diagram] } {
            lappend dlist $diagram
        }
    }
 
    set dlist [lsort -unique $dlist]
 
    set p ""
    foreach diag $dlist {
        append p "<li><A href=\"../[nodes::GetDir $diag]/[nodes::GetIdD $diag].html\" target=\"Diagram\">\
                       [u2::GetValue $diag Name] ([CorrectMetaClassName $diag])</A></li>\n"
    }
 
    if { $p != "" } {
        html_heading $headingLevel "" "Presentations"
        write "<ul>$p</ul>"
    }

}

namespace eval bmp {
    # list bitmaps existing in etc/icons addin directiry
    variable list [glob -directory [file join $addin::path Etc images] -tails *.gif]

    # array of user-defined icons
    variable icons
    variable icon_cnt

    proc Reset {} {
        variable icons
        variable icon_cnt
        array set icons {}
        set icon_cnt 0
    }

    proc GetFileName str {
        if { [regexp {^urn:(.*)$} $str - m] } {
            if { [regexp {^u2:(.*)$} $m - f] } {
                return [file join [std::GetInstallationDirectory] $f]
            } else {
                return $m
            }
        } else {
            return $str
        }
    }

    proc GetIconProperty el {
        set tv [u2::GetTaggedValue $el "icon(.icon16x16.)"]
        if { $tv != 0 } {
            set file [GetFileName [u2::GetValue $tv Value]]
            if { $file != "" } {
                set file [file normalize $file]
                if { [file exists $file] } { return $file }
            }
        }
        return ""
    }

    # returns first available icon for element
    proc GetIcon el {
        variable icons
        set file [GetIconProperty $el]
        if { $file != "" } { return $file }
        foreach ie [u2::GetEntities $el StereotypeInstance] {
            set st [u2::GetEntity $ie InstanceOf]
            if { $st != 0 } {
                set file [GetIconProperty $st]
                if { $file != "" } { return $file }
            }
        }
        return ""
    }

    proc Get el {
        variable list
        variable icons
        variable icon_cnt
        set icon_tv [GetIcon $el]
        set icon_mc [CorrectMetaClassName $el].gif
        if { $icon_tv != "" } {
            if { [info exists icons($icon_tv)] } {
                set icon1 $icons($icon_tv)
            } else {
                set ext [file extension $icon_tv]
                set icon1 "icon_${icon_cnt}[file extension $icon_tv]"
                set icons($icon_tv) $icon1
                incr icon_cnt
            }
            return "<IMG SRC=\"images/$icon1\" WIDTH=\"16\" HEIGHT=\"16\"/>"
        }
        if { [lsearch $list $icon_mc] >= 0 } {
            return "<IMG SRC=\"images/$icon_mc\" WIDTH=\"16\" HEIGHT=\"16\"/>"
        } else {
            return ""
        }
    }

    proc Copy {} {
        variable icons
        foreach bmp [glob -directory [file join $addin::path Etc images] *] {
            if { [catch { file copy $bmp [file join $addin::dst images] } err] } {
                dbg::Output "$err\n"
            }
        }

        foreach {src dst} [array get icons] {
            if { [catch { file copy $src [file join $addin::dst images $dst] } err] } {
                dbg::Output "$err\n"
            }  
        }
    }
}

proc ElementText el {
    set name [GetElementName $el]
    set clas [GetBrowserMetaClassName $el]
    set ownr [u2::GetOwner $el]
    if { $ownr != 0 && [u2::IsKindOf $el Method] } {             
            return "$clas of [GetElementName $ownr]"
    }
    if { $name != "" } {
        if { $clas != "" } {
            if { $name != $clas } {
                return "$name ($clas)"
            } else {
                return "$name"
            }
        } else {
            return $name
        }
    } else {
        if { $clas != "" } {
            return "$clas"
        } else {
            return ""
        }
    }
}

namespace eval tree {
    variable divs
    variable nodes
    variable diagrams
    
    proc Collect { msg } {
        progress::Reset $msg
        foreach root $addin::roots {
            Collect1 $root
        }
        progress::Done
    }

    proc Collect1 { el } {
        if { $el == 0 } { return }

        set children [getChildren $el]

        StartNode $el [llength $children] [u2::IsKindOf $el Diagram]

        progress::Dot
    
        foreach child $children {
            Collect1 $child
        }

        EndNode
    }

    proc ProcessNodes { func msg } {
        variable nodes
        progress::Reset $msg [array size nodes]
        foreach el [array names nodes] { 
            if { [catch { eval $func $el } err] } {
                progress::Err $err
            } else {
                progress::Dot
            }
        }
        progress::Done
    }

    proc ProcessDiagrams { func msg } {
        variable diagrams
        progress::Reset $msg [array size diagrams]
        foreach el [array names diagrams] {
            if { [catch { eval $func $el } err] } {
                progress::Err $err
            } else {
                progress::Dot
            }
        }
        progress::Done
    }
    
    proc StartNode { el children is_diagram } {
        variable divs
        variable nodes
        variable diagrams

        set nodeId [nodes::GetId $el]

        if { [addin::IsRoot $el] } {
            set nodeClass "root"
        } elseif { [llength $children] > 0 } {
            set nodeClass "parent"
        } else {
            set nodeClass "leaf"
        }
        if { $children > 0 } {
            set nodeImage "plus"
        } else {
            set nodeImage "empty"
        }

        set nodeIcon [bmp::Get $el]

        if { $is_diagram } {
            set nodeText "<A href=\"[nodes::GetDir $el]/[nodes::GetIdI $el].html\" \
                             target=\"Info\" \
                             onclick=\"javascript:window.open('[nodes::GetDir $el]/[nodes::GetIdD $el].html','Diagram')\">\
                           [ElementText $el]</A>\n"
        } else {
            set nodeText "<A href=\"[nodes::GetDir $el]/[nodes::GetIdI $el].html\" \
                             [InsertLinkToOwnedDiagram $el 0]
                             target=\"Info\">\
                           [ElementText $el]</A>\n"
        }

        append divs [subst -nocommands [tmpl::read div]]

        set nodes($el) 1
        if { $is_diagram } {
            set diagrams($el) 1
        }
    }

    proc EndNode {} {
        variable divs
        append divs "</DIV>\n"
    }

    proc NodeExists { el } {
        variable nodes
        return [info exists nodes($el)]
    }

    proc DiagramExists { el } {
        variable diagrams
        return [info exists diagrams($el)]
    }

    proc WriteTree {} {
        variable divs
        set navText $divs
        set nav [subst -nocommands [tmpl::read navigation]]
        writehtmlfile navigation $nav
    }

    proc Cleanup {} {
        variable divs {}
        variable nodes
        variable diagrams
        array unset nodes
        array unset diagrams
    }
}

# write text to the specified file
proc writehtmlfile { filename text } {
        set ofilename [file join $addin::dst $filename.html]
        if { [catch {set infile [open $ofilename w] } res] } {
                Output"\nCannot open $ofilename: $res\n"
        } else {
                puts -nonewline $infile $text
                close $infile
        }
}

proc HasInfo el {
    if { $el == 0 } { return 0 }
    if { [u2::GetTaggedValue $el "profile(..)"] != 0 } { return 0 }
    if { [u2::GetTaggedValue $el "hidden(..)"] != 0 } { return 0 }
    if { [u2::IsKindOf $el Diagram] } { return 1 }
    set mc [u2::GetMetaClassName $el]
    set metaClassesWithInfo [list Session Class Operation Attribute StateMachine Collaboration Signal Interface Package ActionNode Artifact Association Choice DataType Interface Internals State SignalList Stereotype Syntype Timer ActivityImplementation Interaction OperationBody StateMachineImplementation InteractionImplementation Performance SimpleStateMachine Connector Port]
    set r [lsearch $metaClassesWithInfo $mc]
    if { $r == -1 } { return 0 } else { return 1 }
}

# return 1 if the diagram element should not have a hyperlink
proc canIgnoreDiagramElement { diagel } {

    if { [u2::IsKindOf $diagel FrameSymbol] } { return 1 }
    if { ![u2::IsKindOf $diagel AreaComponent] } { return 1 }

    if { [u2::IsKindOf $diagel PresentationElement] } {
        set me [u2::GetEntity $diagel ModelElement]
        if { [tree::NodeExists $me] } {
            return 0
        }
    }

    return 1
}

# returns list of diagram elements that referred to model elements
# in specific order (elements that can contain other elements come last)
proc GetDiagramElements d {
    set l1 {}
    set l2 {}
    if { $d == 0 || ![u2::IsKindOf $d Diagram] } { return {} }
    variable compositeElements {SubjectSymbol PartitionReferenceSymbol}
    foreach el [u2::GetEntities $d DiagramElement] {
        if { [u2::IsKindOf $el AreaComponent] && ![u2::IsKindOf $el FrameSymbol] } {
            if { [u2::IsKindOf $el PresentationElement] } {
                set me [u2::GetEntity $el ModelElement]
                if { [tree::NodeExists $me] } {
                    if { [lsearch $compositeElements [u2::GetMetaClassName $el]] >= 0 } {
                        lappend l2 $el
                    } else {
                        lappend l1 $el
                    }
                }
            }
        }
    }
    foreach el $l2 {
        lappend l1 $el
    }
    return $l1
}

proc jpeg_read_1_byte ch {
    if { [eof $ch] } { return -1 }
    set b [read $ch 1]
    if { ![binary scan $b c b] } { return -2 }
    return [expr $b & 0xff]
}

proc jpeg_read_2_byte ch {
    if { [eof $ch] } { return -1 }
    set b [read $ch 2]
    if { ![binary scan $b S b] } { return -1 }
    return [expr $b & 0xffff]
}

proc jpeg_first_marker ch {
    set c1 [jpeg_read_1_byte $ch]
    set c2 [jpeg_read_1_byte $ch]
    if { [expr $c1 == 0xff && $c2 == 0xd8] } { return $c2 } else { return -1 }
}

proc jpeg_next_marker ch {
    set c [jpeg_read_1_byte $ch]
    if { $c < 0 } { return -1 }
    while { $c != 0xff } {
        set c [jpeg_read_1_byte $ch]
        if { $c < 0 } { return -2 }
    }
    while { $c == 0xff } {
        set c [jpeg_read_1_byte $ch]
        if { $c < 0 } { return -3 }
    }
    return $c
}

proc jpeg_skip_marker ch {
    set s [jpeg_read_2_byte $ch]
    if { $s < 0 } { return -1 }
    read $ch [expr $s - 2]
}

proc jpeg_read_size f {
    array set s {0 -1 1 -1 2 -1 3 -1}
    
    set ch [open $f r]
    fconfigure $ch -encoding binary -translation binary

    if { [jpeg_first_marker $ch] < 0 } {
        close $ch
        return [array get s]
    }

    set cont 1
    while { $cont } {
        set m [jpeg_next_marker $ch]

        if { $m < 0 } {
            close $ch
            return [array get s]
        }

        if { $m >= 0xc0 && $m <= 0xcf} {
            set cont 0
            jpeg_read_2_byte $ch; # length
            jpeg_read_1_byte $ch; # precision
            set h [jpeg_read_2_byte $ch]
            set w [jpeg_read_2_byte $ch]

            close $ch
            
            if { $h >= 0 && $w >= 0} {
                set s(2) $w
                set s(3) $h
            }
            return [array get s]
        } else {
            jpeg_skip_marker $ch
        }

    }
}


# create html for the view of a diagram: a html wrapper and an image
proc CreateDiagram { d } {
    global HTMLReportFileName
    if { ![u2::IsKindOf $d Diagram] } return
    if { [u2::HasAppliedStereotype $d hidden] } return
    set nodeid [nodes::GetId $d]
    set dfimgName "[nodes::GetIdD $d]"
    set dfname [file join $addin::dst [nodes::GetDir $d] $dfimgName] ;# Set image file name
    set pname [u2::GetValue $d Name]
    set HTMLReportFileName $dfname.html  ;# Set output filename
    OpenOutputFile $HTMLReportFileName
    dbg::Output "Generating diagram $pname to $HTMLReportFileName\n"

    # Initialize HTML output file content
    html_init
    html_autoinit
    html_head "HTML Report for Diagram $pname"
    html_body_start
    set diagramParent [u2::GetOwner $d] ;# Get diagram encapsulating entity
    if { [u2::IsKindOf $d TextDiagram] && [u2::IsKindOf $diagramParent OperationBody] } {
        # Diagram IS Text Diagram AND parent of diagram is operation
        set unparseddef [u2::Unparse $diagramParent]  ;# diagramParent IS NOT operation, but OperationBody!!
        set unparseddef [string trim $unparseddef "{ }"]
        regsub -all "\r" $unparseddef "" unparseddef
        html_pre_code $unparseddef
    } else {
        # Diagram shall be saved in image file
        set dfpath [file join $addin::dst $dfname.jpg] ;# Set image file path
        # Generate diagram image file
        u2::GenerateImage $d JPEG $dfpath
        
        # discover image size...
        array set pxs [jpeg_read_size $dfpath]

        set xscale [expr double($pxs(2)) / [xsize $d]]
        set yscale [expr double($pxs(3)) / [ysize $d]]
        set xdelta 0
        set ydelta 0

        html_image1 "$dfimgName.jpg" "" "#map_$nodeid" ;# Insert picture in report without constraints (may not fit to page)
        # now create the image map
        html_map_start "map_$nodeid"

        foreach diagel [GetDiagramElements $d] {
            set mel [u2::GetEntity $diagel ModelElement]
            if { $mel == 0 } continue
            set x1 [expr [xleft $diagel] * $xscale - $xdelta]
            set x2 [expr [xright $diagel] * $xscale - $xdelta]
            set y1 [expr [ytop $diagel] * $yscale - $ydelta]
            set y2 [expr [ybottom $diagel] * $yscale - $ydelta]
            set coords "$x1,$y1,$x2,$y2"
            set alt "[GetElementName $mel] ([GetBrowserMetaClassName $mel])"
            html_map_area RECT $coords "../[nodes::GetDir $mel]/[nodes::GetIdI $mel].html" Info $alt $mel
        }
        html_map_end
    }
    # End of Report
    html_body_end
    html_end

    # Close report file
    CloseOutputFile

}

# create html for the information on an element; just an html file
proc CreateInfo { el } {
        # output progress display
        global HTMLReportFileName
        set HTMLReportFileName [file join $addin::dst [nodes::GetDir $el] "[nodes::GetIdI $el].html"]  ;# Set output filename
        set pname [GetElementName $el]
        file mkdir [file dirname $HTMLReportFileName]              ;# Create output directory
        OpenOutputFile $HTMLReportFileName
        dbg::Output "Generating HTML Report to $HTMLReportFileName\n"

        # Initialize HTML output file content
        html_init
        html_autoinit
        html_head "HTML Report for $pname"
        html_body_start

        html_print "<div style=\"float: right\"><a href=\"../intro.html\" target=\"Diagram\">Home</a></div>"
        
        ReportStdElement $el 1

        # End of Report
        html_body_end
        html_end
        
        # Close report file
        CloseOutputFile
}

proc GenerateHTMLReport {} {

    # make active project directory current one
    set addin::dst [std::DirectoryDialog -fromdir [std::GetProjectPath [std::GetActiveProject]]]
    if { $addin::dst == 0 } return
    file mkdir $addin::dst
    file mkdir [file join $addin::dst images]

    SetNamingScheme $addin::roots

    # create .u2ignore file for html directory for discovery based loading
    catch {[close [open $addin::htmlignore w]]}

    # Step 0 - work out what we are collecting info from (the root)
    #set addin::root [std::GetSelection]
    #set root_name [GetElementName $ents]
    #set root_metaclass [GetBrowserMetaClassName $ents]

    Output "Performing HTML generation...\n"

    set t1 [clock seconds]

    # reset icons...
    bmp::Reset

    tree::Collect "Collecting nodes"
    tree::WriteTree

    set navTime [clock format [clock seconds] -format " %H:%M:%S on %a %b %d %Y"]
    writehtmlfile intro [subst -nocommands [tmpl::read intro]]

    tree::ProcessNodes CreateInfo "Creating info files"
    tree::ProcessDiagrams CreateDiagram "Creating diagram files"

    set frames [tmpl::read frameset]
    writehtmlfile index $frames

    tree::Cleanup
    bmp::Copy

    # step 3 open the generated report
    Output "\nOpening [file join $addin::dst index.html]\n"
    std::HtmlReport [file join $addin::dst index.html]
    nodes::Check
    Output "\nDone in [expr [clock seconds] - $t1] seconds\n\n"
}
