# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# Modelbrowser generates frames-based HTML to browse your model
# There are three panes:
#  top-left: navigation tree of the model
#  top-right: Diagram viewing space
#  bottom: textual information about the selected element
#

# Much of the code is moved from this file to "GenerateHTMLReport.tcl"

package require commands

# produce HTML report
proc OnActivateModelBrowser { cmdName } {
 GenerateHTMLReport
}

# a robust test to see if sel is of metaclass
proc isMeta { sel metaclass } {
    if { [catch { set enable [u2::IsKindOf $sel $metaclass] } ] } { ;# catch useful when session element is selected
                set enable 0
        }
        if { $enable != 1 } {
                return 0
        }
        return 1
}

# a robust test to see if sel is the Session
proc isSession { sel } {
        if { $sel == 0 } {
                return 0
        }
        if [catch { set Owner [u2::GetEntity $sel Owner] } ] { ;# catch in case something else is selected
        }
        if { [info exists Owner] } {
                if { $Owner == 0 } {
                        return 1
                }
        }
        return 0
}

# enable addin when nothing, the session, or a single package is selected
proc OnEnableModelBrowser { e } {
    set addin::roots {}
    set sel [std::GetSelection]
    set selection {}
    set curProject [std::GetActiveProject]
    foreach el $sel {
        if { $el == $curProject } {
            set el [std::GetModels -kind U2 -project $curProject]
        }
        # do not append element if it's already in the list
        if { [lsearch -exact $selection $el] == -1 } {
            lappend selection $el
        }
    }
    foreach el $selection {
        set ok [expr {![catch { set hi [HasInfo $el] } ] && $hi}]
        if {$ok} {
            set o [u2::GetOwner $el]
            while {$ok && $o != 0} {
                if {[lsearch $selection $o] != -1} {
                    set ok 0
                }
                set o [u2::GetOwner $o]
            }
        }
        if {$ok} {
            lappend addin::roots $el
        }
    }
    if {[llength $addin::roots]} {
        return 1
    } else {
        return 0
    }
}

proc Init {} {
    std::AddCommand -variable ModelBrowserCmd -name "Generate HTML" -statusmessage "Generate HTML report"  -tooltip "Generate HTML report" -imagefile [file join $addin::path Etc $addin::name.bmp] -OnActivateCommand OnActivateModelBrowser -OnEnableCommand OnEnableModelBrowser
    std::AddToolbar -variable "Model Browser" -commands ModelBrowserCmd
    std::AddMenu -variable ModelBrowserMenu -commands { ModelBrowserCmd } -path {&Tools} -position first
}

# load the rest of scripts...
set localName ModelBrowser
set localPath [file join [GetInstallationDirectory] addins $localName] 
set this [file normalize [file join $localPath Script ${localName}.tcl ]]
foreach inc [glob -dir [file dirname $this] *.tcl] {
  if { $this != [file normalize $inc] } {
    #dbg::Output "loading $inc...\n"
    if { [catch { source $inc } err] } {
        std::Output "error while loading $inc: $err\n"
    }
  }
}

Init
