# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

# HTML library functions

proc html_init {} {
  writeln "<HTML>"
}

proc html_end {} {
  writeln "</HTML>"
}

proc html_head { title {extra ""}} {
  writeln "<HEAD>"
  writeln "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=utf-8\">"
  write "<TITLE>"
  write $title
  writeln "</TITLE>"
  writeln $extra
  writeln "</HEAD>"
}

proc html_heading { level align heading } {
  if { $align != "" } {
    write "<H$level align=\"$align\">"
  } else {
    write "<H$level>"
  }
  write $heading
  writeln "</H$level>"
}

proc html_paragraph_start {} {
  write "<P>"
}

proc html_paragraph_end {} {
  writeln "</P>"
}

proc html_paragraph { str } {
  html_paragraph_start
  write $str
  html_paragraph_end
}

proc html_body_start {} {
  set margin 20
  writeln "<BODY LEFTMARGIN=$margin TOPMARGIN=$margin MARGINWIDTH=$margin MARGINHEIGHT=$margin>"
}

proc html_body_end {} {
  writeln "</BODY>"
}

proc html_print { str } {
  write $str
}

proc html_hr {} {
  write "<HR>"
}

proc html_em { str } {
  write "<EM>"
  write $str
  write "</EM>"
}

proc html_strong { str } {
  write "<STRONG>"
  write $str
  write "</STRONG>"
}

proc html_code { str } {
  write "<CODE>"
  write $str
  write "</CODE>"
}

proc html_samp { str } {
  write "<SAMP>"
  write $str
  write "</SAMP>"
}

proc html_kbd { str } {
  write "<KBD>"
  write $str
  write "</KBD>"
}

proc html_var { str } {
  write "<VAR>"
  write $str
  write "</VAR>"
}

proc html_dfn { str } {
  write "<DFN>"
  write $str
  write "</DFN>"
}

proc html_cite { str } {
  write "<CITE>"
  write $str
  write "</CITE>"
}

proc html_pre { str } {
  write "<PRE>"
  write $str
  write "</PRE>"
}

proc html_pre_code { str } {
  write "<PRE>"
  html_code $str
  write "</PRE>"
}

proc html_br {} {
  write "<BR>"
}

proc html_list_start {} {
  write "<UL>"
}

proc html_list_end {} {
  write "</UL>"
}

proc html_bullet_start { } {
  write "<LI>"
}

proc html_bullet_end { } {
  write "</LI>"
}

proc html_bullet { str } {
  write "<LI>"
  write $str
  write "</LI>"
}

proc html_image { src zoom } {

  if { $zoom == "" } {

    # No zoom parameter is given
    write "<IMG SRC=\"$src\">"

  } else {

    # Use given zoom parameter
    write "<IMG SRC=\"$src\" WIDTH=$zoom\%>"

  };#end_if no zoom is given

};#end_html_image


proc html_href_start { href } {
  write "<A HREF=\"$href\">"
}

proc html_href_end {} {
  write "</A>"
}

proc html_href { href str } {
  html_href_start $href
  write $str
  html_href_end
}

proc html_name_start { name } {
  write "<A NAME=\"$name\">"
}

proc html_name_end {} {
  write "</A>"
}

proc html_name { name str } {
  html_name_start $name
  write $str
  html_name_end
}

proc html_table_start { } {
    write "<TABLE BORDER=\"1\">"
}

proc html_table_wcaption_start { caption } {
  write "<TABLE BORDER=\"1\">"

  write "<CAPTION>"
  write $caption
  write "</CAPTION>"
}

proc html_table_end {} {
  write "</TABLE>"
}

proc html_table_row_start {} {
  write "<TR>"
}

proc html_table_row_end {} {
  write "</TR>"
}

proc html_table_heading { str } {
  write "<TH>"
  write $str
  write "</TH>"
}

proc html_table_heading_colspan { str span } {
  write "<TH COLSPAN=\"$span\">"
  write $str
  write "</TH>"
}

proc html_table_heading_rowspan { str span } {
  write "<TH ROWSPAN=\"$span\">"
  write $str
  write "</TH>"
}

proc html_table_cell_start {} {
  write "<TD>"
}

proc html_table_cell_end {} {
  write "</TD>"
}

proc html_table_cell { str } {
  html_table_cell_start
  write $str
  html_table_cell_end
}

proc html_table_cell_colspan { str span } {
  write "<TD colspan=\"$span\">"
  write $str
  write "</TD>"
}

proc html_table_cell_rowspan { str span } {
  write "<TD rowspan=\"$span\">"
  write $str
  write "</TD>"
}

set _htmllevel1 0
set _htmllevel2 0
set _htmllevel3 0
set _htmllevel4 0
set _htmllevel5 0
set _htmllevel6 0
set _htmllevel7 0

proc html_autoinit {} {
  global _htmllevel1
  global _htmllevel2
  global _htmllevel3
  global _htmllevel4
  global _htmllevel5
  global _htmllevel6
  global _htmllevel7

  set _htmllevel1 0
  set _htmllevel2 0
  set _htmllevel3 0
  set _htmllevel4 0
  set _htmllevel5 0
  set _htmllevel6 0
  set _htmllevel7 0
}

proc html_autonumber { level } {

  global _htmllevel1
  global _htmllevel2
  global _htmllevel3
  global _htmllevel4
  global _htmllevel5
  global _htmllevel6
  global _htmllevel7

  if { $level == 1 } {
    set _htmllevel1 [expr $_htmllevel1 + 1]
    set _htmllevel2 0
    set _htmllevel3 0
    set _htmllevel4 0
    set _htmllevel5 0
    set _htmllevel6 0
    set _htmllevel7 0
    set num "$_htmllevel1\. "
  }
  if { $level == 2 } {
    set _htmllevel2 [expr $_htmllevel2 + 1]
    set _htmllevel3 0
    set _htmllevel4 0
    set _htmllevel5 0
    set _htmllevel6 0
    set _htmllevel7 0
    set num "$_htmllevel1\.$_htmllevel2\. "
  }
  if { $level == 3 } {
    set _htmllevel3 [expr $_htmllevel3 + 1]
    set _htmllevel4 0
    set _htmllevel5 0
    set _htmllevel6 0
    set _htmllevel7 0
    set num "$_htmllevel1\.$_htmllevel2\.$_htmllevel3\. "
  }
  if { $level == 4 } {
    set _htmllevel4 [expr $_htmllevel4 + 1]
    set _htmllevel5 0
    set _htmllevel6 0
    set _htmllevel7 0
    set num "$_htmllevel1\.$_htmllevel2\.$_htmllevel3\.$_htmllevel4\. "
  }
  if { $level == 5 } {
    set _htmllevel5 [expr $_htmllevel5 + 1]
    set _htmllevel6 0
    set _htmllevel7 0
    set num "$_htmllevel1\.$_htmllevel2\.$_htmllevel3\.$_htmllevel4\.$_htmllevel5\. "
  }
  if { $level == 6 } {
    set _htmllevel6 [expr $_htmllevel6 + 1]
    set _htmllevel7 0
    set num "$_htmllevel1\.$_htmllevel2\.$_htmllevel3\.$_htmllevel4\.$_htmllevel5\.$_htmllevel6\. "
  }
  if { $level == 7 } {
    set _htmllevel7 [expr $_htmllevel7 + 1]
    set num "$_htmllevel1\.$_htmllevel2\.$_htmllevel3\.$_htmllevel4\.$_htmllevel5\.$_htmllevel6\.$_htmllevel7\. "
  }

  return $num
}

proc html_auto_heading { level align str } {
  if { $align != "" } {
    write "<H$level align=\"$align\">"
  } else {
    write "<H$level>"
  }
  write "[html_autonumber $level]$str"
  writeln "</H$level>"

}

proc html_start_align_paragraph { align } {
  write "<P ALIGN=\"$align\">"
}

proc html_align_paragraph { align str } {
  html_start_align_paragraph $align
  html_print $str
  html_end_paragraph
}

proc CorrectForHTML { txt } {

  regsub -all {\\r\\n} $txt {\\n} txt   ;# Windows carriage return
  regsub -all {\&} $txt {\&amp;} txt    ;# HTML escape
  regsub -all {<} $txt {\&lt;} txt      ;# Tag opening
  regsub -all {>} $txt {\&gt;} txt      ;# Tag closing
  regsub -all {\"} $txt {\&quot;} txt   ;# quotation mark

  regsub -all {é} $txt {\&eacute;} txt
  regsub -all {É} $txt {\&Eacute;} txt
  regsub -all {è} $txt {\&egrave;} txt
  regsub -all {È} $txt {\&Egrave;} txt
  regsub -all {ê} $txt {\&ecirc;} txt
  regsub -all {Ê} $txt {\&Ecirc;} txt
  regsub -all {ë} $txt {\&euml;} txt
  regsub -all {î} $txt {\&icirc;} txt
  regsub -all {ï} $txt {\&iuml;} txt
  regsub -all {ç} $txt {\&ccedil;} txt
  regsub -all {Ç} $txt {\&Ccedil;} txt
  regsub -all {ç} $txt {\&ccedil;} txt
  regsub -all {Ç} $txt {\&Ccedil;} txt
  regsub -all {æ} $txt {\&aelig;} txt
  regsub -all {œ} $txt {\&oelig;} txt
  regsub -all {ä} $txt {\&auml;} txt
  regsub -all {Ä} $txt {\&Auml;} txt
  regsub -all {ö} $txt {\&ouml;} txt
  regsub -all {Ö} $txt {\&Ouml;} txt

  regsub -all {€} $txt {\&euro;} txt

  return $txt;

};#end_proc CorrectForHTML
