# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
# ========= Procs for generic indented output =========
# 2002-09-18 ERA

proc OpenOutputFile {filename} {
   global OutputFile            # Ugly. Hidden input to writeln et al.
   global Output2File

  file mkdir [file dirname $filename]              ;# Create output directory

   if [expr ![string compare $filename stdout] ]  {
      set Output2File 0
      set OutputFile ""
      writeln ""
   } else {
      set Output2File 1
      set OutputFile [open $filename w]
   }
}

proc CloseOutputFile {} {
   global OutputFile
   global Output2File

   if [expr $Output2File==1] {
      flush $OutputFile
      close $OutputFile
      set Output2File 0
      set OutputFile ""
   } else {
      writeln ""
   }
}

proc indent {} {
  global indentLvl
  global indentString
  set indentLvl [expr 3+$indentLvl]
  set indentString [format "%$indentLvl.$indentLvl\s" ""]
}

proc outdent {} {
  global indentLvl
  global indentString
  if [expr $indentLvl<=3] then {
    set indentLvl 0
  } else {
    set indentLvl [expr $indentLvl-3]
  }
  set indentString [format "%$indentLvl.$indentLvl\s" ""]
}

proc writeln {str} {
  global OutputFile
  global Output2File
  global indentString

  if [expr $Output2File==0] {
     output "$indentString$str\n"
  } else {
     puts -nonewline $OutputFile "$indentString$str\n"
  }
}

proc write {str} {
  global OutputFile
  global Output2File
  global indentString

  if [expr $Output2File==0] {
     output "$indentString$str"
  } else {
     puts -nonewline $OutputFile "$indentString$str"
  }
}

set indentLvl  0
outdent

set Output2File 0
set OutputFile ""



# - - - - - -

proc PrintIt {objid brace} {
# This proc provides "generic" output of model elements; will print the class
# of the element + its name + an optional brace string

  set Class [Class $objid]

  if [expr ![string compare $Class Resource] ]  then {
    set Name [Get $objid Uri]
  } elseif [expr ![string compare $Class Session] ]  then { 
    set Name "<noname>"
  } elseif [expr ![string compare $Class InstanceExpr] ]  then { 
    set Name [Get $objid instanceOf]
  } else {
    set Name [Get $objid Name]
  }

  if [expr [string compare $brace ";"] ]  then {
     set brace " $brace"
  }

  writeln "$Class $Name$brace"
  return 1
}


