# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
namespace eval ExternalReferences {

variable GUID_EXTERNAL_OBJECT			"@Predefined@ExternalObject"
variable GUID_EXTERNAL_OBJECT_REFERENCE 	"@Predefined@externalObjectReference"
variable GUID_EXTERNAL_OBJECT_REFERENCE_SOURCE	"@Predefined@externalObjectReference@source"
variable GUID_EXTERNAL_OBJECT_REFERENCE_TARGET	"@Predefined@externalObjectReference@target"

proc GetExternalObject { session } {
	variable GUID_EXTERNAL_OBJECT
	if {0 == $session} {
		return 0
	}
	return [u2::FindByGuid $session $GUID_EXTERNAL_OBJECT]
}

proc GetExternalObjectReferenceStereotype { session } {
	variable GUID_EXTERNAL_OBJECT_REFERENCE
	if {0 == $session} {
		return 0
	}
	return [u2::FindByGuid $session $GUID_EXTERNAL_OBJECT_REFERENCE]
}

proc GetSourceReference { dep } {
	variable GUID_EXTERNAL_OBJECT_REFERENCE
	variable GUID_EXTERNAL_OBJECT_REFERENCE_SOURCE

	set result ""
	set csValue [u2::GetTaggedValue $dep "'$GUID_EXTERNAL_OBJECT_REFERENCE' (. '$GUID_EXTERNAL_OBJECT_REFERENCE_SOURCE' .)" -interpretIdentsAsGuids true]
	if {0 != $csValue && [u2::IsKindOf $csValue CharstringValue]} {
		set result [u2::GetValue $csValue Value]
	}
	return $result
}

proc GetTargetReference { dep } {
	variable GUID_EXTERNAL_OBJECT_REFERENCE
	variable GUID_EXTERNAL_OBJECT_REFERENCE_TARGET

	set result ""
	set csValue [u2::GetTaggedValue $dep "'$GUID_EXTERNAL_OBJECT_REFERENCE' (. '$GUID_EXTERNAL_OBJECT_REFERENCE_TARGET' .)" -interpretIdentsAsGuids true]
	if {0 != $csValue && [u2::IsKindOf $csValue CharstringValue]} {
		set result [u2::GetValue $csValue Value]
	}
	return $result
}

proc DecodeURL { url dataserver persistenceString } {
	upvar $dataserver ds
	upvar $persistenceString ps

	set dataServerRE "(tlog:)?(//<.*>:)?(Doors|u2)?(:?)(.*)"
	regsub -all $dataServerRE $url {\3} ds
	regsub -all $dataServerRE $url {\5} ps
}

proc GetClient { dep } {
	if {0 == $dep || ![u2::IsKindOf $dep Dependency]} {
		return 0
	}

	set session [u2::GetModel $dep]
	if {0 == $session} {
		return 0
	}

	set client [u2::GetEntity $dep NonOwningClient]
	if {0 == $client} {
		set client [u2::GetEntity $dep Client]
	}

	if {0 == $client || $client == [GetExternalObject $session]} {
		set sourceRef [GetSourceReference $dep]
		if {"" != $sourceRef} {
			set client 0
			catch {
			    set client [GetModelFromUrl $sourceRef]
			}			
		}
	}

	return $client
}

proc GetSupplier { dep } {
	if {0 == $dep || ![u2::IsKindOf $dep Dependency]} {
		return 0
	}

	set session [u2::GetModel $dep]
	if {0 == $session} {
		return 0
	}

	set supplier [u2::GetEntity $dep Supplier]

	if {0 == $supplier || $supplier == [GetExternalObject $session]} {
		set targetRef [GetTargetReference $dep]
		if {"" != $targetRef } {
			set supplier 0
			catch {
			    set supplier [GetModelFromUrl $targetRef ]
			}			
		}
	}

	return $supplier
}

}
