# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
package require commands

# addin parameters
namespace eval addin {

# add-in name
variable name Requirements

# add-in installation path
variable path [file join [GetInstallationDirectory] addins $name] 

# script dir
variable scriptDir [file join $path Script]

proc AddMenus {} {
	AddCommand -variable cmdReqReport -name "Basic" -statusmessage "Lists all requirements in the selected element(s)" -tooltip "List requirements" -accelerator "" -imagefile "" -OnActivateCommand addin::RequirementsReport -OnEnableCommand addin::EnableReport
	AddCommand -variable cmdReqReportDetailed -name "Detailed" -statusmessage "Lists all requirements, and their attribute values, in the selected formal module(s)" -tooltip "List requirements (Detailed)" -accelerator "" -imagefile "" -OnActivateCommand addin::RequirementsReport -OnEnableCommand addin::EnableDetailedReport

	AddCommand -variable cmdNonSatisfiedReport -name "Basic" -statusmessage "Lists non-satisfied requirements in the selected element(s)" -tooltip "List non-satisfied requirements" -accelerator "" -imagefile "" -OnActivateCommand addin::SatisfiedReport -OnEnableCommand addin::EnableReport
	AddCommand -variable cmdNonSatisfiedReportDetailed -name "Detailed" -statusmessage "Lists non-satisfied requirements, and their attribute values, in the selected formal module(s)" -tooltip "List non-satisfied requirements (Detailed)" -accelerator "" -imagefile "" -OnActivateCommand addin::SatisfiedReport -OnEnableCommand addin::EnableDetailedReport
	
	AddCommand -variable cmdSatisfiedReport -name "Basic" -statusmessage "Lists satisfied requirements in the selected element(s)" -tooltip "List satisfied requirements" -accelerator "" -imagefile "" -OnActivateCommand addin::SatisfiedReport -OnEnableCommand addin::EnableReport
	AddCommand -variable cmdSatisfiedReportDetailed -name "Detailed" -statusmessage "Lists satisfied requirements, and their attribute values, in the selected formal module(s)" -tooltip "List satisfied requirements (Detailed)" -accelerator "" -imagefile "" -OnActivateCommand addin::SatisfiedReport -OnEnableCommand addin::EnableDetailedReport

	AddCommand -variable cmdNonVerifiedReport -name "Basic" -statusmessage "Lists non-verified requirements in the selected element(s)" -tooltip "List non-verified requirements" -accelerator "" -imagefile "" -OnActivateCommand addin::VerifiedReport -OnEnableCommand addin::EnableReport
	AddCommand -variable cmdNonVerifiedReportDetailed -name "Detailed" -statusmessage "Lists non-verified requirements, and their attribute values, in the selected formal module(s)" -tooltip "List non-verified requirements (Detailed)" -accelerator "" -imagefile "" -OnActivateCommand addin::VerifiedReport -OnEnableCommand addin::EnableDetailedReport
	
	AddCommand -variable cmdVerifiedReport -name "Basic" -statusmessage "Lists verified requirements in the selected element(s)" -tooltip "List verified requirements" -accelerator "" -imagefile "" -OnActivateCommand addin::VerifiedReport -OnEnableCommand addin::EnableReport
	AddCommand -variable cmdVerifiedReportDetailed -name "Detailed" -statusmessage "Lists verified requirements, and their attribute values, in the selected formal module(s)" -tooltip "List verified requirements (Detailed)" -accelerator "" -imagefile "" -OnActivateCommand addin::VerifiedReport -OnEnableCommand addin::EnableDetailedReport
	
	AddCommand -variable cmdDependencyReport -name "List Requirement Relations" -statusmessage "" -tooltip "" -accelerator "" -imagefile "" -OnActivateCommand addin::DependencyReport -OnEnableCommand addin::EnableReport

	AddMenu -variable mnuRequirements -commands {cmdDependencyReport} -path {"&Requirements"} -position {after &Tools}

	AddMenu -variable mnuNonVerifiedSub -commands {cmdNonVerifiedReport cmdNonVerifiedReportDetailed} -path {"&Requirements" "List Non-Verified Requirements"}
	AddMenu -variable mnuVerifiedSub -commands {cmdVerifiedReport cmdVerifiedReportDetailed} -path {"&Requirements" "List Verified Requirements"}

	AddMenu -variable mnuNonSatisfiedSub -commands {cmdNonSatisfiedReport cmdNonSatisfiedReportDetailed} -path {"&Requirements" "List Non-Satisfied Requirements"}
	AddMenu -variable mnuSatisfiedSub -commands {cmdSatisfiedReport cmdSatisfiedReportDetailed} -path {"&Requirements" "List Satisfied Requirements"}

	AddMenu -variable mnuRequirementsSub -commands {cmdReqReport cmdReqReportDetailed} -path {"&Requirements" "List Requirements"}
}

proc EnableDetailedReport {cmd} {
	set selectedElem [std::GetSelection]
	if { 1 != [llength $selectedElem] || ([GetKind $selectedElem] != "U2")} {
		return 0
	}
	return [expr [u2::HasAppliedStereotype $selectedElem "formalModule"] || [u2::HasAppliedStereotype $selectedElem "requirementAttributes"]]
}

proc IsUMLElement { context } {
	if {0 == [llength $context]} {
		return 0
	}

	foreach elem $context {
		if {[GetKind $elem] != "U2"} {
			return 0
		}
	}

	return 1
}

proc IsProject { context } {
	if {1 != [llength $context]} {
		return 0
	}

	if {[GetKind $context] == "project"} {
			return 1
	}

	return 0
}

proc GetModelFromSelection { } {
	set context [std::GetSelection]
	if {[IsProject $context]} {
		return [std::GetModels -project $context -kind U2]
	}
	return $context
}

proc EnableReport {cmd} {
	return [expr [IsUMLElement [std::GetSelection]] || [IsProject [std::GetSelection]]]
}

proc RequirementsReport {cmd} { 
	source [file join $addin::scriptDir Reports.tcl]
	set type "basic"
	if {$cmd == "cmdReqReportDetailed"} {
		set type "detailed"
	}
	requirements::RequirementsReport [GetModelFromSelection] $type
}

proc SatisfiedReport {cmd} { 
	source [file join $addin::scriptDir Reports.tcl]
	set type "basic"
	if {$cmd == "cmdSatisfiedReportDetailed" || $cmd == "cmdNonSatisfiedReportDetailed"} {
		set type "detailed"
	}
	if {$cmd == "cmdSatisfiedReport" || $cmd == "cmdSatisfiedReportDetailed"} {
		requirements::SatisfiedReport [GetModelFromSelection] $type
	} else {
		requirements::NonSatisfiedReport [GetModelFromSelection] $type
	}
}

proc VerifiedReport {cmd} { 
	source [file join $addin::scriptDir Reports.tcl]
	set type "basic"
	set type "basic"
	if {$cmd == "cmdVerifiedReportDetailed" || $cmd == "cmdNonVerifiedReportDetailed"} {
		set type "detailed"
	}
	if {$cmd == "cmdVerifiedReport" || $cmd == "cmdVerifiedReportDetailed"} {
		requirements::VerifiedReport [GetModelFromSelection] $type
	} else {
		requirements::NonVerifiedReport [GetModelFromSelection] $type
	}
}

proc DependencyReport {cmd} { 
	source [file join $addin::scriptDir Reports.tcl]
	requirements::DependencyReport [GetModelFromSelection] 
}

} 

addin::AddMenus
