// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// prevent dxl timeout dialog
pragma runLim, 0

bool g_makeFullBrowse = true //true - full browse, false - browse only own child elements.

void writeTab(Buffer &b, int nTab)
{
    int x
    for (x = 0; x < nTab; x++) {
        b += " "
    }
}

void writeDBHeader(Buffer &b)
{
    b += "package '" 
    b += replaceCharacters(getDatabaseName())
    b += "' {\n"
}

void writeDBFooter(Buffer &b)
{
   b += "}"
}

void writeDBBaselines(Buffer &b, Module &currModule)
{
    b += "baselines = \"" 
    b += replaceCharacters(getBaselinesString(currModule, '|'))
    b += "\""
}

void writeDBViews(Buffer &b, Module &currModule)
{
    b += "views = \"" 
    b += replaceCharacters(getViewsString(currModule, '|')) 
    b += "\""
}

void writeDBItemHeader(Buffer &b, int nTab, string id, string strName)
{
    writeTab(b, nTab)
  
    if (length(strName)==1)
    {
		if (isalpha(strName[0]))
		{
			b += "package #d" id "#" strName "# {\n"
		}
		else
		{
			b += "package #d" id "#'\\" strName "'# {\n"
		}
    }
    else
    {
        //add prefix d_m_ in case if first symbol of strName is not letter
		b += "package #d" id "#'d_m_" strName "'# {\n"
	}
}

void writeDBItemHeader(Buffer &b, int nTab, Item &currItem, string itemType)
{ 
    string id = itemType "|" uniqueID(currItem)

    string strName = name(currItem)
    writeDBItemHeader(b,nTab, id, strName)
}

void writeDBObjectHeader(Buffer &b, int nTab, Item &currItem, Object &obj, string itemType)
{
    string id = itemType "|" uniqueID(currItem) "." identifier(obj)

    string strName = obj."Object Heading"
    writeDBItemHeader(b,nTab, id, strName)
}

void writeDBItemFooter(Buffer &b, int nTab)
{
    writeTab(b, nTab)
    b += "}\n"
}

void writeDummyElement(Buffer &b, int nTab)
{
    writeTab(b, nTab)
    b += "package #dDummy|0#'d_m_dummy'# {\n"
    writeDBItemFooter(b, nTab)
}

bool isModuleWithAttribute(Item item, const string attr)
{
    if(null item) {
        return false
    }
    
    bool bWasOpened = isModuleOpen item
    Module m = read (fullName (item), false)
    if (null m) {
        return false
    }
    
    AttrDef ad = find(m, attr)
    if (null ad) {
        if(!bWasOpened)
            close m
        return false
    }
    
    if(!bWasOpened)
        close m
    
    return true
}

const string MODULE_U2PROJECT_ATTRIBUTE = "UML Project.ttp"

bool isModuleWithTauProject(Item item)
{
    return isModuleWithAttribute(item, MODULE_U2PROJECT_ATTRIBUTE)
}

const string MODULE_U2FILE_ATTRIBUTE = "UML File.u2"
bool isAnalystModule(Item item)
{
    return isModuleWithAttribute(item, MODULE_U2FILE_ATTRIBUTE)
}

void writeAnalystEditableSectionInner(Buffer &b, int nTab, Module& m, Item& analystModule, Object rootObj)
{
    if (!null m) {
        AttrDef ad = find(m, MODULE_U2FILE_ATTRIBUTE)
        if (!null ad) {
            Object obj
            for obj in rootObj do {
                if(hasSpecificValue(obj, ad)) {
                    writeDBObjectHeader(b, nTab + 4, analystModule, obj, "Section")
                    writeDBItemFooter(b, nTab + 4)
                } else {
                    writeAnalystEditableSectionInner(b, nTab, m, analystModule, obj)
                }
            }   	
        }
    }
}

void writeAnalystEditableSection(Buffer &b, int nTab, Item& analystModule)
{
    bool bWasOpened = isModuleOpen analystModule
    Module m = read (fullName (analystModule), false)
    if (!null m) {
        AttrDef ad = find(m, MODULE_U2FILE_ATTRIBUTE)
        if (!null ad) {
            Object obj
            for obj in top(m) do {
                if(hasSpecificValue(obj, ad)) {
                    writeDBObjectHeader(b, nTab + 4, analystModule, obj, "Section")
                    writeDBItemFooter(b, nTab + 4)
                } else {
                    writeAnalystEditableSectionInner(b, nTab, m, analystModule, obj)
                }
            }   	
        }
        if(!bWasOpened)
            close m
    }
}

//project type
const int FIND_ALL_MODULES = 0 //fast way because we don't have to open modules
const int FIND_MODULES_WITH_PROJECT = 1
const int FIND_MODULES_WITHOUT_PROJECT = 2

void writeDBItemContent(Buffer &b, int nTab, int maxDeepth, Item &parentItem, bool isWriteFormalModules, bool isWriteAnalystModules, int projectType)
{
    if (parentItem != null) {
        Item i
        for i in folder parentItem do {
            string itemType = type(i) 
	
            if (itemType == "Link" or itemType == "Descriptive") {
                // Nothing
                continue
            }          

            // "Folder", "Project" or "Formal"
                        
            if(!isWriteFormalModules && itemType == "Formal")
            {
                continue
            }           
            
            if (itemType == "Formal") {
                if(isWriteAnalystModules) {
                    if(isAnalystModule(i)) {
                        itemType = "Analyst"
                    } else {
                        continue
                    }
                }
                else if(projectType==FIND_MODULES_WITHOUT_PROJECT) {
                    if(isModuleWithTauProject(i)){
                        continue
                    }
                }
                else if(projectType==FIND_MODULES_WITH_PROJECT) {                
                    if(!isModuleWithTauProject(i)){
                        continue
                    }
                } else {
                    string itemDescription = description(i)
                    if (itemDescription == "Tau Integration Module" || itemDescription == "Tau Integration Proxy - do not edit") {
                        itemType = "Surrogate"
                    }
                }
			}
            
            if(maxDeepth>0)
            {
                 // "Folder", "Project", "Formal" or "Surrogate"            
                writeDBItemHeader(b, nTab + 4, i, itemType)

                if (itemType == "Folder" || itemType == "Project") {
                    writeDBItemContent(b, nTab + 4, maxDeepth - 1, i, isWriteFormalModules, isWriteAnalystModules, projectType)			
                }
                
                if (itemType == "Analyst") {
                    writeAnalystEditableSection(b, nTab + 4, i)
                }

                writeDBItemFooter(b, nTab + 4)
            }		
        }
        
        if(maxDeepth==0)
        {
            writeDummyElement(b, nTab)
        }
    }
}

void writeU2PFile(Buffer &b, string rootPath, bool isWriteFormalModules, bool isWriteAnalystModules, int projectType)
{
    Item rootItem = item(rootPath)

    int maxDeepth = 1
    if(g_makeFullBrowse)
        maxDeepth = 100
        
    writeDBHeader(b)
    writeDBItemContent(b, 0, maxDeepth, rootItem, isWriteFormalModules, isWriteAnalystModules, projectType)
    writeDBFooter(b)
}

void writeU2PFile(Buffer &b, bool isWriteFormalModules, bool isWriteAnalystModules, int projectType)
{
    writeU2PFile(b, "/", isWriteFormalModules, isWriteAnalystModules, projectType)
}

void browseDB(string startFrom)
{
    Buffer b = create
    
    writeU2PFile(b, startFrom, true /*write formal modules*/, false /*write Analyst modules*/, FIND_ALL_MODULES)
    returnResult(tempStringOf(b))

    delete b
}

void browseAnalystDB()
{
    Buffer b = create
    
    writeU2PFile(b, true /*write formal modules*/, true /*write Analyst modules*/, FIND_ALL_MODULES)       
    returnResult(tempStringOf(b))

    delete b
}

void browseDBFolders()
{
    Buffer b = create
    
    writeU2PFile(b, false /*write formal modules*/, false /*write Analyst modules*/, FIND_ALL_MODULES)
    returnResult(tempStringOf(b))
 
    delete b
}


//browse folders, projects and formal modules without tau project inside
//rootPath - path of element for start of browsing
void browseDoorsAsFileSystem(string rootPath, bool browseModulesWithProject, bool browseModulesWithoutProject)
{
    g_makeFullBrowse = false
    
    Buffer b = create
    
    int projectType = FIND_ALL_MODULES
    if(browseModulesWithProject && !browseModulesWithoutProject)
        projectType = FIND_MODULES_WITH_PROJECT
    else if(!browseModulesWithProject && browseModulesWithoutProject)
        projectType = FIND_MODULES_WITHOUT_PROJECT 
    
    writeU2PFile(b, rootPath, true /*write formal modules*/, false /*write Analyst modules*/, projectType)
    returnResult(tempStringOf(b))
    
    delete b
}

//browse folders, projects and formal modules with/without tau project inside
void browseDoorsAsFileSystem(bool browseModulesWithProject, bool browseModulesWithoutProject)
{
    g_makeFullBrowse = false
    
    browseDoorsAsFileSystem("/", browseModulesWithProject, browseModulesWithoutProject)
}

/////////////////////////////////////////////////////
/// Get module baselines and views
/////////////////////////////////////////////////////

void getModuleBaselinesAndViews(string moduleId)
{
    Buffer b = create

    Item currItem = itemFromID(moduleId)
    if (type(currItem) == "Formal")
    {
        bool bWasOpened = isModuleOpen(currItem)

        Module m = read (fullName (currItem), false)
        string errMsg = GetLastError()

        if (!null m && null errMsg)
        {
            b += "<<DoorsNodeInfo(."
            writeDBBaselines(b, m)
            b += ", "
            writeDBViews(b, m)
            b += ".)>> "

            if (!bWasOpened)
                close(m)
        }
    }

    string strName = name(currItem)
    if (length(strName)==1)
        b += "package '\\" strName "' {}"
    else
        b += "package '" strName "' {}"


    returnResult(tempStringOf(b))
	
    delete b
}
