// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//<

const int READ_MODE = 1
const int EDIT_MODE = 2
const int SHARE_MODE = 4

const string TAU_STANDARD_VIEW = "Standard view"
const string TAU_ATTR_NUMBER_NAME = "Object Number"

//////////////////////////////////////////////////
//
//////////////////////////////////////////////////
void returnResult(string result)
{
    oleSetResult(result)
}

//////////////////////////////////////////////////
//
//////////////////////////////////////////////////
string checkDoorsVersion()
{
    string strVersion = doorsVersion()
   
    string strMajor = null
    string strMinor = null
    string strResult = null
    Regexp doorsVersionRE = regexp "DOORS ([0-9]+)\\.([0-9]+).*"
    if (doorsVersionRE strVersion)
    {
        strMajor = strVersion[match 1]
        strMinor = strVersion[match 2]
    }
    
    //DXL error in Doors 8.2
    //delete doorsVersionRE

    if (!null strMajor)
    {
        int nMajor = intOf(strMajor)
        int nMinor = intOf(strMinor)
        if (nMajor > 7)
        {
            strResult = strMajor "." strMinor
        }
        else
        {
            strResult = "IDS_UNSUPPORTED_DOORS_VERSION: " strVersion
        }
    }
    else
    {
        strResult = "IDS_UNKNOWN_DOORS_VERSION: " strVersion
    }


    return strResult
}

//////////////////////////////////////////////////
//
//////////////////////////////////////////////////
void getDoorsVersion()
{
    returnResult(checkDoorsVersion())
}
 
//////////////////////////////////////////////////
//
//////////////////////////////////////////////////
void getBaselines(Buffer &b, Module &currModule, char sep)
{
    if (!null b && !null currModule)
    {
        bool bFirst = true
        Baseline bl
        for bl in currModule do
        {
            if (bFirst == false)
            {
                b += sep
            }
            else
            {
                bFirst = false
            }
            // to made resulting string as standard DOORS baseline form
            // b += (major bl) "." (minor bl) " " (suffix bl)
            b += (major bl) "." (minor bl) " "
            if(suffix(bl)!=null && suffix(bl)!="")
                b += "(" suffix(bl) ")"
        }
    }
}

string getBaselinesString(Module &currModule, char sep)
{
    string out_str = ""
    Buffer out = create
    getBaselines(out, currModule, sep)
    out_str = stringOf(out)
    delete(out)
    return out_str
}

//////////////////////////////////////////////////
//
//////////////////////////////////////////////////
Baseline getBaseline(string strBaseline)
{
    if (null strBaseline)
    {
        return null
    }

    string strMajor = null
    string strMinor = null
    string strSufix = null
    Regexp baselineRE = regexp "([0-9]+)\\.([0-9]+) \\((.*)\\)"
    Regexp baselineRE2 = regexp "([0-9]+)\\.([0-9]+) (.*)"
    Regexp baselineRE3 = regexp "([0-9]+)\\.([0-9]+)(.*)"
    if (baselineRE strBaseline) 
    {
        strMajor = strBaseline[match 1]
        strMinor = strBaseline[match 2]
        strSufix = strBaseline[match 3]
    }
    else if (baselineRE2 strBaseline) 
    {
        strMajor = strBaseline[match 1]
        strMinor = strBaseline[match 2]
        strSufix = strBaseline[match 3]
    }
    else if (baselineRE3 strBaseline) 
    {
        strMajor = strBaseline[match 1]
        strMinor = strBaseline[match 2]
        strSufix = strBaseline[match 3]
    }
	
    if (strMajor==null || strMinor==null || strMajor=="" || strMinor=="")
        return null
	
    int nMajor = intOf(strMajor)
    int nMinor = intOf(strMinor)
		
    return baseline(nMajor, nMinor, strSufix)
}

//////////////////////////////////////////////////
//
//////////////////////////////////////////////////
void getViews(Buffer &b, Module &currModule, char sep)
{
    if (!null b && !null currModule)
    {
        string def_view=getDefaultViewForUser(currModule)
        if(def_view=="") {
            def_view=getDefaultViewForModule(currModule)
        }
        bool check_default = false
        if(def_view=="") {
            def_view=TAU_STANDARD_VIEW
            b += def_view
        }
        else {
            b += def_view
            b += sep
            b += TAU_STANDARD_VIEW
            check_default = true
        }
        string viewName
        for viewName in views(currModule) do
        {
            if(check_default && viewName==def_view)
                continue
            b += sep
            b += viewName
       }
       
   }
}

string getViewsString(Module &currModule, char sep)
{
    string out_str = ""
    Buffer out = create
    getViews(out, currModule, sep)
    out_str = stringOf(out)
    delete(out)
    return out_str
}

//////////////////////////////////////////////////////////
// Returns true if the columns is valid for import/update.
// Sets name to the name of the attribute.
//////////////////////////////////////////////////////////

bool IsValidTAUAttribute(string attributeName)
{
    if ("" == attributeName || "Object Identifier" == attributeName || TAU_ATTR_NUMBER_NAME == attributeName)
    {
        return false
    }
    return true            
}

bool IsValidColumn(Column c, string& name)
{
    if (null c)
        return false
        
    string attributeName = attrName(c)

    if (!IsValidTAUAttribute(attributeName) || dxl(c)!="")
    {
        return false
    }
    
    name = attributeName    
    return true            
}

// Check that it's processed object: Visible or Table or Row

bool isProcessedObject(Object o)
{
    return ((table(o) || row(o) || isVisible(o)) && !isDeleted(o))
}

//return last dxl error
string GetLastError()
{
    return lastError()
}
