// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
Skip openedModules = null

// return "0" if the object is _root object
string getParentTAUIDInTree (Object o) 
{
	Object tmp = getParentInTree(o)
    string parentId = "0"
    if (!null tmp)
        parentId = getTAUID(tmp)
    return parentId
}

string getPreviousTAUIDInTree (Object o) 
{
    
    Object tmp = getPreviousSiblingInFilteredTree(o)
    string afterId = "0"
    if (!null tmp)
        afterId = getTAUID(tmp)
    return afterId
}

string getQualifiedNameOfTarget(Link l)
{
    Object sourceObject = source(l)
    if (null sourceObject)
        return ""

    ModName_ targetModuleModName = target(l)
    Item i = item(fullName targetModuleModName)
    bool bWasOpened = false
    string errMsg = null
	
    // the 'targetModule' is needed also to check module attribute 'TLOG Module Guid'
    string targetModuleID=uniqueID (i)
    Module targetModule = openModule(i, READ_MODE, null, null, bWasOpened, false, errMsg)
    if (!null targetModule && bWasOpened && !null openedModules)
        put(openedModules, targetModule, targetModule)

    Object targetObject = target(l)
    if (null targetObject)
        return ""

    // For link on old surogate module 'u2:uid:' style is used
    // For link on old formal module 'Doors:module_id.object_id' style is used
    string tau_surogate_guid=probeAttr_(targetObject,"UML Guid")
    string tau_formal_guid=probeAttr_(targetModule,"TLOG Module Guid")
    if(targetModuleID!="" && (tau_surogate_guid!="" || tau_formal_guid!=""))
    {
        return "Doors:" targetModuleID "." getTAUID(targetObject) ""
    }

    // ordinary case with name-resolved link by full qualified path

    string result = u2pStringQuoted(getTAUName(targetObject))
    
    Object targetParent = parent(targetObject)
    Object sourceParent = parent(sourceObject)

    if (targetParent != sourceParent)
    {        
        while (null != targetParent)
        {
            if (isProcessedObject(targetParent))
            {
	        // Note: The variable is needed for the DXL interpreter to do the correct thing
                string quotedName = u2pStringQuoted(getTAUName(targetParent))
                result = quotedName "::" result
            }
            targetParent = parent(targetParent)
        }                
    }

    string targetModuleName = target(l)
    string sourceModuleName = source(l)

    if (targetModuleName != sourceModuleName)
    {
        // Note: These variables are needed for the DXL interpreter to do the right thing
        string quotedModuleName = u2pStringQuoted(targetModuleName)
	string tmpResult = result

	result = quotedModuleName "::" tmpResult
    } 
    return "ref:" result   
}

string getLinkTargetString(Link l)
{
    Object sourceObject = source(l)
    if (null sourceObject)
        return ""
    ModName_ targetModuleName = target(l)
    string targetModuleID=uniqueID (targetModuleName )
    int targetObjectID=targetAbsNo(l)
    if(targetModuleID!="" && targetObjectID>0)
    {
        return "tlog:Doors:" targetModuleID "." targetObjectID ""
    }
    return ""
}

void WriteLinkCreated(Stream s, Date d, Link l)
{
    int i = intOf(d)
    
    string targetRef = getLinkTargetString(l)
    Object source_obj=source(l)
    if (!null targetRef && source_obj!=null)
    {
        writeToStream(s, "LinkCreated (. time = " i ", id = \"" getTAUID(source_obj) "\", targetRef = \"" targetRef "\" .)\n")
    }
}

Date getCreatedOnDate(Object o)
{
    Date crtDate = null
    History h
    for h in o do
    {
        HistoryType type = h.type
        if (type == createObject)
        {
            crtDate = h.date
            break
        }
        if (crtDate==null || intOf(crtDate)>intOf(h.date))
        {
            crtDate = h.date
        }
    }
    if(crtDate==null) 
    {
        crtDate=o."Created On"
    }

    return crtDate
}

// Writes created links. 
// TODO: Find a way to handle deleted links
void WriteChangedLinks(Stream s, Object o, Date d)
{
    Link l = null

    Buffer tmpLinks = create
    
    bool bFirst = true

    Date objCrtDate = getCreatedOnDate(o)
    Date modDate = objCrtDate
   
    for l in o->"*" do 
    {
	modDate = l."Last Modified On"
        if (intOf(modDate) < intOf(objCrtDate))
            modDate = objCrtDate
        

        if (bFirst) 
        {
            bFirst = false
        } 
        else
        {
            tmpLinks += ", "
        }

        string targetRef = getLinkTargetString(l)
	    
        if (!null targetRef)
            tmpLinks += "\"" targetRef "\""
	

	WriteLinkCreated(s, modDate, l)	 	    
    }

    // We'll have to supply a list of all links that still exists-

    int i = intOf(modDate)
    writeToStream(s, "LinkDeleted (. time = " i ", id = \"" getTAUID(o) "\", remainingLinks = {" tmpLinks "} .)\n")

    delete tmpLinks
}

