// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//<

string getValidOrEmptyModuleName (string originalModuleName) 
{
    ModName_ moduleModName = module(originalModuleName)
    if(null moduleModName)
        return originalModuleName
    
    bool isGoNext = exists(moduleModName) && isDeleted(moduleModName)
    int i = 0
    string new_name = originalModuleName
    while(i<1000 && isGoNext) {
        new_name = originalModuleName " " i "" //originalModuleName (random(1000))
	moduleModName = module(new_name)
	isGoNext = exists(moduleModName) && isDeleted(moduleModName)
        i++
    }
    if(i==1000)
        return ""
    return new_name
}

Module getLinkModule(ModName_ src_mod, ModName_ target_mod, string& errMsg)
{
    string linkModuleName = getDefaultLinkModule(src_mod, target_mod)
    string srcPath = path(src_mod)
    string fullLinkModuleName = ""
    if(isContainChar(linkModuleName,'/'))
    {
		fullLinkModuleName = getValidOrEmptyModuleName (linkModuleName)
    }
    else
    {
		fullLinkModuleName = getValidOrEmptyModuleName (srcPath "/" linkModuleName)
    }
    
    if(fullLinkModuleName == "") {
        errMsg = "IDS_CREATE_LINK_MODULE_FAILED"
        return null
    }
        
    ModName_ linkModuleModName = module(fullLinkModuleName)

    if (null linkModuleModName || !exists(linkModuleModName))
    {
        // Create a new (default) link module
        const string strDescr = "Link module created automatically by TAU-DOORS Integration"
        Module m = create(fullLinkModuleName, strDescr, manyToMany, false)
        if (null m)
        {
            errMsg = "IDS_CREATE_LINK_MODULE_FAILED"
            return null
        }

        return m
    }
    else
    {
	Item i = item(fullLinkModuleName)

        Module m = null
        
	if (!null i && canModify(i))
	{
	    if (open(linkModuleModName))
	    {
                m = module(i)

                if (canModify(m))
                {
                    return m
                }
	    }

	    m = edit(fullLinkModuleName,false)
	}
	
	if (null m)
	{
	    errMsg = "IDS_MODIFY_LINK_MODULE_FAILED"
	}
	
        return m
    }

    return null
}

Linkset getLinkModuleLinkset(Module linkModule, string srcModFullName, string tgtModFullName, bool& wasCreated)
{
    if (linkModule == null)
    {
	return null
    }
    wasCreated = false
    Object o
    for o in linkModule do
    {
	if( o == null )
	    continue;
	Linkset ls = linkset(o)
	if( ls == null )
	    continue;
	string sSourcePath = probeAttr_(o, "Source")
	string sTargetPath = probeAttr_(o, "Target")
	if (sSourcePath == srcModFullName && sTargetPath == tgtModFullName)
	{
	    return ls
	}
    }
    if (!isEdit(linkModule))
    {
        return null
    }
    Linkset ls = create(linkModule, srcModFullName, tgtModFullName)
    if(ls != null)
    {
	unload ls
	wasCreated = true
    }
    return ls
}

Link createLink(Object sourceObj, Object targetObj, Module linkModule, string& errMsg)
{
    if (!canModify(sourceObj)) {
        return null
    }
	
    if (null linkModule)
    {
	Module sourceModule = module(sourceObj)
	Module targetModule = module(targetObj)
	if (null sourceModule || null targetModule)
	    return null
	
	linkModule = getLinkModule(module(fullName(sourceModule)), module(fullName(targetModule)), errMsg)
    }
    
    if (null linkModule)
	return null

    if (!canModify(linkModule))
    {
	errMsg = "IDS_CREATE_LINK_FAILED"
	return null
    }

    // to create Linkset (in Doors>8.2 - it's ask before to be to created)
    Module sourceModule = module(sourceObj)
    Module targetModule = module(targetObj)
    if (sourceModule==null || targetModule==null)
    {
	errMsg = "IDS_CREATE_LINKSET_FAILED"
	return null
    }
    bool wasCreated = false
    Linkset ls = getLinkModuleLinkset(linkModule, fullName(sourceModule), fullName(targetModule), wasCreated)
    if (null ls)
    {
	errMsg = "IDS_CREATE_LINKSET_FAILED"
	return null
    }
        
    Link lnk = targetObj <- fullName(linkModule) <- sourceObj
    return lnk
}

// This function is introduced in order to handle "Drop from DOORS" event
void createLinkByDrop(string srcModuleId, string srcModuleView, string srcModuleBaseline, string srcObjectId, string trgModuleId, string trgModuleView, string trgModuleBaseline, string trgObjectId)
{
    string errMsg = null

    Item smItem = itemFromID(srcModuleId)

    bool bSrcWasOpened = false 
    Module srcModule = openModule(smItem, READ_MODE, srcModuleView, srcModuleBaseline, bSrcWasOpened, false, errMsg)

    if (srcModule == null || errMsg != null)
    {
        if (bSrcWasOpened)
        {
            if (srcModule != null)
            {
                close(srcModule)
            }
            bSrcWasOpened = false;
        }
	
        returnResult(errMsg)
        return
    }

    Item tmItem = itemFromID(trgModuleId)

    bool bTrgWasOpened = false 
    Module trgModule = openModule(tmItem, READ_MODE, trgModuleView, trgModuleBaseline, bTrgWasOpened, false, errMsg)
    if (trgModule == null || errMsg != null)
    {
        if (bTrgWasOpened)
        {
            if (trgModule != null)
            {
                close(trgModule)
            }
            bTrgWasOpened = false;
        }
	

        if (bSrcWasOpened)
        {
            close(srcModule)
        }       

        returnResult(errMsg)
        return
    }

    Module linkModule = getLinkModule(module(fullName(srcModule)), module(fullName(trgModule)), errMsg)
    if (!null linkModule)
    {
        Object srcObject = findAnyObject(srcModule, srcObjectId, errMsg)
        Object trgObject = findAnyObject(trgModule, trgObjectId, errMsg)

        if (!null srcObject && !null trgObject)
        {
            Link createdLink = createLink(srcObject, trgObject, linkModule, errMsg)

            if (!null createdLink)
            {
                save(linkModule)
            }
        }

        close(linkModule)
    }

    if (bSrcWasOpened)
    {
        close(srcModule)
    }

    if (bTrgWasOpened)
    {
        close(trgModule)
    }

    if (!null errMsg)
    {
        returnResult(errMsg)
    }
}
