// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// prevent dxl timeout dialog
pragma runLim, 0

// Converts a string into a legal XML-string, e.g. replaces > with &gt;
//
// Note: We might need two versions of this function one for ANSI and one for
// UTF-8. I found that the following characters are problematic in UTF-8:
// $, 133, 146, 147, 148
//

// tab (9 t) line_feed (10 n) carriage_return (13 r) 
// line_tab (11 v) form_feed (12 f) delete (127)
// 27  19  esc 27: <- 19: (single quote = 39)

// single quote = 39 == Equal unvisible control

bool isUnVisibleControlChar(char c) {
    int c_int=intOf(c)
    if(c_int>0 && c_int<32 || c_int==127 || c_int==39) { 
    	if(c_int>=9 && c_int<=13 && c_int!=11)
            return false
	return true
    }
    return false
}

bool isUnVisibleControlCharInString(string s) {
    if ("" == s)
        return false
    int i
    for (i = 0; i < length(s); i++) {
        char c = s[i]
        if (isUnVisibleControlChar(c))
            return true
    }
    return false
}

bool removeUnVisibleControlChar(string &s)
{
    if ("" == s)
        return false
    Buffer result = null
    int stringLength = length(s)
    bool isDeleted=false
    int i
    for (i = 0; i < length(s); i++) {
        char c = s[i]
        if(isUnVisibleControlChar(c)) {
            isDeleted=true
        }
        else {
            if (null result)
                result = create(stringLength)
            result += c
        }
    }
    if(isDeleted)
    {
        if (!null result)
        {
            s = stringOf(result)
        }
        else
        {
            s =""
        }
    }

    delete result
    return isDeleted
}

// Transform standard XML special symbol in it's special notation.
// and change some visible control in accordance with removeControlCharacters()

bool TransformXMLChar(char c, string &out) {
    // special XLM chars
    //	'\'' - out = "&apos;" TAU don't support
    int c_int=intOf(c)
    if ('"' == c)
        out = "&quot;"
    else if ('>' == c)
        out = "&gt;"
    else if ('<' == c)
        out = "&lt;"
    else if ('&' == c)
        out = "&amp;"
    // single quote - is filtered before as control
    else if ('\'' == c) 
        out = "&apos;"
    // control symbol to make the same as for update
    else if (c_int == 9)    // tab
        out = "&#9;"
    else if (c_int == 10)    // new line
        out = "&#13;&#10;"
    else if (c_int == 12)    // form feed
        out = ""
    else if (c_int == 13)    // carriage return
        out = "&#13;&#10;"
    else
        return false
    return true
}

void getXMLString(string s, string& result)
{
    if ("" == s)
    {
        result = ""
        return
    }
            
    string add
    int stringLength = length(s)
    Buffer tmpBuf = null
    bool bufferUsed = false
    bool wasRemoved = false
    
    int i
    for (i = 0; i < stringLength; i++)
    {
        char c = s[i]
        if(TransformXMLChar(c,add))
        {
            if (null tmpBuf)
            {
                tmpBuf = create(stringLength + 50)
                bufferUsed = true
            }
            tmpBuf += add
        }
        else if (!isUnVisibleControlChar(c))
        {
            if (null tmpBuf)
            {
                tmpBuf = create(stringLength + 50)
                bufferUsed = true
            }
	    tmpBuf += c
	}
	else
	{
	    wasRemoved = true
	}
    }
    
    if (bufferUsed)
    {
        result = stringOf(tmpBuf)
        delete tmpBuf
        return
    }
    else if (wasRemoved)
    {
        result = ""
        return
    }
    
    result = s
}

// ===========================================================

string replaceCharacters(string s)
{
    if ("" == s)
        return ""
    Buffer result = create
    int i
    for (i = 0; i < length(s); i++) {
        char c = s[i]
        if ('"' == c)
            result += "\\\""
        else
            result += c
    }
    string out_str=stringOf(result)
    delete result
    return out_str
}

string removeControlCharacters(string s, string pref1, string pref2)
{
    if ("" == s)
        return ""
        
    Buffer b = create
    b = s
    
    Buffer result = create
    int i
    for (i = 0; i < length(b); i++)
    {
        char c = b[i]
        int c_int=intOf(c)
        if ('"' == c) {
            result += pref1
            result += "\""
        }
        else if ('\\' == c) {	    // backslash
            result += pref1
            result += "\\"
        }
        else if (c_int == 9) {	    // tab result += "\\\\\\\t"
            result += pref2
            result += "t"
        }
        else if (c_int == 10) {    // new line
            result += pref2
            result += "r"
            result += pref2
            result += "n"
        }
        //else if (c_int == 12)    // form feed
        //    result += ""
        else if (c_int == 13) {    // carriage return
            result += pref2
            result += "r"
            result += pref2
            result += "n"
        }
        //else if (27 == intOf(c) || 19 == intOf(c))    // 27: <- 19: !!
        //    result += ""
        else if(c_int>0 && c_int<32 || c_int==127 || c_int == 39) // controls symbol
            result += ""
        else
            result += c
    }
    
    delete b
    return stringOf(result)
}

// Adds quotes around the string if needed in the u2p format
// Note that this function doesn't treat the case where
// the entire string is an integer. This is handled in u2pString
// for performance. (We don't need to call removeControlCharacters
// in that case.)
string addQuotesIfNeeded(string s)
{    
    // check that string star from digit
    if(length(s)>0) then {
        // equal_regexp "^[0-9]" 
        char c = s[0]
        if (c>='0' && c<='9') then { 
            return "'" s "'"
        }
    }
    // check that all symbols in the string is alfanumerik or _
    int i
    for (i = 0; i < length(s); i++) {
        char c = s[i]
        if (!isalnum(c) && c != '_') then {
            return "'" s "'"
        }
    }
    return s
}


// Returns a valid u2 string of the given string
string u2String(string s)
{
    //removeUnVisibleControlChar(s)

    string result
    getXMLString(s, result)

    return result
}

// Returns a valid u2p string of the given string
string u2pString(string s)
{
    if (null s)
        return ""
    string result = removeControlCharacters(s, "\\", "\\" )
    return result
}

string u2p2pString(string s)
{
    if (null s)
        return ""
    string result = removeControlCharacters(s, "\\\\\\", "\\\\" )
    return result
}

string u2pStringQuoted(string s)
{
    if (null s)
        return ""
    // quoted with back solidus if this is one char and not letter
    if (length(s) == 1) then {
        if(iscntrl(s[0]) ) then {
            int c_int = intOf(s[0])
            if (c_int == 9) then {
                // this must be rechecked after case 'icr 1120'
                return "'\\\\t'"
            }
            else {
                return ""
            }
        }
        if(s[0] == '\\' ) then {
            // the one character _\_ is forbidden as _name in TAU
            return ""
        }
        if(!isalpha(s[0]) ) then {
            return "'\\\\" s "'"
        }
    } 
    string result = removeControlCharacters(s, "\\", "\\")
    return addQuotesIfNeeded(result)
}

// doors don't contains '\r' in string - only '\n'
// during comparison we skip all '\r'

bool isEqualStringNoUNIXEndline(string str1, string str2)
{
    if(str1==null && str2==null)
    {
        return true
    }
    if(str1==null || str2==null)
    {
        return false
    }
    int len1=length(str1)
    int len2=length(str2)
    int i1=0
    int i2=0
    while (i1<len1 && i2<len2)
    {
        char c1 = str1[i1]
        int c1_int=intOf(c1)
        char c2 = str2[i2]
        int c2_int=intOf(c2)
        if(c1_int==13) 
        {
            i1++
            continue
        }
        if(c2_int==13) 
        {
            i2++
            continue
        }
        if(c1!=c2)
        {
            return false
        }
        i1++
        i2++
    }
    while(i1<len1 && intOf(str1[i1])==13)
    {
        i1++
    }
    while(i2<len2 && intOf(str2[i2])==13)
    {
        i2++
    }
    if(i1==len1 && i2==len2)
    {
        return true
    }
    return false
}

// =========================================
// process 'input' buffer to get 
// out - substring from 'position+1' pisition up to ''\n'-1' with cutted '\n' '\r' from start and from end
// (!!! can return out="" is we have "\n\n" in input buffers - but it's not the end!)
// Return 'false' is the source string is processed up to end

int MyContains(Buffer input, char ch, int start_position)
{
    int len=length(input) 
    int index
    for(index=start_position; index<len; index++)
    {
        if(input[index]==ch)
        {
            return index
        }
    }
    return -1
}

bool getNextSubString(Buffer input, int &position, string &out)
{
    int len=length(input) 
    if(position+1>=len)
    {
        return false
    }
    char endline='\n'
    char endRline='\r'
    int new_end
    new_end=MyContains(input, endline, position);
    int real_first=position
    int real_last=new_end-1
    if(new_end==-1)
    {
        new_end=len-1
        real_last=new_end
    }
    // swap empty values and 
    while(real_first<len && (input[real_first]==endline || input[real_first]==endRline))
    {
        real_first++
    }
    while(real_last>=real_first && (input[real_last]==endline || input[real_last]==endRline))
    {
        real_last--
    }
    // update position
    position = new_end+1
    if(real_last>=real_first && real_last<len)
    {
        // good substring
        out=input[real_first:real_last]
    }
    else
    {
        out=""
    }
    return true
}

void parseAttributesString(string fullString, Skip &outList)
{
    string tmp_attValue=""
    Buffer input=create
    input += fullString
    int position=0
    while(getNextSubString(input, position, tmp_attValue))
    {
        if(tmp_attValue!="")
        {
            put(outList, tmp_attValue, false)
        }
    }
    delete input
}

bool isContainChar(string s, char ch)
{
	int i=0;
	for(i=0;i<length(s);++i)
	{
		if(s[i]==ch)
		{
		    return true
		}
	}
	
	return false
}

