// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//////////////////////////////////////////////////
//
// Message Strings to translate
//
const string GLSTR_obj_was_created = "Object was created"
const string GLSTR_obj_was_deleted = "Object was deleted"
const string GLSTR_obj_was_changed = "Object was changed"
const string GLSTR_obj_was_moved   = "Object was moved"
const string GLSTR_link_was_created = "Link was created"
const string GLSTR_link_was_deleted = "Link was deleted"
const string GLSTR_table_was_moved  = "Table was moved"
const string GLSTR_attribute_not_exists = "ERROR: The attribute not exists"
const string GLSTR_attribute_not_editable = "The attribute is not editable"
const string GLSTR_attribute_try_to_change_not_editable = "ERROR: You try to change not editable attribute"
const string GLSTR_attribute_validate_not_editable = "WARNING: Changing of the not editable attribute in TAU. The original value was restored in TAU:"
const string GLSTR_attribute_bad_value = "ERROR: Not alloved value for attribute"
const string GLSTR_attribute_bad_enum_value = "ERROR: Not alloved value for enumerated type"
const string GLSTR_attribute_bad_integer = "ERROR: The value is not Integer"
const string GLSTR_attribute_bad_real    = "ERROR: The value is not Real"
const string GLSTR_attribute_bad_date    = "ERROR: The value is not Date"
const string GLSTR_attribute_bad_range   = "ERROR: The value is not in the range"
const string GLSTR_warning_obj_name_changed = "WARNING: Changing of the object names in TAU. The original doors name was restored in TAU:"

// This value is used to set the order of some command at the end of the command list

const int MAX_INT_VALUE = 2147483646


//////////////////////////////////////////////////
// GLOBAL VARIABLES

//////////////////////////////////////////////////
// Current Module - set in 'beginUpdate'
Module currentUpdateModule = null
bool   currentUpdateModule_bWasOpened = false
string currentUpdateModuleID = ""
string currentUpdateModuleView = ""
bool   currentUpdateModule_bFullTree = false

bool   currentUpdateModule_bNeedPurge = false

// To work with attributes we need to set our module to 
// 'current' state. This variable is used to restore previous
// 'current' module in 'endUpdateModule'
Module previousCurrentModule = null

//////////////////////////////////////////////////
// All other opened modules ()
//  is filled by all opened modules and used to close all opened 
//   module during 'endUpdateModule'
Skip openedModulesIdMap = null
Skip openedModulesMap = null

//////////////////////////////////////////////////
// Store pairs of string TAUGUID-DOORSID for all new objects 
//  is used to create link on the objects which have 
//  not native doors id jet.
Skip createdTAUGUIDObjectsMap = null

//////////////////////////////////////////////////
// Store pairs string_DOORSID-Object for all object whic must be deleted 
// during 'endUpdateObjects' - but fails (by some reason).
// We save list of such object and to do second try to delete it
// during 'endUpdateModule'. 
// If some object was not deleted during second try - the message
// oabout this will pushed to TAU
Skip faildedDeleteObjectsMap = null

//////////////////////////////////////////////////
// Output resulting information from DOORS to TAU into external file
// it created in 'beginUpdate' and out to TAU in 'endUpdate' if some
// information in TAU must be updated
Stream infoToTAU = null
string infoToTAU_U2FileName = ""

//////////////////////////////////////////////////
// Statistic of all actions inside 'beginUpdate'-'endUpdate'
//
int statisticToTAU_object_processed = 0
int statisticToTAU_object_created = 0
int statisticToTAU_object_deleted = 0
int statisticToTAU_object_failed_create = 0
int statisticToTAU_object_failed_delete = 0
int statisticToTAU_object_moved = 0
int statisticToTAU_object_changed = 0

int statisticToTAU_link_processed = 0
int statisticToTAU_link_created = 0
int statisticToTAU_link_deleted = 0
int statisticToTAU_link_failed_delete = 0
int statisticToTAU_link_failed_create = 0

int statisticToTAU_table_processed = 0
int statisticToTAU_table_deleted = 0
int statisticToTAU_table_failed_deleted = 0
int statisticToTAU_table_failed_create = 0
int statisticToTAU_row_processed = 0
int statisticToTAU_row_deleted = 0
int statisticToTAU_row_failed_deleted = 0
int statisticToTAU_row_failed_create = 0
int statisticToTAU_cell_processed = 0
int statisticToTAU_cell_deleted = 0
int statisticToTAU_cell_failed_deleted = 0
int statisticToTAU_cell_failed_create = 0

bool isOutInformationObjectMove = true
bool isOutInformationObjectCreate = true
bool isOutInformationObjectDelete = true
bool isOutInformationObjectChange = true
bool isOutInformationLinkCreate = true
bool isOutInformationLinkDelete = true

//////////////////////////////////////////////////
// FUNCTIONS

//////////////////////////////////////////////////
// Write information back to TAU

void WriteObjectMessage(Stream s, string id, string TAUGUID, string message, string comment)
{
    int iDate = intOf(dateAndTime(today))
    //string out_message = u2pStringQuoted(message)
    //string out_comment = u2pStringQuoted(comment)
    string out_message = u2pString(message)
    string out_comment = u2pString(comment)
    writeToStream(s, "OutMessage (. time = " iDate " ,  id = \"" id "\", TAUGUID = \"" TAUGUID "\", message = \"" out_message "\", add_comment = \"" out_comment "\" .)\n")
}

void WriteIDOfUndeltedObjects(Stream s, string allID)
{
    writeToStream(s, "ObjectsWasNotDeleted (. time = " MAX_INT_VALUE " ,  objectID = { " allID " } .)\n")
}

void WriteStatisticSummary(Stream s, Module mod)
{
    int iDate = intOf(dateAndTime(today))
    // string tmpModuleName = u2pStringQuoted(fullName mod)
    // ", moduleName = \"" tmpModuleName 
    writeToStream(s, "StatisticSummary (. time = " iDate " , objProcessed = \"" statisticToTAU_object_processed"\" , linkProcessed = \"" statisticToTAU_link_processed "" )
    writeToStream(s, "\", objFailedCreate = \"" statisticToTAU_object_failed_create "\", objCreated = \"" statisticToTAU_object_created "" )
    writeToStream(s, "\", objFailedDelete = \"" statisticToTAU_object_failed_delete "\", objDeleted = \"" statisticToTAU_object_deleted "" )
    writeToStream(s, "\", linkFailedCreate = \"" statisticToTAU_link_failed_create "\", linkCreated = \"" statisticToTAU_link_created "" )
    writeToStream(s, "\", linkFailedDelete = \"" statisticToTAU_link_failed_delete "\", linkDeleted = \"" statisticToTAU_link_deleted "" )

    writeToStream(s, "\", tableProcessed = \"" statisticToTAU_table_processed "\", tableDeleted = \"" statisticToTAU_table_deleted "" )
    writeToStream(s, "\", tableFailedDelete = \"" statisticToTAU_table_failed_deleted "\", tableFailedCreate = \"" statisticToTAU_table_failed_create "" )
    writeToStream(s, "\", rowProcessed = \"" statisticToTAU_row_processed "\", rowDeleted = \"" statisticToTAU_row_deleted "" )
    writeToStream(s, "\", rowFailedDelete = \"" statisticToTAU_row_failed_deleted "\", rowFailedCreate = \"" statisticToTAU_row_failed_create "" )
    writeToStream(s, "\", cellProcessed = \"" statisticToTAU_cell_processed "\", cellDeleted = \"" statisticToTAU_cell_deleted "" )
    writeToStream(s, "\", cellFailedDelete = \"" statisticToTAU_cell_failed_deleted "\", cellFailedCreate = \"" statisticToTAU_cell_failed_create "" )
    
    writeToStream(s, "\", objMoved = \"" statisticToTAU_object_moved "\", objChanged = \"" statisticToTAU_object_changed "\" .)\n" )
}

//////////////////////////////////////////////////
//
// If we have information that some tables will be commited to the 
// we need set special state (it will discard optimization)
// This function must be called inside of block [beginUpdateModule-endUpdateModule]

void setTableModuleState(bool isModuleContainsTable)
{
    if(currentUpdateModule_bFullTree==true)
    {
        if(isModuleContainsTable==true)
        {
            currentUpdateModule_bFullTree = false
        }
    }
}

//////////////////////////////////////////////////
// Open module and save it as current

bool beginUpdateModule(string strModuleId, string strView)
{
    Item i = itemFromID(strModuleId)
    string errMsg = null
    currentUpdateModule_bWasOpened = false 
    currentUpdateModule = openModule(i, EDIT_MODE, strView, null, currentUpdateModule_bWasOpened, false, errMsg)

    if (currentUpdateModule==null || errMsg!=null)
    {
        if (currentUpdateModule_bWasOpened)
        {
            if(currentUpdateModule!=null)
            {
                close(currentUpdateModule)
            }
            currentUpdateModule_bWasOpened = false;
        }
	
        returnResult(errMsg)
        return false
    }	
    currentUpdateModuleID = strModuleId
    currentUpdateModuleView = strView
    if(strView == null || strView == "" || strView == TAU_STANDARD_VIEW)
    {
        currentUpdateModule_bFullTree = true
    }
    else
    {
        currentUpdateModule_bFullTree = false
    }

    // prepare output stream to returned information
    infoToTAU_U2FileName = tempFileName() ".u2p"
    infoToTAU = getStream(infoToTAU_U2FileName)
    if (infoToTAU == null)
    {
        close(currentUpdateModule)
        returnResult("IDS_CANNOT_OPEN_FILE: " lastError())
        return false
    }

    // init statistic
    statisticToTAU_object_processed = 0
    statisticToTAU_object_created = 0
    statisticToTAU_object_deleted = 0
    statisticToTAU_object_failed_create = 0
    statisticToTAU_object_failed_delete = 0
    statisticToTAU_object_moved = 0
    statisticToTAU_object_changed = 0

    statisticToTAU_link_processed = 0
    statisticToTAU_link_created = 0
    statisticToTAU_link_deleted = 0
    statisticToTAU_link_failed_delete = 0
    statisticToTAU_link_failed_create = 0

    statisticToTAU_table_processed = 0
    statisticToTAU_table_deleted = 0
    statisticToTAU_table_failed_deleted = 0
    statisticToTAU_table_failed_create = 0
    statisticToTAU_row_processed = 0
    statisticToTAU_row_deleted = 0
    statisticToTAU_row_failed_deleted = 0
    statisticToTAU_row_failed_create = 0
    statisticToTAU_cell_processed = 0
    statisticToTAU_cell_deleted = 0
    statisticToTAU_cell_failed_deleted = 0
    statisticToTAU_cell_failed_create = 0
    
    currentUpdateModule_bNeedPurge = false
    
    // init caches
    openedModulesIdMap = create
    openedModulesMap = create
    createdTAUGUIDObjectsMap = create
    faildedDeleteObjectsMap = create
    
    if (!null openedModulesIdMap)
        put(openedModulesIdMap, strModuleId, currentUpdateModule)
    if (!null openedModulesMap)
        put(openedModulesMap, currentUpdateModule, currentUpdateModule_bWasOpened)			
            
    // save setting of previous 'current' module
    // we need 'current' just to check the existing of Attributes
    previousCurrentModule=current Module
    if(previousCurrentModule==null || previousCurrentModule!=currentUpdateModule)
    {
        current = currentUpdateModule
    }
    
    return true
}

void endUpdateModule() 
{

    // Do second try to delete failed-undeleted objects (from 'endUpdateObjects')
    // inform to TAU about undeleted objects
    if(faildedDeleteObjectsMap!=null)
    {
        // multi pass processing of delted object need to do correct deletions of the object
        // with 'child'        
        bool wasDeletedAtLeasOneObject=false
        bool tmpWasDeletedObjectInLastCicle=true
        while (tmpWasDeletedObjectInLastCicle)
        {
            tmpWasDeletedObjectInLastCicle=false
            Object o
            for o in faildedDeleteObjectsMap do
            {
                if (o==null)
                    continue
                string tmp_CanDelete = canDelete(o)
                if (tmp_CanDelete!="")
                {
                    continue
                }
                tmpWasDeletedObjectInLastCicle=true
                wasDeletedAtLeasOneObject=true
                statisticToTAU_object_deleted++
                if(isOutInformationObjectDelete && infoToTAU != null)
                {
                    WriteObjectMessage(infoToTAU, getTAUID(o), "", GLSTR_obj_was_deleted , getTAUName(o))
                }
                softDelete(o)
                string tmpID=(string key faildedDeleteObjectsMap)
                delete(faildedDeleteObjectsMap, tmpID)
            }
            purgeObjects_(currentUpdateModule)
        }

        // info to TAU about final list of all undeleted objects
        Buffer bufAllUndeleted=create
        bool allDeletedSuccessfull=true
        Object o
        for o in faildedDeleteObjectsMap do
        {
            if (o==null)
                continue
            string strObjID = (string key faildedDeleteObjectsMap)
            if(!allDeletedSuccessfull)
            {
                bufAllUndeleted+=", "
            }
            bufAllUndeleted+='\"'
            bufAllUndeleted+=u2pString(strObjID)
            bufAllUndeleted+='\"'
            allDeletedSuccessfull=false
            statisticToTAU_object_failed_delete++
            if(infoToTAU != null)
            {
                 string tmp_CanDelete = canDelete(o)
                 string tmp_comment = getTAUName(o) " : " tmp_CanDelete ""
                 WriteObjectMessage(infoToTAU, getTAUID(o), "", "IDS_DOORS_OBJ_DELETE_FILED", tmp_comment)
            }
        }
        
        if(!allDeletedSuccessfull && infoToTAU != null)
        {
            WriteIDOfUndeltedObjects(infoToTAU, stringOf(bufAllUndeleted))
        }
        delete bufAllUndeleted
        
        delete faildedDeleteObjectsMap
        faildedDeleteObjectsMap = null
        //flushDeletions()
        if(wasDeletedAtLeasOneObject) 
        {
            // Discard purging from Tables if we made it for Object
            if(currentUpdateModule_bNeedPurge)
            {
                currentUpdateModule_bNeedPurge = false
            }
            string purge_result=purgeObjects_(currentUpdateModule)
            if(purge_result!=null && purge_result!="" && infoToTAU != null)
            {
                WriteObjectMessage(infoToTAU, "", "", "IDS_DOORS_OBJ_DELETE_FILED",  purge_result)
            }
        }
    }

    // Purging if it need for deleted Table Cell
    if(currentUpdateModule_bNeedPurge) 
    {
        currentUpdateModule_bNeedPurge=false
        string purge_result=purgeObjects_(currentUpdateModule)
        if(purge_result!=null && purge_result!="" && infoToTAU != null)
        {
            WriteObjectMessage(infoToTAU, "", "", "IDS_DOORS_OBJ_DELETE_FILED",  purge_result)
        }
    }
            
    if(currentUpdateModule!=null && infoToTAU!=null)
    {
        WriteStatisticSummary(infoToTAU, currentUpdateModule)
    }
    
    if(infoToTAU!=null)
    {
        close infoToTAU
        infoToTAU = null
    }

    if(currentUpdateModule != null)
    {
        save (currentUpdateModule)
    }
    
    //if(currentUpdateModule_bWasOpened==true && currentUpdateModule != null)
    //{
    //    close (currentUpdateModule)
    //}

    if(openedModulesMap!=null)
    {
        bool b
        for b in openedModulesMap do
        {
            if (!b)
                continue
            Module m = (Module key openedModulesMap)
            if (!null m)
            {
                close(m)
            }
        }
        delete openedModulesMap
        openedModulesMap = null
    }
    
    if(openedModulesIdMap!=null)
    {
        delete openedModulesIdMap
        openedModulesIdMap = null
    }

    if(createdTAUGUIDObjectsMap!=null)
    {
        delete createdTAUGUIDObjectsMap
        createdTAUGUIDObjectsMap = null
    }
		
	// Refresh DOORS Explorer after update
	if(currentUpdateModule!=null)
	{
		refreshExplorer(currentUpdateModule)
	}
    currentUpdateModule = null
    currentUpdateModuleID = ""
    currentUpdateModuleView = ""

    // restore previous 'current' module
    // we need 'current' just to check the existing of Attributes
    if(previousCurrentModule!=null)
    {
        current = previousCurrentModule
    }
    
    if(infoToTAU_U2FileName!=null && infoToTAU_U2FileName!="") 
    {
        returnResult(infoToTAU_U2FileName)
        infoToTAU_U2FileName = null
    }
    else 
    {
        returnResult("")
    }
}

