// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//////////////////////////////////////////////////
// Temporary cache and global variables

Skip objectLinkMap = null
Skip needsSaveMap = null

Module currentUpdateLinkModule = null
string currentUpdateLinkModuleFullName = ""

int TARGET_MODULE_ID = 0
int TARGET_MODULE_BASELINE = 1
int TARGET_OBJECT_ID = 2

//////////////////////////////////////////////////
//
// If the links is update with parameter link module
// than this module will be used for all new links
//
Module getUpdatedLinkModule(ModName_ src, ModName_ target, string& errMsg)
{
    if(currentUpdateLinkModule!=null)
        return currentUpdateLinkModule
    return getLinkModule(src, target, errMsg)
}

//////////////////////////////////////////////////
//
// Called when initiating a synchronization of links
// from TAU to DOORS. Initializes all internal structures.
//
//////////////////////////////////////////////////
bool beginUpdateLinks(string linkModuleName)
{
    if(currentUpdateModule == null)
    {
        return false
    }
    
    currentUpdateLinkModule = null
    currentUpdateLinkModuleFullName = ""
    bool currentUpdateLinkModule_bWasOpened = false
    
    if(linkModuleName!=null && linkModuleName!="")
    {
        // try to open given link module
        
        ModName_ moduleName = module(linkModuleName)
        if (null moduleName || !exists(moduleName))
        {
            // I dont sure now - may be we need create the module if it don't exist???
            // Create a new link module with given Name
            //const string strDescr = "Link module created automatically by TAU-DOORS Integration"
            //currentUpdateLinkModule = create(linkModuleName, strDescr, manyToMany, false)
            //if (null currentUpdateLinkModule)
            //{
            //    errMsg = ""
            //    return false
            //}
            WriteObjectMessage(infoToTAU, "", "", "IDS_LINK_MODULE_NOT_FOUND",  linkModuleName)
            return false
        }
        Item i = item(linkModuleName)
        if(null i || !canModify(i))
        {
            WriteObjectMessage(infoToTAU, "", "", "IDS_MODIFY_LINK_MODULE_FAILED",  linkModuleName)
            return false
        }
        Module m = null
        if(open(moduleName))
        {
            m = module(i)
            if (!null m && !canModify(m))
            {
                m = edit(linkModuleName,false)
            }
        }
        else 
        {
            m = edit(linkModuleName,false)
            currentUpdateLinkModule_bWasOpened = true
        }
        if(null m)
        {
            WriteObjectMessage(infoToTAU, "", "", "IDS_MODIFY_LINK_MODULE_FAILED",  linkModuleName)
            return false
        }
        currentUpdateLinkModule = m
        currentUpdateLinkModuleFullName = linkModuleName
        if (!null openedModulesMap)
            put(openedModulesMap, currentUpdateLinkModule, currentUpdateLinkModule_bWasOpened)			
    }

    objectLinkMap = create
    needsSaveMap = create

    return true
}

//////////////////////////////////////////////////////////////////////////////////////////
//
// Called for each link that is present in TAU.
// The link information is later used to synchronize all linksin endUpdateLinks.
//
// Note: beginUpdateLinks must be called before calling addLink
//
//////////////////////////////////////////////////////////////////////////////////////////
void addLink(string objectId, string targetModuleId, string targetBaseline, string targetId)
{
    if (null objectLinkMap)
        return

    Skip objectLinksSkip = null

    if (!find(objectLinkMap, objectId, objectLinksSkip))
    {
        objectLinksSkip = create
        put(objectLinkMap, objectId, objectLinksSkip)
    }

    Skip tmp = create
    put(tmp, TARGET_MODULE_ID, targetModuleId)
    put(tmp, TARGET_MODULE_BASELINE, targetBaseline)
    put(tmp, TARGET_OBJECT_ID, targetId)

    put(objectLinksSkip, targetModuleId "$" targetBaseline "$" targetId, tmp)    

}

void addLink(string objectId, string objectTAUGUID, string targetModuleId, string targetBaseline, string targetId, string targetTAUGUID)
{
    if(objectId==null || objectId=="") 
    {
        if(createdTAUGUIDObjectsMap==null || objectTAUGUID==null || objectTAUGUID=="")
            return
        if(!find(createdTAUGUIDObjectsMap, objectTAUGUID, objectId))
            return
        if(objectId==null || objectId=="")
            return
    }
    if(targetId==null || targetId=="") 
    {
        if(createdTAUGUIDObjectsMap==null || targetTAUGUID==null || targetTAUGUID=="")
            return
        if(!find(createdTAUGUIDObjectsMap, targetTAUGUID, targetId))
            return
        if(targetId==null || targetId=="")
            return
        targetModuleId = currentUpdateModuleID
        targetBaseline = ""
    }
    addLink(objectId, targetModuleId, targetBaseline, targetId)
}

//////////////////////////////////////////////////////////////////////////////////////////
//
// Same as addLink above, but used for links that are unbound in TAU.
// We don't have any target module id or target object id in that case 
// and have to derive the information in DOORS.
//
// Note: beginUpdateLinks must be called before calling addLink
//
//////////////////////////////////////////////////////////////////////////////////////////

Module getModule(string strModuleId, string strView, string strBaseline, int nMode, string& errMsg)
{
    Module result = null;

    if (openedModulesIdMap==null || !find(openedModulesIdMap, strModuleId, result))
    {
        bool bWasOpened = false
        result = openModule(itemFromID(strModuleId), nMode, strView, strBaseline, bWasOpened, false, errMsg)
        if (null result)
            return null
            
        // Store all opened modules in a map for optimization
        if (!null openedModulesIdMap)
        {
            put(openedModulesIdMap, strModuleId, result)
        }
        if (!null openedModulesMap)
        {
            put(openedModulesMap, result, bWasOpened)                        
        }
    }

    return result    
}

void getTargets(Skip& s, Module& targetModule, Object& targetObject)
{
    targetModule = null
    targetObject = null
    
    string targetModuleId = null
    string targetModuleBaseline = null
    string targetObjectId = null

    string targetModuleName = null
    string targetObjectReference = null

    find(s, TARGET_MODULE_ID, targetModuleId)
    find(s, TARGET_MODULE_BASELINE, targetModuleBaseline)
    find(s, TARGET_OBJECT_ID, targetObjectId)

    if (null targetModuleId)
        return

    // Match object id as well, for that we need to open the target module
    string errMsg = null
    targetModule = getModule(targetModuleId, null, targetModuleBaseline, READ_MODE, errMsg)
        
    if (null targetModule)
        return

    if (null targetObjectId)
        return

    targetObject = object(intOf(targetObjectId), targetModule)
}

//////////////////////////////////////////////////////////////////////////////////////////
//
// Called after adding all links that should be synchronized using addLink
// 
// Links present in TAU, i.e. added using addLink are preserved in DOORS if they exist. 
// If they don't exist they are created. Links that are not present in TAU are deleted.
//
// Note: beginUpdateLinks and addLink must be called before calling endUpdateLinks
//
//////////////////////////////////////////////////////////////////////////////////////////
void endUpdateLinks()
{
    // Verify that a successful call to beginUpdateLinks has been made
    // If not, preserve the error(s) from beginUpdateLinks and just return
    if (null currentUpdateModule || null objectLinkMap || null needsSaveMap)
        return

    string errMsg = null
    Object o
    for o in entire currentUpdateModule do
    {
        if (!isProcessedObject(o))
            continue
                        
        Skip value = null
        if (find(objectLinkMap, getTAUID(o), value))
        {
            string targetModuleId = null
            string targetModuleBaseline = null
            string targetObjectId = null

            Skip matchedLinks = create
            
            Link l
            for l in o -> "*" do
            {
                ModName_ linkTargetModuleName = target(l)
                Item i = item(fullName linkTargetModuleName)
                if (null i)
                    continue
                    
                string linkTargetModuleId = uniqueID(i)

                bool bLinkFound = false
                                                
                Skip tmp = null                
                for tmp in value do
                {
                    if (null tmp)
                        continue

                    // Optimization for the case where the modules are given by id and are different
                    if (find(tmp, TARGET_MODULE_ID, targetModuleId) && linkTargetModuleId != targetModuleId)
                        continue
                        
                    Module tmpM
                    Object tmpO
                    getTargets(tmp, tmpM, tmpO)
                    
                    if (null tmpM || null tmpO)
                        continue
                    string targetModuleBaseline
                    find(tmp, TARGET_MODULE_BASELINE, targetModuleBaseline)
                    
                    // Match the targets of the link with the targets of the skip entry
                    
                    // Start with the module names
                    if (fullName(tmpM) != fullName(linkTargetModuleName))
                        continue
                        
                    // Then the objects...
                    // For that we need to open the link target module
                                        
                    string errMsg = null
                    Module targetModule = getModule(linkTargetModuleId, null, targetModuleBaseline, READ_MODE, errMsg)
                    if (null targetModule)
                        continue
                    
                    Object linkTargetObject = target(l)                    
                    if (null linkTargetObject)
                        continue
                    
                    string tmpTargetId = getTAUID(tmpO)
                    if (tmpTargetId == getTAUID(linkTargetObject))
                    {
                        bLinkFound = true
                        if (!null matchedLinks)
                            put(matchedLinks, targetModuleId "$" targetModuleBaseline "$" tmpTargetId, true)
                    }
                }
                
                statisticToTAU_link_processed++

                if (!bLinkFound)
                {
                    if (canDelete(l))
                    {
                        delete l
                        statisticToTAU_link_deleted++
                        if(isOutInformationLinkDelete && infoToTAU != null)
                        {
                            string tmp_comment = "" source(l) "->" target(l) ""
                            WriteObjectMessage(infoToTAU, getTAUID(o), "", GLSTR_link_was_deleted, tmp_comment)
                        }
                        
                    }
                    else
                    {
                        statisticToTAU_link_failed_delete++
                        if(infoToTAU != null)
                        {
                            string tmp_comment = "" source(l) "->" target(l) ""
                            WriteObjectMessage(infoToTAU, getTAUID(o), "", "IDS_DELETE_LINK_FAILED", tmp_comment)
                        }
                    }
                }                
                                
            }                
            
            flushDeletions()
            
            Skip tmp = null                
            for tmp in value do
            {
                if (null tmp)
                    continue

                string s = (string key value)                
                if (!find(matchedLinks, s))
                {
                    Module targetModule = null
                    Object targetObject = null
                    getTargets(tmp, targetModule, targetObject)
                    
                    if (null targetModule || null targetObject)
                        continue

                    statisticToTAU_link_processed++
                        
                    Module linkModule = getUpdatedLinkModule(module(fullName(currentUpdateModule)), module(fullName(targetModule)), errMsg)
                    if (null linkModule)
                    {
                        statisticToTAU_link_failed_create++
                        if(infoToTAU != null)
                        {
                            string tmp_comment = "" fullName(currentUpdateModule) "->" fullName(targetModule) ""
                            WriteObjectMessage(infoToTAU, getTAUID(o), "", "IDS_CREATE_LINK_FAILED", tmp_comment)
                        }
                        continue
                    }

                    Link l = createLink(o, targetObject, linkModule, errMsg)
                    if (null l)
                    {
                        statisticToTAU_link_failed_create++
                        if(infoToTAU != null)
                        {
                            string tmp_comment = "" fullName(currentUpdateModule) "->" fullName(targetModule) "." getTAUID(targetObject) ""
                            WriteObjectMessage(infoToTAU, getTAUID(o), "", "IDS_CREATE_LINK_FAILED", tmp_comment)
                        }
                        continue
                    }

                    statisticToTAU_link_created++
                    if(isOutInformationLinkCreate && infoToTAU != null)
                    {
                        string tmp_comment = "" fullName(currentUpdateModule) "->" fullName(targetModule) "." getTAUID(targetObject) ""
                        WriteObjectMessage(infoToTAU, getTAUID(o), "", GLSTR_link_was_created, tmp_comment)
                    }
                    
                    if(openedModulesMap!=null)
                        put(openedModulesMap, linkModule, true)
                    if(needsSaveMap!=null)
                    {
                        put(needsSaveMap, linkModule, linkModule)
                        //put(needsSaveMap, currentUpdateModule, linkModule)  // ??? olegt ??? 
                    }
                }
            }
            
            delete matchedLinks
        }
        else
        {
            // Delete all outgoing links
            Link l
            for l in o -> "*" do {

                statisticToTAU_link_processed++
                
                if (canDelete(l))
                {
                    delete (l)
                    statisticToTAU_link_deleted++
                    if(isOutInformationLinkDelete && infoToTAU != null)
                    {
                        string tmp_comment = "" source(l) "->" target(l) ""
                        WriteObjectMessage(infoToTAU, getTAUID(o), "", GLSTR_link_was_deleted, tmp_comment)
                    }
                } 
                else
                {
                    statisticToTAU_link_failed_delete++
                    if(infoToTAU != null)
                    {
                        string tmp_comment = "" source(l) "->" target(l) ""
                        WriteObjectMessage(infoToTAU, getTAUID(o), "", "IDS_DELETE_LINK_FAILED", tmp_comment)
                    }
                    continue
                }
            }
            flushDeletions()

        }        
    }

    if (!null objectLinkMap)
    {
        Skip tmp = null
        for tmp in objectLinkMap do
        {
            if (!null tmp)
                delete tmp
        }
        delete objectLinkMap
    }

    if (!null needsSaveMap)
    {
        Module m = null
        for m in needsSaveMap do
        {
            save(m)
        }
        delete needsSaveMap
    }

    currentUpdateLinkModule = null
    currentUpdateLinkModuleFullName = ""
       
}
