// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:21 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//////////////////////////////////////////////////
//
// The objects in module can be updated in 2 mode - Ordered and Unordered
// (the second is not realized yet)
//
// In Ordered mode the order of created object must be in 
// accordance with their hierarchi in the tree.
//   (it's fast mode without additional search of object by ID to move)
//   (the 'moveObject' function don't used - the 'level' value is used)
//
// The Unordered mode can be used to update any number of objects in any 
// orbitraty order but to set obejct in right position you must used 
// finction 'moveObject' and you must be sure that all objects parameters 
// have DOORs ID before using.
//

//////////////////////////////////////////////////
// GLOBAL VARIABLES

//////////////////////////////////////////////////
// This stack is used to minimize the search of objects in module
// the information from it is used in 'beginUpdateObject' to move
// the object in correct position
// To move the object in arbitrary position the function 
// 'moveObject' must be used
Array currentObjectStack = null
int   currentObjectStackSize = 0
bool  isOrderedUpdateMode = true

//////////////////////////////////////////////////
// Map of processed object
Skip processedObjectIdMap = null

//////////////////////////////////////////////////
// Map of processed tables (used in EndUpdateObjects to delete all visible unprocessed tables)

Skip processedTableIdMap = null

//////////////////////////////////////////////////
// Map of processed row inside of the tables 
// This is used only to be sure that order of rows
// inside of the table is not changed.
// The reason - that I cannot do 'move' inside of table to reorder row 
// in accordance with information from TAU side.
// If order is damaged - the warning message is out.

Skip processedTableRowIdMap = null
Skip processedTableRowToDeleteIdMap = null

//////////////////////////////////////////////////
// Map of processed cell inside of the table row
// This is used only to be sure that order of cells
// inside of the table row is not changed.
// The reason - that I cannot do 'move' inside of table row to reorder cell
// in accordance with information from TAU side.
// If order is damaged - the warning message is out.

Skip processedTableCellIdMap = null
Skip processedTableCellToDeleteIdMap = null

//////////////////////////////////////////////////
// Current Object - set in 'beginUpdateObject'
Object currentUpdatedObject = null
string currentUpdatedObjectID = ""
string currentUpdatedObjectTAUGUID = ""
int    currentUpdatedObjectLevel = 0
bool   currentUpdatedObject_wasChanged = false
bool   currentUpdatedObject_wasCreated = false

//////////////////////////////////////////////////
// FUNCTIONS

string DeleteDoorsTable(Object ptrCell)
{
    
    string tmp_WasDelete = deleteTable(ptrCell)
    currentUpdateModule_bNeedPurge = true
    //string tmp_WasDelete = "Deletion/filtering of the table don't supported jet"
    return tmp_WasDelete
}

//////////////////////////////////////////////////
// Write information back to TAU

void WriteObjectIDChanged(Stream s, string oldID, string TAUGUID, string newID)
{
    writeToStream(s, "ObjectIDChanged (. time = 0, oldID = \"" oldID "\", newID = \"" newID "\", TAUGUID = \"" TAUGUID "\" .)\n")
}

// 'isRequirementAttribute' must be 'true' for attributes from <requirementAttribute> stereotype
// if 'isRequirementAttribute'==false  the type must be 'name/text/heading' to set appropriate
// attributes of <requirement> stereotype
void WriteObjectAttributeChanged(Stream s, string doorsID, string TAUGUID, bool isRequirementAttribute, string attr_type, string attr_value)
{
    string tmps_type=u2p2pString(attr_type)
    string tmps_value=u2p2pString(attr_value)
    string reqAttr = isRequirementAttribute ? "true" : "false"
    writeToStream(s, "ObjectAttributeChanged (. time = 0, doorsID = \"" doorsID "\", TAUGUID = \"" TAUGUID "\", reqAttr = " reqAttr ", name = \"" tmps_type "\", 'value' = \"" tmps_value "\" .)\n")
}

//////////////////////////////////////////////////
void AddTableIdentificatorToProcessedTableIdMap(Object table)
{
	string tableID = getTAUID table
	
	if(processedTableIdMap!=null && tableID!="")
	{
        put(processedTableIdMap, tableID, tableID)  
    }
}

//////////////////////////////////////////////////
// Start Updating of all objects - init stack of objects for ordered mode

bool beginUpdateObjects(int stackSize) 
{
    if(currentUpdateModule==null)
    {
        return false
    }
    
    isOrderedUpdateMode = true
    if(stackSize>0)
    {
        currentObjectStackSize = stackSize+1
    }
    else 
    {
        currentObjectStackSize = 1
    }
    currentObjectStack = create(currentObjectStackSize,1)
    if (currentObjectStack==null)
    {
        return false
    }	
    
    processedObjectIdMap = create
    if(processedObjectIdMap==null)
    {
        delete currentObjectStack
        currentObjectStack = null
        currentObjectStackSize = 0
        return false
    }

    processedTableIdMap = create
    if(processedTableIdMap==null)
    {
        delete currentObjectStack
        delete processedObjectIdMap
        currentObjectStack = null
        currentObjectStackSize = 0
        return false
    }
    
    return true
}

void endUpdateObjects() 
{

    // Delete all visible objects in module which was not processed by 'beginUpdateObject'
    if(currentUpdateModule!=null && processedObjectIdMap!=null && processedTableIdMap!=null) 
    {
        bool was_object_deleted=false
        Object o
        for o in entire currentUpdateModule do
        {
            string tmp_deleted = null
            
            // Delete not processed tables which contains visible cells
            if(table(o) && !find(processedTableIdMap, getTAUID(o), tmp_deleted) && !leaf(o))
            {      
                statisticToTAU_object_processed++
                string table_name = getTAUName(o)
                string table_id = getTAUID(o)
                Object visibleCell=getFirstVisibleTableCell(o)
                if(visibleCell!=null)
                {
                    string tmp_WasDelete = DeleteDoorsTable(visibleCell)
                    if (tmp_WasDelete=="")
                    {
                        was_object_deleted = true
                        statisticToTAU_table_deleted++
                        if(isOutInformationObjectDelete && infoToTAU != null)
                        {
                            string tmp_comment = "Table: [" table_name "]"
                            WriteObjectMessage(infoToTAU, table_id, "", GLSTR_obj_was_deleted , tmp_comment)
                        }
                    }
                    else
                    {
                        statisticToTAU_table_failed_deleted++
                        if(infoToTAU != null)
                        {
                            string tmp_comment = "" tmp_WasDelete " Table: [" table_name "]"
                            WriteObjectMessage(infoToTAU, table_id, "", "IDS_DOORS_OBJ_DELETE_FILED", tmp_comment)
                        }
                    }
                }
                else
                {
                    // assert - this brunch must not be run never
                    string tmp_comment = "Internal error during deletion of Table: [" table_name "]"
                    WriteObjectMessage(infoToTAU, table_id, "", "IDS_DOORS_OBJ_DELETE_FILED", tmp_comment)
                }
                continue
            }

            // Skipp from deletion all Unvisible/Deleted/Cell objects 
            // (cells must be delted inside of BeginUpdateTable()-EndUpdateTable()
            //if (!isVisible(o) || isDeleted(o))
            if (!isVisible(o) || isDeleted(o) || cell(o) || row(o) || table(o))
            {
                continue
            }
            
            if (!find(processedObjectIdMap, getTAUID(o), tmp_deleted))
            {
                statisticToTAU_object_processed++
                string tmp_CanDelete = canDelete(o)
                if (tmp_CanDelete=="")
                {
                
                    was_object_deleted = true
                    statisticToTAU_object_deleted++
                    if(isOutInformationObjectDelete && infoToTAU != null)
                    {
                        WriteObjectMessage(infoToTAU, getTAUID(o), "", GLSTR_obj_was_deleted , getTAUName(o))
                    }
                    //delete (o)
                    softDelete (o)
                }
                else
                {
                    // just put to special cache to do second try to delete during 'endUpdateModule'
                    put(faildedDeleteObjectsMap, getTAUID(o), o)
                }
                
            }
        }
        //flushDeletions()
        if(was_object_deleted) 
        {
            // Discard purging from Tables if we made it for Object
            if(currentUpdateModule_bNeedPurge)
            {
                currentUpdateModule_bNeedPurge = false
            }
            string purge_result=purgeObjects_(currentUpdateModule)
            if(purge_result!=null && purge_result!="" && infoToTAU != null)
            {
                WriteObjectMessage(infoToTAU, "", "", "IDS_DOORS_OBJ_DELETE_FILED", purge_result)
            }
        }
    }
        
    if(currentObjectStack!=null) 
    {
        delete currentObjectStack
        currentObjectStack = null
        currentObjectStackSize = 0
    }
    if(processedObjectIdMap!=null) 
    {
        delete processedObjectIdMap
    }
    if(processedTableIdMap!=null) 
    {
        delete processedTableIdMap
    }
}

//////////////////////////////////////////////////
// Clear given level in stack

void clearStackLevel(int stackLevel) 
{
    put(currentObjectStack, null, stackLevel, 0) 
}

//////////////////////////////////////////////////
// Start updating of object - set it as current
//
// 1. Find object with given ID
// 2. Create object if it was not found or given ID is empty
// 3. Move object if it was not created in right position (for Ordered mode)
// 4. Save object as current
// 5. Save object as givel level of stack
// 6. If the object was created out the command 'ObjectIDChanged' to output file to TAU

bool beginUpdateObject(string objectId, string objectITAUGUID, int objectLevel)
{
    if(processedObjectIdMap==null || processedTableIdMap==null || (isOrderedUpdateMode==true && currentObjectStackSize==null))
    {
        return false
    }
    string errMsg = null
    Object obj = null
    bool was_created = false
    if(objectId != "")
    {
        obj = findObject(currentUpdateModule, objectId, errMsg)
    }
    if(obj==null) 
    {
        // object not found - create it
        was_created = true
        if(isOrderedUpdateMode)
        {
            Object objRef = null
            objRef = (Object get(currentObjectStack,objectLevel,0)) 
            if(objRef != null) 
            {
                obj = create (objRef)
            }
            else 
            {
                if(objectLevel-1 >= 0)
                {
                    objRef = (Object get(currentObjectStack,objectLevel-1,0)) 
                }
                if(objRef != null) 
                {
                    obj = create (below (objRef))
                }
                else 
                {
                    obj = create (currentUpdateModule)
                }
                
            }
        }
        else
        {
            obj = create (currentUpdateModule)
        }
    }

    statisticToTAU_object_processed++
    
    if(obj==null) 
    {
        statisticToTAU_object_failed_create++
        if(infoToTAU != null)
        {
            WriteObjectMessage(infoToTAU, objectId, objectITAUGUID, "IDS_DOORS_OBJ_CREATE_FILED",  "")
        }
        return false
    }

    if(table(obj) || row(obj) || cell(obj))
    {
        if(infoToTAU != null)
        {
            WriteObjectMessage(infoToTAU, objectId, objectITAUGUID, "IDS_UNKNOWN_DOORS_ERROR",  "Processing of the table/row/cell is not supported inside beginUpdateObject()")
        }
        return false
    }
    
    string objRealID = getTAUID(obj)
    put(processedObjectIdMap, objRealID, objRealID)

    if(isOrderedUpdateMode==true && was_created!=true)
    {
        Object objRef = null
        objRef = (Object get(currentObjectStack,objectLevel,0)) 
        if(objRef != null) 
        {
            // set after 'objRef'
            //if(currentUpdateModule_bFullTree)
            Object objRefOld = null
            if(currentUpdateModule_bFullTree)
            {
                // fast function without any search (because we know that it's Standart View)
                objRefOld = getPreviousSiblingInTree (obj)
            }
            else
            {
                // function to work with View with FILTERED Tree
                objRefOld = getPreviousSiblingInFilteredTree (obj)
            }
            if(objRefOld!=objRef) {
                //check for canRead - don't move read-locked objects
                if(null objRefOld || canRead(objRefOld)){
                    move(obj, objRef)
                    statisticToTAU_object_moved++
                    if(isOutInformationObjectMove && infoToTAU != null && obj!=null)
                    {
                        WriteObjectMessage(infoToTAU, objRealID, objectITAUGUID, GLSTR_obj_was_moved, getTAUName(obj))
                }
                }
            }
        }
        else 
        {
            if(objectLevel-1 >= 0)
            {
                objRef = (Object get(currentObjectStack,objectLevel-1,0)) 
            }
            if(objRef != null) 
            {
                // set as child of 'objRef'
                Object objRefOld = getParentInTree (obj) 
                if(objRefOld!=objRef) {
                    move(obj, below (objRef))
                    statisticToTAU_object_moved++
                    if(isOutInformationObjectMove && infoToTAU != null && obj!=null)
                    {
                        WriteObjectMessage(infoToTAU, objRealID, objectITAUGUID, GLSTR_obj_was_moved, getTAUName(obj))
                    }
                }
            }
            else 
            {
                // move to first visible position
                if(move_to_top(currentUpdateModule, obj))
                {
                    statisticToTAU_object_moved++
                    if(isOutInformationObjectMove && infoToTAU != null && obj!=null)
                    {
                        WriteObjectMessage(infoToTAU, objRealID, objectITAUGUID, GLSTR_obj_was_moved, getTAUName(obj))
                    }
                }
            }
        }
    }

    if(isOrderedUpdateMode)
    {
        put(currentObjectStack,obj,objectLevel,0)
    }

    if(was_created==true) 
    {
        if(infoToTAU != null)
        {
            WriteObjectIDChanged(infoToTAU, objectId, objectITAUGUID, objRealID)
        }
        // update statistic
        statisticToTAU_object_created = statisticToTAU_object_created+1

        if(isOutInformationObjectCreate && infoToTAU != null && obj!=null)
        {
            WriteObjectMessage(infoToTAU, objRealID, objectITAUGUID, GLSTR_obj_was_created, getTAUName(obj))
        }
        
        // add element in cashe of created objects
        put(createdTAUGUIDObjectsMap, objectITAUGUID, objRealID)
        currentUpdatedObject_wasCreated = true
    }
    else
    {
        currentUpdatedObject_wasCreated = false
    }
    
    currentUpdatedObject = obj
    currentUpdatedObjectID = objectId
    currentUpdatedObjectTAUGUID = objectITAUGUID
    currentUpdatedObject_wasChanged = false
    currentUpdatedObjectLevel = objectLevel
    
    return true
}

//////////////////////////////////////////////////
// Clear current object

void endUpdateObject() 
{
    if(currentUpdatedObject_wasChanged) 
    {
        statisticToTAU_object_changed++

        if(isOutInformationObjectChange && infoToTAU != null && currentUpdatedObject!=null)
        {
            WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_obj_was_changed, getTAUName(currentUpdatedObject))
        }
        
    }
    currentUpdatedObject = null
    currentUpdatedObjectID = ""
    currentUpdatedObjectTAUGUID = ""
    currentUpdatedObject_wasChanged =  false
    currentUpdatedObject_wasCreated = false
    currentUpdatedObjectLevel = 0
}

//////////////////////////////////////////////////
// Set attribute values for current object

void RestoreOriginalAttributeValueInTAUForCurrentObject(string attName, string attValue, string attOrigValue)
{
    // the message is out only if you try to change the value
    if(infoToTAU != null)
    {
        if(isTAUAttributeValidated)
        {
            // generate command to TAU to return this attribute to original DOORS value
            WriteObjectAttributeChanged(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, true, attName, attOrigValue)
            // the message is out only for 'old' objects (they was not created in 'BeginUpdateObject')
            if(!currentUpdatedObject_wasCreated)
            {
                string tmp_comment= "[" attValue "]->[" attOrigValue "]"
                WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_validate_not_editable, tmp_comment)
            }
        }
        else
        {
            WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_try_to_change_not_editable, attName)
        }
    }
}

//-----------------------------------------------------------------
bool createDiagramTable(Object diagramObject, Object &diagramCell, string diagramGUID) 
{
	const string local_TAU_ATTR_UML_GUID = "UML Guid"

	Object diagramTable = getTable diagramObject
	if (diagramTable != null) {
		return false
	}

	Column column
	int totalWidth = 0
	for column in current Module do {
		totalWidth += width(column)
	}

	diagramTable = table(below diagramObject, 1,1)
	setShowTableAcrossModule(diagramTable, true)
	setAllCellsWidth(diagramTable, totalWidth)
	Object rowO
	for rowO in table (diagramTable) do {
		Object cellO
		for cellO in row (rowO) do {
			diagramCell = cellO
			diagramCell.local_TAU_ATTR_UML_GUID = (diagramGUID == "" || diagramGUID == null) ? "N/A" : diagramGUID
		}
	}
	
	//for endUpdateObjects - do not delete this table
	AddTableIdentificatorToProcessedTableIdMap(diagramTable)
        
	return true
}

Object getDiagramImage (Object diagramObject, bool createNew) 
{
	const string strNULL				= null
	const string local_TAU_ATTR_UML_GUID		= "UML Guid"
	const string local_OBJECT_TEXT			= "Object Text"

	if (getTable(diagramObject) != null) {
		// Already inside a table
		return null
	}

	Module currentModule = module (diagramObject)

	Object diagramTable = null
	Object diagram = null

	string diagramGUID = probeAttr_(diagramObject, local_TAU_ATTR_UML_GUID)
	for diagramTable in diagramObject do 
	{
		if (table diagramTable) {
			int cellNumber = 0
			Object rowHead
			for rowHead in table (diagramTable) do {
				Object cell
				for cell in row rowHead do {
					cellNumber++
					diagram = cell
				}
			}
			string cellGUID = probeAttr_(diagram, local_TAU_ATTR_UML_GUID)
			if ((cellNumber == 1) && (diagramGUID == cellGUID || cellGUID == "N/A")) {
				//for endUpdateObjects - do not delete this table
				AddTableIdentificatorToProcessedTableIdMap(diagramTable)
    
				// Found existing diagram image
				break
			} else {
				// Need to create a new one
				diagram = null
			}
		}
	}

	if (diagram == null && createNew) {
		createDiagramTable(diagramObject, diagram, diagramGUID)
	}
	
	return diagram
}

string setRTFDiagramImage (string rtfPath, Object diagramObject) 
{
	const string strNULL 				= null
	const string local_TAU_ATTR_UML_GUID		= "UML Guid"
	const string local_OBJECT_TEXT			= "Object Text"
	const string local_OBJECT_HEADING		= "Object Heading"

	if (diagramObject == null) 
	{
		return "Diagram object is null"
	}
	
	bool createNewDiagramImage = true;
	if(null rtfPath) //this needed for elements (this function envoked for deleting RTF attribute for elements)
	{
		createNewDiagramImage = false;
	}

	Object diagram = getDiagramImage(diagramObject, createNewDiagramImage)

	if (diagram == null) 
	{
		return "Error accessing diagram image object"
	}

	if (null rtfPath) 
	{
		Object table = getTable(diagram)
		if (null != table) 
		{
			deleteTable(table)
		}
		return strNULL // Success
	}

	// Create attribute if non-existent; normally it exists for DOORS/Analyst
	Module m = module diagram
	current = m

	string sModulePath = fullName(module diagram)
	bool bModuleAlreadyOpen = open(module sModulePath)
	bool bIsEdit = bModuleAlreadyOpen && isEdit(module diagram)


    // Read RTF data from file
	Stat s = create rtfPath

	if (!null s) 
	{
		string rtf = readFile(rtfPath)    

		diagram.local_OBJECT_TEXT = richText rtf

		delete s
	}
	else
	{
		return "Unable to read diagram image file " rtfPath
	}

	deleteFile rtfPath      

	// Force modification of Object Heading
	string sObjectHeading = diagramObject.local_OBJECT_HEADING
	diagramObject.local_OBJECT_HEADING = ""
	diagramObject.local_OBJECT_HEADING = sObjectHeading

	setCellAlignment(diagram, center)

	return strNULL // Success
}

void SetRTFDiagramImage (string rtfPath) 
{
	setRTFDiagramImage(rtfPath, currentUpdatedObject)
}
//-----------------------------------------------------------------

void createObjectAttributeValue(string attrName, string attrValue)//!!!
{
    if (!exists (attribute attrName))
    {
		create object type "Text" attribute(attrName)
    }

    currentUpdatedObject.attrName = attrValue
}

void setObjectProperty(string propertyName, string propertyVal)
{
	if(propertyName=="RTF Image")
	{
	    if(propertyVal!="")
			SetRTFDiagramImage(propertyVal)
			
		return
	}
	createObjectAttributeValue(propertyName, propertyVal)
}

void setObjectAttributeValue(string attName, string attValue)
{
    if(currentUpdatedObject==null || attName=="")
    {
        return
    }
    //if(!exists (attribute attName))
    //{
    //    if(infoToTAU != null)
    //    {
    //        WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_not_exists, attName)
    //    }
    //    return
    //}
    //
    // The attribute "Object number" is absent in 'find(currentUpdateModule, attName)'
    // and must be processed and restored separetely 
    if(!IsValidTAUAttribute(attName))
    {
        // restore in TAU original value
        noError
        string old_value=probeAttr_(currentUpdatedObject,attName)
        if (lastError != null)
        {
            if(infoToTAU != null)
            {
                WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_not_exists, attName)
            }
            return
        }
        if(!isEqualStringNoUNIXEndline(old_value, attValue))
        {
            RestoreOriginalAttributeValueInTAUForCurrentObject(attName, attValue, old_value)
        }
        return
    }
    
    AttrDef ad = find(currentUpdateModule, attName) 
    if(ad==null)
    {
        if(infoToTAU != null)
        {
            WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_not_exists, attName)
        }
        return
    }
    AttrType at = ad.type
    if(at==null)
    {
        if(infoToTAU != null)
        {
            WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_not_exists, attName)
        }
        return
    }
    // if Value is equal to old - nothing to do
    string old_value=probeAttr_(currentUpdatedObject,attName)
    if(isEqualStringNoUNIXEndline(old_value, attValue))
    {
        return
    }
    
    // Check on editable
    //if(!at.canWrite) // useraccess
    if(!ad.useraccess)
    {
        RestoreOriginalAttributeValueInTAUForCurrentObject(attName, attValue, old_value)
        return
    }
    // Separated processing for Enum/Integer/Real/Date/+-Range
    if(at.type==attrReal)
    {
        if(!isValidReal(attValue))
        {
            if(infoToTAU != null)
            {
                WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_real, attValue)
            }
        }
        else
        {
            real newval=realOf(attValue)
            real oldval=currentUpdatedObject.attName
            if(oldval!=newval)
            {
                if (isRanged(at))
                {
                    bool minValueSet = at.minValue
                    bool maxValueSet = at.maxValue
                    if ((minValueSet && newval < at.minValue) || (maxValueSet && newval > at.maxValue))
                    {
                        if(infoToTAU != null)
                        {
                            Buffer tmp_str = create
                            tmp_str+= "" attValue " <> ["
                            if(minValueSet)
                            {
                                real tmpr=at.minValue
                                tmp_str+= "" tmpr ""
                            }
                            tmp_str+= ":"
                            if(maxValueSet)
                            {
                                real tmpr=at.maxValue
                                tmp_str+= "" tmpr ""
                            }
                            tmp_str+= "]"
                            WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_range, stringOf(tmp_str))
                            delete tmp_str
                        }
                        return
                    }
                }
                currentUpdatedObject.attName = newval
                currentUpdatedObject_wasChanged = true
            }
        }
        return
    }
    if(at.type==attrInteger)
    {
        if(!isValidInt(attValue))
        {
            if(infoToTAU != null)
            {
                WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_integer, attValue)
            }
        }
        else
        {
            int newval=intOf(attValue)
            int oldval=currentUpdatedObject.attName
            if(oldval!=newval)
            {
                if (isRanged(at))
                {
                    bool minValueSet = at.minValue
                    bool maxValueSet = at.maxValue
                    if ((minValueSet && newval < at.minValue) || (maxValueSet && newval > at.maxValue))
                    {
                        if(infoToTAU != null)
                        {
                            Buffer tmp_str = create
                            tmp_str+= "" attValue " <> ["
                            if(minValueSet)
                            {
                                int tmpi=at.minValue
                                tmp_str+= "" tmpi ""
                            }
                            tmp_str+= ":"
                            if(maxValueSet)
                            {
                                int tmpi=at.maxValue
                                tmp_str+= "" tmpi ""
                            }
                            tmp_str+= "]"
                            WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_range, stringOf(tmp_str))
                            delete tmp_str
                        }
                        return
                    }
                }
                currentUpdatedObject.attName = newval
                currentUpdatedObject_wasChanged = true
            }
        }
        return
    }
    if(at.type==attrDate)
    {
        //  !!! There ate not validation of string for Date! 
        // by the trye - it's IS - but dont WORK!
        /*
        if(!isValidDate(attValue))
        {
            if(infoToTAU != null)
            {
                WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_date, attValue)
            }
        }
        else
        {
        */

        //
        //Date newval = attValue
        noError
        Date newval=convertDate(attValue)
        if (lastError != null || newval==null)
        {
            if(infoToTAU != null)
            {
                string tmp_comment= "" lastError " [" attValue "]"
                WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_date, tmp_comment)
            }
            return
        }
        Date oldval=currentUpdatedObject.attName
        if(oldval!=newval)
        {
            if (isRanged(at))
            {
                bool minValueSet = at.minValue
                bool maxValueSet = at.maxValue
                if ((minValueSet && newval < at.minValue) || (maxValueSet && newval > at.maxValue))
                {
                    if(infoToTAU != null)
                    {
                        string tmp_comment= "" attValue " <> [" at.minValue " : " at.maxValue "]"
                        WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_range, tmp_comment)
                    }
                    return
                }
            }
            currentUpdatedObject.attName = newval
	        currentUpdatedObject_wasChanged = true
        }
        return
    }
    
    if(at.type==attrEnumeration)
    {
        bool isMultiValue = ad.multi
        if(isMultiValue)
        {
            Skip newValuesList = create
            parseAttributesString(attValue, newValuesList)

            // scan all possible values in this type, and set Values it if it's finded in 'attValue'
            // (also marked the used records in 'newValuesList' as 'processed')
            int i
            for(i = 0; i < at.size; i++)
            {
                string type_template=at.strings[i]
                bool isProcessed=false
                if(find(newValuesList, type_template, isProcessed))
                {
                    if(!isMember(currentUpdatedObject.attName, type_template))
                    {
                        currentUpdatedObject.attName += type_template
                        currentUpdatedObject_wasChanged = true
                    }
                    delete(newValuesList, type_template)
                }
                else 
                {
                    if(isMember(currentUpdatedObject.attName, type_template))
                    {
                        currentUpdatedObject.attName -= type_template
                        currentUpdatedObject_wasChanged = true
                    }
                }
            }
            // scan processed 'attValue' and give warning in tau about all 'not processed' values
            Buffer tmp_str = create
            bool isUnprocessedPresented=false
            bool isProcessed
            for isProcessed in newValuesList do
            {
                string not_processed_value = (string key newValuesList)
                if(isUnprocessedPresented)
                {
                    tmp_str += ", "
                }
                else
                {
                    tmp_str += "The value(s) ["
                }
                tmp_str +="["
                tmp_str += not_processed_value
                tmp_str +="]"
                isUnprocessedPresented=true
            }
            if(isUnprocessedPresented)
            {
                tmp_str += "] is not in the range of ["
                int ii
                for(ii = 0; ii < at.size; ii++)
                {
                    tmp_str += " ["
                    tmp_str += at.strings[ii]
                    tmp_str += "]"
                }
                tmp_str += "]"
                if(infoToTAU != null)
                {
                    WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_enum_value, stringOf(tmp_str))
                }
            }
            // clear error string and skip list
            delete tmp_str
            delete newValuesList
            // all multi value is processed
            return
        }

        // Processing of Single value enum
        
        // check that given value is alloved
        int i
        for(i = 0; i < at.size; i++)
        {
            if(attValue==at.strings[i])
            {
                break
            }
        }
        if(at.size!=0 && i==at.size)
        {
            // Bad Value
            Buffer tmp_str = create
            tmp_str += "Value [" 
            tmp_str += attValue 
            tmp_str += "] is not in the range of ["
            int ii
            for(ii = 0; ii < at.size; ii++)
            {
                tmp_str += " ["
                tmp_str += at.strings[ii]
                tmp_str += "]"
            }
            tmp_str += "]"
            if(infoToTAU != null)
            {
                WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_enum_value, stringOf(tmp_str))
            }
            delete tmp_str
            return
        }
        
    }
        
    noError
    currentUpdatedObject.attName = attValue 
    if (lastError != null)
    {
        if(infoToTAU != null)
        {
            string tmp_comment= "" lastError " [" attName " = " attValue "]"
            WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_value, tmp_comment)
        }
        return
    }
    currentUpdatedObject_wasChanged = true
}

void setObjectName(string attValue)
{
    string old_value=getTAUName(currentUpdatedObject)
    if(old_value != attValue)
    {
        if(isTAUNameValidated)
        {
            // generate command to TAU for back rename
            if(infoToTAU != null)
            {
                WriteObjectAttributeChanged(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, false, "name", old_value)
                // the message is out only for 'old' objects (they was not created in 'BeginUpdateObject')
                if(!currentUpdatedObject_wasCreated)
                {
                    string tmp_comment= "" GLSTR_warning_obj_name_changed " [" attValue "]->[" old_value "]"
                    WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, "IDS_DONT_SUPPORTED",  tmp_comment)
                }
            }
            return
        }
        if(isTAUNameEdited)
        {
            if(!setTAUName(currentUpdatedObject, attValue))
            {
                if(infoToTAU != null)
                {
                    string tmp_comment= "" lastError " [Name = " attValue "]"
                    WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_value, tmp_comment)
                }
                return
            }
    	    currentUpdatedObject_wasChanged = true
        }
    }
}

void setObjectText(string attValue)
{
    string old_value=getTAUText(currentUpdatedObject)
    if(!isEqualStringNoUNIXEndline(old_value , attValue))
    {
        if(!setTAUText(currentUpdatedObject, attValue))
        {
            if(infoToTAU != null)
            {
                string tmp_comment= "" lastError " [Text = " attValue "]"
                WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_value, tmp_comment)
            }
            return
        }
    	currentUpdatedObject_wasChanged = true
    }
}

void setObjectShortText(string attValue)
{
    string old_value=getShortText(currentUpdatedObject)
    if(!isEqualStringNoUNIXEndline(old_value , attValue))
    {
        if(!setShortText(currentUpdatedObject, attValue))
        {
            if(infoToTAU != null)
            {
                string tmp_comment= "" lastError " [ShortText = " attValue "]"
                WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_value, tmp_comment)
            }
            return
        }
    	currentUpdatedObject_wasChanged = true
    }
}

void setObjectHeading(string attValue)
{
    string old_value=getTAUHeading(currentUpdatedObject)
    if(old_value != attValue)
    {
        if(!setTAUHeading(currentUpdatedObject, attValue))
        {
            if(infoToTAU != null)
            {
                string tmp_comment= "" lastError " [Heading = " attValue "]"
                WriteObjectMessage(infoToTAU, getTAUID(currentUpdatedObject), currentUpdatedObjectTAUGUID, GLSTR_attribute_bad_value, tmp_comment)
            }
            return
        }
    	currentUpdatedObject_wasChanged = true
    }
}

//////////////////////////////////////////////////
//
// Work with Current table
//
// in this functions I must do something to delete cell from screen
// if it not present in TAU - i cannot other way except deleteCell/Row
// But I don't sure that Delete it's right decision!
//

Object currentTable = null
string currentTableID = ""
string currentTableTAUGUID = ""

Object currentTableRow = null
string currentTableRowID = ""
string currentTableRowTAUGUID = ""

Object currentTableCell = null
// currentUpdatedObject??? is used to store ID TAUGUID

bool DeleteDoorsCell(Object ptrCell)
{
    string deleted_cell_name = getTAUName(ptrCell)
    string deleted_cell_id = getTAUID(ptrCell)

    string result = deleteCell(ptrCell)
    if(result!="")
    {
        // error OutMessage
        statisticToTAU_cell_failed_deleted++
        string tmp_comment = "" result " [" deleted_cell_name "]"
        WriteObjectMessage(infoToTAU, deleted_cell_id, "", "IDS_DOORS_OBJ_DELETE_FILED", tmp_comment)
        return false
    }
    statisticToTAU_cell_deleted++
    
    currentUpdateModule_bNeedPurge = true
    if(isOutInformationObjectDelete && infoToTAU != null)
    {
        string tmp_comment = "Cell [" deleted_cell_name "]"
        WriteObjectMessage(infoToTAU, deleted_cell_id, "", GLSTR_obj_was_deleted , tmp_comment)
    }
    //string tmp_CanDelete = canDelete(ptrCell)
    //if (tmp_CanDelete=="")
    //{
    //    softDelete(ptrCell)
    //}
    //else
    //{
    //}


    //string tmp_comment = "Deletion/filtering of the table cells don't supported jet [" deleted_cell_name "]"
    //WriteObjectMessage(infoToTAU, deleted_cell_id, "", "IDS_DOORS_OBJ_DELETE_FILED", tmp_comment)
    
    return true
}

bool DeleteDoorsRow(Object ptrCell)
{
    string deleted_cell_name = getTAUName(ptrCell)
    string deleted_cell_id = getTAUID(ptrCell)

    string result = deleteRow(ptrCell)
    if(result!="")
    {
        // error OutMessage
        statisticToTAU_row_failed_deleted++
        string tmp_comment = "" result " [" deleted_cell_name "]"
        WriteObjectMessage(infoToTAU, deleted_cell_id, "", "IDS_DOORS_OBJ_DELETE_FILED", tmp_comment)
        return false
    }
    statisticToTAU_row_deleted++
    
    currentUpdateModule_bNeedPurge = true
    if(isOutInformationObjectDelete && infoToTAU != null)
    {
        string tmp_comment = "Row [" deleted_cell_name "]"
        WriteObjectMessage(infoToTAU, deleted_cell_id, "", GLSTR_obj_was_deleted , tmp_comment)
    }
    //string tmp_CanDelete = canDelete(ptrCell)
    //if (tmp_CanDelete=="")
    //{
    //    softDelete(ptrCell)
    //}
    //else
    //{
    //}
    
    //string tmp_comment = "Deletion/filtering of the table rows don't supported jet [" deleted_cell_name "]"
    //WriteObjectMessage(infoToTAU, deleted_cell_id, "", "IDS_DOORS_OBJ_DELETE_FILED", tmp_comment)
    
    return true
}

//////////////////////////////////////////////////
//
// Some cell in table can be deleted/unvisible but nothing not moved!!!

bool BeginUpdateTable(string tableID, string tableTAUGUID, int tableLevel)
{
    processedTableRowIdMap = create
    if(processedTableRowIdMap==null)
    {
        return false
    }
    processedTableRowToDeleteIdMap = create
    if(processedTableRowToDeleteIdMap==null)
    {
        delete processedTableRowIdMap
        return false
    }
    
    if(currentUpdateModule==null)
    {
        return false
    }
    string errMsg = null
    Object newTable = findAnyObject(currentUpdateModule, tableID, errMsg)
    if(newTable==null || !table(newTable))
    {
        WriteObjectMessage(infoToTAU, tableID, tableTAUGUID, "IDS_CREATION_IS_NOT_SUPPORTED",  "Table object was not found in the module or was found as not table")
        statisticToTAU_table_failed_create++
        return false
    }
    //
    
    statisticToTAU_table_processed++

    currentTable = newTable
    currentTableID = tableID
    currentTableTAUGUID = tableTAUGUID
    
    currentTableRow = null
    currentTableCell = null
    if(processedTableIdMap!=null)
        put(processedTableIdMap, tableID, tableID)


    // Move ALL TABLE in right position        
    if(isOrderedUpdateMode)
    {
        Object objRef = null
        objRef = (Object get(currentObjectStack,tableLevel,0)) 
        if(objRef != null) 
        {
            // set after 'objRef'
            //if(currentUpdateModule_bFullTree)
            Object objRefOld = null
            if(currentUpdateModule_bFullTree)
            {
                // fast function without any search (because we know that it's Standart View)
                objRefOld = getPreviousSiblingInTree (currentTable)
            }
            else
            {
                // function to work with View with FILTERED Tree
                objRefOld = getPreviousSiblingInFilteredTree (currentTable)
            }
            if(objRefOld!=objRef) {
                move(currentTable, objRef)
                statisticToTAU_object_moved++
                if(isOutInformationObjectMove && infoToTAU != null && currentTable!=null)
                {
                    WriteObjectMessage(infoToTAU, tableID, tableTAUGUID, GLSTR_table_was_moved, getTAUName(currentTable))
                }
            }
        }
        else 
        {
            if(tableLevel-1 >= 0)
            {
                objRef = (Object get(currentObjectStack,tableLevel-1,0)) 
            }
            if(objRef != null) 
            {
                // set as child of 'objRef'
                Object objRefOld = getParentInTree (currentTable) 
                if(objRefOld!=objRef) 
                {
                    move(currentTable, below (objRef))
                    statisticToTAU_object_moved++
                    if(isOutInformationObjectMove && infoToTAU != null && currentTable!=null)
                    {
                        WriteObjectMessage(infoToTAU, tableID, tableTAUGUID, GLSTR_table_was_moved, getTAUName(currentTable))
                    }
                }
            }
            else 
            {
                // move to first visible position
                if(move_to_top(currentUpdateModule, currentTable))
                {
                    statisticToTAU_object_moved++
                    if(isOutInformationObjectMove && infoToTAU != null && currentTable!=null)
                    {
                        WriteObjectMessage(infoToTAU, tableID, tableTAUGUID, GLSTR_table_was_moved, getTAUName(currentTable))
                     }
                }
            }
        }
        put(currentObjectStack,currentTable,tableLevel,0)
    }
        
    // currentUpdatedObjectLevel=tableLevel
                
    return true
}

//////////////////////////////////////////////////
//
// Clean up all rows start from next after 'currentTableRow' up to end of table

void EndUpdateTable()
{
    if(currentTable==null)
        return
    
    bool isStartRow=false
    Object ptrRow = null
    for ptrRow in table currentTable do 
    {
        if(ptrRow==null)
            continue
        //
        // clean up the end of 'currentTableRow' string from current element up to end
        //
        if(ptrRow==currentTableRow)
        {
            isStartRow=true
            continue
        }
        //
        // skip all before 'currentTableRow'
        //
        if(!isStartRow && currentTableRow!=null)
            continue
        //
        // scan all row after 'currentTableRow' and delete Row if
        // there are at least one Visible cell is precent
        Object ptrCell = null
        for ptrCell in row ptrRow do
        {
            if(ptrCell==null)
                continue
            if(isVisible(ptrCell))
            {
                // deleteRow (mark to delete as pair ROW_ID-CELL_OBJECT in EndUpdateTable)
                // DeleteDoorsRow(ptrCell)
                if(processedTableRowToDeleteIdMap!=null)
                    put(processedTableRowToDeleteIdMap, getTAUID(ptrRow), ptrCell)
                break
            }
        }
    }
    
    if(processedTableRowIdMap!=null) 
    {
        delete processedTableRowIdMap
        processedTableRowIdMap = null
    }
    
    // Delete marked rows
    if(processedTableRowToDeleteIdMap!=null)
    {
        Object o
        for o in processedTableRowToDeleteIdMap do
        {
            if (o==null)
                continue
            DeleteDoorsRow(o)
        }
        delete processedTableRowToDeleteIdMap
        processedTableRowToDeleteIdMap = null
    }
    
    currentTableRow = null
    currentTable = null
}

//////////////////////////////////////////////////
//
// Scan all row after 'currentTableRow' and before 'newTableRow' and delete Row if
// there are at least one Visible cell is precent

bool BeginUpdateTableRow(string rowID, string rowTAUGUID)
{
    processedTableCellIdMap = create
    if(processedTableCellIdMap==null)
    {
        return false
    }
    processedTableCellToDeleteIdMap = create
    if(processedTableCellToDeleteIdMap==null)
    {
        delete processedTableCellIdMap
        return false
    }
    
    if(currentTable==null)
        return false
    string errMsg = null
    Object newTableRow = findAnyObject(currentUpdateModule, rowID, errMsg)
    if(newTableRow==null || !row(newTableRow))
    {
        WriteObjectMessage(infoToTAU, rowID, rowTAUGUID, "IDS_CREATION_IS_NOT_SUPPORTED",  "Row object was not found in the module or it was found as not row")
        statisticToTAU_row_failed_create++
        return false
    }

    statisticToTAU_row_processed++
    
    if(processedTableRowIdMap!=null)
    {
        if(find(processedTableRowIdMap, rowID))
        {
            // Current string was processed already! 
            // It means that order of rows in TAU was corrupted! It's bug!
            WriteObjectMessage(infoToTAU, rowID, rowTAUGUID, "IDS_DONT_SUPPORTED",  "Order of the Rows in the Table was changed in TAU")
            // And also delete this row drom list to delete
            if(find(processedTableRowToDeleteIdMap, rowID))
            {
                delete(processedTableRowToDeleteIdMap, rowID)
            }
            return false
        }
    }
    
    if(processedTableRowIdMap!=null)
        put(processedTableRowIdMap, rowID, rowID)
    
    bool isStartRow=false
    Object ptrRow = null
    for ptrRow in table currentTable do 
    {
        if(ptrRow==null)
            continue
        if(ptrRow==newTableRow)
        {
            break
        }
        if(ptrRow==currentTableRow)
        {
            isStartRow=true
            continue
        }
        if(!isStartRow && currentTableRow!=null)
            continue
        // save all skiped rows as processed
        if(processedTableRowIdMap!=null)
        {
            string tmp_row_id=getTAUID(ptrRow)
            put(processedTableRowIdMap, tmp_row_id, tmp_row_id)
        }
        // delete the all midle rows if it contains any visible element
        Object ptrCell = null
        for ptrCell in row ptrRow do
        {
            if(ptrCell==null)
                continue
            if(isVisible(ptrCell))
            {
                // deleteRow (mark to delete as pair ROW_ID-CELL_OBJECT in EndUpdateTable)
                // DeleteDoorsRow(ptrCell)
                if(processedTableRowToDeleteIdMap!=null)
                    put(processedTableRowToDeleteIdMap, getTAUID(ptrRow), ptrCell)
                break
            }
        }
    }
    if(ptrRow!=newTableRow) 
    {
        // If not found such Row in table - out message
        WriteObjectMessage(infoToTAU, rowID, rowTAUGUID, "IDS_CREATION_IS_NOT_SUPPORTED",  "The Row was not found in the Table")
        statisticToTAU_row_failed_create++
        return false
    }
    currentTableRow = newTableRow
    currentTableRowID = rowID
    currentTableRowTAUGUID = rowTAUGUID
    currentTableCell = null
    return true
} 

//////////////////////////////////////////////////
//
// Clean up the end of 'currentTableRow' string from 'currentTableCell' element up to end
//
void EndUpdateTableRow()
{
    if(currentTable==null || currentTableRow==null)
        return
    bool isStartCell=false
    Object ptrCell = null
    for ptrCell in row currentTableRow do
    {
        if(ptrCell==null)
            continue
        if(ptrCell==currentTableCell)
        {
            isStartCell=true
            continue
        }
        if(!isStartCell && currentTableCell!=null)
            continue
        // delete all visible cell after start
        if(isVisible(ptrCell))
        {
            // delete Cell (mark to delete as pair CELL_ID-CELL_OBJECT in EndUpdateTable)
            // DeleteDoorsCell(ptrCell)
            if(processedTableCellToDeleteIdMap!=null)
                put(processedTableCellToDeleteIdMap, getTAUID(ptrCell), ptrCell)
        }
    }
    
    if(processedTableCellIdMap!=null) 
    {
        delete processedTableCellIdMap
        processedTableCellIdMap = null
    }
    
    // Delete marked rows
    if(processedTableCellToDeleteIdMap!=null)
    {
        Object o
        for o in processedTableCellToDeleteIdMap do
        {
            if (o==null)
                continue
            DeleteDoorsCell(o)
        }
        delete processedTableCellToDeleteIdMap
        processedTableCellToDeleteIdMap = null
    }
    
} 

//////////////////////////////////////////////////
//
// Clean up this row from 'currentTableRow' up to newTableCell
//

bool BeginUpdateTableCell(string cellID, string cellTAUGUID)
{
    if(currentTable==null || currentTableRow==null)
        return false
    string errMsg = null
    Object newTableCell = findAnyObject(currentUpdateModule, cellID, errMsg)
    if(newTableCell==null || !cell(newTableCell))
    {
        WriteObjectMessage(infoToTAU, cellID, cellTAUGUID, "IDS_CREATION_IS_NOT_SUPPORTED",  "Cell object was not found in the module or was found as not cell")
        statisticToTAU_cell_failed_create++
        return false
    }

    statisticToTAU_cell_processed++

    if(processedTableCellIdMap!=null)
    {
        if(find(processedTableCellIdMap, cellID))
        {
            // Current cell was processed already! 
            // It means that order of cell in TAU was corrupted! It's bug!
            WriteObjectMessage(infoToTAU, cellID, cellTAUGUID, "IDS_DONT_SUPPORTED",  "Order of the Cells inside of the Row in the Table was changed in TAU")
            // And also delete this row drom list to delete
            if(find(processedTableCellToDeleteIdMap, cellID))
            {
                delete(processedTableCellToDeleteIdMap, cellID)
            }
            return false
        }
    }
    
    if(processedTableCellIdMap!=null)
        put(processedTableCellIdMap, cellID, cellID)
        
    bool isStartCell=false
    Object ptrCell = null
    for ptrCell in row currentTableRow do
    {
        if(ptrCell==null)
            continue
        if(ptrCell==newTableCell)
        {
            break
        }
        if(ptrCell==currentTableCell)
        {
            isStartCell=true
            continue
        }
        if(!isStartCell && currentTableCell!=null)
            continue
        // save all skiped cells as processed
        if(processedTableCellIdMap!=null)
        {
            string tmp_cell_id=getTAUID(ptrCell)
            put(processedTableCellIdMap, tmp_cell_id, tmp_cell_id)
        }
        // delete all visible cell after start
        if(isVisible(ptrCell))
        {
            // delete Cell (mark to delete as pair CELL_ID-CELL_OBJECT in EndUpdateTable)
            // DeleteDoorsCell(ptrCell)
            if(processedTableCellToDeleteIdMap!=null)
                put(processedTableCellToDeleteIdMap, getTAUID(ptrCell), ptrCell)
        }
    }
    if(ptrCell!=newTableCell)
    {
        WriteObjectMessage(infoToTAU, cellID, cellTAUGUID, "IDS_CREATION_IS_NOT_SUPPORTED",  "Cell not found in row")
        statisticToTAU_cell_failed_create++
        return false
    }

    if(!isVisible(ptrCell))
    {
        // I don't know how made cell is visible?
        WriteObjectMessage(infoToTAU, cellID, cellTAUGUID, "IDS_DONT_SUPPORTED",  "Changing of the Visibility of the Cell object")
    }
    
    // Set new current cell
    currentTableCell = newTableCell

    // Set Object parameters to update attributes    
    currentUpdatedObject = currentTableCell
    
    currentUpdatedObjectID = cellID
    currentUpdatedObjectTAUGUID = cellTAUGUID
    currentUpdatedObject_wasChanged = false
    currentUpdatedObject_wasCreated = false
    // currentUpdatedObjectLevel = objectLevel
    
    return true
} 

//////////////////////////////////////////////////
//
// 
//

void EndUpdateTableCell()
{
    endUpdateObject() 
}

//////////////////////////////////////////////////
// Checking that the names of Table and Row is the same as in TAU - 
// If it's not so - the command 'ObjectChanged' is send back to doors 
// with old original name.
/*
void WriteTableNameChanged(Stream s, Object o)
{
    if(!table(o) && !row(o))
        return
	string obj_id = getTAUID(o)
	string obj_name = u2pString(getTAUName(o))
	string ttype = getObjectTableType(o)
	writeToStream(s, "ObjectChanged (. time = 0, id = \"" obj_id "\", name = \"" obj_name "\", tabletype = \"" ttype "\" .)\n")
}
*/

void validateTableName(string attValue)
{
    string old_value=getTAUName(currentTable)
    if(currentTable!=null && old_value != attValue)
    {
        if(infoToTAU != null)
        {
            string tmp_comment= "" GLSTR_warning_obj_name_changed " Table [" attValue "]->[" old_value "]"
            WriteObjectMessage(infoToTAU, currentTableID, currentTableTAUGUID, "IDS_DONT_SUPPORTED", tmp_comment)
            //WriteTableNameChanged(infoToTAU, currentTable)
            WriteObjectAttributeChanged(infoToTAU, getTAUID(currentTable), currentTableTAUGUID, false, "name", old_value)
        }
    }
}

void validateTableRowName(string attValue)
{
    string old_value=getTAUName(currentTableRow)
    if(currentTableRow!=null && old_value != attValue)
    {
        if(infoToTAU != null)
        {
            string tmp_comment= "" GLSTR_warning_obj_name_changed " Row [" attValue "]->[" old_value "]"
            WriteObjectMessage(infoToTAU, currentTableRowID, currentTableRowTAUGUID, "IDS_DONT_SUPPORTED", tmp_comment)
            //WriteTableNameChanged(infoToTAU, currentTableRow)
            WriteObjectAttributeChanged(infoToTAU, getTAUID(currentTableRow), currentTableRowTAUGUID, false, "name", old_value)
        }
    }
}
