# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
proc Init {} {

	global U2
	# Calculation of the base path for the semantic checker profile
	set SAProfileInEtc [GetInstallationDirectory]etc

	# Loading of the semantic checker general profile
	set SAProfilePath $SAProfileInEtc/TTDSemCheckerProfile.u2
	output "Loading the Semantic checker profile: $SAProfilePath\n"
	set err [catch { LoadProfile $SAProfilePath } log ]
	if { $err } {
            output "$log"
        }
}

#Initialization of semantic analyser profile
set dialogWidth 600
set dialogHeight 300

# relative coordinates
set dlgX0 10
set dlgY0 10

# defualt values
set dfltDist 10
set dfltStatusW 100

# default label width and height
set lblDfltW 150
set lblDfltH 25
set btnDfltW 100
set btnDfltH 25

# label Group
set lblGroupX $dlgX0
set lblGroupY $dlgY0
set lblGroupW $lblDfltW
set lblGroupH $lblDfltH

# ComboBox GroupStatus
set cbxGroupStatusW $dfltStatusW

# ComboBox Groups
set cbxGroupsX $lblGroupX
set cbxGroupsY [expr $lblGroupY + $lblGroupH - $dfltDist ]
set cbxGroupsW [expr ($dialogWidth - 2 * $dlgY0 - ( $cbxGroupStatusW  + $dfltDist )) / 2]

# ComboBox GroupStatus (continue)
set cbxGroupStatusX [expr $cbxGroupsX + $cbxGroupsW + $dfltDist]
set cbxGroupStatusY $cbxGroupsY

# label GroupStatus
set lblGroupStatusX $cbxGroupStatusX
set lblGroupStatusY $dlgY0
set lblGroupStatusW $lblDfltW
set lblGroupStatusH $lblDfltH

# label Rule
set lblRuleX $dlgX0
set lblRuleY [expr $lblGroupY + $lblGroupH + 2 * $dfltDist]
set lblRuleW $lblDfltW
set lblRuleH $lblDfltH

# ComboBox Rule status
set cbxRuleStatusW $dfltStatusW

# ComboBox Rules
set cbxRulesX $lblRuleX
set cbxRulesY [expr $lblRuleY + $lblRuleH - $dfltDist ]
set cbxRulesW [expr $dialogWidth - 2 * $dlgY0 - ( $cbxRuleStatusW + $dfltDist )]

# ComboBox Rule status (continue)
set cbxRuleStatusX [expr $cbxRulesX + $cbxRulesW + $dfltDist]
set cbxRuleStatusY $cbxRulesY


# Label Rule status
set lblRuleStatusX $cbxRuleStatusX
set lblRuleStatusH $lblDfltH
set lblRuleStatusY [expr $cbxRuleStatusY - $lblRuleStatusH + $dfltDist]
set lblRuleStatusW $lblDfltW

# Button Close
set btnCloseW $btnDfltW
set btnCloseH $btnDfltH
set btnCloseX [expr $dialogWidth - $dlgX0 - $btnCloseW ] 
set btnCloseY [expr $dialogHeight - $btnCloseH - 30]

# Button Apply
set btnApplyW $btnDfltW
set btnApplyH $btnDfltH
set btnApplyX [expr $dialogWidth - $dlgX0 - $btnCloseW ] 
set btnApplyY [expr $dialogHeight - 7 * $btnCloseH - 20]

# Button Remove
set btnRemoveW $btnDfltW
set btnRemoveH $btnDfltH
set btnRemoveX [expr $dialogWidth - $dlgX0 - $btnCloseW ] 
set btnRemoveY [expr $btnApplyY + $btnApplyH ]

# Button Clear
set btnClearW $btnDfltW
set btnClearH $btnDfltH
set btnClearX [expr $dialogWidth - $dlgX0 - $btnCloseW ] 
set btnClearY [expr $btnRemoveY + $btnRemoveH ]

# Button Commit
set btnCommitW $btnDfltW
set btnCommitH $btnDfltH
set btnCommitX [expr $dialogWidth - $dlgX0 - $btnCloseW ] 
set btnCommitY [expr $btnClearY + $btnClearH ]

# ListBox Messages
set lstbMessagesX $dlgX0
set lstbMessagesY [expr $cbxRulesY + 3 * $dfltDist]
set lstbMessagesW $cbxRulesW
set lstbMessagesH [expr $btnCloseY - $cbxRuleStatusY]

# initalize addin
Init

proc OnActivateSemCheck {cmdName} {
  global dialogWidth dialogHeight
  global CurrSelection, selection

  package require dialogs
  Dialog -variable "SemCheck" -name "Semantic check configuration" -w $dialogWidth -h $dialogHeight -onbuilddialog OnBuildSemCheck -oninitdialog OnInitDialog -onclosedialog OnCloseDialog -closecmddialog CloseDialog
}

# removes 'sel' from 'lst', returns result
proc RemoveFromList {mylst sel} {
   set res {}
   set state 0
   foreach {i} $mylst {
	  set state 1
	  set AddToList 1
	  foreach {j} $sel {
		if { $i == $j } {
			set AddToList 0
		}
	  }
	  if { $AddToList == 1 } {
		lappend res $i
	  }
   }
   if { $state == 1 } {
	  return $res
   }
   return $lst
}

proc SemGroups { path } {
    set result [list]
    set semEntities [u2::GetSemEntities $path]
    foreach entity $semEntities {
        if { [u2::IsSemGroup $entity] } {
            lappend result $entity
        }
    }
    return $result
}

proc SemRules { path } {
    set result [list]
    set semEntities [u2::GetSemEntities $path]
    foreach entity $semEntities {
        if { ![u2::IsSemGroup "$path/$entity"] } {
            lappend result $entity
        }
    }
    return $result
}

proc OnBuildSemCheck {dialog} {

  global selection

  global groupCombo rulesCombo ruleEnabledCombo groupEnabledCombo treeControl btnRemove
  global lstbMessages
  global dialogWidth dialogHeight lblGroupX lblGroupY lblGroupW lblGroupH dlgX0 dlgY0
  global cbxGroupsX cbxGroupsY cbxGroupsW
  global cbxGroupStatusX cbxGroupStatusY cbxGroupStatusW 
  global lblGroupStatusX lblGroupStatusY lblGroupStatusW lblGroupStatusH
  global lblRuleX lblRuleY lblRuleW lblRuleH
  global cbxRulesX cbxRulesY cbxRulesW
  global cbxRuleStatusX cbxRuleStatusY cbxRuleStatusW
  global lblRuleStatusX lblRuleStatusY lblRuleStatusH lblRuleStatusW
  global btnCloseX btnCloseY btnCloseW btnCloseH
  global lstbMessagesX lstbMessagesY lstbMessagesW lstbMessagesH
  global btnApplyW btnApplyH btnApplyX btnApplyY
  global btnRemoveW btnRemoveH btnRemoveX btnRemoveY
  global btnClearW btnClearH btnClearX btnClearY
  global btnCommitW btnCommitH btnCommitX btnCommitY

  set groups [SemGroups /]

  # Label Group
  Label -name "Group:" -parent $dialog -x $dlgX0 -y $dlgY0 -w $lblGroupW -h $lblGroupH

  # Label Status
  Label -name "Status:" -parent $dialog -x $lblGroupStatusX -y $lblGroupStatusY -w $lblGroupStatusW -h $lblGroupStatusH

  # ComboBox Groups
  ComboBox -variable groupCombo -name "Groups" -parent $dialog -x $cbxGroupsX -y $cbxGroupsY -w $cbxGroupsW -stringlist $groups -selchangecmd GetRules
  ComboBox -variable groupEnabledCombo -parent $dialog -x $cbxGroupStatusX -y $cbxGroupStatusY -w $cbxGroupStatusW -stringlist {"" disabled enabled}
  
  # Label Rule
  Label -name "Rule:" -parent $dialog -x $lblRuleX -y $lblRuleY -w $lblRuleW -h $lblRuleH

  # Label Status
  Label -name "Status:" -parent $dialog -x $lblRuleStatusX -y $lblRuleStatusY -w $lblRuleStatusW -h $lblRuleStatusH

  # ComboBox Rules
  ComboBox -variable rulesCombo -name "Rules" -parent $dialog -x $cbxRulesX -y $cbxRulesY -w $cbxRulesW
  ComboBox -variable ruleEnabledCombo -parent $dialog -x $cbxRuleStatusX -y $cbxRuleStatusY -w $cbxRuleStatusW -stringlist {"" disabled enabled}

  # Button Close
  Button -name "Close" -parent $dialog -x $btnCloseX -y $btnCloseY -w $btnCloseW -h $btnCloseH -command OnClose

  # Button Apply
  Button -name "Add" -parent $dialog -x $btnApplyX -y $btnApplyY -w $btnApplyW -h $btnApplyH -command OnApply
  
  # Button Remove
  Button -variable btnRemove -name "Remove" -parent $dialog -x $btnRemoveX -y $btnRemoveY -w $btnRemoveW -h $btnRemoveH -command OnRemove

  # Button Clear
  Button -name "Clear" -parent $dialog -x $btnClearX -y $btnClearY -w $btnClearW -h $btnClearH -command OnClear

  # Button Commit
  Button -name "Commit" -parent $dialog -x $btnCommitX -y $btnCommitY -w $btnCommitW -h $btnCommitH -command OnCommit

  # ListBox config rules
  ListBox -variable lstbMessages -name "Errors" -parent $dialog -x $lstbMessagesX -y $lstbMessagesY -w $lstbMessagesW -h $lstbMessagesH -selchangecmd OnSelectRule

  set firstGroup [lindex $groups 0]
  $groupCombo -selected $firstGroup
  GetRules $firstGroup

  set tmp {}

  if { ([llength $selection] == 1) && ([GetKind $selection] == "U2" ) } {
    set tmp [u2::GetConfigRules $selection]	
  }
  $lstbMessages -stringlist $tmp
}

proc OnClose {} {
    CloseDialog
}

proc DoCommit {} {

}

proc HasCommand { lstCommands lstComm } {
   foreach {i} $lstCommands {
      if { $i == $lstComm } {
	     return 1
	  }
   }
   return 0
}

proc OnApply {} {
    global selection
    global groupCombo rulesCombo ruleEnabledCombo groupEnabledCombo 
    global lstbMessages

	if { ([llength $selection] == 1) && ([GetKind $selection] == "U2" ) } {
		
		set tmpGroupStatus [$groupEnabledCombo -selected]
		set tmpCurrGroup [$groupCombo -name]
		set tmpCurrRule  [$rulesCombo -name]
		set tmpRuleStatus [$ruleEnabledCombo -selected]

		set lstCommands  [$lstbMessages -stringlist]
		# generate rule for group
		if { ($tmpGroupStatus == "enabled") || ($tmpGroupStatus == "disabled") } {
		   # generate config rule
		   set tmpConfigRule "/$tmpCurrGroup $tmpGroupStatus"
		   # check that we don't have one
		   if { [HasCommand $lstCommands $tmpConfigRule] == 0 } {
			  # add it to the list
		      lappend lstCommands $tmpConfigRule
		      # update list box
		      $lstbMessages -stringlist $lstCommands
		   }
		}
		# generate rule for checks
		if { ($tmpGroupStatus == "") || ($tmpGroupStatus == "enabled") } {
		if { ([llength $tmpCurrRule ] != 0) && (($tmpRuleStatus == "disabled") || ($tmpRuleStatus == "enabled"))} {
		   # generate config rule
		   set tmpConfigRule "/$tmpCurrGroup/$tmpCurrRule $tmpRuleStatus"
		   # check that we don't have one
		   if { [HasCommand $lstCommands $tmpConfigRule] == 0 } {
		      # add it to the list
		      lappend lstCommands $tmpConfigRule
		      # update list box
		      $lstbMessages -stringlist $lstCommands
		   }
		}
		}
		return 0
	} 
	MessageBox pop "Invalid selection."	
}

proc OnRemove {} {
    global btnRemove
	global selection
    global groupCombo rulesCombo ruleEnabledCombo groupEnabledCombo 
    global lstbMessages
	
	set lstCommands [$lstbMessages -stringlist]
	set curSelection [$lstbMessages -selected]
	
	Output "Current selection is $curSelection \n"
	set lstNewCommands [RemoveFromList $lstCommands $curSelection]
	$lstbMessages -stringlist $lstNewCommands
}

proc OnClear {} {
    global lstbMessages
	$lstbMessages -stringlist {}
}

proc OnCommit {} {
	global selection
	global lstbMessages

	if { ([llength $selection] == 1) && ([GetKind $selection] == "U2" )  &&  [CanCreateIn $selection "InstanceExpr"] } {

		set lstRules [$lstbMessages -stringlist]
		set strConfig "\{"
		set notFirst 0
		set bForceAdvanced 0
		foreach confRule $lstRules {
		    if { $notFirst == 1 } {
				set strConfig "${strConfig},"
			}

			set statusIndex [string last enabled $confRule]
			set status "true"
			if { $statusIndex == -1 } {
				set statusIndex [string last disabled $confRule]
				set status "false"
			}

   # statusIndex and status should be set here correctly - since enabled and disabled are the only options
			set path [string range $confRule 0 [expr $statusIndex-2]]
			if {$bForceAdvanced  == 0 && $status == "false"} {
				set strGroupName [string range $path 0 11]
				if {$strGroupName == "/Consistency" || $strGroupName == "/Expressions"} {
					set dialogAnswer [std::MessageDialog -name "Are you sure?" -message "You are about to disable a check from groups Consistency or Expressions.\nDisabling such checks is strongly not recommended since it can cause unexpected behavior.\nWould you like to commit configuration anyway?" -style yesno -icon warning]
					if {$dialogAnswer == 7} {
						return
					} else {
						set bForceAdvanced 1
					}
				}
			}
			set strConfig "${strConfig}SemEntityConfig(.path=\"${path}\",status=${status}.)"
			set notFirst 1
		}
		set strConfig "${strConfig}\}"
		
		set tag [GetTaggedValue $selection "ConfigChecker (. .)"]
		if { $tag != 0 } {
			Delete $tag
		}
		set tag [CreateIn $selection "InstanceExpr"]
		SetA $tag InstanceOf "ConfigChecker"
		
		SetInstanceValue $tag configs $strConfig 
	}
}


proc OnSelectRule { SelectedRule } {
			
}

proc GetRules { semGroup } {
	global rulesCombo groupEnabledCombo ruleEnabledCombo

	# Get rules and select first rule
	set tmpRules [SemRules /$semGroup]
	if {[llength $tmpRules] > 0} {
		set first [lindex $tmpRules 0]
		$rulesCombo -stringlist $tmpRules
		$rulesCombo -selected $first
#		GetRuleStatus $first
	}
}

proc OnEnableSemCheck {cmdName} {
  return 1;
}


proc OnInitDialog {dialog} {
}

proc OnCloseDialog {} {
}

# Declaration and registration of commands/toolbar/menu
package require commands

Declare addcommand -variable cmdSemCheck -name "Configure semantic checks..." -statusmessage "Configuration of semantic checks." -tooltip "Configure semantic checks" -accelerator "" -onactivatecommand OnActivateSemCheck -onenablecommand OnEnableSemCheck

AddCommand cmdSemCheck

AddMenu -variable mnuSemCheck -commands { separator cmdSemCheck } -path {&Tools} -position {last}
