# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#########################################################################################
#  										   	#	
#											#
#	Name of Addin : XMI Export Addin for Tau G2					#
#	File Name     :	XMIexport.tcl							#
#	Date          : 16 MARCH 2006							#
#        										#
#	Description   : This exports the Model in IBM Rational Tau to XMI file	 	# 
#											#
# 											#
######################################################################################### 

namespace import u2::*
source [std::GetInstallationDirectory]/addins/XMIExport/Script/ModelAccess.tcl
 
#------------------------------------------------------------------

#Declaring all global variables
global u2
global text
global id
global pendingLine
global indent
global optstreaming 
global file
global owner
global font_size
global font_name
global color
global Assoc_id
global default_size
global default_Font
global owner_prev
global commenttext_prev
global Stereo_id
global comment_id
global commentsymbol_id
global Model_id
global Multiplicity_id
global Guard_id
global number
global list_diagram
global list_diagram_state
global list_State
global list_State_scope
global list_State_id

global isPresent
global state_transition
global state
global list_attributes
global tasksymbol_id
global list_sender
global list_receiver
global CountError
global CountWarning
global access_comment
global Cor
global DiagNo
global SeqDiagNo 
global SeqDiagGUID
global New_file 
global U2
global xmlNS

global idLast
global default_color

global AssSourceID
set AssSourceID "" 

global PerLineGuid
set PerLineGuid ""

global transitionLineText
set transitionLineText ""


global priorityValue
set priorityValue ""

global transitionGuardText
set transitionGuardText ""

#Defining all variables
set DiagNo 0  
set SeqDiagNo 0
set SeqDiagGUID ""
set xmlNS ""
set optStreaming 0
set id 1
set idLast 0
set pendingLine 0
set indent 0
set optStreaming 0
set owner 0
set font_size 12
set font_name Arial
set color 16777215
set Assoc_id 1
set owner_prev 0
set commenttext_prev ""
set default_size 10
set default_Font Arial
set default_color 16773875
set Stereo_id 1
set comment_id 1
set commentsymbol_id 1
set Model_id 1
set Multiplicity_id 1
set Guard_id 1
set number 0
set list_diagram ""
set list_diagram_state ""
set list_State ""
set list_State_scope ""
set list_State_id ""
set isPresent 1
set state_transition ""
set state ""
set list_attributes ""
set tasksymbol_id ""
set list_sender ""
set list_receiver ""
set CountError 0
set CountWarning 0
set access_comment 0
set Cor ""

global  ModelNumber


# for SynTYPE

global synTypetype
set synTypetype ""


# for XMIExport Strip 
ReportInit "XMIExport" Element 150 0 Severity 70 0 Information 800 0 

OutputTab clear Script
OutputTab activate Script

std::Output "********** Starting XMI Export... **********\n"

std::Output "\nReading Model View..."
	set verA "1.0"
	set Ver "version=\"$verA\""
	set encA "UTF-8" 
	set Enc "encoding=\"$encA\""
        set text "<?xml $Ver $Enc ?>" 
        set file [open "$New_file" w]
	set r "$text"
	puts $file $text


#Writing all procedures here.
proc EndLine {this suffix} {
        global pendingLine 
	if {$pendingLine == 0} { puts "**INTERNAL ERROR: EndLine with no pending line" }
	pendingLine 0
}

proc GetIndent {} {
	global indent
	set ret {}
	for {set i 0} {$i < $indent} {incr i} {
		append ret {  }
	}
	return $ret
}

proc WriteLine {this line} {
	global file
	global optStreaming
	puts $file [GetIndent]$line
}

proc XMLComment {comment indent} {
	global optStreaming
	if {$comment == ""} { return "" }
	regsub -all -- {--} $comment {==} comment
	set r "$indent<!-- $comment -->"
	return "$r"
}


proc WriteComment {this comment} {
	global pendingLine
	set Comment [XMLComment $comment "  "]
	if {$Comment != ""} {	
        	if {$pendingLine != 0} { [EndLine $this ">"] }
		WriteLine $this $Comment
	}
}

proc UMLElementName {this qualname} {
	global xmlNS
	if {$xmlNS == ""} {
		return [join $qualname .]
	} else {
		return "$xmlNS:[lindex $qualname 1]"
	}
}

# Proc for Performance Elements

proc StartUML_PerfElements {this qualname {id ""} {uuid ""} {name ""} {agg ""} {visible ""} {changeable ""} {navigable ""} {scope ""} {owner ""} {type ""} } {
global xmlNS
global indent
global Export_Rose

	if {$id != ""} { append attrs " xmi.id=\"$id\"" }
	if {$uuid != "" } { append attrs " xmi.uuid=\"$uuid\"" }
	append attrs " name=\"[XMLCharData $name]\"" 
	append attrs " visibility=\"$visible\"" 
	append attrs " isNavigable=\"$navigable\"" 
	append attrs " aggregation=\"$agg\"" 
        if {$Export_Rose==1} {	
		append attrs " targetScope=\"$scope\" "
	}
	append attrs " changeability=\"$changeable\"" 
	if {$type == "association" && $Export_Rose==1} {
		append attrs " constraint=\"C.$uuid\" "
	}
	append attrs " type=\"$owner\" "

	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]
}

# Proc for Performance

proc StartUML_Perf {this qualname {id ""} {uuid ""}} {
	global xmlNS
	global indent
	set attrs ""
	global pendingLine

	set id [u2::GetValue $uuid Guid]
	if {$id != ""} { append attrs " xmi.id=\"$id\"" }
	if {$id != "" } { append attrs " xmi.uuid=\"$id\"" }

	# Code Review
	set metaClassName [u2::GetMetaClassName $uuid] 	

	if { $metaClassName == "Association"} {
		append attrs " name=\"[u2::GetValue $uuid Name]\"" 
	}

	if { $metaClassName == "AssociationLine"} {
		append attrs " name=\"[u2::GetValue $uuid Text]\"" 

	}


	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}

# Proc for Dependency

proc StartUML_Dep {this qualname {id ""} {uuid ""} {client ""} {supplier ""} {name ""}} {
	global xmlNS
	global indent
       	global Export_Rose
	set attrs ""
	global pendingLine

	set id [u2::GetValue $uuid Guid]
	if {$id != ""} { append attrs " xmi.id=\"$id\"" }
	if {$id != "" } { append attrs " xmi.uuid=\"$id\"" }

        if {$Export_Rose==1} { 
	  append attrs " name=\"[XMLCharData $name]\"" 
        }  
	append attrs " client=\"$client\" "
	append attrs " supplier=\"$supplier\" "
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}

# Proc for Generalization

proc StartUML_Gen {this qualname {id ""} {uuid ""} {parnt ""} {child ""}} {
	global xmlNS
	global indent
	set attrs ""
	global pendingLine

	set id [u2::GetValue $uuid Guid]
	if {$id != ""} { append attrs " xmi.id=\"$id\"" }
	if {$id != "" } { append attrs " xmi.uuid=\"$id\"" }
	append attrs " name=\"\"" 
	append attrs " child=\"$child\" "
	append attrs " parent=\"$parnt\" "
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}
 
# For multiply the X and y coordinate by some no.
proc XYCordinate {Coordinate} {
        global Cor
 	set X [lindex $Coordinate 0]
        set Y [lindex $Coordinate 1]
	set X [expr int($X *1.52)] 
	set Coordinate ""
	set Coordinate $X
        lappend Coordinate $Y   
        set Cor $Coordinate
}
 
proc StartUML_DiagramElement {this qualname {subject ""} {id_subject ""} {id ""} {uuid ""}} {
global Cor
global Export_Rose
global xmlNS
global indent
global id_selection
global parent
global child
global font_size
set font_size [string trimright $font_size]
global font_name
set font_italic 0
global color
global comment_id
global class


# Added for U2 Model
if {$color==16711680} {
     set color 16773875
}


set hexvalue [format %4.6X $color]
scan "$hexvalue" "%2x%2x%2x" b g r
set red $r
set green $g
set blue $b
global owner
global SQN
global list_State
global list_State_id
global list_State_scope
global element_text

	set style_text ""
	set attrs ""
	set geo_text ""
 
 

	switch -- [u2::GetMetaClassName $uuid] { 
	"PerformanceLine" {
			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			set geo_text [AppendGeo $Coordinate]
			set style_text "Association:"

			}
	"AssociationLine" {

			switch -- [u2::GetMetaClassName $id_subject] { 
				"Attribute" {
					set owner ""
					MapRole $id_subject ParticipatesIn ForOwner
					if {$owner == ""} {
						set owner [u2::GetValue $uuid Guid]
						}
					}

			}

			set subject $owner
			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			set geo_text [AppendGeo $Coordinate]
			set style_text "Association:"

			}
	"ActorSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
			XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"UseCaseSymbol" {
			set isAbstract [u2::GetValue $id_subject IsAbstract]

  
			if { $isAbstract=="true"} {
				set font_italic 1
			}

			set Coordinate "[u2::GetValue $uuid Position]"
			XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"ClassSymbol" {
			set isAbstract [u2::GetValue $id_subject IsAbstract]
			if { $isAbstract=="true"} {
				set font_italic 1
			}
			set Coordinate "[u2::GetValue $uuid Position]"
  		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"OperationSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
   		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"CollaborationSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
 		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"InterfaceSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
 		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}

	"RealizedInterfaceSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
 		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
			set name ""
			MapRole $uuid PortSymbol ForOwner
			MapRole $id_selection ModelElement ForOwner
			MapRole $id_selection Realized ForOwner
			if {[u2::GetMetaClassName $id_selection] == "Interface"} {
         			set name "[u2::GetValue $id_selection Name]"
 				set subject $owner
			}
		if {$name!=""} {
			
		    WarningMesgPath  
		    Report $uuid "Warning" "RealizedInterfaceSymbol($name) is translated as Interface Symbol" 
		}
		}

	"RequiredInterfaceSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
 		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
			MapRole $uuid PortSymbol ForOwner
			MapRole $id_selection ModelElement ForOwner
			MapRole $id_selection Required ForOwner
			set name ""
			if {[u2::GetMetaClassName $id_selection] == "Interface"} {
   				set name "[u2::GetValue $id_selection Name]"
 				set subject $owner
			}
			if {$name!=""} {
			  WarningMesgPath			   
			  Report $uuid "Warning" "RequiredInterfaceSymbol($name) is translated as Interface Symbol" 
			}

			}

	"PackageSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
 		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"TextSymbol" {
			append style_text "Note:"
			set subject [u2::GetValue $uuid Guid]
			append subject "-"
			set Coordinate "[u2::GetValue $uuid Position]"
	                set X [lindex $Coordinate 0]
			set X [expr int($X*1.6)]
			set Y [lindex $Coordinate 1]
	                if {$Y > 150 } { 
        		           set Y [expr $Y-100]
                 	}
	                set Coordinate ""
            	        set Coordinate $X
        		lappend Coordinate $Y   
 			set geo_text [AppendGeo $Coordinate]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"CommentSymbol" {

			append style_text "Note:"
			set subject [u2::GetValue $uuid Guid]
			append subject "-"
			set Coordinate "[u2::GetValue $uuid Position]"
		        set X [lindex $Coordinate 0]
		        set X [expr int($X*1.6)]
            		set Y [lindex $Coordinate 1]
	                if {$Y > 150 } { 
                             set Y [expr $Y-100]
          		}
	                set Coordinate ""
        	        set Coordinate $X
        		lappend Coordinate $Y   
			set geo_text [AppendGeo $Coordinate]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
			set comment_id [expr $comment_id + 1]
		}
 

         "TimerSymbol" {
       
			set Coordinate "[u2::GetValue $uuid Position]"
   		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
         "StereotypeSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
   		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
         "StateMachineSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
   		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"ArtifactSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
   		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"DataTypeSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
   		        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"SignalSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
   		        set X [lindex $Coordinate 0]
         		set Y [lindex $Coordinate 1]
	 		set X [expr int($X *1.52)] 
                        # set X [expr int($X *2)] 
        		set Y [expr int($Y+60)] 
	 		set Coordinate ""
			set Coordinate $X
         		lappend Coordinate $Y
                        set geo_text [AppendGeo $Coordinate]
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}

	"LifeLineSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set id_selection ""
			set class ""
			MapRole $id_subject Selector ForIdentName
			if {$class == "Attribute"} {
				set size "40 162"

			}
			set geo_text $geo_text[AppendGeo $size]
		}
	"DestroySymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
        		set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"StateSymbol" {
		 	set subject [u2::GetValue $id_subject Guid]
			set present 0
			foreach item $list_State_id {
				if {$subject == [u2::GetValue $item Guid]} {
					set present 1
				}
			}
			if {$present == 0} {	
			MapRole $uuid Owner ForOwner
			MapRole $id_selection Owner ForOwner
			set owner_state $owner
			set index "none"
			set i 0
			foreach item $list_State {
				if {[u2::GetValue $uuid Text] == $item} {
					set temp_state [lindex $list_State_id $i]
					MapRole $temp_state Owner ForOwner
						if {$owner == $owner_state} {
							set index $i
						} 
				} else {
					set i [expr $i + 1]
				}

			}
			if {$index != "none"} {
				set subject [u2::GetValue [lindex $list_State_id $index] Guid]
			}

		}
			set Coordinate "[u2::GetValue $uuid Position]"
	                XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"StartSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"StopSymbol" {
			WarningMesgPath 
			Report $uuid "Warning" "StopSymbol ($element_text) is translated into End State."
			set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
        "FlowFinalSymbol" {
			
			WarningMesgPath 
			Report $uuid "Warning" "Flow Final Node is translated into End State."

			set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
                        }

	"ReturnSymbol" {
			WarningMesgPath 
			Report $uuid "Warning" "ReturnSymbol ([u2::GetValue $uuid Text]) is translated into End State."
			set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"ActivityFinalSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"InitialNodeSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
	"DecisionSymbol" {
			set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
		}
          "ActivityDecisionSymbol" {
                         set Coordinate "[u2::GetValue $uuid Position]"
	                 XYCordinate $Coordinate
        	         set geo_text [AppendGeo $Cor]	
   			 set size "[u2::GetValue $uuid Size]"
			 set geo_text $geo_text[AppendGeo $size]
                 }
            
         "ActionActivitySymbol" {
                        set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
                 }

       "SendSignalSymbol" {
                        set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
                 }

      "AcceptEventSymbol" {
                        set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
              		set geo_text $geo_text[AppendGeo $size]
                 }

     "AcceptTimeEventSymbol" {
                        set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
			set size "[u2::GetValue $uuid Size]"
			set geo_text $geo_text[AppendGeo $size]
 			set ElementText [u2::GetValue $uuid Text]

 WarningMesgPath
Report $uuid "Warning" "AcceptTimeEventSymbol ($ElementText) is translated to an unnamed Activity with a receive action"
               
                }
}


	if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
	append attrs " geometry=\"$geo_text\"" 
	append attrs " style=\"$style_text"
	append attrs "FillColor.Blue=$blue,"
	append attrs "FillColor.Green=$green,"
	append attrs "FillColor.Red=$red,"
	append attrs "Font.FaceName=$font_name,"
	append attrs "Font.Size=$font_size,"
	append attrs "Font.Bold=0,"
	append attrs "Font.Italic=$font_italic, "
	append attrs "Font.Strikethrough=0, "
	append attrs "Font.Underline=0,"
       
if {$Export_Rose==0} { 

	# Code Review
	set metaClassName [u2::GetMetaClassName $uuid] 	


	if {$metaClassName =="ClassSymbol" || $metaClassName =="SignalSymbol" || $metaClassName =="DataTypeSymbol"||$metaClassName =="StateMachineSymbol" || $metaClassName=="ArtifactSymbol"  || $metaClassName=="InterfaceSymbol" || $metaClassName=="TimerSymbol" || $metaClassName=="OperationSymbol"} {   

      	if {[u2::GetValue $uuid Autosize]=="true"} {
            	append attrs "AutomaticResize=1,"
      	} else {
            	append attrs "AutomaticResize=0,"
      	}  
        append attrs "ShowAllAttributes=1,"
       
        if {[u2::GetMetaClassName $uuid]!="SignalSymbol"} {
                 append attrs "ShowAllOperations=1," 
                 append attrs "ShowOperationSignature=1," 
                 append attrs "SuppressOperations=0,"   
        }
          	append attrs "SuppressAttributes=0,\""
     	} else {
        	append attrs "\""
     	} 
} else {
                append attrs "\""
}

	switch -- [u2::GetMetaClassName $uuid] { 
	"GeneralizationLine" {

			MapRole $uuid Relationship ForRelationship
			if {$parent == "Interface"} {
			     set style_text "RealizeRelation"
			}
			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			foreach elem $Coordinate {
				append geo_text $elem
				append geo_text ","
			}
			set attrs ""
			set style_text "Inheritance"
#If Generalization is between Class and Interface, export it as Realize
			if {$parent == "Interface" && $child == "Class"} {
				set style_text "RealizeRelation"
			}
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
			append attrs " style=\"$style_text\" "
			}

	"DependencyLine" {
			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			set geo_text [AppendGeo $Coordinate]
			set attrs ""
			                    
                        if {$Export_Rose==1} {
                                 set style_text "ClassDependency"
                        } else {
                                 set style_text "DependencyRelation"
                        }
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
			append attrs " style=\"$style_text\" "
			}
	"ExtensionLine" {

			set subject [u2::GetValue $uuid Guid]
			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			set geo_text [AppendGeo $Coordinate]
			set attrs ""
			                    
                        if {$Export_Rose==1} {
                                 set style_text "ClassDependency"
                        } else {
                                 set style_text "DependencyRelation"
                        }
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
			append attrs " style=\"$style_text\" "
			}

	"MessageLine" {
			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			set geo_text [AppendGeo $Coordinate]
			set attrs ""
			set style_text "Message, SQN= $SQN,"
			set SQN [expr $SQN + 1]
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
			append attrs " style=\"$style_text\" "
			}

	"TimerTimeoutSymbol" {

			set Coordinate "[u2::GetValue $uuid Position]"
			set geo_text [AppendGeo $Coordinate]
			set attrs ""
			set style_text "Message, SQN= $SQN,"
			set SQN [expr $SQN + 1]
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
			append attrs " style=\"$style_text\" "
			}
	"InstanceCreateLine" {
			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			set geo_text [AppendGeo $Coordinate]
			set attrs ""
			set style_text "Message, SQN= $SQN,"
			set SQN [expr $SQN + 1]
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
			append attrs " style=\"$style_text\" "
			}
	"MethodCallLine" {
			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			set geo_text [AppendGeo $Coordinate]
			set attrs ""
			set style_text "Message, SQN= $SQN,"
			set SQN [expr $SQN + 1]
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
			append attrs " style=\"$style_text\" "
			}
	"MethodReplyLine" {
			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			set geo_text [AppendGeo $Coordinate]
			set attrs ""
			set style_text "Message, SQN= $SQN,"
			set SQN [expr $SQN + 1]
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
			append attrs " style=\"$style_text\" "
			}
	"TransitionLine" {
			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			set geo_text [AppendGeo $Coordinate]
			set style_text "Transition"
			set attrs ""
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
			append attrs " style=\"$style_text\" "
			}
	"FlowLine" {

	MapRole $uuid Src ForOwner

	# Code Review
	set metaClassName [u2::GetMetaClassName $id_selection] 	
		
	if {$metaClassName == "InputSymbol" || $metaClassName == "GuardSymbol"} {
		MapRole $id_selection TriggeredTransition ForOwner
		set subject $owner
	}
	if {[u2::GetMetaClassName $id_selection] == "DecisionAnswerSymbol"} {
		MapRole $id_selection DecisionAnswer ForOwner
		set subject $owner
	}
	if {[u2::GetMetaClassName $id_selection] == "StartSymbol" && $subject == ""} {
		MapRole $id_selection StartTransition ForOwner
		set subject T.$owner
	}


 			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			set geo_text [AppendGeo $Coordinate]
			set style_text "Transition"
			set attrs ""
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
			append attrs " style=\"$style_text\" "
			}

	"ActivityEdgeLine" {

			set owner ""
			MapRole $uuid ActivityEdge ForOwner
			set subject $owner
			set Coordinate "[u2::GetValue $uuid SegmentPoints]"
			set geo_text [AppendGeo $Coordinate]
			set style_text "Transition"
			set attrs ""
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
			append attrs " style=\"$style_text\" "
			}

	"ForkSymbol" {

                        set size [u2::GetValue $uuid Size] 
                        set p1 [lindex $size 0]
                        set p2 [lindex $size 1]      
                        set Coordinate "[u2::GetValue $uuid Position]"
                        XYCordinate $Coordinate
                        set geo_text [AppendGeo $Cor]	
                        set geo_text $geo_text[AppendGeo $size]
  
                        if {$p1>$p2} {    
                               	set style_text "SyncItem, Horizontal=1,"
                        }
                        #  for Vertical Line
                        if {$p1<$p2} {    
                               	set style_text "SyncItem, Horizontal=0,"
                        }
                           
 			set attrs ""
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
         		append attrs " style=\"$style_text\" "
	       	 }    
	"PackageSymbol" {   
                     if {$Export_Rose==0} {
                        set style_text "Category"
 			set attrs ""
			if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
			append attrs " geometry=\"$geo_text\"" 
         		append attrs " style=\"$style_text\" "
                        		}  
			}           
		}

	if {$Export_Rose==1} { 
      	 	append attrs " subject=\"$subject\"" 
      
  	} else {
	
		# Code Review
		set metaClassName [u2::GetMetaClassName $uuid] 	
	
       		if {$metaClassName!="CommentSymbol" && $metaClassName!="TextSymbol"} {
	        		append attrs " subject=\"$subject\""
       		}         
  	}

	if {$Export_Rose==1} {
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]
   } 

   if {$Export_Rose==0} {
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
              
	# Code Review
	set metaClassName [u2::GetMetaClassName $uuid] 

        if {$metaClassName=="CommentSymbol" || $metaClassName=="TextSymbol"} {
                global file
                set PreEle "<UML:PresentationElement.subject>"
                puts $file $PreEle
                set PreComm "<UML:Comment xmi.idref=\"$subject\"/>"
                WriteLine $this $PreComm 
                set PreEle "</UML:PresentationElement.subject>"
                puts $file $PreEle   
            }  
          
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]
   }
}


# Procedure to write elements corresponding to Comment Line

proc StartUML_DiagramComment {this qualname {sub ""} {id_selection ""} {id ""} {uuid ""}} {
global xmlNS
global indent
global parent
global child
global font_size
set font_size [string trimright $font_size]
global font_name
set font_italic 0
global color
global Export_Rose

# added for U2 test case 
if {$color==16711680} {
     set color 16773875
}

set hexvalue [format %4.6X $color]
scan "$hexvalue" "%2x%2x%2x" b g r
set red $r
set green $g
set blue $b
set style_text ""
set attrs ""
set geo_text ""

		append style_text " Note:"
		set Coordinate "[u2::GetValue $uuid Position]\n"

 		set X [lindex $Coordinate 0]
                set X [expr int($X*1.6)]
     		set Y [lindex $Coordinate 1]
                if {$Y > 150 } { 
                 set Y [expr $Y-100]
                }
                set Coordinate ""
                set Coordinate $X
                lappend Coordinate $Y   

		foreach elem $Coordinate {

			append geo_text "$elem"
			append geo_text ","
			}

		set size "[u2::GetValue $uuid Size]"
		foreach elem $size {

			append geo_text $elem
			append geo_text ","
			}

	if {$id != ""} { append attrs " xmi.id=\"$id\"" }
	
    if {$Export_Rose==1} {   
        append attrs " geometry=\"$geo_text\"" 
	append attrs " style=\"$style_text"
	append attrs "FillColor.Blue=$blue,"
	append attrs "FillColor.Green=$green,"
	append attrs "FillColor.Red=$red,"
	append attrs "Font.FaceName=$font_name,"
	append attrs "Font.Size=$font_size,"
	append attrs "Font.Bold=0,"
	append attrs "Font.Italic=$font_italic, "
	append attrs "Font.Strikethrough=0, "
	append attrs "Font.Underline=0,\" "
	append attrs " subject=\"$sub\""
	

    } else {
        set style_text "NoteRelation:"
        append attrs " geometry=\"$geo_text\"" 
	append attrs " style=\"$style_text"
	append attrs "LineColor.Blue=$blue,"
	append attrs "LineColor.Green=$green,"
        append attrs "LineColor.Red=$red,\""
              
      
    }  
 

	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}




proc StartUML_DiagramRole {this qualname {owner ""} {id ""} {uuid ""}} {

global Assoc_id
global xmlNS
global indent
global font_size
set font_size [string trimright $font_size]
global font_name
global color
set id "A."
append id $Assoc_id
global pendingLine

	set style_text "Role"
	set attrs ""
	set sub "A."
	append sub $owner
	set geo_text ""
	set Coordinate "[u2::GetValue $uuid Position]\n"
	foreach elem $Coordinate {

		append geo_text "$elem"
		append geo_text ","
	}

	set size "[u2::GetValue $uuid Size]"
	foreach elem $size {

		append geo_text $elem
		append geo_text ","
		}
	if {$id != ""} { append attrs " xmi.id=\"$id\"" }	
	append attrs " geometry=\"$geo_text\"" 
	append attrs " style=\"$style_text\""
	append attrs " subject=\"$sub\""


	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]
	set Assoc_id [expr $Assoc_id + 1]

}


proc StartUMLElement_Diagram {this qualname {owner ""} {id ""} {label ""} {uuid ""}} {
	global xmlNS
	global indent
	set attrs ""
	global pendingLine

	set id [u2::GetValue $uuid Guid]
	if {$id != ""} { append attrs " xmi.id=\"$id\"" }
	append attrs " name=\"[XMLCharData $label]\"" 
	append attrs " toolName=\"Rational Rose 98\""
	append attrs " diagramType=\"$this\""
	append attrs " style=\"\""
	append attrs " owner=\"$owner\""
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}

#Procedure for Parameter
proc StartUMLElement_Para {this qualname {owner ""} {id ""} {label ""} {uuid ""}} {
	global xmlNS
	global indent
	global Data_id
	set attrs ""
	global pendingLine

	set id [u2::GetValue $uuid Guid]
	if {$id != "" } { append attrs " xmi.uuid=\"$id\"" }

	if {$id != ""} { append attrs " xmi.id=\"$id\"" }
	append attrs " name=\"[XMLCharData $label]\"" 
	append attrs " namespace=\"$owner\""

	if { [u2::GetMetaClassName $uuid] == "Parameter" } {
		set Data_id ""
		MapRole $uuid Type ForName
		append attrs " type=\"$Data_id\"" 

	}
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}

proc StartUMLElement_Model {this qualname {id ""} {label ""} {uuid ""}} {
	global xmlNS
	global indent
	set attrs ""
	global pendingLine

	set id [u2::GetValue $uuid Guid]
	if {$id != "" } { append attrs " xmi.uuid=\"$id\"" }

	if {$id != ""} { append attrs " xmi.id=\"$id\"" }
	append attrs " name=\"[XMLCharData $label]\"" 
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}

 

proc StartUMLElement {this qualname {namespace ""} {id ""} {label ""} {uuid ""}} {
global xmlNS
global indent
set attrs ""
global Data_id
global owner
global Export_Rose
global pendingLine

# RASHID
global Class_xmiid 




	set id [u2::GetValue $uuid Guid]
	if {$id != "" } { append attrs " xmi.uuid=\"$id\"" }

	if {$id != ""} { append attrs " xmi.id=\"$id\"" }
	append attrs " name=\"[XMLCharData $label]\"" 

	# Code Review
	set metaClassName [u2::GetMetaClassName $uuid] 

	if {$metaClassName!= "Package" && $metaClassName != "Attribute"} {
		set isAbstract [u2::GetValue $uuid IsAbstract]
		append attrs " isAbstract=\"$isAbstract\""
		if {$Export_Rose == 1} {	
                append attrs " targetScope=\" [getscope $uuid]\" " 
		} 

	}
	
        append attrs " namespace=\"$namespace\""
	set visible [getVisibility $uuid]
	append attrs " visibility=\"$visible\"" 

	if { [u2::GetMetaClassName $uuid] == "Attribute" } {

		if {$qualname !="UML:Actor"} {
                            set Data_id ""

			    # Case        : For Case TLOG#29324 The XMI-exporter produce faulty XML
			    # Author      : Rashid M		
			    # Change      : Added Below Single Line	(set Class_xmiid ""	)

			    set Class_xmiid ""
       		            
			    MapRole $uuid Type ForName	
                            	
			    if {[string range $Class_xmiid  0 10] != "@Predefined"} {
				set Data_id $Class_xmiid 
			    }	

			    append attrs " type=\"$Data_id\"" 

               } 

		}
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

 

}

#Procedure for Tag

proc StartUML_Tag {this qualname {id ""} {uuid ""} {owner ""} {url ""} {type ""}} {
	global xmlNS
	global indent
	set attrs ""
	global pendingLine

	set id $uuid
	if {$id != ""} { append attrs " xmi.id=\"$uuid\"" }

	append attrs " value=\"$url\" "
	append attrs " modelElement=\"$owner\" "
	append attrs " tag=\"$type\" "

	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}

#Procedure for Comment Text

proc StartUML_CommentText {this qualname {id ""} {uuid ""} {owner ""} } {

	global xmlNS
	global indent
	set attrs ""
	set id $uuid

	if {$id != ""} { append attrs " xmi.id=\"$uuid\"" }

	append attrs " tag=\"documentation\" "
	append attrs " modelElement=\"$owner\" "
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}

#Procedure for Comment Symbol

proc StartUML_Comment {this qualname {id ""} {uuid ""} {text ""} {item ""}} {

global xmlNS
global indent
global commentsymbol_id
global Export_Rose
global target
global file
global ClassType  
global pendingLine

	set attrs ""

        if {$id != ""} { append attrs " xmi.id=\"$id\"" }

	if {$Export_Rose==0} {
             
             append attrs " name=\"[XMLCharData $text]\" "
	} 
	if {$Export_Rose==1} {
          append attrs " annotatedElement=\"$item\" "
	}
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	     if {$Export_Rose==1} {
                      
                } else {
                     puts $file "<UML:Comment.annotatedElement>"
                     foreach it $target {
                      if {$it!="None"} {   
                        set ClassType "[u2::GetMetaClassName $it]"
                        MapRole $it AppliedStereotypeInstance Fortype
                         
# Change from [Get $it Guid] to [u2::GetValue $it Guid]

            puts $file "<UML:$ClassType xmi.idref=\"[u2::GetValue $it Guid]\">"
                        puts $file "</UML:$ClassType>"
                      }
                     }              
                     puts $file "</UML:Comment.annotatedElement>" 
                   
                } 
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}


#Procedure for Constraints

proc StartUML_Constraint {this qualname {id ""} {name ""} {owner ""} } {

global xmlNS
global indent
global Export_Rose
global pendingLine

	set attrs ""

	
	if {$id != ""} { append attrs " xmi.id=\"$id\"" }
if {$Export_Rose == 1} {
	append attrs " name=\"$name\" "
}
	append attrs " constrainedElement=\"$owner\" "
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}




proc EndUMLElement {this qualname {comment ""}} {
	
	global indent
	global pendingLine
	set indent [expr $indent - 1]
	
	if {$pendingLine == 0} {	
		if {$comment != ""} { set comment [XMLComment $this "End of $comment"] }
		set g "</[UMLElementName $this $qualname]>$comment"
		WriteLine $this "</[UMLElementName $this $qualname]>[WriteComment $this $comment]"


	} else {
		 EndLine $this "/>"
	}
}



proc XMLCharData {value} {

	regsub -all {&} $value {\&amp;} value
	regsub -all {<} $value {\&lt;} value
	regsub -all {>} $value {\&gt;} value
	regsub -all {"} $value {\&quot;} value

	return $value
}

proc WriteValueElement {this name value {comment ""}} {

	if {$value == ""} {		
		WriteLine $this "<$name/>[XMLComment $comment]"
	} else {
		set t [XMLCharData $value]
		set j [XMLComment $comment " "]
		WriteLine $this "<$name>$t</$name>$j"
	}
	
}


proc WriteUMLStringValue {this qualname value} {

	global pendingLine
	
	if {$pendingLine == 0} {		
		WriteValueElement $this $qualname $value
	} elseif {[regexp "\[\x01-\x1F\]" $value]} {
		 EndLine ">"
		 WriteValueElement $this $qualname $value
	} else {
		 
	}

}

proc GetId {uuid} {
	
	global id
	global idLast
	set id "$idLast"
	set id [expr $id + 1]
	set idLast "$id"	
	return $id
}

proc NextLine {this line} {
		global pendingLine


		set linelen [string length $line]
		if { $pendingLine + $linelen <= 128} {
		 
			$this pendingLine [expr $pendingLine + $linelen + 1]
		} else {
			puts $file ""
			set pendingLine [expr $linelen + 3]
		}
}

proc WriteElement {this name {attrs ""} {comment ""}} {
	if {$attrs == ""} {
		 WriteLine $this "<$name/>[ XMLComment $this $comment]"
	} else {
		 WriteLine $this "<$name [string trimleft $attrs]/>[ XMLComment $this $comment]"
	}
}

proc WriteUMLEnumValue {this qualname value} {
	global pendingLine
	if { $pendingLine == 0} {
		 WriteElement $this  $qualname "xmi.value=\"$value\""
	} else {
		 NextLine $this "[lindex [split [lindex $qualname 1] .] 1]=\"$value\""
	}
}

# Procedure to write Stereotype in XMI 

proc Writing_Stereotype {selection name guid base} {

global file
 		set text "<UML:"
		append text "Stereotype "
		append text "xmi.id=\"$selection\" "
		append text "name=\"[XMLCharData $name]\" "
		append text "icon=\"\" "
		append text "baseClass=\"$base\" "
		append text "extendedElement=\"$guid\"> "
          	puts $file $text
		set text "</UML:"
		append text "Stereotype> "
		puts $file $text
}

proc StartUML_DepForExcp {this qualname {id ""} {uuid ""} {client ""} {supplier ""}} {

	global xmlNS
	global indent
	set attrs ""
	global pendingLine
	 
	set id $uuid
        if {$id != ""} { append attrs " xmi.id=\"$id\"" }
	if {$uuid != "" } { append attrs " xmi.uuid=\"$uuid\"" }
	append attrs " name=\"\"" 
	append attrs " client=\"$client\" "
	append attrs " supplier=\"$supplier\" "
	set name "$qualname"
	if {$attrs != ""} { set attrs " [string trimleft $attrs]" }
	if { $xmlNS == ""} {
		WriteLine $this "<$name$attrs>"
	} else {
		if { $pendingLine != 0} { EndLine ">" }
		FirstLine "<$name$attrs"
	}
	set indent [expr $indent + 1]

}

proc WritinginXMI_DepForExcp {selection client supplier} {
global owner

		set umltype "UML:Dependency"
		set this ""
		set comment ""
		set Name ""
		set ID ""
		StartUML_DepForExcp $this $umltype $ID $selection $client $supplier
		set this ""
		set comment ""

		EndUMLElement $this $umltype $comment
}

proc ForWritingException {selection} {
  global name
  global Stereo_id
  global Class_xmiid

  set name ""
  global client
  global supplier
  global owner
  global id_selection

                switch -- [u2::GetMetaClassName $selection] { 

                "Operation" {
		
			# Case        : For Case TLOG#29324 The XMI-exporter produce faulty XML
			# Author      : Rashid M		
			# Change      : Added Below Single Line		(set Class_xmiid "")
			
			set Class_xmiid ""
                                          
			set fail [catch {MapRole $selection RaisedException ForName} error]
			if {$fail} {
		 		  Report $selection "Catch Error" $error
			}


                       	if {$name!=""} { 
  	                       
			set fail [catch { set client "[u2::GetValue $selection Guid]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

                        
                                set supplier $Class_xmiid
                                WritinginXMI_DepForExcp $selection $client $supplier 
				set id "St."
				append id "$Stereo_id"
				set name "throws"
				set base "Dependency"
                         	Writing_Stereotype $id $name $selection $base  
				set Stereo_id [expr $Stereo_id + 1]
                               }
                            }
                }
 return 1
}


global AttrFlag 
set AttrFlag 0 

proc AttrHierarchy {selection} {

global AttrFlag
global file
global owner
global id_selection

set fail [catch {MapRole $selection Owner ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


set fail [catch {MapRole $id_selection Owner ForOwner} error]
if {$fail} {
 	  Report $id_selection "Catch Error" $error
}

set namespace $owner
		
		set fail [catch {set Name [u2::GetValue $selection Name]} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		
		set fail [catch {set this [u2::GetMetaClassName $selection]} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}


if {$this=="Class" || $this=="Choice"|| $this=="Artifact"|| $this=="Collaboration" || $this=="DataType" || $this=="Interface" || $this=="Stereotype"} {
 
                 set AttrFlag 1
                 if {$this!="Interface"} {
                    set this "Class"
                 }  

 WarningMesgPath
Report $selection "Warning" "[u2::GetMetaClassName $selection] ($Name) within Attribute is moved up in Rose Hierarchy"     


                 set ID 1  
                 set umltype "UML:"
		 append umltype $this
		 set comment " $Name $this "
		 WriteComment $this $comment
        	 StartUMLElement $this $umltype $namespace $ID $Name $selection
                 Traverse $selection 
		 EndUMLElement $this $umltype $comment
   }
  
   return 1 
}


global F 
set F 0
 
proc ChoiceHirar {selection} {
global F
global isActor 
global file
global owner 
	MapRole $selection Owner ForOwner
        set namespace $owner
        set Name [u2::GetValue $selection Name]
	 
	set isActor "" 
	MapRole $selection AppliedStereotypeInstance Fortype
 
	 if {$isActor=="Actor"} {
	     set this "Actor"
	     set F 1
	 } else {
	     set this "Attribute"
	     set F 1
	 }   
		 set ID 1  
                 set umltype "UML:"
		 append umltype $this
		 set comment " $Name $this "
		 WriteComment $this $comment
 
         	 StartUMLElement $this $umltype $namespace $ID $Name $selection
             
		 EndUMLElement $this $umltype $comment
  return 1
}
 

# Procedure to write UseCase in XMI 

proc WritinginXMIUseCase {selection namespace} {
global file
global id_selection
global owner
global class
set class ""

		set Name [u2::GetValue $selection Name]
		set this "UseCase"

		set ID 1
		set umltype "UML:"
		append umltype $this
		set comment " $Name $this "
		WriteComment $this $comment

		StartUMLElement $this $umltype $namespace $ID $Name $selection
		Traverse $selection
		EndUMLElement $this $umltype $comment

}

 
# Date : 25 June 2007
proc ForSynType	{selection} {
  global synTypetype
  set synTypetype [u2::GetValue $selection Name]    
   
}

# Procedure to write in XMI 

proc WritinginXMI {selection} {
global file
global owner
global class
global id_selection
global this
global Stereotype_Name
global Stereotype_count
global isOperation
global isInteraction
global Export_Rose


set Stereotype_Name ""
set Stereotype_count 0
set isStereotype 0
set isOperation "Operation"
set isInteraction 0
set isStateMachine 0
set isActivity 0
set isUseCase 0	

  		MapRole $selection Owner ForOwner
		set namespace $owner
		set Name [u2::GetValue $selection Name]
		set this [u2::GetMetaClassName $selection]

	 
		#  For SynType 
		   global synTypetype 
		   set synTypetype ""	

		   if {[u2::GetMetaClassName $selection]=="Syntype"} {
			MapRole $selection Type ForSynType
			# Public syntype INT32 = Integer;
			 
			set Name ""
			append Name "[getVisibility $selection] syntype " 
			append Name "[u2::GetValue $selection Name] = "
			append Name $synTypetype  
 
				
		   } 
  			
		# END
 
		switch -- [u2::GetMetaClassName $selection] { 

		 

		"Parameter" {

			set this "Attribute"

			}


		"Collaboration" {
                          if {$Export_Rose==1} {
                               set this "Class"
                           } else {
                               set this "Collaboration"
                           }  

			}

		"Operation" {


			set class ""
			set isOperation "Class"
			MapRole $selection AppliedStereotypeInstance Fortype
			set this $isOperation
			if {$isOperation=="Class"} {
				MapRole $selection Owner ForOwner
				if {$class == "Class" || $class == "SimpleStateMachine" || $class == "DataType" || $class == "Artifact" || $class == "Choice"} {

				return 1
				}		
			}
                      	if {$isOperation=="activity"} {
				set isActivity 1
				if {$Export_Rose == 1} {
 WarningMesgPath
Report $selection "Warning" "Activity ($Name) is translated to Class stereotyped as <<activity>>"
					set this "Class"	
				} else {
					set this "Activity"		
				}
                               	}
                      	if {$isOperation=="interaction"} {
				set isInteraction 1
				set this "Class"

 WarningMesgPath
Report $selection "Warning" "Interaction ($Name) is translated to Class stereotyped as <<interaction>>"	
                               	}
                      	if {$isOperation=="UseCase"} {

				set isUseCase 1

				MapRole $selection Owner ForOwner

				if {[u2::GetMetaClassName $id_selection]!= "Package"} {
					return 1
				}
					
				}

			}
		"Attribute" {

			global isActor
			set isActor "Attribute"
			MapRole $selection AppliedStereotypeInstance Fortype

			set class ""
			MapRole $selection Owner ForOwner


if {$isActor != "Actor" && $class == "Package"} {

# Export Choice and Class Up in model hierrachy  while in these in Attributes

  MapRole $selection InlineType AttrHierarchy

}

			if {[u2::GetValue $selection Derived]=="true"} { 
                           set Derived "/"
                           set Name $Derived$Name
                         } 

			set this $isActor
			if {$isActor == "Actor"} {
			set class ""
			MapRole $selection Owner ForOwner

			if {$class == "Collaboration" || $class == "Class" || $class == "ActivityImplementation" || $class == "SimpleStateMachine" || $class == "Interaction" || $class == "Choice"} {
				return 1
				} else {
					if {$class == "ActivityImplementation"} {
				set this "Class"
				MapRole $id_selection Owner ForOwner
				set namespace $owner
					}
				}
				}
			}
		"Signal" {

			if {$Export_Rose == 1} {
				set this "Class"
 WarningMesgPath
Report $selection "Warning" "Signal ($Name) is translated to Class stereotyped as <<signal>>"
			}

			}
                "StateMachine" {
			
			#if {[GetPresentations $selection]==""} {
				#return
	 		#}

    			set class ""
                   	set this "Class"
			set isStateMachine 1
WarningMesgPath 
Report $selection "Warning" "StateMachine ($Name) is translated to Class stereotyped as <<stateMachine>>"
                        }
                 "Artifact" {
                        set this "Class"
 WarningMesgPath
Report $selection "Warning" "Artifact ($Name) is translated to Class stereotyped as <<artifact>>"
                        } 
                 "DataType" { 
WarningMesgPath 
Report $selection "Warning" "DataType ($Name) is translated to Class"
                        if {$Export_Rose==1} {
                           set this "Class"
                        } else {
                           set this "DataType"

                        }  
                          
                  }  
                  "Timer" {
                        set this "Class"
WarningMesgPath 
Report $selection "Warning" "Timer ($Name) is translated to Class stereotyped as <<timer>>"
                   }

                 "Choice" {

                        set this "Class"
WarningMesgPath 
Report $selection "Warning" "Choice ($Name) is translated to Class stereotyped as <<choice>>"
                   }

                 "Stereotype" {
                     if {$Export_Rose==1} {
                             set this "Class"
WarningMesgPath 
Report $selection "Warning" "Stereotype ($Name) is translated to Class stereotyped as <<stereotype>>"

                      } else {
                             set this "Stereotype" 
                      } 
                   }
		}
		set ID 1
		set umltype "UML:"
		append umltype $this
		set comment " $Name $this "
		WriteComment $this $comment

 

		# RASHID  :: 05 August 2006
		# Below code change for exporting Actor in TauG2 without inline class. All definition
		# inside inline class should be specified for UML:Actor node in the XML file.

		global class
		if {$this=="Class"} {
	  	   MapRole $selection Owner ForOwner
 		   if {$class== "Attribute"} {
			Traverse $selection		
		   } else {
			StartUMLElement $this $umltype $namespace $ID $Name $selection
	       	 	Traverse $selection
			EndUMLElement $this $umltype $comment
		   }
			 
		} else {
 	
			StartUMLElement $this $umltype $namespace $ID $Name $selection
	       	 	Traverse $selection
			EndUMLElement $this $umltype $comment
		}




         	if {[u2::GetMetaClassName $selection] == "Class"} {
		 	MapRole $selection Signature ForWritingException
		}

		if {[u2::GetMetaClassName $selection] == "Operation" && $isUseCase != 1} {
		 
		}

		if {$isStateMachine==1} {
			if {[u2::GetMetaClassName $selection] == "StateMachine"} {
			}
		}

}

# Procedure to write StateMachine (For StateChart and Activity Dia) in XMI 
 
proc WritinginXMI_Statemachine {selection type} {

global file
global owner
set owner ""
global id_selection
set id_selection ""
global Export_Rose
global list_sender
global list_receiver


global transitionLineText
set transitionLineText ""

		if {$type == "SimpleStateMachine"} {
			set top_text "StateMachine"
			set implement_text "StateMachineImplementation"

		}
		if {$type == "ActivityImplementation"} {
			set top_text "ActivityGraph"
			set implement_text "ActivityImplementation"
		}

		MapRole $selection Owner ForOwner
		

		#if {$type == "SimpleStateMachine"} {
		#	set implement_text "[u2::GetValue $id_selection Name] "
		#	MapRole $id_selection Owner ForOwner
		#}			

		set text "<UML:"
		append text "$top_text "
		append text "xmi.id=\"[u2::GetValue $selection Guid]\" "
		append text "xmi.uuid=\"[u2::GetValue $selection Guid]\" "

		if {$Export_Rose == 1} {

		   #if {$type == "SimpleStateMachine"} {	 
			#append text "name=\"$implement_text\" "
		  # } else {
			append text "name=\"$implement_text of [u2::GetValue $id_selection Name]()\" "
		  # }	
	
		} else {
			append text "name=\"[u2::GetValue $id_selection Name]\"  "
		}
			append text "context=\"$owner\" "	
			append text ">"
			puts $file $text
			set text "<UML:"
			append text "StateMachine.top>"
			puts $file $text
			WritinginXMICompositeState $selection $type
			
			set text "</UML:"
			append text "StateMachine.top>"
			puts $file $text
			set text "<UML:"
			append text "StateMachine.transitions>"
			puts $file $text

		if {$type == "SimpleStateMachine"} {
			
			MapRole $selection Transition WritinginXMI_Transition
			u2::MetaVisit $selection StatemachineDefinition
		}

		if {$type == "ActivityImplementation"} {
			set list_sender ""
			set list_receiver "" 
			MapRole $selection Edge WritinginXMI_Transition
			u2::MetaVisit $selection StatemachineDefinition
		}


		set text "</UML:"
			append text "StateMachine.transitions>"
			puts $file $text
		set text "</UML:"
			append text "$top_text> "
			puts $file $text

		if {$type == "SimpleStateMachine"} {
		
		MapRole $selection Transition WritinginXMI_SignalEvent
		u2::MetaVisit $selection SignalEventDefinition
		}

        	if {$type == "ActivityImplementation"} {
	           	MapRole $selection Edge WritinginXMI_SignalEvent
			u2::MetaVisit $selection SignalEventDefinition
 		}
             
       
return 1
}

proc StatemachineDefinition {definition} {
global isOperation
set isOperation ""


if {[u2::GetMetaClassName $definition] == "StateMachine"} {
		
		set fail [catch {MapRole $definition InlineMethod ForCompositeTransition} error]
		if {$fail} {
		 	  Report $definition "Catch Error" $error
		}


}

if {[u2::GetMetaClassName $definition] == "Operation"} {
		
		set fail [catch {MapRole $definition AppliedStereotypeInstance Fortype} error]
		if {$fail} {
		 	  Report $definition "Catch Error" $error
		}

		if {$isOperation!="UseCase"} {

		
		set fail [catch {MapRole $definition InlineMethod ForCompositeTransition} error]
		if {$fail} {
		 	  Report $definition "Catch Error" $error
		}

		}

}

}

proc ForCompositeTransition {selection} {

	if {[u2::GetMetaClassName $selection] == "SimpleStateMachine"} {
			
	
	    set fail [catch {MapRole $selection Transition WritinginXMI_Transition} error]
	    if {$fail} {
 		  Report $selection "Catch Error" $error
	    }

	}

	if {[u2::GetMetaClassName $selection] == "ActivityImplementation"} {
			
	
		set fail [catch {MapRole $selection Edge WritinginXMI_Transition} error]
		if {$fail} {
 			  Report $selection "Catch Error" $error
		}

	}

return 1
}

proc SignalEventDefinition {definition} {
global isOperation
set isOperation ""

	if {[u2::GetMetaClassName $definition] == "StateMachine"} {
		
		set fail [catch {MapRole $definition InlineMethod ForCompositeSignals} error]
		if {$fail} {
		 	  Report $definition "Catch Error" $error
		}

	}
	if {[u2::GetMetaClassName $definition] == "Operation"} {
		
		
		set fail [catch {MapRole $definition AppliedStereotypeInstance Fortype} error]
		if {$fail} {
		 	  Report $definition "Catch Error" $error
		}

			if {$isOperation!="UseCase"} {
				
		set fail [catch {MapRole $definition InlineMethod ForCompositeSignals} error]
		if {$fail} {
		 	  Report $definition "Catch Error" $error
		}

			}
	}

}

proc ForCompositeSignals {selection} {

	if {[u2::GetMetaClassName $selection] == "SimpleStateMachine"} {
			
		set fail [catch {MapRole $selection Transition WritinginXMI_SignalEvent} error]
		if {$fail} {
			 	  Report $selection "Catch Error" $error
		}

	}
	if {[u2::GetMetaClassName $selection] == "ActivityImplementation"} {
			
			set fail [catch {MapRole $selection Edge WritinginXMI_SignalEvent} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

	}

return 1
}

 
proc ForCompositeStateChart {selection} {

global list_diagram
global list_diagram_state
global composite_id

	if {[u2::GetMetaClassName $selection] == "StatechartDiagram"} {
		lappend list_diagram $selection
		lappend list_diagram_state $composite_id
	}
return 1
}


# Procedure to write Composite State in XMI

proc WritinginXMICompositeState {selection type} {

global file
global id_selection
global class
global owner
set id_selection ""
set class ""
set name ""
global composite_id
global list_State
global list_State_scope
global list_State_id
set flag 0
global Export_Rose
global element_id
global element_text

	MapRole $selection Owner ForOwner
	MapRole $id_selection Owner ForOwner

	if {$class == "State"} {
		append name [u2::GetValue $id_selection Name]
		MapRole $composite_id Owner ForOwner
		set id [u2::GetValue $composite_id Guid]
		foreach item $list_State {
			if {$item == "$name"} {
				foreach item1 $list_State_scope {
					if {$item1 == "$owner"} {
						set flag 1
					}
				}
			}

		}
			if {$flag == 0} {
				MapRole $selection Diagram ForCompositeStateChart
				lappend list_State $name
				lappend list_State_scope $owner
				lappend list_State_id $composite_id
			}
	} else {
				set name "{top}"
				set id $selection
				lappend list_State $name
				lappend list_State_scope $owner
				lappend list_State_id $selection
	}

	if {$type == "ActionNode" && $Export_Rose == 1} {
		set type_text "SubactivityState"
		set element_id [u2::GetValue $selection Guid]
		set element_text ""
		set element_text ""
                Diagram_Text $selection
			if {$element_text == ""} {
				set id_selection ""
				MapRole $selection Activity ForOwner
				if {$id_selection != ""} {
					set element_text [u2::GetValue $id_selection Name]
				}
			}
				set name [XMLCharData $element_text]
				set id $element_id
			} else {
				set type_text "CompositeState"
}

if {$flag == 0} {


		set text "<UML:"
		append text "$type_text "
		append text "xmi.id=\"$id\" "
		append text "name=\"$name\" "
		if {$type == "ActionNode" && $Export_Rose == 1} {
			append text "isConcurrent=\"false\" "
			append text "isDynamic=\"false\" "
		}
		append text ">"
		puts $file $text
		set text "<UML:"
		append text "CompositeState.subvertex>"
		puts $file $text

		if {$type == "SimpleStateMachine"} {
			MapRole $selection MultiState ForState
			MapRole $selection State ForState
			MapRole $selection Transition WritinginXMI_Start
		}


		if {$type == "ActivityImplementation"} {
			WritinginXMI_ActivityImplementation $selection
 		}

		if {$type == "ActionNode"} {
    	                MapRole $selection Activity ForWritingActivity
		}

		set text "</UML:"
		append text "CompositeState.subvertex>"
		puts $file $text
		set text "</UML:"
		append text "$type_text>"
		puts $file $text

		}
}

# Procedure to write nodes and transition

proc WritinginXMI_ActivityImplementation {selection} {

global id_selection
global element_id
global element_text
global list_sender_activity 
global list_receiver_activity
global list_activity
	
	MapRole $selection Node ForNode 
set list_sender_activity ""
set list_receiver_activity "" 
set list_activity ""
	MapRole $selection Edge ForListTransition
	set index "none"
	set i 0
	foreach item $list_receiver_activity {
	set done 1

		if {$item!= ""} {
			if {[u2::GetMetaClassName $item] == "SendSignalNode"} {
			set index $i

				if {[u2::GetMetaClassName [lindex $list_sender_activity $index]] == "InitialNode" || [u2::GetMetaClassName [lindex $list_sender_activity $index]] == "ActionNode" || [u2::GetMetaClassName [lindex $list_sender_activity $index]] == "ActivityDecisionNode" || [u2::GetMetaClassName [lindex $list_sender_activity $index]] == "AcceptEventNode"} {

		set send_signal $item
		set done 0
		foreach item1 $list_sender_activity {
			if {$item1!= ""} {
				if {[u2::GetValue $item Guid] == [u2::GetValue $item1 Guid]} {
					set done 1
				}
			}
		}
	
		foreach element $list_activity {
			if {$send_signal == $element} {
				set done 1
			}
		}
		
		if {$done == 0} {
			set type send
			set element_id ""
			set element_text ""
			set element_id [u2::GetValue $send_signal Guid]
			Diagram_Text $send_signal
			set T ""
				foreach item $element_text {
					 if {$item!=""} {
					    append T $item
 					 }
				} 
 				set element_text $T

WarningMesgPath				 
Report $send_signal "Warning" "SendSignalSymbol ($element_text) is translated to an unnamed Activity with a send action" 
				
				WritingdoActivity $send_signal $element_text $type
				lappend list_activity $send_signal
				}
			}
		}
	}
	set i [expr $i + 1]

}

set index "none"
set i 0
foreach item $list_sender_activity {
	if {$item!= ""} {
		if {[u2::GetMetaClassName $item] == "AcceptEventNode"} {

  		set index $i

			if {[u2::GetMetaClassName [lindex $list_receiver_activity $index]] == "ActivityFinalNode" || [u2::GetMetaClassName [lindex $list_receiver_activity $index]] == "ActionNode" || [u2::GetMetaClassName [lindex $list_receiver_activity $index]] == "ActivityDecisionNode" || [u2::GetMetaClassName [lindex $list_receiver_activity $index]] == "FlowFinalNode" || [u2::GetMetaClassName [lindex $list_receiver_activity $index]] == "SendSignalNode"} {
			set receive_signal $item

			set done 0
			foreach item1 $list_receiver_activity {
				if {$item1!= ""} {
					if {[u2::GetValue $item Guid] == [u2::GetValue $item1 Guid]} {
						set done 1
					}
				}
			}

# Check if AcceptTime Event then it is already exported

		set id_selection ""
		MapRole $receive_signal Trigger ForOwner
		if {$id_selection != ""} {
			if {[u2::GetMetaClassName $id_selection] == "TimeTrigger"} {

				set done 1
			}
		}

foreach element $list_activity {

	if {$receive_signal == $element} {
		set done 1
	}
}
		if {$done == 0} {
  			set type receive
			set element_id ""
			set element_text ""
			set element_id [u2::GetValue $receive_signal Guid]
			Diagram_Text $receive_signal

			set T ""
			foreach item $element_text {
				 if {$item!=""} {
				    append T $item
				 }
			} 

				set element_text $T

WarningMesgPath				 
Report $receive_signal "Warning" "AcceptEventSymbol ($element_text) is translated to an unnamed Activity with a receive action"

		WritingdoActivity $receive_signal $element_text $type
		lappend list_activity $receive_signal
				
				}
			}
		}
	}
	set i [expr $i + 1]
   }

}



# Procedure to write Action of Activity symbol
proc WritingdoActivity {item element_text type} {
global file
	set text "<UML:ActionState "
	append text "xmi.id=\"[u2::GetValue $item Guid]\" "
 	append text ">"
	puts $file $text
        set text "<UML:State.doActivity>"
	puts $file $text
	set text "<UML:"
	append text "ActionSequence "
	append text "xmi.id=\"AS.$item\" "
	append text ">"
	puts $file $text

	set text "<UML:"
	append text "ActionSequence.action>"
	puts $file $text
	set text "<UML:"
	append text "UninterpretedAction "
	append text "xmi.id=\"UA.$item\" "
	append text "name=\"$type $element_text;\" "

	append text ">"
	puts $file $text

	set text "</UML:"
	append text "UninterpretedAction>"
	puts $file $text

	set text "</UML:"
	append text "ActionSequence.action>"
	puts $file $text
	
	set text "</UML:"
	append text "ActionSequence>"
	puts $file $text

	set text "</UML:State.doActivity>"
	puts $file $text

	set text "</UML:ActionState>"
	puts $file $text

}
 

# procedure to make a list of all senders and receivers of all transitions

proc ForListTransition {selection} {
global list_sender_activity
global list_receiver_activity
global id_selection
global sender
global receiver
set sender ""
set receiver ""
global element_id


set fail [catch {set element_id [u2::GetValue $selection Guid]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

switch -- [u2::GetMetaClassName $selection] { 

	"ActivityEdge" {
                      	
			set fail [catch {MapRole $selection Owner ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}
                       	
			
			set fail [catch {MapRole $id_selection Diagram ForDiagram_Message} error]
			if {$fail} {
			 	  Report $id_selection "Catch Error" $error
			}
	
			lappend list_sender_activity $sender
			lappend list_receiver_activity $receiver

		}
	}



return 1
}


proc ForWritingSubNode {selection} {
	if {[u2::GetMetaClassName $selection] == "ActivityImplementation"} {
		WritinginXMI_ActivityImplementation $selection
   	}
return 1
}

proc ForWritingActivity {selection} {
	
	set fail [catch {MapRole $selection InlineMethod ForWritingSubNode} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}
return 1
}
 
# Procedure to write State in XMI

proc ForState {selection} {
global isComposite
set isComposite 0
global class
global element_id
global number
set number 0
global id_selection
global composite_id
global state_id

if {[u2::GetMetaClassName $selection] == "MultiState" } {
	set state_id $selection
	
	set fail [catch {MapRole $selection Transition ForStateTransition} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	
	set fail [catch {MapRole $selection Excluded ForOwner} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	if {$number == 0} {
		set number 0
		
		set fail [catch {MapRole $selection Included ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		if {$number == 1} {
			set composite_id $selection
			
		set fail [catch {MapRole $id_selection InlineStateMachine ForComposite} error]
			if {$fail} {
			 	  Report $id_selection "Catch Error" $error
			}


		}

	}
}
		
	if {[u2::GetMetaClassName $selection] == "State" } {
		set composite_id $selection
 		
		set fail [catch {MapRole $selection InlineStateMachine ForComposite} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		set id_selection $selection
	}
		
	if {$isComposite == 0} {

		set type "SimpleState"
		WritinginXMIState $selection $type
	} else {
		
		
	set fail [catch {MapRole $id_selection InlineStateMachine ForWritingComposite} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}

	}

return 1

}

proc ForStateTransition {selection} {
global state_transition
global state
global state_id
lappend state_transition $selection
lappend state $state_id
return 1

}


# Procedure for Composite State in XMI

proc ForComposite {selection} {

global isComposite
set isComposite 1

return 1

}

proc ForWritingComposite {selection} {


set fail [catch {MapRole $selection InlineMethod ForCompositeState} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}
return 1

}


proc ForCompositeState {selection} {


set fail [catch {set type [u2::GetMetaClassName $selection]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}
		WritinginXMICompositeState $selection $type

return 1

}
 



# Procedure to write Nodes of Activity Diagram  in XMI


proc ForNode {selection} {
global id_selection
global subactivity 
set subactivity 0
global element_id


set fail [catch {set element_id [u2::GetValue $selection Guid]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

global element_text
set element_text ""




switch -- [u2::GetMetaClassName $selection] { 

    "FlowFinalNode" {


                        set type "FinalState"
			WritinginXMIState $selection $type 
          
                     } 

     "InitialNode" {  
			set type "Pseudostate"
			WritinginXMIState $selection $type
                 
		}
   
     "ActivityFinalNode" {

set element_text ""
Diagram_Text $selection
 WarningMesgPath
Report $selection "Warning" "Activity Final Node is translated into End State in Rose." 		  
			set type "FinalState"
			WritinginXMIState $selection $type
                } 
     "ActivityDecisionNode" {
                       	set type "Pseudostate"
			WritinginXMIState $selection $type
                }
     "ActionNode" {
MapRole $selection Activity ForActivity
			if {$subactivity == 0} {
                        	set type "ActionState"
				WritinginXMIState $selection $type
			} else {
				
			set fail [catch {set type [u2::GetMetaClassName $selection]} error]
				if {$fail} {
			 		  Report $selection "Catch Error" $error
				}
				WritinginXMICompositeState $selection $type
			}
                 }
     "ForkNode" {
		        set type "Pseudostate"
		        WritinginXMIState $selection $type
                 } 
    "AcceptEventNode" {

# Check whether this is AcceptTimerEvent if yes then export it as Action state 

			set id_selection ""
			
			set fail [catch {MapRole $selection Trigger ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}
			if {$id_selection != ""} {
				if {[u2::GetMetaClassName $id_selection] == "TimeTrigger"} {
					set type "receive"
					set element_text ""

					Diagram_Text $selection

				WritingdoActivity $selection $element_text $type

				}
			}
			

                 }
  
	} 


return 1

}

proc ForSubActivity {selection} {
global subactivity 
global actionactivity

if {[u2::GetMetaClassName $selection]!= "OperationBody"} {
set subactivity 1
} else 	{

set actionactivity 1

}
return 1
}

proc ForActivity {selection} {


set fail [catch {MapRole $selection InlineMethod ForSubActivity} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


return 1
}

 

# Procedures to write Start and Stop Symbol of StateChart Diagram in XMI


proc WritinginXMI_Start {selection} {

global file


		
switch -- [u2::GetMetaClassName $selection] { 

		"StartTransition" {

			set type "Pseudostate"
			WritinginXMIState $selection $type
			
			set fail [catch {u2::MetaVisit $selection ForStopAction} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


		}
		"TriggeredTransition" {


		
		set fail [catch {u2::MetaVisit $selection ForStopAction} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		}



	}


return 1

}


proc ForStopAction {selection} {


	switch -- [u2::GetMetaClassName $selection] { 

		"StopAction" {


			set type "FinalState"
			WritinginXMIState $selection $type

			}
		"DecisionAction" {
			
			set type "Pseudostate"
			WritinginXMIState $selection $type

			}
		"ReturnAction" {	

 			set type "FinalState"
			WritinginXMIState $selection $type
			}
		}

}


proc WritinginXMIState {selection type} {
global file
global owner
global id_selection
global element_id
set element_id [u2::GetValue $selection Guid]
global element_text
set element_text ""
global name
global list_State
global list_State_id
global list_State_scope
global isPresent
set isPresent 0
global actionactivity
set actionactivity 0


			set text "<UML:$type "
			append text "xmi.id=\"$element_id\" "

       if {$type == "ActionState"} { 
		set element_text ""
                Diagram_Text $selection
		if {$isPresent == 0} {
			return

		}
	if {$element_text == "" && [u2::GetMetaClassName $selection]=="ActionNode"} {
			set id_selection ""
			MapRole $selection Activity ForOwner
			if {$id_selection != ""} {
			set element_text [u2::GetValue $id_selection Name]
			}
		}
                append text "name=\"[XMLCharData $element_text]\" "

        }
  
      if {$type == "Pseudostate"} {
                       
                       switch -- [u2::GetMetaClassName $selection] { 
                                "StartTransition" {
                                         append text "kind=\"initial\" "
                                 } 
                                "DecisionAction" {
                                         Diagram_Text $selection
                                         
			             
                     			 append text "kind=\"branch\" "
					append text "name=\"[XMLCharData $element_text]\""
                                } 
                        	"ActivityDecisionNode" {
                                         Diagram_Text $selection
                                         append text "kind=\"branch\" "
			append text "name=\"[XMLCharData $element_text]\""
         		  
                                 }
                                  
                                 "InitialNode" {
                                         append text "kind=\"initial\" "
                                  }
                                 "ForkNode" { 
                                         Diagram_Text $selection
                                         append text "kind=\"join\" "
        		append text "name=\"[XMLCharData $element_text]\""
                    		  }   
                        }
	}
       
	if {$type == "SimpleState" && [u2::GetMetaClassName $selection] == "State"} {

		MapRole $selection Owner ForOwner
		set element_text [u2::GetValue $selection Name]
		set i 0
		foreach item $list_State {
			if {$item == $element_text} {
				foreach item1 $list_State_scope {
					set trueScope [lindex $list_State_scope $i]
					if {$item1 == $owner && $trueScope==$owner} {	
						return 1
					}
				}			
			}
			set i [expr $i+1]

		}   
			lappend list_State $element_text
			lappend list_State_id $selection
			lappend list_State_scope $owner
                        append text "name=\"[XMLCharData $element_text]\" "
                         
	}

	if {$type == "SimpleState" && [u2::GetMetaClassName $selection] == "MultiState"} {

		set element_text ""
                Diagram_Text $selection  
		MapRole $selection Owner ForOwner
		set i 0
		foreach item $list_State {
			if {$item == $element_text} {
				foreach item1 $list_State_scope {
					set trueScope [lindex $list_State_scope $i]
					if {$item1 == $owner && $trueScope==$owner} {	

						return 1
					}
				}			
			}
			set i [expr $i+1]
		} 


			lappend list_State $element_text
			lappend list_State_id $selection
			lappend list_State_scope $owner

global number
global id_selection
set number 0
set test 0
MapRole $selection Included ForOwner 
set included $number
if {$id_selection!= ""} {
	if {[u2::GetMetaClassName $id_selection] == "State"} {

		if {[u2::GetValue $id_selection Name] != $element_text} {

			set test 1
		}

	}

}

set number 0
MapRole $selection Excluded ForOwner 

if {$included > 1 || $number > 0 || $test == 1 || $element_text == "*"} {  
 WarningMesgPath
 Report $selection "Warning" "Generating a state symbol with the state name set to \"$element_text\""
}

                        append text "name=\"[XMLCharData $element_text]\" "
	}

        
 
        if {$type == "FinalState" &&  [u2::GetMetaClassName $selection] == "ReturnAction"} {

			Diagram_Text $selection

			MapRole $selection Expression ForIdentName
			append text "name=\"[XMLCharData $element_text]\" "
	}
 

 			append text ">"
			puts $file $text

       if {$type == "ActionState"} { 

		MapRole $selection Activity ForActivity
		if {$actionactivity == 1} {
			WritinginXMIActionActivity $selection

		}
	}

			set text "</UML:"
			append text "$type> "
			puts $file $text


}
 
# Procedure to write action of activity symbol

proc WritinginXMIActionActivity {selection} {
global file
	set text "<UML:State.entry>"
	puts $file $text

	MapRole $selection Activity WritinginXMI_Effect

	set text "</UML:State.entry>"
	puts $file $text

}
 

# procedure for extracting the text of Activity Line and Guard Text 
proc ActivityLineText {ActyLineTxt} {

 

global LineText
global GuardText
 
	set prefix "\["
	set start [string first $prefix $ActyLineTxt]
	set prefix "\]"
	set end [string first $prefix $ActyLineTxt]

	set GuardStart [expr $start +1]
	set GuardEnd [expr $end -1]

	set GuardText [string range $ActyLineTxt $GuardStart $GuardEnd]
	 
	if {$start>0} {
       		set Tstart [expr $start -1]
	        set LineText [string range $ActyLineTxt 0 $Tstart]
    	}
 
	if {$start==0} {
       		set Tstart [expr $end +1]
       		set LineText [string range $ActyLineTxt $Tstart $end]
	}
     
    	set length [string length $ActyLineTxt]
        set l [expr $length - 1 ]
	if {$end < $l} {
	      set end [expr $end + 1 ]
      	      set subtext [string range $ActyLineTxt $end $l]
	      append LineText $subtext
	}
             
}


 
#----------------------------------------------------------------------------

# Procedure to write Transition of StateChart and Activity Diagram in XMI


proc WritinginXMI_Transition {selection} {

global file
global IntValue
global owner
global id_selection
global class
global sender
global receiver
set sender ""
set receiver ""
global sender_class
global receiver_class
set sender_class ""
set receiver_class ""
global sender_id
global receiver_id
set sender_id ""
set receiver_id ""
global element_id


set fail [catch {set element_id [u2::GetValue $selection Guid]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

global transition_id
global element_text
set element_text ""
Diagram_Text $selection
global LineText
set LineText ""
global GuardText
set index 0
global list_State
global list_State_id
global list_State_scope
global state
global state_transition
global list_sender
global list_receiver

 

switch -- [u2::GetMetaClassName $selection] { 

	"ActivityEdge" {

                       set GuardText ""
                       ActivityLineText $element_text 
         
                       
		       set fail [catch {MapRole $selection Owner ForOwner} error]
		       if {$fail} {
			  Report $selection "Catch Error" $error
		       }
			
                       
		       set fail [catch {MapRole $id_selection Diagram ForDiagram_Message} error]
		       if {$fail} {
			 	  Report $id_selection "Catch Error" $error
			}
	


                       set owner ""

lappend list_sender $sender
lappend list_receiver $receiver
set done 0
set trigger ""
set signal ""
while {$done == 0} {
set i 0
set index "none"

# Code Review
set metaClassName [u2::GetMetaClassName $sender] 

if {$metaClassName == "AcceptEventNode" || $metaClassName == "SendSignalNode"} {
	if {$metaClassName == "AcceptEventNode"} {
			set id_selection ""
			
			set fail [catch {MapRole $sender Trigger ForOwner} error]
			if {$fail} {
			 	  Report $sender "Catch Error" $error
			}

			set trigger $id_selection
		}
		if {[u2::GetMetaClassName $sender] == "SendSignalNode"} {
			
			set fail [catch {set signal [u2::GetValue $sender Guid]} error]
			if {$fail} {
			 	  Report $sender "Catch Error" $error
			}

		}
		set done 0
		foreach item $list_receiver {
		if {[u2::GetValue $item Guid] == [u2::GetValue $sender Guid]} {
			set index $i
		} else {
			set i [expr $i +1]
		}
	}
} else {
set done 1
}
if {$index!= "none"} {
	set sender [lindex $list_sender $index]
} else {
	set done 1
}
}

set done 0
while {$done == 0} {
set i 0
set index "none"

# Code Review
set metaClassName [u2::GetMetaClassName $receiver]
 
if {$metaClassName == "AcceptEventNode" || $metaClassName == "SendSignalNode"} {


	if {$metaClassName == "AcceptEventNode"} {
			set id_selection ""
			
			set fail [catch {MapRole $receiver Trigger ForOwner} error]
			if {$fail} {
			 	  Report $receiver "Catch Error" $error
			}

			set trigger $id_selection
		}
		if {[u2::GetMetaClassName $receiver] == "SendSignalNode"} {
			
			set fail [catch {set signal [u2::GetValue $receiver Guid]} error]
			if {$fail} {
			 	  Report $receiver "Catch Error" $error
			}	

		}


	set done 0
	foreach item $list_sender {
	if {[u2::GetValue $item Guid] == [u2::GetValue $receiver Guid]} {
		set index $i
		} else {
			set i [expr $i +1]
		}

	}

} else {
	set done 1
}


if {$index!= "none"} {
	set receiver [lindex $list_receiver $index]
} else {
	set done 1
}

}


# Code Review
set sMetaClassName [u2::GetMetaClassName $sender]


# Code Review
set rMetaClassName [u2::GetMetaClassName $receiver]

if {$sMetaClassName != "AcceptEventNode" && $rMetaClassName != "AcceptEventNode" && $sMetaClassName!= "SendSignalNode" && $rMetaClassName != "SendSignalNode" && $sMetaClassName!= "Parameter" && $rMetaClassName != "Parameter" && $sMetaClassName != "ConnectorNode" && $rMetaClassName!= "ConnectorNode" && $sMetaClassName != "ObjectNode" && $rMetaClassName != "ObjectNode"} {

		       set text "<UML:"
                       append text "Transition "
                       append text "xmi.id=\"$element_id\" "
if {$LineText != "" && $trigger == ""} {
set trigger $selection
}
if {$trigger != ""} {
		       append text "trigger=\"E.$trigger\" "
}
	               append text "source=\"[u2::GetValue $sender Guid]\" "
                       append text "target=\"[u2::GetValue $receiver Guid]\" "

                       append text ">"
                       puts $file $text  

                       set IntValue ""
 	               
			set fail [catch {MapRole $selection Guard ForDefault} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

                       set LineText ""
                       set GuardText ""
     
                       ActivityLineText $element_text

                       set IntValue $GuardText 
  
                       if {$IntValue != ""} {
	              	    WritinginXMI_Guard $selection $IntValue
                       }


			set text "<UML:"
			append text "Transition.effect> "
			puts $file $text

			set text "<UML:"
			append text "ActionSequence> "
			puts $file $text
			
			set text "<UML:"
			append text "ActionSequence.action> "
			puts $file $text
if {$signal!= ""} {

			set text "<UML:"
			append text "SendAction "
			append text "xmi.id=\"$id_selection\" "
			append text "signal=\"S.$signal\" "
			append text " >"

			puts $file $text

			set text "</UML:"
			append text "SendAction> "
			puts $file $text
}

			set text "</UML:"
			append text "ActionSequence.action> "
			puts $file $text

			set text "</UML:"
			append text "ActionSequence> "
			puts $file $text

			set text "</UML:"
			append text "Transition.effect> "
			puts $file $text
 
                       set text "</UML:"
	               append text "Transition"
                       append text ">"
		       puts $file $text
			}

			if {[u2::GetMetaClassName $sender] == "AcceptEventNode"} {

			set text "<UML:"
                       append text "Transition "
                       append text "xmi.id=\"$element_id\" "
	               append text "source=\"[u2::GetValue $sender Guid]\" "
                       append text "target=\"[u2::GetValue $receiver Guid]\" "

                       append text ">"
                       puts $file $text  

                       set text "</UML:"
	               append text "Transition"
                       append text ">"
		       puts $file $text

			}

			if {[u2::GetMetaClassName $receiver] == "SendSignalNode"} {

			set text "<UML:"
                       append text "Transition "
                       append text "xmi.id=\"$element_id\" "
	               append text "source=\"[u2::GetValue $sender Guid]\" "
                       append text "target=\"[u2::GetValue $receiver Guid]\" "

                       append text ">"
                       puts $file $text  

                       set text "</UML:"
	               append text "Transition"
                       append text ">"
		       puts $file $text

			}



                }


		"TriggeredTransition" {

		
		set fail [catch {MapRole $selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		
		set fail [catch {MapRole $id_selection Diagram ForDiagram_Message} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
 

		if {$sender == "" || $receiver == ""} {
			set i 0
			set index "none"
			foreach item $state_transition {
				if {$item == $selection} {
					set index $i
				} else {
					set i [expr $i + 1]
				}
			}
 
			set sender_state 0
			if {$index != "none"} {
				set sender [lindex $state $index]
				foreach item $list_State_id {
					if {$sender == $item} {
						set sender_state 1
					}
				}

				if {$sender_state == 0} {
					set i 0
					if {[u2::GetMetaClassName $sender] == "MultiState"} {
						set fail [catch {set element_id [u2::GetValue $sender Guid]} error]
						if {$fail} {
					 	  Report $sender "Catch Error" $error
						}

						set element_text ""
               					Diagram_Text $selection  
						foreach item $list_State {
							if {$item == $element_text} {
								set index $i
							}
								set i [expr $i +1]
						}	
								set sender [lindex $list_State_id $index]
					}
				}
			}
				set transition_id $selection
				set fail [catch {MapRole $selection Action ForFlowLine} error]
				if {$fail} {
			 		  Report $selection "Catch Error" $error
				}
	
		} else {
		
				 set transition_id $selection			

				set sender_state 0
				set receiver_state 0
				if {$receiver_class== "MultiState" || $sender_class== "MultiState"} {
					foreach item $list_State_id {
						if {$receiver == $item} {
							set receiver_state 1
						}
						if {$sender == $item} {
							set sender_state 1
						}
					}

				set fail [catch {MapRole $selection Owner ForOwner} error]
				if {$fail} {
				      Report $selection "Catch Error" $error
				}
	
				set trans_owner $owner
			   if {$receiver_state == 0 && $receiver_class== "MultiState"} {
				set i 0
				foreach item $list_State {
					if {$item == $receiver_id} {
						set index_temp $i
						set id [lindex $list_State_id $index_temp]
				
						set fail [catch {MapRole $id Owner ForOwner} error]
						if {$fail} {
					 	   Report $id "Catch Error" $error
						}

						if {$owner == $trans_owner} {
							set index $i
						}
					}
						set i [expr $i +1]
				}	
						set receiver [lindex $list_State_id $index]
			   }

			 if {$sender_state == 0 && $sender_class== "MultiState"} {
				set i 0
				foreach item $list_State {
					if {$item == $sender_id} {
						set index_temp $i
						set id [lindex $list_State_id $index_temp]
			
						set fail [catch {MapRole $id Owner ForOwner} error]
						if {$fail} {
						 	  Report $id "Catch Error" $error
						}
		
						if {$owner == $trans_owner} {
							set index $i
						}
					}
						set i [expr $i +1]
				}
				set sender [lindex $list_State_id $index]
			}

		}
			if {$sender != "" && $receiver!=""} {
				WritingTransition $selection $sender $receiver

	
			}

			}
		}

		"StartTransition" {

			set sender $selection
			set transition_id $selection
			
			set fail [catch {MapRole $selection Action ForFlowLine} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

		}


	}


return 1

}

# This procedure writes the transition to XMI

proc WritingTransition {id source target} {
global file
global owner
global id_selection
global IntValue
global operator
set operator ""
global element_id
set element_id [u2::GetValue $id Guid]
global element_text
set element_text ""


global transitionGuardText
set transitionGuardText ""

		set owner ""
		if {[u2::GetMetaClassName $id] == "TriggeredTransition"} {
		MapRole $id Trigger ForEvent
		if {$owner == ""} {
			if {[u2::GetValue $id AsteriskTrigger] == "true"} {
				set owner "A.[u2::GetValue $id Guid]"
				}
			}
		}
if {$id == $source} {
set element_id T.$element_id

}
		set text "<UML:"
		append text "Transition "
		append text "xmi.id=\"$element_id\" "
		if {$owner != ""} {
			append text "trigger=\"$id.$owner\" "
		}
		append text "source=\"[u2::GetValue $source Guid]\" "
		append text "target=\"[u2::GetValue $target Guid]\" "


		append text ">"
		puts $file $text

set element_id [u2::GetValue $id Guid]

		set IntValue ""
		if {[u2::GetMetaClassName $id] == "TriggeredTransition"} {
			set transitionGuardText ""	
			MapRole $id Guard ForGuardText
 
		# RASHID -- 04 - JULY -2006 
		# If Guard Text is set on Transition Line then it is stored in "transitionGuardText" varibale 
		# If Guard text is contains >,<,-,+ etc then it will be stored in 'IntValue' varible by Line Text
		# It is Trick  :) : ) :)
		
		        if {$transitionGuardText == ""} {
				set IntValue [XMLCharData $element_text]

				set startpos [expr ([string first "\[" $IntValue]+1)]	
				set endpos [expr ([string first "\]" $IntValue]-1)]	
				set IntValue [string range $IntValue $startpos $endpos]

				regsub -all {"} $IntValue {\&quot;} IntValue
			}
		}



		if {[u2::GetMetaClassName $id] == "DecisionAnswerTransition"} {
			MapRole $id Owner ForOwner
			Diagram_Text $id_selection
			set IntValue [XMLCharData $element_text]
			regsub -all {"} $IntValue {\&quot;} IntValue
		}
	
		if {$IntValue =="" } {
		   set IntValue $transitionGuardText 	
		}
	
		if {$IntValue != ""} {

			WritinginXMI_Guard $id $IntValue
			set IntValue ""
		
		}
	
		if {[u2::GetMetaClassName $id]!= "NextStateAction"} {




			set text "<UML:"
			append text "Transition.effect> "
			puts $file $text

			MapRole $id Action WritinginXMI_Effect

			set text "</UML:"
			append text "Transition.effect> "
			puts $file $text
		} else {

			MapRole $id Owner ForOwner
			
			if {[u2::GetMetaClassName $id_selection] == "CompoundAction"} {
			set text "<UML:"
			append text "Transition.effect> "
			puts $file $text

			MapRole $id_selection Action WritinginXMI_Effect

			set text "</UML:"
			append text "Transition.effect> "
			puts $file $text	
			}

		}

		set text "</UML:"
		append text "Transition"
		append text ">"
		puts $file $text


}

# Procedure to extract Guard Text

proc ForGuardText {selection} {


global owner
global id_selection
global element_id
global class

global transitionGuardText
set transitionGuardText ""

set fail [catch {set transitionGuardText [u2::GetValue $selection Value]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

set fail [catch {set transitionGuardText [u2::GetValue $selection Name]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

 

set fail [catch {MapRole $selection Owner ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


global element_text

set element_id $owner
Diagram_Text $id_selection


 

return 1
}




# This procedure is to extract the information of the flow line

proc ForFlowLine {selection} {

 

global owner
set owner ""
global id_selection
global class
global file
global element_id
global list_State_id
global list_State
global sender
global transition_id
global state_transition
global state
global element_text

switch -- [u2::GetMetaClassName $selection] { 


	"CompoundAction" {
		
		set fail [catch {MapRole $selection Action ForFlowLine} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
	}
	"DecisionAction" {
		set receiver $selection
		if {$sender != "" && $receiver!= ""} {
		WritingTransition $transition_id $sender $receiver
		}
		set sender $selection
		
		set fail [catch {MapRole $selection DecisionAnswer ForFlowLine} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}	
	}
	
	"DecisionAnswerTransition" {
		
		set fail [catch {MapRole $selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
		set sender $id_selection

		set transition_id $selection

		
		set fail [catch {MapRole $selection Action ForFlowLine} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}		
	}
	"JoinAction" {
		set receiver ""
		
		set fail [catch {MapRole $selection JoinedLabel ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
		
		set fail [catch {MapRole $id_selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
		if {$class == "ReturnAction"} {
		set receiver $id_selection
		} else {
			
			set fail [catch {MapRole $id_selection LibraryOwner ForFlowLine} error]
			if {$fail} {
		 		  Report $id_selection "Catch Error" $error
			}
		}
		if {$sender != "" && $receiver!= ""} {
		WritingTransition $transition_id $sender $receiver
		}
	}

	"ReturnAction" {

		set receiver $selection
		if {$sender != "" && $receiver!= ""} {
		WritingTransition $transition_id $sender $receiver
		}
	}

	"StopAction" {

		if {[u2::GetMetaClassName $sender] == "MultiState"} {
			set sender_state 0
			set index "none"
			set i 0
			foreach item $state_transition {
				if {$item == $transition_id} {
					set index $i
				}
				set i [expr $i + 1]

			}
			if {$index != "none"} {

				set sender [lindex $state $index]
				foreach item $list_State_id {
					if {$sender == $item} {
						set sender_state 1
						}
					}

				if {$sender_state == 0} {

				set i 0
				if {[u2::GetMetaClassName $sender] == "MultiState"} {
				set element_id [u2::GetValue $sender Guid]
				set element_text ""
               			Diagram_Text $selection  
				foreach item $list_State {
					if {$item == $element_text} {
						set index $i
					}
					set i [expr $i +1]
				}	
				set sender [lindex $list_State_id $index]
				}
			}
			}
			}
			set receiver $selection

			if {$sender != "" && $receiver!= ""} {
			WritingTransition $transition_id $sender $receiver
			}
		
	}


	"NextStateAction" {


		
		set fail [catch {MapRole $selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
		
		
		set fail [catch {MapRole $id_selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}

		if {$class == "StartTransition"} {
			set sender $id_selection
			set transition_id $selection

		}

		set owner ""
		
		set fail [catch {MapRole $selection State ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		if {$owner != ""} {

		set target $id_selection
		
		set fail [catch {set target_id [u2::GetValue $id_selection Name]} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error	
		}
		
		set target_state 0
		if {$class == "State"} {
			foreach item $list_State_id {
				if {$target == $item} {
					set target_state 1
					}
			}	

		}
		if {$target_state == 0} {
			set i 0
			foreach item $list_State {
				if {$item == $target_id} {
					set index $i
				}
				set i [expr $i +1]
			}	
			set target [lindex $list_State_id $index]

		}

		if {$sender != "" && $target!= ""} {

		WritingTransition $transition_id $sender $target
		}

		}

	}

}

return 1
}

 
proc ForEvent {selection} {

global id_selection
global id_event
global ident_count
set ident_count 0
global value
set value ""

	
	set fail [catch {MapRole $selection Definition ForOwner} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	set id_event $id_selection
	
	set fail [catch {MapRole $selection Lvalue ForLvalue} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error	
	}

return 1
}

 


# Procedure to write Guard value in XMI


proc WritinginXMI_Guard {selection IntValue} {
global file
global Guard_id

		set text "<UML:"
		append text "Transition.guard> "
		puts $file $text

		set text "<UML:"
		append text "Guard "
		append text "xmi.id=\"G.$Guard_id\" "
		append text "name=\"\" "
		append text ">"
		puts $file $text

		set text "<UML:"
		append text "Guard.expression> "
		puts $file $text

		set text "<UML:"
		append text "BooleanExpression  "
		append text "language=\"\" "
		append text "body=\"$IntValue\" "
		append text ">"
		puts $file $text


		set text "</UML:"
		append text "BooleanExpression>  "
		puts $file $text

		set text "</UML:"
		append text "Guard.expression> "
		puts $file $text

		set text "</UML:"
		append text "Guard> "
		puts $file $text

		set text "</UML:"
		append text "Transition.guard> "
		puts $file $text

		set Guard_id [expr $Guard_id +1]



}

 
# RASHID BHAI

# Procedure to write Effect for transitions in XMI
proc WritinginXMI_Effect {selection} {
global file
global id_selection 
global action_name
set action_name ""

set fail [catch {MapRole $selection Owner ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}
 



if {[u2::GetMetaClassName $selection] == "CompoundAction" || [u2::GetMetaClassName $id_selection] == "ActionNode"} {
		set text "<UML:"
		append text "ActionSequence "
		append text "xmi.id=\"$selection\" "
		append text ">"
		puts $file $text

		set text "<UML:"
		append text "ActionSequence.action>"
		puts $file $text
 
		if {[u2::GetMetaClassName $selection] == "CompoundAction"} {
			MapRole $selection Action WritinginXMI_Action
		} else {
			global element_id

			set fail [catch {set element_id [u2::GetValue $id_selection Guid]} error]
			if {$fail} {
			 	  Report $id_selection "Catch Error" $error
			}

			global element_text
			set element_text ""
			global action_text
			set action_text ""
			Diagram_Text $id_selection
			set action_name $action_text
		}

		if {$action_name != ""} {
			WritinginXMI_UninterruptedAction $selection $action_name
		}

		set text "</UML:"
		append text "ActionSequence.action>"
		puts $file $text

		set text "</UML:"
		append text "ActionSequence>"
		puts $file $text

}
return 1
}



proc WritinginXMI_Action {selection} {
global file
global owner
global id_selection
set id_selection ""
global class
set class ""
global name
set name ""
global action_name
global target
global output
global id_argument
set id_argument ""
global value
global element_id
global element_text
global transition_id
set element_text ""
 

global transitionLineText
 


	switch -- [u2::GetMetaClassName $selection] {
       
	"CompoundAction" {

		
			set fail [catch {MapRole $selection Action WritinginXMI_Action} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}
		}

        
	"OutputAction" {
set owner ""
set target ""
set output ""
set id_argument ""
set value ""


set fail [catch {MapRole $selection OutputItem ForOutput} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

		set text "<UML:"
		append text "SendAction "
		append text "xmi.id=\"$selection\" "
		append text "signal=\"S.$selection\" "

		append text ">"
		puts $file $text

		set text "<UML:"
		append text "Action.target> "
		puts $file $text

		set text "<UML:"
		append text "ObjectSetExpression "
		append text "language=\"\" "
		append text "body=\"$target\" "

		append text ">"
		puts $file $text

		set text "</UML:"
		append text "ObjectSetExpression> "
		puts $file $text


		set text "</UML:"
		append text "Action.target> "
		puts $file $text
		if {$id_argument!= ""} {
			set text "<UML:"
			append text "Action.actualArgument> "
			puts $file $text

			set text "<UML:"
			append text "Argument "
			append text "xmi.id=\"$id_argument\"  "
			append text "name=\"\" "
			append text ">"
			puts $file $text

			set text "<UML:"
			append text "Argument.value> "
			puts $file $text
		

			set text "<UML:"
			append text "Expression "
			append text "language=\"\" "
			append text "body=\"$value\" "
			append text ">"
			puts $file $text

			set text "</UML:"
			append text "Expression> "
			puts $file $text


			set text "</UML:"
			append text "Argument.value> "
			puts $file $text

			set text "</UML:"
			append text "Argument> "
			puts $file $text

			set text "</UML:"
			append text "Action.actualArgument> "
			puts $file $text
		}


		set text "</UML:"
		append text "SendAction>"
		puts $file $text

		
		}

	"DefAction" {
		set output ""
		
		set fail [catch {MapRole $selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

			
		set fail [catch {MapRole $id_selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
		
			
		set fail [catch {set element_id [u2::GetValue $id_selection Guid]} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
		
		Diagram_Text $transition_id
		if {$element_text != ""} {
		append action_name " [XMLCharData $element_text]"
		}
		if {$action_name == ""} {

		
		set fail [catch {MapRole $selection Definition ForOutput} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		append action_name "$output"
		}
		set id_selection ""

		}

	"ExpressionAction" {
 
		set id_selection ""
		
		
		set fail [catch {MapRole $selection Expression ForOutput} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
 
	
		if {$id_selection != ""} {
 

		     if {[u2::GetMetaClassName $id_selection] == "Signal"} {
			set fail [catch {append action_name [u2::GetValue $id_selection name]} error]
			if {$fail} {
 			  Report $id_selection "Catch Error" $error
			}
		     }

		     # Added for Action Text as Operation on Tran Line 		
		     if {[u2::GetMetaClassName $id_selection] == "Operation"} {
			set fail [catch {append action_name [u2::GetValue $id_selection name]} error]
			if {$fail} {
 			  Report $id_selection "Catch Error" $error
			}
		     }	
			
		}
		
		set fail [catch {MapRole $selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
		
			
		set fail [catch {MapRole $id_selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
		
		set fail [catch {set element_id [u2::GetValue $id_selection Guid]} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
 
		Diagram_Text $transition_id
		 

		if {$element_text != ""} {
			append action_name " [XMLCharData $element_text]"
		}


		set startpos [expr ([string last "/" $transitionLineText]+1)]	
		set strlen [expr ([string length $transitionLineText] -1)]		 
		set act [string range $transitionLineText $startpos $strlen]

		if {$act != "" && $action_name ==""} {
			append action_name " [XMLCharData $act]"
  		}
	
		if {$action_name != ""} {
 
		}

		}

	"ReturnAction" {
set class ""


set fail [catch {MapRole $selection Owner ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}	


set fail [catch {MapRole $id_selection Owner ForOwner} error]
if {$fail} {
 	  Report $id_selection "Catch Error" $error
}

if {$class == "CompoundAction"} {


		append action_name " return"

		
		set fail [catch {MapRole $selection Expression ForIdentName} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		if {$name != ""} {
			append action_name " ($name)"
		}

	 
}

		} 
	"ContinueAction" {

		append action_name " continue"
	 

		} 
	"BreakAction" {


		append action_name " break"

		 

		} 
	"StopAction" {
		set class ""
		
		set fail [catch {MapRole $selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		
		set fail [catch {MapRole $id_selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
	
		if {$class == "CompoundAction"} {
			append action_name " stop"
		 
			}

		} 
	"TimerSetAction" {
		
		
		set fail [catch {MapRole $selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

				
		set fail [catch {MapRole $id_selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}

		
		set fail [catch {set element_id [u2::GetValue $id_selection Guid]} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}

		set element_text ""
		Diagram_Text $transition_id
		if {$element_text != ""} {
		set element_text [XMLCharData $element_text]
		append action_name " $element_text"
	 
		}

		}
	"TimerResetAction" {
		
		
		set fail [catch {MapRole $selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
	
		MapRole $id_selection Owner ForOwner		
		set fail [catch {MapRole $id_selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
	
		
		set fail [catch {set element_id [u2::GetValue $id_selection Guid]} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
		set element_text ""
		Diagram_Text $transition_id
		if {$element_text != ""} {
		set element_text [XMLCharData $element_text]
		append action_name " $element_text"
		 
		}
		}
	"LoopAction" {
		
		
		set fail [catch {MapRole $selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
	
				
		set fail [catch {MapRole $id_selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}

		
		set fail [catch {set element_id [u2::GetValue $id_selection Guid]} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
		set element_text ""
		Diagram_Text $transition_id
		if {$element_text != ""} {
		set element_text [XMLCharData $element_text]
		append action_name " $element_text"
		 
		}
		}
	"IfAction" {
		
		
		set fail [catch {MapRole $selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error		
		}

				
		set fail [catch {MapRole $id_selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
		
		
		set fail [catch {set element_id [u2::GetValue $id_selection Guid]} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
		set element_text ""
		Diagram_Text $transition_id
		if {$element_text != ""} {
		set element_text [XMLCharData $element_text]
		append action_name " $element_text"
	 
		}
		}

	"JoinAction" {
		
		set fail [catch {MapRole $selection JoinedLabel ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
	
		
		set fail [catch {MapRole $id_selection Owner WritinginXMI_Action} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}
		
		}

	}


return 1
}



proc ForOutput {selection} {


global value
global ident_count
set value ""
set ident_count 0
global owner
set owner ""
global output
set output ""


if {[u2::GetMetaClassName $selection] == "CallExpr"} {


set fail [catch {MapRole $selection Called ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

set output $owner


set fail [catch {MapRole $selection To Forsendtraget} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


set fail [catch {MapRole $selection Argument ForLvalue} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


}

if {[u2::GetMetaClassName $selection] == "Attribute"} {
	
	set fail [catch {set output "[u2::GetValue $selection Name]"} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}	
}

return 1

}

proc Forsendtraget {selection} {
global target

switch -- [u2::GetMetaClassName $selection] {
       

	"SenderExpr" {

		set target "sender"
		}
	"SelfExpr" {

		set target "self"
		}
	"ParentExpr" {

		set target "parent"
		}
	"OffspringExpr" {

		set target "offspring"
		}
	}

return 1

}




proc WritinginXMI_UninterruptedAction {selection action_name} {
global file

	set text "<UML:"
	append text "UninterpretedAction "
	append text "xmi.id=\"UA.$selection\" "
	append text "name=\"$action_name\" "

	append text ">"
	puts $file $text

	set text "</UML:"
	append text "UninterpretedAction>"
	puts $file $text

}

 
#Procedure for accessing the Parameter of transition Event : Activity Diag

proc TransitionEventPara {selection} {
global ParaName
global Data_id
set Data_id ""


set fail [catch {set ParaName [u2::GetValue $selection Name]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


set fail [catch {MapRole $selection Type ForName} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

return 1
}





proc ForPriorityValue {selection} {	
 
    global priorityValue
    set priorityValue ""		
    set priorityValue [u2::GetValue $selection Value] 
  
  return 1
}



# Procedure to write SignalEvent of StateChart Diagram in XMI

proc WritinginXMI_SignalEvent {selection} {

global file
global value
global owner
global id_selection
set id_selection ""
global class
set class ""
global id_event
set id_event ""
global Data_id
global element_id


set fail [catch {set element_id [u2::GetValue $selection Guid]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

global element_text
set element_text ""
global LineText
global GuardText
global ident_count
set ident_count 0
global id
set id ""
set LineText ""
global list_sender
global list_receiver
set trigger ""
set signal ""
 		
global priorityValue
set priorityValue ""


 
switch -- [u2::GetMetaClassName $selection] { 

  "ActivityEdge" {
         
                       Diagram_Text $selection 
                       set GuardText ""
                       ActivityLineText $element_text 
                       
		       set fail [catch {MapRole $selection Source ForOwner} error]
		       if {$fail} {
			 	  Report $selection "Catch Error" $error
		       }

       		       set sender $id_selection

 
	       if {$class == "AcceptEventNode"} {
		    set owner ""

		    
		    set fail [catch {MapRole $id_selection Trigger ForOwner} error]
		    if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		    }		
        	    set trigger $id_selection

		   
	            if {$owner != "" && $class == "Trigger"} {
		        
			set fail [catch {MapRole $id_selection Definition ForOwner} error]
			if {$fail} {
			 	  Report $id_selection "Catch Error" $error
			}
		    if {$LineText != ""} {
		 	 append LineText ","
			 }
		        
		set fail [catch {append LineText " [u2::GetValue $id_selection Name]"} error]
			if {$fail} {
			 	  Report $id_selection "Catch Error" $error
			}
        	     }
 
	       }



if {$class == "SendSignalNode"} {
	
	set fail [catch {set signal [u2::GetValue $sender Guid]} error]
	if {$fail} {
 		  Report $sender "Catch Error" $error
	}		

	set element_text ""
	
	set fail [catch {set element_id [u2::GetValue $id_selection Guid]} error]
	if {$fail} {
 		  Report $id_selection "Catch Error" $error
	}
	
	Diagram_Text $selection
	if {$element_text!=""} {

                       set text "<UML:"
        	       append text "Signal "
   		       append text "xmi.id=\"S.$signal\" "
                       append text "name=\"[XMLCharData $element_text]\" "
                       append text ">"
 		       puts $file $text
                       
                       set text "</UML:"
                       append text "Signal"
		       append text ">"
                       puts $file $text 
		}
	}



if {$LineText != ""} {
if {$trigger == ""} {
	set trigger $selection
}
  
                       set owner ""
                       set value ""
                       set text "<UML:"
        	       append text "SignalEvent "
   		       append text "xmi.id=\"E.$trigger\" "
                       append text "name=\"[XMLCharData $LineText]\" "
		       append text "signal=\"$owner\" "
                       append text ">"
 		       puts $file $text
                       

 
 if {$class=="Signal"} {
  global ParaName
  set ParaName ""
  global Data_id  
set Data_id ""
   
  set fail [catch {MapRole $id_selection Parameter TransitionEventPara} error]
  if {$fail} {
 	  Report $id_selection "Catch Error" $error
 }	

                        set text "<UML:"
			append text "Event.parameter> "
			puts $file $text
			set text "<UML:"
			append text "Parameter "
			append text "xmi.id=\"$id_selection\" "
			append text "name=\"$ParaName\" "
 			append text "type=\"$Data_id\" " 
	 

			append text ">"
			puts $file $text
			set text "</UML:"
			append text "Parameter> "
			puts $file $text

			set text "</UML:"
			append text "Event.parameter> "
 			puts $file $text
                      
                       set text "</UML:"
                       append text "SignalEvent"
		       append text ">"
                       puts $file $text 
  } else { 
                       set text "</UML:"
                       append text "SignalEvent"
		       append text ">"
                       puts $file $text 
 }
 

                     		        
                }
		}



	"TriggeredTransition" {

		
		set fail [catch {MapRole $selection Action ForTransitionSignal} error]
		if {$fail} {
 	  		Report $selection "Catch Error" $error
		}

		set owner ""
		set value ""
		set name ""
		
		set fail [catch {MapRole $selection Trigger ForEvent} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
		if {$id_event != ""} {

			if {[catch {[u2::GetValue $id_event Name]} ]} {
		 		set name [u2::GetValue $id_event Name]
			} else {
				set name ""
			}
		}

				
		set priorityValue ""
		MapRole $selection Priority ForPriorityValue
		 		 
		if {[u2::GetValue $selection Virtuality]=="VkFinalized"} {
		    set name "finalized $name"	
		}
		if {[u2::GetValue $selection Virtuality]=="VkVirtual"} {
		    set name "virtual $name"	
		}

		if {[u2::GetValue $selection Virtuality]=="VkRedefined"} {
		     set name "redefined $name"	
		}
		
		
		if {$priorityValue!=""} {	
		    append name " \[priority $priorityValue\]"
		}

		if {[u2::GetValue $selection AsteriskTrigger] == "true"} {
			
			set fail [catch {set owner "A.[u2::GetValue $selection Guid]"} error]
			if {$fail} {
		 	  Report $selection "Catch Error" $error
			}
			set name "*"

		}

		if {$owner != ""} {
			set text "<UML:"
			append text "SignalEvent "
			append text "xmi.id=\"$selection.$owner\" "
			append text "name=\"[XMLCharData $name]\" "
			append text "signal=\"$owner\" "
			append text ">"
			puts $file $text
               
               if {$value != ""} {
			set text "<UML:"
			append text "Event.parameter> "
			puts $file $text
			set text "<UML:"
			append text "Parameter "

# RASHID change $id_selection to $id_selection.$selection below to remove Duplicate Guid

			append text "xmi.id=\"$id_selection.$selection\" "
			append text "name=\"$value\" "
			if {$class == "Attribute"} {
				set Data_id ""
				
				set fail [catch {MapRole $id_selection Type ForName} error]
				if {$fail} {
				 	  Report $id_selection "Catch Error" $error
				}
				append text "type=\"$Data_id\" " 
			}

			append text ">"
			puts $file $text

			set text "</UML:"
			append text "Parameter> "
			puts $file $text

			set text "</UML:"
			append text "Event.parameter> "
			puts $file $text


		}





		set text "</UML:"
		append text "SignalEvent"
		append text ">"
		puts $file $text
		}


		}


	}


return 1

}



proc ForTransitionSignal {selection} {
global file
global ident_count
set ident_count 0
global class
global id_selection
global id
global outputsignal
set outputsignal ""

switch -- [u2::GetMetaClassName $selection] {
       
	"CompoundAction" {

		
		set fail [catch {MapRole $selection Action ForTransitionSignal} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
		}
      
	"OutputAction" {

	set class ""
	set id $selection
	
	set fail [catch {MapRole $selection Owner ForOwner} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	
	set fail [catch {MapRole $id_selection Owner ForOwner} error]
	if {$fail} {
 		  Report $id_selection "Catch Error" $error
	}

	
	set fail [catch {MapRole $selection OutputItem ForTransitionOutput} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

		set text "<UML:"
		append text "Signal "
		append text "xmi.id=\"S.$id\" "
		append text "name=\"$outputsignal\" "
		append text ">"
		puts $file $text

		set text "</UML:"
		append text "Signal>"
		puts $file $text

		}
	"DecisionAction" {
		
			
		set fail [catch {MapRole $selection DecisionAnswer ForTransitionSignal} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		}
       
	"DecisionAnswerTransition" {
		set ident_count 0
		
		set fail [catch {MapRole $selection Action ForTransitionSignal} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
		}
		}
return 1
}


proc ForTransitionOutput {selection} {
global outputsignal


if {[u2::GetMetaClassName $selection] == "CallExpr"} {

	
	set fail [catch {MapRole $selection Called ForLvalue} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}	


}

return 1

}


 


# for MessageStereotype 

proc MessagStereotype {selection} {

global file
global id_selection
global element_id
global sender
global receiver
global MessageType
set MessageType "" 
set sender ""
set receiver ""


set fail [catch {set element_id [u2::GetValue $selection Guid]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


set base "Message"

if {[u2::GetMetaClassName $selection]== "TimerTimeout"} {
set MessageType "timeout"

} else {
	
	set fail [catch {MapRole $selection Owner ForOwner} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

    	
	set fail [catch {MapRole $id_selection Diagram ForDiagram_Message} error]
	if {$fail} {
 		  Report $id_selection "Catch Error" $error
	}

  
 
}      
if {$MessageType!=""} {
          Writing_Stereotype $selection $MessageType $element_id $base 
}    

return 1

}


 

proc SeqDiagMessage {selection} {
  
   global file
   global SeqDiagNo
   global SeqDiagGUID 
		 
                set  SeqDiagNo [expr $SeqDiagNo + 1]
  		set text "<UML:"
		append text "Interaction "
		append text "xmi.id=\"$SeqDiagGUID$SeqDiagNo\" "
 
		append text ">"
		puts $file $text

		set text "<UML:"
		append text "Interaction.message>"
		puts $file $text 
global list_owner
global list_y
set list_y ""
set list_owner ""


set fail [catch {MapRole $selection DiagramElement ForMessagelines} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

set list_owner [sort_list $list_y $list_owner]	

foreach item $list_owner {

	if {[u2::GetMetaClassName $item] == "TimerTimeout"} {
		WritinginXMI_Fragment $item

	} else {
        	WritinginXMI_Message $item
	}
}          
	
		set text "</UML:"
		append text "Interaction.message>"
		puts $file $text

		set text "</UML:"
		append text "Interaction>"
		puts $file $text

   return 1
}




# Procedure to write Collaboration (For Seq Dia) in XMI 
 
proc WritinginXMI_Collaboration {selection} {

global file
 global MessageType
 global element_id
global element_text
 set base "Message"
global id_selection
global sender
global receiver
global SeqDiagGUID 
global SeqDiagNo 


 		set text "<UML:"
		append text "Collaboration "
		append text "xmi.id=\"$selection\" "
		append text "name=\"[u2::GetMetaClassName $selection]\" "
	
		append text ">"
		puts $file $text

		set text "<UML:"
		append text "Namespace.ownedElement>"
		puts $file $text
			MapRole $selection Participant WritinginXMI_Lifline
		set text "</UML:"
		append text "Namespace.ownedElement>"
		puts $file $text


		set text "<UML:"
		append text "Collaboration.interaction>"
		puts $file $text

 
set SeqDiagGUID  [u2::GetValue $selection Guid]
set SeqDiagNo 0
MapRole $selection Diagram SeqDiagMessage
 
		set text "</UML:"
		append text "Collaboration.interaction>"
		puts $file $text


		set text "</UML:"
		append text "Collaboration> "
		puts $file $text
               

global Export_Rose

if {$Export_Rose==0} {

foreach item $list_owner {

	if {[u2::GetMetaClassName $item]!= "TimerTimeout"} {

set sender ""
set receiver ""
set element_id [u2::GetValue $item Guid]

MapRole $item Owner ForOwner
MapRole $id_selection Diagram ForDiagram_Message

if {$sender=="" || $receiver==""} {

} else {
                set element_text ""
                Diagram_Text $item
		set text "<UML:"
		append text "UninterpretedAction "
		append text "xmi.id=\"XX.$item\" "
		append text "name=\"[XMLCharData $element_text]\" "
                append text " />" 
                puts $file $text   
		}
	}
}         
}
 
                MapRole $selection Message MessagStereotype
		MapRole $selection Fragment MessagStereotype

               
          
return 1
}
 

# Procedure to write LifeLine in XMI 

proc LifeLineActorStick {selection} {
    global NewBase

    
    set fail [catch {set NewBase [u2::GetValue $selection Guid]} error]
    if {$fail} {
 	  Report $selection "Catch Error" $error
    } 
    return 1
}

 
proc WritinginXMI_Lifline {selection} {

global file
global owner
global id_selection
global name
global class
set name ""
set owner ""
set class ""
global Export_Rose

global element_id


set fail [catch {set element_id [u2::GetValue $selection Guid]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

global element_text
set element_text ""

set class


set fail [catch {MapRole $selection Type ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

set base $owner
 
global NewBase
set NewBase ""
if {$base==""} {
  
	set fail [catch {MapRole $selection Attribute LifeLineActorStick} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}
 
set base $NewBase
 
}

set fail [catch {MapRole $selection Selector ForIdentName} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

if {$class == "Attribute"} {
 

}

Diagram_Text $selection

if {$Export_Rose == 1} {
	set name ""
	
	set fail [catch {MapRole $selection Operation ForIdentName} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}	
	if {$name != ""} {
		set element_text "$element_text ref $name"
	}
}

		set text "<UML:"
		append text "ClassifierRole "
		append text "xmi.id=\"$element_id\" "
		append text "xmi.uuid=\"$element_id\" "
		append text "name=\"[XMLCharData $element_text]\" "
		append text "base=\" $base\" "	
		append text ">"
		puts $file $text


		set text "</UML:"
		append text "ClassifierRole> "
		puts $file $text

return 1
}
 




# Procedure to write Message in XMI 
 
proc WritinginXMI_Message {selection} {

global file
global id_selection
global sender
global receiver
set sender ""
set receiver ""
global element_id
set element_id [u2::GetValue $selection Guid]
global element_text
set element_text ""

global class


MapRole $selection Owner ForOwner
MapRole $id_selection Diagram ForDiagram_Message
 

Diagram_Text $selection

if {$sender=="" || $receiver==""} {
 
if {[u2::GetValue $selection IsLostOrFound] =="false"} {
   if {$receiver=="" && $sender==""} {
   } else { 
	 if {$receiver==""} {
        	WarningErrorPath	 
	       Report $selection "Error" "Message New ($element_text) is not exported"
   	 }
	
         if {$sender==""} {
 		WarningErrorPath 
	       Report $selection "Error" "Message old ($element_text) is not exported"
 	 }
  }
 return 1
}


if {[u2::GetValue $selection IsLostOrFound] =="true"} {

if {$receiver==""} {
	 WarningErrorPath
  	Report $selection "Error" "Message Lost ($element_text) is not exported"
} 

if {$sender==""} {
 	 WarningErrorPath
  	Report $selection "Error" "Message Found ($element_text) is not exported"
} 
}
 
return 1
}

		
		set text "<UML:"
		append text "Message "
		append text "xmi.id=\"$element_id\" "
		append text "name=\"[XMLCharData $element_text]\" "
		append text "sender=\"$sender\" "
		append text "receiver=\"$receiver\" "

 
               global Export_Rose
               
               if {$Export_Rose==0} {
                  append text "action=\"XX.$selection\" " 
               }  
 
		append text ">"
		puts $file $text


		set text "</UML:"
		append text "Message> "
		puts $file $text
 
  


return 1
}
 


# Procedure to write Fragment of Interaction in XMI 
 
proc WritinginXMI_Fragment {selection} {

global owner

set owner ""

global file
global class
global element_id

set element_id [u2::GetValue $selection Guid]
global element_text
set element_text ""

		switch -- [u2::GetMetaClassName $selection] { 

		"TimerTimeout" {
			
			Diagram_Text $selection

			MapRole $selection Participant ForOwner
			set sender $owner
			set receiver $owner

			set text "<UML:"
			append text "Message "
			append text "xmi.id=\"$element_id\" "
			append text "name=\"[XMLCharData $element_text]\" "
			append text "sender=\"$sender\" "
			append text "receiver=\"$receiver\" "


			append text ">"
			puts $file $text


			set text "</UML:"
			append text "Message> "
			puts $file $text
 

			}

		}



return 1
}
 




# Procedure to write Template Parameter in XMI 
 
proc WritinginXMITemplate {selection} {

global file

set fail [catch {set id "[u2::GetValue $selection Guid]"} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

		set text "<UML:"
		append text "TemplateParameter "
		append text "xmi.id=\"$id\" "
		append text "modelElement2=\"$selection\" "
	
		append text ">"
		puts $file $text

		set text "</UML:"
		append text "TemplateParameter> "
		puts $file $text

return 1
}
 




# Procedure to write Abstraction in XMI 
 
proc WritinginXMI_Abstract {selection} {

global owner
global file
global extended_text
global id_selection
 
   

 
 

 


		MapRole $selection Parent ForOwner
                set supplier $owner

# Change from  [Grt $id_selection Name] to [u2::GetValue $id_selection Name] in set and Report

set from [u2::GetValue $id_selection Name]

                MapRole $selection Child ForOwner
                set client $owner  
 

WarningMesgPath 
Report $selection "Warning" "Creating a Realization for ImplementationLine from $from to [u2::GetValue $id_selection Name]"

		set text "<UML:"
		append text "Abstraction "
		append text "xmi.id=\"$selection\" "
		append text "name=\" \" "
		append text "supplier=\"$supplier \" "
		append text "client=\"$client\"> "
		puts $file $text

		set text "</UML:"
		append text "Abstraction> "
		puts $file $text
append extended_text "$selection "



} 

# Procedure to export elements of Class - Sarika
proc WritinginXMI_Class {selection} {
global file
global owner
global this
global class
global id_selection


 
  		MapRole $selection Owner ForOwner
		set Name [u2::GetValue $selection Name]
		set this [u2::GetMetaClassName $selection]
		switch -- [u2::GetMetaClassName $selection] { 

		"Operation" {

			global isOperation
			set isOperation "Operation"
			MapRole $selection AppliedStereotypeInstance Fortype
			set this $isOperation
                     	if {$isOperation=="activity" || $isOperation=="interaction" || $isOperation=="UseCase"} {
				return 1	
                               	}
			set ID 1
			set umltype "UML:"
			append umltype $this
			set comment " $Name $this "
			WriteComment $this $comment
			StartUMLElement $this $umltype $owner $ID $Name $selection
			Traverse $selection
			EndUMLElement $this $umltype $comment

			}

		"StateMachine" {

			return 1
			}
		"Attribute" {

			global isActor
			set isActor "Attribute"
			MapRole $selection AppliedStereotypeInstance Fortype


if {$isActor != "Actor"} {

# Export Choice and Class Up in model hierrachy  while in these in Attributes

  MapRole $selection InlineType AttrHierarchy

}

			if {[u2::GetValue $selection Derived]=="true"} { 
                           set Derived "/"
                           set Name $Derived$Name
                         } 

			if {$isActor == "Actor"} {

MapRole $selection Owner ForOwner

if {$class == "ActivityImplementation" || $class == "SimpleStateMachine"} {
				MapRole $id_selection Owner ForOwner
}

			set this "Class"
			set ID 1
			set umltype "UML:"
			append umltype $this
			set comment " $Name $this "
			WriteComment $this $comment
			StartUMLElement $this $umltype $owner $ID $Name $selection
			Traverse $selection
			EndUMLElement $this $umltype $comment



				}

			
			}



		}



}

# Procedure to write DataTypes in XMI
 

  proc WritinginXMI_Datatype {selection name Data_id} {
    global file 
    if {$Data_id!=""} {	
      set Tag "<UML:DataType xmi.id=\"$Data_id\" name=\"[XMLCharData $name]\" />"  
      puts $file $Tag
    } 
 }

 


# Procedure to write Parameters in XMI 

proc WritinginXMI_Para {selection} {

global owner
global this

 

  		MapRole $selection Owner ForOwner
		set Name [u2::GetValue $selection Name]

 
		set this "Attribute"

		set ID 1
		set umltype "UML:"
		append umltype $this
		set comment " $Name $this "
		WriteComment $this $comment
	
		StartUMLElement_Para $this $umltype $owner $ID $Name $selection

		EndUMLElement $this $umltype $comment



}



proc WritinginXMI_Diagram {selection} {

global file
global owner
global class
global id_selection
global font_size
global font_name
global color
global default_size
set default_size 10
global default_Font
set default_Font Arial
global default_color
set default_color 16711680
set owner ""
global SQN
set SQN 1

global list_y
set list_y ""
global list_id
set list_id ""
set class ""
set id_selection ""
global list_diagram
global list_diagram_state
global DiagNo

  		MapRole $selection Owner ForOwner

		set subject $owner
		set sub_class $class

# Change from [Get $selection Name] to [u2::GetValue $selection Name]

		set Name [u2::GetValue $selection Name]

 
std::Output "\n"
std::Output "\nInformation: Reading "
std::Output "$Name"

		set this [u2::GetMetaClassName $selection]


 


if {$this=="SequenceDiagram"} {
     set DiagNo [expr $DiagNo +1]
     set Temp ""
     append Temp $subject
     append Temp $DiagNo  
     set subject $Temp
}


		if {$this =="TextDiagram" || $this =="PackageDiagram"} {
		set class ""
  		MapRole $selection Owner ForOwner

			if {$class == "SimpleStateMachine"} {
				MapRole $id_selection Owner ForOwner
				MapRole $id_selection Owner ForOwner
				set subject $owner
			}


		}


		if {$this =="UseCaseDiagram"} {
		set class ""
  		MapRole $selection Owner ForOwner
  
		if {$class != "Package"} {
			set done 0
			set id_selection $selection
			while {$done == 0} {
				set class ""
				MapRole $id_selection Owner ForOwner
				if {$class == "" || $class == "Package" || $class == "Session"} {
					set done 1
					set subject $owner
WarningMesgPath 
Report $selection "Warning" "[u2::GetMetaClassName $selection] ($Name) is moved up in Hierarchy"
				}
				if {$class == "Operation"} {
			global isOperation
			set isOperation ""
			MapRole $id_selection AppliedStereotypeInstance Fortype
				if {$isOperation == "UseCase"} {
					set done 1
					set subject $owner
WarningMesgPath 
Report $selection "Warning" "[u2::GetMetaClassName $selection] ($Name) is moved up in Hierarchy"
					}

				}
			
			}

			}
		}





		if {$this =="ClassDiagram"} {
		set class ""
  		MapRole $selection Owner ForOwner
  
		if {$class != "Package"} {
			set done 0
			set id_selection $selection
			while {$done == 0} {
				set class ""
				MapRole $id_selection Owner ForOwner
				if {$class == "" || $class == "Package" || $class == "Session"} {
					set done 1
					set subject $owner
 WarningMesgPath
Report $selection "Warning" "[u2::GetMetaClassName $selection] ($Name) is moved up in Hierarchy"
				}
			
			}

			}
		}







		               
		set test [u2::IsKindOf $selection "ActivityDiagram"]
		if {$test==1} {
# Check if Activity Diagram is in Composite State, set subject to Composite state
  		MapRole $selection Owner ForOwner
		MapRole $id_selection Owner ForOwner
		MapRole $id_selection Owner ForOwner
		if {$class == "ActionNode"} {
			set subject "$owner"
		}
}

		set test [u2::IsKindOf $selection "StatechartDiagram"]
		if {$test==1} {
		set this "StateDiagram"

# Check if Statechart Diagram is in Composite State, set subject to Composite state
  		MapRole $selection Owner ForOwner
		MapRole $id_selection Owner ForOwner
		MapRole $id_selection Owner ForOwner

		if {$class == "State"} {
set subject ""
set i 0
set index -1

foreach item $list_diagram {
	if {$item == $selection} {
		set index $i
	} else {
		set i [expr $i + 1]
	}
	}
if {$index != -1} {

set subject_id [lindex $list_diagram_state $index]
set subject [u2::GetValue $subject_id Guid]

}

		}

			

		}

#Check text Diagram and export it as Class Diagram                 
                set textDiag [u2::IsKindOf $selection "TextDiagram"]
		set test [u2::IsKindOf $selection "ClassDiagram"]
		if {$test==1 || $textDiag==1} {
			global isPack
			set isPack "ClassDiagram"
  			 
			set this $isPack
		}
		set ID 1
		set ID "[GetId $ID]"
		set umltype "UML:Diagram"
		set comment "$this $Name"
		WriteComment $this $comment

if {$sub_class == "Internals"} {
MapRole $selection Owner ForOwner
MapRole $id_selection Owner ForOwner
set subject $owner
}
if {$sub_class == "SimpleStateMachine"} {
MapRole $selection Owner ForOwner
MapRole $id_selection Owner ForOwner
if {$class == "Package"} {
set subject $owner
}
}
			
		StartUMLElement_Diagram $this $umltype $subject $ID $Name $selection

set text "<UML:"
append text "Diagram.element>"
puts $file $text

set font_size $default_size
set font_name $default_Font
set color $default_color
	MapRole $selection HiddenStereotypeInstance ForExpression_Dia

	set default_size $font_size
	set default_Font $font_name
	set default_color $color
		Traverse_Diagram $selection


set list_id [sort_list $list_y $list_id]	



foreach item $list_id {
			WritinginXMI_DiagramElement $item
}

set text "</UML:"
append text "Diagram.element>"
puts $file $text

	EndUMLElement $this $umltype $comment

}

proc WritinginXMI_DiagramElement {selection} {

 
global owner
global id_selection
global font_name
global font_size
global color
global default_size
global default_Font
global default_color
global class
set owner ""
set id_selection ""
set font_size $default_size
set font_name $default_Font
set color $default_color
global Export_Rose


	MapRole $selection ModelElement ForOwner
        MapRole $selection HiddenStereotypeInstance ForExpression_Dia 
                set umltype "UML:DiagramElement"
		set this ""
		set comment ""
		set Name ""
		set ID $selection

 
if {$Export_Rose==0} {
	
    # Code Review
   set metaClassName [u2::GetMetaClassName $selection]

    if {$metaClassName!="CollaborationSymbol" && $metaClassName!="StereotypeSymbol" } {
                StartUML_DiagramElement $this $umltype $owner $id_selection $ID $selection
		set this ""
        	set comment ""
		EndUMLElement $this $umltype $comment
		set this [u2::GetMetaClassName $selection]
		 
		if {$this=="PerformanceLine" || $this=="AssociationLine"} {
			MapRole $selection Src ForRole
			MapRole $selection Dst ForRole
		}
    	 
    }
} else {
               	StartUML_DiagramElement $this $umltype $owner $id_selection $ID $selection
		set this ""
        	set comment ""
		EndUMLElement $this $umltype $comment
		set this [u2::GetMetaClassName $selection]
		 
		if {$this=="PerformanceLine" || $this=="AssociationLine"} {
			MapRole $selection Src ForRole
			MapRole $selection Dst ForRole
		}
}
}

proc WritinginXMI_CommentLine {selection} {

global owner
global id_selection
global font_name
global font_size
global color
global default_size
global default_Font
global default_color
global class
set sub ""

set font_size $default_size
set font_name $default_Font
set color $default_color

set ID $selection
set sub [u2::GetValue $selection Guid]

		MapRole $selection Dst ForOwner



 

if { $class != "PortSymbol" && $class != "RealizedInterfaceSymbol" && $class != "RequiredInterfaceSymbol" && $class != "InteractionOccurrenceSymbol" && $class != "InlineFrameSymbol" && $class != "ContinuationSymbol" && $class != "TimeSpecificationLine" && $class != "CoregionSymbol" && $class != "CompoundActionOccurrenceSymbol" && $class!= "NextStateActionOccurrenceSymbol" && $class != "TimerSetSymbol" && $class != "TimerResetSymbol" && $class != "InputSymbol" && $class != "OutputSymbol" && $class != "TaskSymbol" && $class != "DecisionAnswerSymbol" && $class != "SaveSymbol" && $class != "GuardSymbol" && $class != "JunctionSymbol" && $class != "HistoryStateSymbol" && $class != "ObjectNodeSymbol" && $class != "ConnectorSymbol" && $class != "AcceptEventSymbol" && $class != "SendSignalSymbol" && $class != "AcceptTimeEventSymbol" && $class != "FlowFinalSymbol" && $class != "ActivityPartitionSymbol" && $class != "PinSymbol" && $class != "GeneralizationLine"} {

		MapRole $id_selection ModelElement ForOwner

		set dest $owner
		MapRole $selection Src ForOwner
		set sub $owner
		append sub "-"
		append sub $dest
		set selection $id_selection
		MapRole $selection ModelElement ForOwner
		MapRole $selection HiddenStereotypeInstance ForExpression_Dia

		set umltype "UML:DiagramElement"
		set this ""
		set comment ""
		set Name ""
		StartUML_DiagramComment $this $umltype $sub $id_selection $ID $selection
		set this ""
		set comment ""

		EndUMLElement $this $umltype $comment
	}

}


proc ForRole {selection} {


global owner
global id_selection


set fail [catch {MapRole $selection ModelElement ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

		set umltype "UML:DiagramElement"
		set this ""
		set comment ""
		set Name ""
		set ID ""
		StartUML_DiagramRole $this $umltype  $owner $ID $selection
		set this ""
		set comment ""

		EndUMLElement $this $umltype $comment

}




# Procedure to export Generalization to XMI

proc WritinginXMI_Gen {selection} {
global owner
global file
set child ""
set parnt ""

 

		MapRole $selection Child ForOwner
		set child $owner
		MapRole $selection Parent ForOwner
		set parnt $owner

	if { $child != $parnt} { 

		set text "<UML:"
		append text "Namespace.ownedElement> "
		puts $file $text

		set umltype "UML:Generalization"
		set this ""
		set comment ""
		set Name ""
		set ID ""
		StartUML_Gen $this $umltype $ID $selection $parnt $child 
		set this ""
		set comment ""

		EndUMLElement $this $umltype $comment

		set text "</UML:"
		append text "Namespace.ownedElement> "
		puts $file $text

	}



}



# Procedure to export Association to XMI

proc WritinginXMI_Perf {selection} {
global file
global Stereotype_Name
global Stereotype_count
global Stereo_id
set Stereotype_Name ""
set Stereotype_count 0
global Export_Rose

global PerLineGuid
set PerLineGuid [u2::GetValue $selection Guid]


		set umltype "UML:Association"
		set this ""
		set comment ""
		set Name ""
		set ID ""
		StartUML_Perf $this $umltype $ID $selection
		set text "<UML:"
		append text "Association.connection>"
		puts $file $text
 

		Traverse_Perf $selection

		set text "</UML:"
		append text "Association.connection>"
		puts $file $text

		EndUMLElement $this $umltype $comment

# Code to write Stereotype of Association
		if { [u2::GetMetaClassName $selection] == "Performance"} {

			set Stereotype_Name "performance"
			set Stereotype_count 1

		}
		MapRole $selection AppliedStereotypeInstance ForInstance

		
		if {$Stereotype_Name != ""} {
		set id "St."
		append id "$Stereo_id"
		set base "Association"
		set guid "[u2::GetValue $selection Guid]"
                Writing_Stereotype $id $Stereotype_Name $guid $base  
		set Stereo_id [expr $Stereo_id + 1]
		}
# Code to write constraints for Roles of Association
		if {[u2::GetMetaClassName $selection] == "Association" && $Export_Rose == 1} {

		MapRole $selection AssociationEnd ForConstraints

		}


}
 
# Procedure to export Association which is present only in Diagram to XMI



proc Writing_AssociationInPresent {selection} {


global file
global navigable
global upper
global lower
global agg_value
global id_selection
global name
set name ""
 
 WarningMesgPath
 Report $selection "Warning" "Creating an Association corresponding to Association Line "



		set umltype "UML:Association"
		set this ""
		set comment ""
		set Name "[u2::GetValue $selection Text]"
		set ID ""
		StartUML_Perf $this $umltype $ID $selection
		set text "<UML:"
		append text "Association.connection>"
		puts $file $text
		MapRole $selection Source ForAttributesofAssociation
set navigable "true"
set agg_value ""

#output "to: "
		MapRole $selection Dst ForAssociationLine
		MapRole $selection Source ForAttributesofAssociation

set navigable ""
set lower ""
set upper ""
set name ""
#output "from: "
		MapRole $selection Src ForAssociationLine

		set text "</UML:"
		append text "Association.connection>"
		puts $file $text

		EndUMLElement $this $umltype $comment
MapRole $selection Owner ForOwner
set Name "[u2::GetValue $id_selection Name]"
 
}

proc ForAssociationLine {selection} {

global AssSourceID
global agg_value
global owner
global id_selection

global navigable
global name

set visible ""
set changeable ""
set scope ""

global RoleTxt
set RoleTxt ""


set fail [catch {MapRole $selection ModelElement ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

#output "[u2::GetValue $id_selection Name] "

if {[u2::GetMetaClassName $id_selection] != "Collaboration"} {

WritinginXMI_AssocEnds_Present $id_selection $name $agg_value $visible $changeable $navigable $scope $owner $AssSourceID

}
return 1
}



# Procedure to access the property of source of the Association Line

proc ForAttributesofAssociation {selection} {
global agg_value
global lower
global upper
global open
global operator
set lower ""
set upper ""
set open ""
set operator ""
global name

	
	set fail [catch {MapRole $selection Multiplicity ForMultiplicity} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

if {$open != ""} {
	set lower $open
	set upper $open
	if {$operator == ">=" || $operator == ">" } {
		set upper "-1"
	}
}
set agg_value [getAggregation $selection]


set fail [catch {set name [u2::GetValue $selection Name]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

return 1
}
 
 
 
# Procedure to export Association Ends to XMI

proc WritinginXMI_AssocEnds_Present {selection name agg visible changeable navigable scope owner {AssID ""}} {
 
global file
global lower
global upper
global Multiplicity_id

		set umltype "UML:AssociationEnd"
		set this ""
		set comment ""
				 
		set ID "Ass.[u2::GetValue $selection Guid]$AssID"
		
		set type "association_pres"
		set selection "As.$AssID$selection"

	StartUML_PerfElements $this $umltype $ID $selection $name $agg $visible $changeable $navigable $scope $owner $type
		set text "<UML:"
		append text "AssociationEnd.multiplicity>"
		puts $file $text
		
		set text "<UML:"
		append text "Multiplicity>"
		puts $file $text

		if {$lower!= "" && $upper!= ""} {

		set text "<UML:"
		append text "Multiplicity.range>"
		puts $file $text

		set text "<UML:MultiplicityRange "
		append text "xmi.id=\"M.$Multiplicity_id\" "
		append text "lower=\"$lower \" "
		append text "upper=\"$upper \" >"
		puts $file $text
		
		set text "</UML:"
		append text "MultiplicityRange>"
		puts $file $text

		set text "</UML:"
		append text "Multiplicity.range>"
		puts $file $text

		}

		set text "</UML:"
		append text "Multiplicity>"
		puts $file $text

		set text "</UML:"
		append text "AssociationEnd.multiplicity>"
		puts $file $text

		EndUMLElement $this $umltype $comment
		set Multiplicity_id [expr $Multiplicity_id +1]

}
 


# Procedure to export Performance Elements to XMI

proc WritinginXMI_PerfElements {selection name agg visible changeable navigable scope perGuid} {
global file

set owner [u2::GetValue $selection Guid]

	set ID "A."
	append ID "$perGuid:$owner"

		set umltype "UML:AssociationEnd"
		set this ""
		set comment ""
		set Name ""
		set type "performance"
                set selection "$perGuid.$selection" 
		StartUML_PerfElements $this $umltype $ID $selection $name $agg $visible $changeable $navigable $scope $owner $type

		set text "<UML:"
		append text "AssociationEnd.multiplicity>"
		puts $file $text


		set text "</UML:"
		append text "AssociationEnd.multiplicity>"
		puts $file $text

		EndUMLElement $this $umltype $comment
}


# Procedure to export Association Ends to XMI

proc WritinginXMI_AssocEnds {selection name agg visible changeable navigable scope owner} {
global file
global Multiplicity_id
global lower
global upper
global open
global operator
set lower ""
set upper ""
set open ""
set operator ""

	MapRole $selection Multiplicity ForMultiplicity

if {$open != ""} {
	set lower $open
	set upper $open
	if {$operator == ">=" || $operator == ">" } {
		set upper "-1"
	}
}

		set umltype "UML:AssociationEnd"
		set this ""
		set comment ""
		set Name ""
		set ID "[u2::GetValue $selection Guid]"
		set type "association"
		StartUML_PerfElements $this $umltype $ID $selection $name $agg $visible $changeable $navigable $scope $owner $type

		set text "<UML:"
		append text "AssociationEnd.multiplicity>"
		puts $file $text
		
		set text "<UML:"
		append text "Multiplicity>"
		puts $file $text

		if {$lower!= "" && $upper!= ""} {

		set text "<UML:"
		append text "Multiplicity.range>"
		puts $file $text

		set text "<UML:MultiplicityRange "
		append text "xmi.id=\"M.$Multiplicity_id\" "
		append text "lower=\"$lower \" "
		append text "upper=\"$upper \" >"
		puts $file $text
		
		set text "</UML:"
		append text "MultiplicityRange>"
		puts $file $text

		set text "</UML:"
		append text "Multiplicity.range>"
		puts $file $text

		}

		set text "</UML:"
		append text "Multiplicity>"
		puts $file $text

		set text "</UML:"
		append text "AssociationEnd.multiplicity>"
		puts $file $text

		EndUMLElement $this $umltype $comment
		set Multiplicity_id [expr $Multiplicity_id +1]
}



# Procedure to export Dependency to XMI

proc WritinginXMI_Dep {selection client supplier name} {
global owner
global Stereo_id
global Stereotype_Name
global Stereotype_count
set Stereotype_Name ""
set Stereotype_count 0

global element_id
set element_id [u2::GetValue $selection Guid]
global element_text
set element_text ""


		set umltype "UML:Dependency"
		set this ""
		set comment ""
		set Name ""
		set ID ""
		StartUML_Dep $this $umltype $ID $selection $client $supplier $name
		set this ""
		set comment ""

		EndUMLElement $this $umltype $comment

# Code to write Stereotype for Dependency

		MapRole $selection StereotypeInstance ForInstance


		if {$Stereotype_Name != ""} {

		set id "St."
		append id "$Stereo_id"
		set base "Dependency"
		set guid "[u2::GetValue $selection Guid]"
                Writing_Stereotype $id $Stereotype_Name $guid $base  
		set Stereo_id [expr $Stereo_id + 1]
		}


}

# Procedure to export Tag values to XMI

proc WritinginXMI_Tag {selection owner URL} {


		set umltype "UML:TaggedValue"
		set this ""
		set comment ""
		set Name ""
		set ID ""

#This is to check whether the link is of File type or URL
set filepath "$URL"
set prefix "file://"
set idx [string first $prefix $filepath]

if {$idx == 0} {

  	set start [string length $prefix]
  	set end [string length $filepath]
  	set url [string range $filepath $start $end]
	set type "RationalRose:externalFile"

  } else {

	set prefix "http://"
	set idx [string first $prefix $filepath]

	if {$idx == 0} {

 	 	set start [string length $prefix]
 	 	set end [string length $filepath]
  		set url [string range $filepath $start $end]
		set type "RationalRose:externalURL"
  		} else {

			set prefix "tlog://"
			set idx [string first $prefix $filepath]

			if {$idx == 0} {

  			set url ""
			append attrs " tag=\"\" "
  			} 
		}

  } 
		if {$url != "" } {

		StartUML_Tag $this $umltype $ID $selection $owner $url $type
		set this ""
		set comment ""

		EndUMLElement $this $umltype $comment
		}
}


# Procedure to export Comment Texts to XMI

proc WritinginXMI_CommentText {selection owner commenttext} {
global file
global owner_prev
global commenttext_prev

		set umltype "UML:TaggedValue"
		set this ""
		set comment ""
		set Name ""
		set ID ""

		StartUML_CommentText $this $umltype $ID $selection $owner 	
	

		set text "<UML:TaggedValue.value>"
		puts $file $text
 

if {$owner_prev == $owner} {
	append commenttext_prev "\n"
	append commenttext_prev $commenttext
} else {
	set commenttext_prev $commenttext
}

 
 set  commenttext_prev [XMLCharData $commenttext_prev]

		puts $file $commenttext_prev


		set text "</UML:TaggedValue.value>"
		puts $file $text
		set this ""
		set comment ""

		EndUMLElement $this $umltype $comment
                set owner_prev $owner
 
}

# Procedure to export Comment Symbols to XMI

proc WritinginXMI_Comment {selection Text} {
global file
global owner
global source
global target
set target "None"
global c_id
global Export_Rose

set c_id "[u2::GetValue $selection Guid]"
		set umltype "UML:Comment"
		set this ""
		set comment ""
		set Name $Text
		set ID "[u2::GetValue $selection Guid]"
		MapRole $selection Owner ForLine

if {$Export_Rose==1} {
  foreach item $target {
 	if {$item == "None"} {
        	set item ""
	}
	set ID "[u2::GetValue $selection Guid]"
	append ID "-"
	append ID "$item"
		StartUML_Comment $this $umltype $ID $selection $Name $item
 
 
set text "<UML:ModelElement.name>"
puts $file $text
 
puts $file $Text
 

set text "</UML:ModelElement.name>"
puts $file $text
 

		set this ""
		set comment ""
		EndUMLElement $this $umltype $comment
  }
} else {
        set item [lindex $target 0]
   
 	if {$item == "None"} {
        	set item ""
 	} else {
   	 	set item [u2::GetValue $item Guid]
        }
                set ID "[u2::GetValue $selection Guid]"
	 	append ID "-"
	        append ID "$item"
  		StartUML_Comment $this $umltype $ID $selection $Name $item
		set this ""
		set comment ""
		EndUMLElement $this $umltype $comment

}
}


# Procedure to export Constraints to XMI

proc WritinginXMI_Constraint {selection constraint} {
global file
		set umltype "UML:Constraint"
		set this ""
		set comment ""
		set ID "C.$selection"
		set Name "Constraint-$ID"
		set owner [u2::GetValue $selection Guid]
		StartUML_Constraint $this $umltype $ID $Name $owner 	
	

		set text "<UML:Constraint.body>"
		puts $file $text

		set text "<UML:BooleanExpression "
		append text "language=\"\" "
		append text "body=\"$constraint\">"		
		puts $file $text

		set text "</UML:BooleanExpression>"
		puts $file $text

		set text "</UML:Constraint.body>"
		puts $file $text
		set this ""
		set comment ""

		EndUMLElement $this $umltype $comment
}

 

set comment "<!DOCTYPE XMI SYSTEM 'UMLX13-11.dtd' >"
set this " "
WriteComment $this $comment

set text <XMI
append text " xmi.version=\"1.1\" "
append text " xmlns:UML=\"href://org.omg/UML/1.3\" "
append text " timestamp=\"[clock format [clock seconds] -format "%a %b %d %H:%M:%S %Y" -gmt false]\">"

puts $file $text
puts $file <XMI.header>
puts $file <XMI.documentation>
puts $file <XMI.exporter>
puts $file "Tau G2 2.6 XMI Exporter"
puts $file </XMI.exporter>
puts $file <XMI.exporterVersion>
puts $file "1.0"
puts $file </XMI.exporterVersion>
puts $file </XMI.documentation>
set text <XMI.metamodel
append text " xmi.name=\"UML\""
append text " xmi.version=\"1.3\"> "
puts $file $text
puts $file </XMI.metamodel>
puts $file </XMI.header>
puts $file <XMI.content>


# To export the model
 
  
u2::Bind $ModelNumber
 




MapRole $ModelNumber Session ForEachResource
 
 
global DataType_list
set DataType_list {None}

 

# Procedures to access all the Tag Values in Model  

# This accesses the Impelementation

proc Implement_Tag {selection} {



	switch -- [u2::GetMetaClassName $selection] {

	"Interaction" {

		
		set fail [catch {MapRole $selection Participant ForTag_Dependency} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		MapRole $selection Message ForTag_Dependency
		set fail [catch {MapRole $selection Participant ForTag_Dependency} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		}
	"SimpleStateMachine" {

		
		set fail [catch {MapRole $selection Signature ForTag_Dependency} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		set fail [catch {MapRole $selection MultiState ForTag_Dependency} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		
		set fail [catch {MapRole $selection Transition ForTag_Dependency} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		
		set fail [catch {MapRole $selection Diagram Implement_Tag} error]
		if {$fail} {
 			  Report $selection "Catch Error" $error
		}

		}

	"StatechartDiagram" {

		
		set fail [catch {MapRole $selection DiagramElement ForTag_Dependency} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}


		}
	"ActivityImplementation" {

		
		set fail [catch {MapRole $selection Node ForTag_Dependency} error]
		if {$fail} {
 	  		Report $selection "Catch Error" $error
		}

		
		set fail [catch {MapRole $selection Edge ForTag_Dependency} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		}

	}
return 1
}


proc ForTag_Dependency {selection} {
global commenttext_prev
set commenttext_prev ""

if {[u2::GetMetaClassName $selection] == "StateMachine"} {
		return 1
	}

if {[u2::GetMetaClassName $selection] != "DecisionAnswerTransition"} {

	
	set fail [catch {MapRole $selection HiddenStereotypeInstance ForExpression} error]
	if {$fail} {
 
		  Report $selection "Catch Error"  $error 	
 		   
	}

 	
	set fail [catch {MapRole $selection Comment ForCommentText} error]
	if {$fail} {

 	 	  Report $selection "Catch Error"  $error 	
 
	}
}

	switch -- [u2::GetMetaClassName $selection] { 

		"StartTransition" {
			  set fail [catch {MapRole $selection Action ForTag_Dependency} error]
			  if {$fail} {
 
			    Report $selection "Catch Error"  $error	
			  }
			}

		"TriggeredTransition" {
			
			set fail [catch {MapRole $selection Action ForTag_Dependency} error]
			if {$fail} {
 
				Report $selection "Catch Error"  $error
			}
			}
		"CompoundAction" {
			
			set fail [catch {MapRole $selection Action ForTag_Dependency} error]
			if {$fail} {
				Report $selection "Catch Error"  $error	
			}
			}
		"DecisionAction" {
			
		 set fail [catch {MapRole $selection DecisionAnswer ForTag_Dependency} error]
		 	if {$fail} {
 
		             Report $selection "Catch Error"  $error	
				}
			}
		"DecisionAnswerTransition" {
			
			set fail [catch {MapRole $selection Action ForTag_Dependency} error]
			if {$fail} {
 
			 	  Report $selection "Catch Error"  $error 	
			}
			}
	}

 return 1
}


proc All_Dependency {selection} {
	
	set fail [catch {MapRole $selection ClientDependency ForTag_Dependency} error]
	if {$fail} {
 	  Report $selection "Catch Error" $error
	}

 return 1
}

proc TagDefinition {definition} {

  Traverse_Tag $definition

}

proc Traverse_Tag {selection} {

global commenttext_prev
set commenttext_prev ""


# To access the links

        # x-ruyane ::: TAU#5223
        set has_not_role [catch {GetRole $selection HiddenStereotypeInstance} error]
        if {!$has_not_role} { # $selection has HiddenStereotypeInstance role
        	# RASHID 12-APRIL ::: TAU#2788 : Export of trivial model results in Tcl errors
        	set fail [catch {MapRole $selection HiddenStereotypeInstance ForExpression} error]
        	if {$fail} {
        	 	  Report $selection "Catch Error" $error
        	}
        }

# To access Comment associated with elements

        # x-ruyane ::: TAU#5223
        set has_not_role [catch {GetRole $selection Comment} error]
        if {!$has_not_role} { # $selection has Comment role
        	# RASHID 12-APRIL ::: TAU#2788 : Export of trivial model results in Tcl errors	
        	set fail [catch {MapRole $selection Comment ForCommentText} error]
        	if {$fail} {
        	       Report $selection "Catch Error" $error
                }
        }



	switch -- [u2::GetMetaClassName $selection] {
       
		"Package" {

			MapRole $selection Signature All_Dependency

      			 }
		"Operation" {

                
			MapRole $selection InlineMethod Implement_Tag

      			 }
		"StateMachine" {

                
			MapRole $selection InlineMethod Implement_Tag


      			 }

		}
}

 
	
u2::MetaVisit $ModelNumber TagDefinition
 

 


# Procedures to access all the diagrams in Model - Sarika

# This accesses the Impelementation

proc Implement_Dia {selection} {

global  DiagNo
set  DiagNo 0
 
	switch -- [u2::GetMetaClassName $selection] {

	"Internals" {

		
		set fail [catch {MapRole $selection Diagram Dia} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		}

	"Interaction" {

		
		set fail [catch {MapRole $selection Diagram Dia} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		}
	"SimpleStateMachine" {

		
		set fail [catch {MapRole $selection Diagram Dia} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		}
        "ActivityImplementation" {

		
		set fail [catch {MapRole $selection Diagram Dia} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		}
	}
return 1
}


proc DiagramDefinition {definition} {

  Traverse_Dia $definition

}

proc Traverse_Dia {selection} {


	switch -- [u2::GetMetaClassName $selection] {
       
		"Package" {
			MapRole $selection Diagram Dia
                	MapRole $selection Implementation Implement_Dia

      			 }
		"Operation" {

                
			MapRole $selection InlineMethod Implement_Dia


      			 }
		"StateMachine" {

                
			MapRole $selection InlineMethod Implement_Dia


      			 }
		"Collaboration" {

			MapRole $selection Diagram Dia


      			 }
		"Class" {

			MapRole $selection Diagram Dia


      			 }


		}
}

 
u2::MetaVisit $ModelNumber DiagramDefinition





 
 

puts $file </XMI.content>
puts $file </XMI>
close $file


if {$CountWarning > 0 || $CountError > 0} {
std::Output "\n\n********* Total $CountWarning Warning(s) and $CountError Error(s) *********"

}

 
std::Output "\n\n\n********** XMI Export Finished **********\n"
