# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#########################################################################################
#  										   	#
#		                                                                        #
#	Name of Addin : XMI Export Addin for Tau G2					#
#	File Name     :	modelElementProperties.tcl					#
#	Date          : 12 MARCH 2006							#
#        										#
#	Description   : This file contains the procedures to access different		# 
#			properties of the objects					#
#			 								#
# 											#
######################################################################################### 
   
 
namespace import u2::*

# Procedure to output Name and Value of an object


global tagGuid
set tagGuid ""

proc ForDefault {selection} {
global style_prop
global IntValue
global CharValue
global name
global operator

	switch -- [u2::GetMetaClassName $selection] {

	"Ident" {
			
			set fail [catch {set name [u2::GetValue $selection Name]} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

		switch -- [u2::GetValue $selection Name] {
			"points" {
					set style_prop "Size"
				}
			"name" {
					if {$style_prop == "URL"} {
						set style_prop "LinkName"
					} else {
						set style_prop "FaceName"
					}
				}
			"color" {
					set style_prop "Color"
				}
			"URL" {
					set style_prop "URL"
				}
			}

		}
	"IntegerValue" {
		
		set fail [catch {set IntValue "[u2::GetValue $selection Value] "} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		}
	"CharstringValue" {
		
		set fail [catch {set CharValue "[u2::GetValue $selection Value]"} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		}
	"BinaryExpr" {
		
		set fail [catch {MapRole $selection LeftOperand ForDefault} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		
		set fail [catch {MapRole $selection RightOperand ForDefault} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		
		set fail [catch {MapRole $selection Operation ForDefault} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		set name $name$operator$IntValue
		set IntValue ""

		}
	"Operation" {
		
		set fail [catch {set operator "[u2::GetValue $selection Name]"} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		if {$operator == "<"} {
			set operator "&lt;"
		}
		if {$operator == ">"} {
			set operator "&gt;"
		}
		if {$operator == "=<"} {
			set operator "=&lt;"
		}
		if {$operator == ">="} {
			set operator "&gt;="
		}

		}

	}
return 1
}


# This procedure outputs the Multiplicity

proc ForMultiplicity {selection} {
global IntValue
global lower
global upper
set IntValue ""
global open
global operator

	switch -- [u2::GetMetaClassName $selection] {
	"ClosedRange" {
		
		
		set fail [catch {MapRole $selection LowerBound ForDefault} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
		
		set lower $IntValue
		
		set fail [catch {MapRole $selection UpperBound ForDefault} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		set upper $IntValue
		}
 	"OpenRange" {
		
		set fail [catch {set operator [u2::GetValue $selection Operator]} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		
		set fail [catch {MapRole $selection Boundary ForDefault} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		set open $IntValue
		}
	}
return 1


}


#Procedure to set global variable owner to Guid and class to Class of the selection


proc ForOwner {selection} {
global owner
set owner ""
global class
global id_selection
global number
		
		set fail [catch {set owner [u2::GetValue $selection Guid]} error]
		if {$fail} {
			Report $selection "Catch Error"  $error	
		}
	
			
		set fail [catch {set class [u2::GetMetaClassName $selection]} error]
		if {$fail} {
			    Report $selection "Catch Error"  $error
		}	
	
		set id_selection $selection
  		set number [expr $number + 1]
		
 

return 1
}


#This procedure is to output name and Guid of any object

proc ForName {selection} {
global Export_Rose
global name
global Data_id
if {$Export_Rose == 1} {
  set Data_id "D."
} else {
set Data_id ""
}
global Class_xmiid


 	
	set fail [catch {set Class_xmiid "[u2::GetValue $selection Guid]"} error]
	if {$fail} {
		 Report $selection "Catch Error"  $error		  
	}
		 
	
	set fail [catch {set name "[u2::GetValue $selection Name]"} error]
	if {$fail} {
 		Report $selection "Catch Error"  $error
	}

       	append Data_id $name


return 1


}

# This procedure will output comment associated with the object

proc ForCommentText {selection} {

global comment
global owner
global id_selection
global Export_Rose
global class
set class ""
global tagGuid


set fail [catch {set comment "[u2::GetValue $selection Text]"} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}



set fail [catch {MapRole $selection Owner ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}
 

if {$Export_Rose==1 && $class!= "ActionNode"} {
   set isExist [lsearch -exact $tagGuid $selection]
   if {$isExist==-1} {
	WritinginXMI_CommentText $selection $owner $comment
	lappend tagGuid $selection
   } 	
}
 
	switch -- [u2::GetMetaClassName $id_selection] { 

		"Operation" {
		set owner ""
		
		set fail [catch {MapRole $id_selection ActivityContainer ForOwner} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}

		set selection "A.$selection"
		if {$Export_Rose==1 && $owner!= ""} {
   			WritinginXMI_CommentText $selection $owner $comment
		}

		}
	}

return 1


}

# This procedure will output text associated with the object

proc ForText {selection} {
 

return 1


}

# This outputs the constraint property of an object

proc GetConstraint {selection} {
global constraint

set constraint "[u2::GetValue $selection InformalText]"

 
return 1


}

# This extracts the Visibility property of an element and then converts it to proper format to write in to XMI

proc getVisibility {selection} {


	set visible "[u2::GetValue $selection Visibility]"
	if {$visible=="VkPublic"} {
		set visible "public"
	}
	if {$visible=="VkPrivate"} {
		set visible "private"
	}
	if {$visible=="VkProtected"} {
		set visible "protected"
	}
	if {$visible=="VkNoVisibility"} {
		set visible "none"
	}
	if {$visible=="VkPackage"} {

		set visible "package"
	}
return $visible

}

# This extracts the Aggregation property of an attribute and then converts it to proper format to write in to XMI

proc getAggregation {selection} {

	set agg "[u2::GetValue $selection Aggregation]"
	if {$agg == "AkReference"} {
	set agg "none"
	}
	if {$agg == "AkAggregate"} {
	set agg "aggregate"
	}
	if {$agg == "AkComposite"} {
	set agg "composite"
	}
return $agg

}

# This extracts the changeability property of an attribute and then converts it to proper format to write in to XMI

proc getchangeability {selection} {

	set changeable "[u2::GetValue $selection Changeability]"
	if {$changeable == "CkChangeable"} {
	set changeable "changeable"
	}
	
return $changeable

}


# This procedure is for checking whether a datatype is an enumeration, if it comes here it is enumeration

proc Enumeration {selection} {
global isEnumeration

	set isEnumeration 1
	

}

# This extracts the ownerscope property of an attribute and then converts it to proper format to write in to XMI

proc getscope {selection} {

	set scope "[u2::GetValue $selection OwnerScope]"
	if {$scope == "OskClassifier"} {
	set scope "classifier"
	}
	if {$scope == "OskInstance"} {
	set scope "instance"
	}
	
return $scope

}


#This procedure is to extract name of any object

proc ForIdentName {selection} {
global name

switch -- [u2::GetMetaClassName $selection] {

	"Ident" {
	
	set fail [catch {set name "[u2::GetValue $selection Name]"} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	
	set fail [catch {MapRole $selection Definition ForOwner} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	}

	"Operation" {
	
	set fail [catch {set name "[u2::GetValue $selection Name]"} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	}
	"AnyExpr" {
	set name "any"
	}
	"CharstringValue" {
	
	set fail [catch {set name "[u2::GetValue $selection ValueString]"} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	}

	"ParenthesisExpr" {
	
	set fail [catch {MapRole $selection Expression ForIdentName} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


	}
	"State" {
	
	set fail [catch {set name "[u2::GetValue $selection Name]"} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	}

}


return 1

}


#This procedure is to extract and append name of any object

proc ForLvalue {selection} {
global value
global ident_count
global id_argument
set id_argument $selection
global outputsignal
switch -- [u2::GetMetaClassName $selection] {

	"Ident" {
		if {$ident_count != 0} {
			append value ", "
			append outputsignal ", "

			}
		
		set fail [catch {append outputsignal "[u2::GetValue $selection Name]"} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
		
		
		set fail [catch {append value "[u2::GetValue $selection Name]"} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		
		set fail [catch {MapRole $selection Definition ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		set ident_count [expr $ident_count +1]
		}
	"Signal" {

		if {$ident_count != 0} {
			append outputsignal ", "
			}
		
		set fail [catch {append outputsignal "[u2::GetValue $selection Name]"} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
	
		set ident_count [expr $ident_count +1]
		}
	"Operation" {

		if {$ident_count != 0} {
			append outputsignal ", "
			}
		
		set fail [catch {append outputsignal "[u2::GetValue $selection Name]"} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}
	
		set ident_count [expr $ident_count +1]
		}
	}

return 1

}




proc ForInstanceExpr {selection} {

global name_ident
global name

set fail [catch {MapRole $selection InstanceOf ForName} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

append name_ident $name
set name ""

set fail [catch {MapRole $selection Expression ForIdentName} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


if {$name != ""} {
set name_ident $name_ident\($name\)
}
return 1
}



 
# This extracts the test associated with a diagram element


proc Diagram_Text {selection} {

global id_selection
global class
set class ""




set fail [catch {MapRole $selection Owner ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


        if {$class=="PortSymbol" || $class=="Package"} {
             
	       set fail [catch {MapRole $id_selection Diagram Traverse_Diagram_Text} error]
	       if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}

        } 
  

	if {$class=="Interaction"} {
		
		set fail [catch {MapRole $id_selection Diagram Traverse_Diagram_Text} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}

	}
	if {$class=="DecisionAction"} {

			
		set fail [catch {MapRole $id_selection Owner ForOwner} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}


	}
 
	if {$class=="CompoundAction"} {

		
		set fail [catch {MapRole $id_selection Owner Diagram_Text} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}


	}

	if {$class=="SimpleStateMachine"} {

		
		set fail [catch {MapRole $id_selection Diagram Traverse_Diagram_Text} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}

	}
      	if {$class=="ActivityImplementation"} {
                
		set fail [catch {MapRole $id_selection Diagram Traverse_Diagram_Text} error]
		if {$fail} {
		 	  Report $id_selection "Catch Error" $error
		}

        }


}


proc Traverse_Diagram_Text {selection} {
   
   set fail [catch {MapRole $selection DiagramElement ForPresElements_Text} error]
   if {$fail} {
  	  Report $selection "Catch Error" $error
   }
		
return 1
}

proc ForPresElements_Text {selection} {
global element_text
global element_id
global owner
global id_selection
set id_selection ""
global isPresent
global tasksymbol_id
global Export_Rose
global action_text
global transitionLineText

 
 

	switch -- [u2::GetMetaClassName $selection] { 

	"TransitionLine" {
		set isPresent 1
		set owner ""
		
		set fail [catch {MapRole $selection ModelElement ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		if {$element_id == $owner} {
		
			set element_text [u2::GetValue $selection Text]

 			set fail [catch {set transitionLineText "[u2::GetValue $selection Text]"} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}
		}
	
	}
		


       "DependencyLine" {

			set owner ""
			
			set fail [catch {MapRole $selection Relationship ForOwner} error]
			if {$fail} {
		 		  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
		set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

                        }  
 
         }  


    
        "StopSymbol" {
set isPresent 1
			set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
		set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

                        }  
 
         }  
        "StateSymbol" {
			set isPresent 1
			set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
		set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

                      }
        }
   
	"LifeLineSymbol" {
 
			set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
		set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}


				if {$Export_Rose == 1} {
				set prefix ":"
				set idx [string first $prefix $element_text]
				if {$idx != -1} {
  				set end [expr $idx -1]
  				set start 0
  				set element_text [string range $element_text $start $end]
				}
				set prefix "ref"
				set idx [string first $prefix $element_text]
				if {$idx != -1} {
  				set end [expr $idx -1]
  				set start 0
  				set element_text [string range $element_text $start $end]
  				} 
				}
			}

		
			
	set fail [catch {MapRole $selection ActionOccurrenceSymbol ForPresElements_Text} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

		}

	"TimerTimeoutSymbol" {
set isPresent 1
			set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
	set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

			}
		}
	"MessageLine" {
set isPresent 1
			set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
		set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

			}
		}

         "ActivityEdgeLine" {
set isPresent 1
			set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
	set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

			}
		}

         
          "InstanceCreateLine" {
set isPresent 1
			set owner ""
                        
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

                      	if {$owner == $element_id} {
				
		set fail [catch {set element_text [u2::GetValue $selection Text]} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

                                 append element_text ":{Create}"
   
 
 WarningMesgPath 
 Report $selection "Warning" "Creating an Object Message $element_text for Create Event"

                    	}   
		}
	 "MethodCallLine" {
set isPresent 1
			set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
				 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
		set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}	

			}
		}
	  "MethodReplyLine" {
set isPresent 1
			set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
		set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}
	
			}
		}
	  "ReturnSymbol" {
set isPresent 1
			set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
	set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

			}
		}
	  "StateSymbol" {


			set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


			if {$element_id == $owner} {

				
		set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}


			}


		}
          "ActivityDecisionSymbol" {
set isPresent 1
                        set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {

				
		set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
			 		  Report $selection "Catch Error" $error
				}

			}
          }
          "ActionActivitySymbol" {

                        set owner ""
			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


			if {$element_id == $owner} {
				set isPresent 1
				
		set fail [catch {set element_text "[u2::GetValue $selection Text]"} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

				set action_text ""
			
		set fail [catch {MapRole $selection ActionLabel ForPresElements_Text} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			}
           }

	  "ActivityActionLabel" {
			
			
		set fail [catch {set action_text "[u2::GetValue $selection Text]"} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

		}




	"GuardSymbol" {

			
			set fail [catch {MapRole $selection TriggeredTransition ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


			if {$element_id == $owner} {
				
		set fail [catch {set element_text [u2::GetValue $selection Text]} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}


			}

		}
	"TaskSymbol" {

			
			set fail [catch {MapRole $selection CompoundAction ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


			if {$element_id == $owner} {
				if {$tasksymbol_id != $owner} {
				
		set fail [catch {set element_text [u2::GetValue $selection Text]} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

			set tasksymbol_id $owner
				}

			}

		}
	"DecisionSymbol" {
			
			set fail [catch {MapRole $selection DecisionAction ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
			set fail [catch {set element_text [u2::GetValue $selection Text]} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}


			}
		
	set fail [catch {MapRole $selection DecisionAnswerSymbol ForPresElements_Text} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

			
		}
	"DecisionAnswerSymbol" {

			
			set fail [catch {MapRole $selection DecisionAnswer ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$element_id == $owner} {
				
			set fail [catch {set element_text [u2::GetValue $selection Text]} error]
				if {$fail} {
			 		  Report $selection "Catch Error" $error
				}


			}
		}
	"SendSignalSymbol" {

			
			set fail [catch {MapRole $selection ActivityNode ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}
	

			if {$element_id == $owner} {
				
		set fail [catch {set element_text [u2::GetValue $selection Text]} error]
				if {$fail} {
			 	    Report $selection "Catch Error" $error
				}



			}

		}

	"AcceptEventSymbol" {

			
			set fail [catch {MapRole $selection ActivityNode ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}
	

			if {$element_id == $owner} {
				
		set fail [catch {set element_text [u2::GetValue $selection Text]} error]
				if {$fail} {
			 		  Report $selection "Catch Error" $error
				}



			}

		}

	"AcceptTimeEventSymbol" {

			
			set fail [catch {MapRole $selection ActivityNode ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}


			if {$element_id == $owner} {
				
			set fail [catch {set element_text [u2::GetValue $selection Text]} error]
				if {$fail} {
			 		  Report $selection "Catch Error" $error
				}



			}

		}


	}

	
  return 1
}



# This is to sort a list

proc sort_list {list list_2} {

set len [llength $list]

 
  
for {set x 1} {$x<$len} {incr x} {

for {set y 0} {$y<[expr $len-1]} {incr y} {


if {[lindex $list $x] < [lindex $list $y]} {

set temp [lindex $list $x]
set list [lreplace $list $x $x [lindex $list $y]]
set list [lreplace $list $y $y $temp]

set temp_2 [lindex $list_2 $x]
set list_2 [lreplace $list_2 $x $x [lindex $list_2 $y]]
set list_2 [lreplace $list_2 $y $y $temp_2]

}


}

}

return $list_2
}





# Procedure to extract all messages in a diagram and store them in a list

proc Extracting_Message {selection} {

MapRole $selection DiagramElement ForMessagelines

return 1

}

# Procedure to generate random number

proc myRand { min max } {
    set maxFactor [expr [expr $max + 1] - $min]
    set value [expr int([expr rand() * 100])]
    set value [expr [expr $value % $maxFactor] + $min]
return $value
}

# Procedure to print the warning message path

proc WarningMesgPath {} {   
   global CountWarning
   set CountWarning [expr $CountWarning + 1]
}


# Procedure for printing the Error message path 
proc WarningErrorPath {} {   
  global CountError
  set CountError [expr $CountError + 1]
}
 


 
