# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#########################################################################################
#  										   	#		
#                                                                        		#
#	Name of Addin : XMI Export Addin for Tau G2					#
#	File Name     :	presentationElement.tcl						#
#	Date          : 12 MARCH 2006							#
#        										#
#	Description   : This File contains the procedures to access the presentation	# 
#			 elements which are in a diagram				#
#			 								#
# 											#
######################################################################################### 
 
namespace import u2::*
	

# This procedure is being used for defining geometry for exporting presentation elements
proc AppendGeo {Coordinate } {
	foreach elem $Coordinate {
			append geo_text "$elem"
			append geo_text ","
		}
return $geo_text
}

proc ForAssociation {selection} {
	switch -- [u2::GetMetaClassName $selection] { 
	"Attribute" {
		MapRole $selection Multiplicity ForMultiplicity
	}
}
return 1
}

proc Forpres {selection} {
global style_prop
global IntValue
global font_size
global CharValue
global font_name
global color
global url

	
	set fail [catch {MapRole $selection LeftOperand ForDefault} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	
	set fail [catch {MapRole $selection RightOperand ForDefault} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}



	if {$style_prop=="Size"} {
		set font_size $IntValue
	} 

	if {$style_prop=="FaceName"} {
		set font_name $CharValue
	}
 
	if {$style_prop=="Color"} {
		set color $IntValue
	}
 
	if {$style_prop=="URL"} {
		set url $CharValue
	} 
return 1
}


# Procedure to extract name of Stereotype - Sarika

proc ForInst {selection} {
global Stereotype_Name
global Stereotype_count


set fail [catch {set St_Name [u2::GetValue $selection Name]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

if {$St_Name != "HYPERLINK" && $St_Name != "usecase"} {
	if {$Stereotype_count!= 0} {
		append Stereotype_Name ", "
	}
	append Stereotype_Name $St_Name
	set Stereotype_count [expr $Stereotype_count + 1]
}
 
return 1
}


proc ForInstance {selection} {

set fail [catch {MapRole $selection InstanceOf ForInst} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


return 1

}


proc ForStereotype {selection} {
global Stereotype_Name
global Stereotype_count
set Stereotype_Name ""
set Stereotype_count 0

set fail [catch {set guid [u2::GetValue $selection Guid]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


set fail [catch {set base [u2::GetMetaClassName $selection]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

	
	set fail [catch {MapRole $selection StereotypeInstance ForInstance} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

if {$Stereotype_Name != ""} {
	Writing_Stereotype $selection $Stereotype_Name $guid $base
}
return 1

}


proc ForExpression {selection} {

global font_size
global default_size
global font_name
global default_Font
global color
global default_color
global style_prop
global owner
global url
set owner ""
set style_prop "none"
set font_size $default_size
set font_name $default_Font
set color $default_color
set url "None"
global Export_Rose


set fail [catch {MapRole $selection Owner ForOwner} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


set fail [catch {MapRole $selection Expression Forpres} error]
if {$fail} {
 	  Report $selection "Catch Error" $error  
}

if {$Export_Rose==1} {
       if {$url != "None"} {
 	    WritinginXMI_Tag $selection $owner $url
       }
}
return 1

}

# Procedure for diagrams
proc ForExpression_Dia {selection} {
global font_size
global default_size
global font_name
global default_Font
global color
global default_color
global style_prop

set style_prop "none"


set fail [catch {MapRole $selection Expression Forpres} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}

return 1

}


proc ForRelationship {selection} {
global parent
global child
global class
set class ""
	switch -- [u2::GetMetaClassName $selection] { 

	"Generalization" {

	
	set fail [catch {MapRole $selection Parent ForOwner} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	
set parent $class
set class ""
	
	set fail [catch {MapRole $selection Child ForOwner} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


set child $class
		}

	"Dependency" {

	
	set fail [catch {MapRole $selection Client ForName} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}



	
	set fail [catch {MapRole $selection Supplier ForName} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}



		}

	}

 return 1
}

proc BasicProperties {selection} {
		 
 return 1
}


proc ForPresElements {selection} {


	 
	set fail [catch {set test [u2::GetMetaClassName $selection]} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}


	if {$test == "FrameSymbol"} {
   		  
		set fail [catch {MapRole $selection PinSymbol ForPresElements} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

	}


#For writing warning message for symbol/element which are not supported by Rose
	if {$test == "ClassSymbol"} {
  		
		set fail [catch {MapRole $selection PortSymbol ForPresElements} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

	}

	if {$test == "PortSymbol"} {
 	 	
	set fail [catch {MapRole $selection RealizedInterfaceSymbol ForPresElements} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

  		
	set fail [catch {MapRole $selection RequiredInterfaceSymbol ForPresElements} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

	}
 
 

	if {$test!="FrameSymbol" && $test!="MethodSuspensionSymbol" && $test!="MethodActivationSymbol" && $test!="TimeSpecificationLine" && $test!="InputSymbol" && $test!="OutputSymbol" && $test!="SaveSymbol" && $test!="JunctionSymbol" && $test!="TaskSymbol" && $test!="GuardSymbol" && $test!="PortSymbol" && $test!="SubjectSymbol" && $test!="ActivityPartitionSymbol"  && $test!="ObjectNodeSymbol" && $test!="ConnectorSymbol" && $test!="PinSymbol" && $test!="NextStateActionOccurrenceSymbol" && $test!="ContinuationSymbol" && $test!="CoregionSymbol" && $test!="InlineFrameSymbol" && $test!="InteractionOccurrenceSymbol" && $test!="TimerSetSymbol" && $test!="TimerResetSymbol" && $test!="TimeSpecificationLine" && $test!="ActivityPartitionSymbol" && $test!="CompoundActionOccurrenceSymbol"} {

		
		set fail [catch {set test1 [u2::IsKindOf $selection "CommentLine"]} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		if {$test1==0} {
			
			set fail [catch {set test2 [u2::GetMetaClassName $selection]} error]
			if {$fail} {
		 	  Report $selection "Catch Error" $error
			}

			if {$test2=="MessageLine" || $test2=="TimerTimeoutSymbol" || $test2=="InstanceCreateLine" || $test2=="MethodCallLine" || $test2=="MethodReplyLine"} {
			
				ForMessagelines $selection
			} else {

			WritinginXMI_DiagramElement $selection
			}
		} else {
			WritinginXMI_CommentLine $selection
		}


	} else {

 		 if {$test!="FrameSymbol" && $test!="InputSymbol" && $test!="OutputSymbol" && $test!="GuardSymbol" && $test!="TaskSymbol"} {
set name ""



  if {[catch {set name "[u2::GetValue $selection Text]" }]} {
	              
	  } else {
	set name "[u2::GetValue $selection Text]"
   }

   		 
                
                if {$test=="CompoundActionOccurrenceSymbol"} {
			WarningErrorPath
                        Report $selection "Error" "$test is not exported "  
                } else {

		     if {$name == ""} {
			WarningErrorPath
      		  	Report $selection "Error" "$test is not exported "
                     } else {
			WarningErrorPath
      		        Report $selection "Error" "$test ($name) is not exported "
		     }
                }
            }           
	}
	
	set fail [catch {set test [u2::IsKindOf $selection "LifeLineSymbol"]} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	if {$test==1} {
		
	set fail [catch {MapRole $selection ActionOccurrenceSymbol ForPresElements} error]
		if {$fail} {
 			  Report $selection "Catch Error" $error
		}


		}
  return 1
}


# this procedure makes a list of all messages lines in a diagram

proc ForMessagelines {selection} {
global list_y
global list_id
global list_owner
set Coordinate ""
global id_selection
set id-selection ""


set fail [catch {set test [u2::GetMetaClassName $selection]} error]
if {$fail} {
 	  Report $selection "Catch Error" $error
}


if {$test=="TimerTimeoutSymbol"} {
	
	set fail [catch {MapRole $selection ModelElement ForOwner} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}
	
	
	set fail [catch {set Coordinate "[u2::GetValue $selection Position]"} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	lappend list_y [lindex $Coordinate 1]
	lappend list_id $selection
	lappend list_owner $id_selection
} else {
	if {$test=="MessageLine" || $test=="InstanceCreateLine" || $test=="MethodCallLine" || $test=="MethodReplyLine"} {
			
		set fail [catch {MapRole $selection ModelElement ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		
		set fail [catch {set Coordinate "[u2::GetValue $selection SegmentPoints]"} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		lappend list_y [lindex $Coordinate 1]
		lappend list_id $selection
		lappend list_owner $id_selection
	}
}
if {$test=="LifeLineSymbol"} {
  
  set fail [catch {MapRole $selection ActionOccurrenceSymbol ForMessagelines} error]
  if {$fail} {
     Report $selection "Catch Error" $error
  }
		
}

return 1
}


#This procedure stores all the attributes associated with an association in a list

proc ForAssociationAttributes_1 {selection} {
global owner
global class
global list_attributes

	set test [u2::IsKindOf $selection "AssociationLine"]
	if {$test==1} {
		MapRole $selection Source ForOwner
		lappend list_attributes $owner
		}

return 1
}



proc ForCommentSymbol {selection} {

	
	set fail [catch {set test [u2::IsKindOf $selection "TextSymbol"]} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}	

	if {$test==1} {
		 
		 set fail [catch {set Text "[u2::GetValue $selection Text]"} error]
		 if {$fail} {
		 	  Report $selection "Catch Error" $error
		 }
		
		 set NoteText ""
		 regsub -all {[\n]} [XMLCharData $Text] {\&#x000d;\&#x000a;} NoteText 
		
                 # added For Case TLOG$# 29218	
		 regsub -all {\\} $NoteText {\\\\} NoteText 
		
		 set Text ""
		 foreach item $NoteText {
		   append Text $item
		   append Text " "
		 } 
 
		WritinginXMI_Comment $selection $Text
	}

	
	set fail [catch {set test [u2::IsKindOf $selection "CommentSymbol"]} error]
	if {$fail} {
 		  Report $selection "Catch Error" $error
	}

	if {$test==1} {
		
		set fail [catch {set Text "[u2::GetValue $selection Text]"} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

 		set NoteText ""
	        regsub -all {[\n]} [XMLCharData $Text] {\&#x000d;\&#x000a;} NoteText 
	
		# added For Case TLOG$# 29218	
		regsub -all {\\} $NoteText {\\\\} NoteText 
		set Text ""
		foreach item $NoteText {
		   append Text $item
		   append Text " "
		} 
		WritinginXMI_Comment $selection $Text
	}



return 1
}

# Procedure to access ExtensionLine

proc ForExtensionLine {selection} {
  
global owner
global class
global id_selection
global Stereo_id
set owner ""
global Export_Rose
	

global AssSourceID
set AssSourceID ""

		
		set fail [catch {set test [u2::IsKindOf $selection "ExtensionLine"]} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		if {$test==1} {
			set name ""
         	std::Output "\n " 
         	std::Output "\nInformation: Reading [u2::GetMetaClassName $selection]"   

		if {$Export_Rose == 1} {
   			 

		}
 		
			
			set fail [catch {MapRole $selection Src ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			
			set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $id_selection "Catch Error" $error
			}

			set src $owner
			if {$Export_Rose == 1} {
			  set from [Get $id_selection Name] 
			}
                        
			set fail [catch {MapRole $selection Dst ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			
			set fail [catch {MapRole $id_selection ModelElement ForOwner } error]
			if {$fail} {
			 	  Report $id_selection "Catch Error" $error
			}

			set dst $owner
			set owner ""

			if {$Export_Rose == 1} {
WarningMesgPath				   
Report $selection "Warning" "Creating a Dependency stereotyped as <<extend>> for ExtensionLine from $from to [Get $id_selection Name]" 

			}

         			WritinginXMI_Dep $selection $src $dst $name

				set id "St."
				append id "$Stereo_id"
				set name "extend"
				set base "Dependency"
				set extended "[u2::GetValue $selection Guid]"
				Writing_Stereotype $id $name $extended $base
				set Stereo_id [expr $Stereo_id + 1]

			}
		
		set fail [catch {set test [u2::IsKindOf $selection "AssociationLine"]} error]
		if {$fail} {
			 	  Report $selection "Catch Error" $error
		}

		if {$test==1} {

			
			set fail [catch {MapRole $selection ModelElement ForOwner} error]
			if {$fail} {
			 	  Report $selection "Catch Error" $error
			}

			if {$class == "Attribute"} {
				set class ""
				
			set fail [catch {MapRole $id_selection ParticipatesIn ForOwner} error]
			if {$fail} {
			 	  Report $id_selection "Catch Error" $error
			}

			}

			if {$class == ""} {
				set AssSourceID $selection
				Writing_AssociationInPresent $selection

         	}

	}
  return 1
}


proc Access_Line {selection} {
global owner
global source
global target
global id_selection
global c_id 
global class
set owner ""
global Export_Rose

	switch -- [u2::GetMetaClassName $selection] {

	"CommentLine" {

		
		set fail [catch {MapRole $selection Src ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}

		if {$c_id == $owner} {
		
		set fail [catch {MapRole $selection Dst ForOwner} error]
		if {$fail} {
		 	  Report $selection "Catch Error" $error
		}


		if {$class != "CommentLine" } {
			
			set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
			if {$fail} {
		 		  Report $id_selection "Catch Error" $error
			}

         			if {$class != "PortSymbol"} {
                                   	if {$class == "MultiState"} {
						  					  set fail [catch {MapRole $id_selection Included ForOwner} error]
						  if {$fail} {
						 	  Report $id_selection "Catch Error" $error
						  }
	
					}
						if {$Export_Rose==1} { 												append target " $owner" 
						} else {
                		               	 	append target " $id_selection" 
                				}	
			 	    					}
				}
			}
		 }
 	}

  return 1
}



proc ForLine {selection} {

MapRole $selection DiagramElement Access_Line
  return 1
}


# This procedure extracts the properties of Message line in Sequence Diagram

proc ForMessage {selection} {
global lifeline_id
global element_id
global owner
global sender
global receiver
global sender_class
global receiver_class
global sender_id
global receiver_id
global class
global id_selection
global name
set owner ""
global MessageType
global flag
set flag ""
 
	switch -- [u2::GetMetaClassName $selection] {
              "ActivityEdgeLine" {

                              	
				set fail [catch {MapRole $selection ModelElement ForOwner} error]
				if {$fail} {
			 		  Report $selection "Catch Error" $error
				}

				if {$owner == $element_id} {

	               		set owner ""
			        
				set fail [catch {MapRole $selection Src ForOwner} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

               			
			set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
				if {$fail} {
				 	  Report $id_selection "Catch Error" $error
				}

				set class_src $class
	        		set sender $id_selection
				set owner ""
				
				set fail [catch {MapRole $selection Dst ForOwner} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

				
			set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
				if {$fail} {
				 	  Report $id_selection "Catch Error" $error
				}

				set receiver $id_selection

				if {$class == "ForkNode" && $class_src == "ForkNode"} {
					set temp $sender
					set sender $receiver
					set receiver $temp

					}

		        	}             
       	        }
  
  
     
               "MethodReplyLine" {
                                
				set fail [catch {MapRole $selection ModelElement ForOwner} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

                      		if {$owner == $element_id} {
                                	set MessageType "return"
                   			
					set fail [catch {MapRole $selection Src ForOwner} error]
					if {$fail} {
					 	  Report $selection "Catch Error" $error
					}

		              		if {$class == "LifeLineSymbol"} {
				            
			    set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
					    if {$fail} {
					 	  Report $id_selection "Catch Error" $error
					     }
	
				        }
                        		    set sender $owner
					set owner ""

                			
					set fail [catch {MapRole $selection Dst ForOwner} error]
					if {$fail} {
					 	  Report $selection "Catch Error" $error
					}

		             		if {$class == "LifeLineSymbol"} {
				            
			    set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
					    if {$fail} {
					 	  Report $id_selection "Catch Error" $error
					    }
	
				        }
				            set receiver $owner      
                                }   
                } 

                "MethodCallLine" {
 
                                
				set fail [catch {MapRole $selection ModelElement ForOwner} error]
				if {$fail} {
			 	   Report $selection "Catch Error" $error
				}
	
                      		if {$owner == $element_id} {
                                 set MessageType "procededure_call"
					set owner ""
                                                          
                   			
					set fail [catch {MapRole $selection Src ForOwner} error]
					if {$fail} {
					 	  Report $selection "Catch Error" $error
					}

		              		if {$class == "LifeLineSymbol"} {
				            
			    set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
					    if {$fail} {
					 	  Report $id_selection "Catch Error" $error
					     }
	
				        }
                        		    set sender $owner
					set owner ""
                			
					set fail [catch {MapRole $selection Dst ForOwner} error]
					if {$fail} {
					 	  Report $selection "Catch Error" $error
					}
 	
		             		if {$class == "LifeLineSymbol"} {
				            
			    set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
					    if {$fail} {
					 	  Report $id_selection "Catch Error" $error
					    }
	
				        }
				            set receiver $owner      
                                }   
                  }
 
                "InstanceCreateLine" {

                                 
			 set fail [catch {MapRole $selection ModelElement ForOwner} error]
				 if {$fail} {
				 	  Report $selection "Catch Error" $error
				 }

                      		if {$owner == $element_id} {
                    			set owner ""
                   			
					set fail [catch {MapRole $selection Src ForOwner} error]
					if {$fail} {
					 	  Report $selection "Catch Error" $error
					}

		              		if {$class == "LifeLineSymbol"} {
				            
			    set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
					    if {$fail} {
					 	  Report $id_selection "Catch Error" $error
					    }
	
				        }
                        		    set sender $owner
					set owner ""
                			
					set fail [catch {MapRole $selection Dst ForOwner} error]
					if {$fail} {
					 	  Report $selection "Catch Error" $error
					}

		             		if {$class == "LifeLineSymbol"} {
				            
		    set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
					    if {$fail} {
					 	  Report $id_selection "Catch Error" $error
					     }
	
				        }
				            set receiver $owner      
                                }   

                 }  


		"MessageLine" {


         			
				set fail [catch {MapRole $selection ModelElement ForOwner} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

				if {$owner == $element_id} {
  					set owner ""
					
					set fail [catch {MapRole $selection Src ForOwner} error]
					if {$fail} {
					 	  Report $selection "Catch Error" $error
					}

 
				if {$class == "LifeLineSymbol"} {
				   
			   set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
				   if {$fail} {
				 	  Report $id_selection "Catch Error" $error
				   }
	
				}
				set sender $owner
				set owner ""
				
				set fail [catch {MapRole $selection Dst ForOwner} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

 
				if {$class == "LifeLineSymbol"} {
				   
			set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
				   if {$fail} {
				 	  Report $id_selection "Catch Error" $error
				   }
	
				}
				set receiver $owner
				
				}

			}
		"TransitionLine" {
					
				set fail [catch {MapRole $selection ModelElement ForOwner} error]
				if {$fail} {
				 	  Report $selection "Catch Error" $error
				}

				if {$owner == $element_id} {
				    set owner ""
				    set class ""
				    	
					set fail [catch {MapRole $selection Src ForOwner} error]
					if {$fail} {
					 	  Report $selection "Catch Error" $error
					}

					if {$class == "StateSymbol"} {
						
			set fail [catch {set sender_id [u2::GetValue $id_selection Text]} error]
						if {$fail} {
					 	  Report $id_selection "Catch Error" $error
						}

					}
					
			set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
					if {$fail} {
					 	  Report $id_selection "Catch Error" $error
					}

					set sender $id_selection
					set sender_class $class
					set owner ""
					
					set fail [catch {MapRole $selection Dst ForOwner} error]
					if {$fail} {
				 	  Report $selection "Catch Error" $error
					}

					if {$class == "StateSymbol"} {
						
		set fail [catch {set receiver_id [u2::GetValue $id_selection Text]} error]
						if {$fail} {
					 	  Report $id_selection "Catch Error" $error
						}

					}	
				
		set fail [catch {MapRole $id_selection ModelElement ForOwner} error]
				if {$fail} {
				 	  Report $id_selection "Catch Error" $error
				}

				set receiver $id_selection
				set receiver_class $class
			
				}
			}
	}
return 1
}

# This procedure calls another procedure to access the diagrams in element

proc ForDiagram_Message {selection} {
 
	set fail [catch {MapRole $selection DiagramElement ForMessage} error]
	if {$fail} {
 	   Report $selection "Catch Error" $error
        }
 	
return 1
}
