# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:17 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
package require commands
package require dialogs

# Return active project
proc GetActiveSession {} {
    set activeProject [std::GetActiveProject]
    if { $activeProject == 0 } {
        return 0
    }
    set projects [std::GetModels -kind U2 -project $activeProject]
    foreach p $projects {
        return $p
    }
    return 0
}

# Load library
proc LoadLib { profile msg } {
    set etcDir [GetInstallationDirectory]etc
    set profilePath "$etcDir/$profile"
    output "Loading the $msg library: $profilePath\n"
    set err [catch { u2::LoadLibrary $profilePath } log ]
}

# Unload library by its GUID
proc UnloadLib { lib } {
    set curProject [std::GetActiveProject]
    set model [std::GetModels -kind U2 -project $curProject]
    set package [u2::FindByGuid $model $lib]
    if { $package != 0 } {
        set err [catch { u2::UnloadLibrary $package } log ]
        if { $err } {
            output "$log"
        }
    }
}

proc Init {} {
    LoadLib "TTDXMLFramework.u2" "XML Framework"
}


proc BeforeUnload { } {
#    UnloadLib "@xsd"
#    UnloadLib "@TTDXMLFramework"
}

Init
