/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
/* TAU RTOS integration for Win32 */

HANDLE xFreeSignalMutex;
HANDLE xFreeTimerMutex;
HANDLE xCreateMutex;
#ifdef USER_CFG_USE_MEMORY_PACK
  HANDLE xMemoryMutex;
#endif
HANDLE xInitSem;
#if (!defined(USER_CFG_USE_xInEnv)) && (!defined(XENV))
  HANDLE xMainThreadSem;
#endif


void xThreadInit (void)
{
  xFreeSignalMutex = CreateSemaphore(NULL, 1, 1, NULL);
  xFreeTimerMutex = CreateSemaphore(NULL, 1, 1, NULL);
  xCreateMutex = CreateSemaphore(NULL, 1, 1, NULL);
  #ifdef USER_CFG_USE_MEMORY_PACK
    xMemoryMutex = CreateSemaphore(NULL, 1, 1, NULL);
  #endif
  xInitSem = CreateSemaphore(NULL, 0, INT_MAX, NULL);
}


void xThreadInitOneThread(struct _xSystemData *xSysDP)
{
  xSysDP->ThreadVars.SignalQueueMutex = CreateSemaphore(NULL, 1, 1, NULL);
  xSysDP->ThreadVars.SignalQueueCond = CreateSemaphore(NULL, 0, 1, NULL);
}


static void xThreadEntryFunc (void *xSysDP)
{
  WaitForSingleObject(xInitSem, INFINITE);
  ReleaseSemaphore(xInitSem, 1, NULL);
  xMainLoop((xSystemData *)xSysDP);
}


void xThreadStartThread(struct _xSystemData *xSysDP,
                        unsigned int StackSize,
                        unsigned int Prio,
                        unsigned int User1,
                        unsigned int User2)
{
  xSysDP->ThreadVars.ThreadId = 
    (HANDLE)_beginthread(xThreadEntryFunc, StackSize, (void *)xSysDP);
  SetThreadPriority(xSysDP->ThreadVars.ThreadId, Prio);
}


#if (defined(THREADED)) || (defined(CFG_USED_DYNAMIC_THREADS))
void xThreadStopThread(struct _xSystemData *xSysDP)
{
  (void)CloseHandle(xSysDP->ThreadVars.SignalQueueMutex);
  (void)CloseHandle(xSysDP->ThreadVars.SignalQueueCond);
  (void)_endthread();
}
#endif


void xThreadGo(void)
{
  #if defined(USER_CFG_USE_xInEnv)
    ReleaseSemaphore(xInitSem, 1, NULL);
    xInEnv();  /* AgileC */
  #elif defined(XENV)
    ReleaseSemaphore(xInitSem, 1, NULL);
    xInEnv(xNow());  /* Cadvanced */
  #else
    xMainThreadSem = CreateSemaphore(NULL, 0, 1, NULL);
    ReleaseSemaphore(xInitSem, 1, NULL);
    WaitForSingleObject(xMainThreadSem, INFINITE);
  #endif
}


void xThreadLock (HANDLE M)
{
  WaitForSingleObject(M, INFINITE);
}


void xThreadUnlock (HANDLE M)
{
  ReleaseSemaphore(M, 1, NULL);
}


void xThreadWaitUnlock (struct _xSystemData *xSysDP)
{
  ReleaseSemaphore(xSysDP->ThreadVars.SignalQueueMutex, 1, NULL);
  
  #if (defined(CFG_USED_TIMER)) || (defined(THREADED))
  #ifdef THREADED
      /* Cadvanced */
    if (xSysDP->xTimerQueue->Suc == xSysDP->xTimerQueue) { 
  #else
      /* AgileC */
    if (! xSysDP->TimerQueue) {
  #endif
      WaitForSingleObject(xSysDP->ThreadVars.SignalQueueCond, INFINITE);
    } else {
      DWORD TimeOut;
      SDL_Time SDLTime;
      SDLTime = xNow();
      #ifdef THREADED
          /* Cadvanced */
        SDLTime.s  = ((xTimerNode)xSysDP->xTimerQueue->Suc)->TimerTime.s  - SDLTime.s;
        SDLTime.ns = ((xTimerNode)xSysDP->xTimerQueue->Suc)->TimerTime.ns - SDLTime.ns;
      #else
          /* AgileC */
      SDLTime.s  = xSysDP->TimerQueue->Time.s  - SDLTime.s;
      SDLTime.ns = xSysDP->TimerQueue->Time.ns - SDLTime.ns;
      #endif
      
      TimeOut = (DWORD)((SDLTime.s  * 1000) + (SDLTime.ns / 1000000));
      WaitForSingleObject(xSysDP->ThreadVars.SignalQueueCond, TimeOut);
    }
  #else
    WaitForSingleObject(xSysDP->ThreadVars.SignalQueueCond, INFINITE);
  #endif
}


void xThreadSignalUnlock (struct _xSystemData *xSysDP)
{
  WaitForSingleObject(xSysDP->ThreadVars.SignalQueueCond, 0); /* set blocking mode */
  ReleaseSemaphore(xSysDP->ThreadVars.SignalQueueCond, 1, NULL);
  ReleaseSemaphore(xSysDP->ThreadVars.SignalQueueMutex, 1, NULL);
}


SDL_Time xNow (void)
{
  SDL_Time Result;

  #ifdef _MSC_VER
    struct _timeb CurrentTime;
    _ftime((struct _timeb *) &CurrentTime);
  #else
    struct timeb CurrentTime;
    ftime((struct timeb *) &CurrentTime);
  #endif
  Result.s  = (xint32)(CurrentTime.time);
  Result.ns = (xint32)(CurrentTime.millitm * 1000000);
  return Result;
}
