/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef CODER_REMOVE_BER

#include "cucf.h"
#include "er/ber/ber_content.h"

/*************************************************/
/******************* DECODE **********************/
/*************************************************/

/**************************************************
 * NAME: BERDecode
 *       
 *
 */

int
BERDecode(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  int retCode;
  void* DecVal;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BERDecode\n");
#endif

  if ((retCode = BufGetErrorCode(Coder)) != ec_SUCCESS)
    return retCode;

  CUCFSetErrorCatcher(Coder, retCode);
  if (retCode == 0)
    {
      tVMSULong Length;
      unsigned char* DataCurr;

      Coder->ER.MemStart = BufGetMemory(Coder, &Length);
      Coder->ER.MemEnd   = Coder->ER.MemStart + Length;
      Coder->ER.DataEnd  = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
      Coder->ER.DataCurr = BufGetDataCurr(Coder, &Coder->ER.BitCurr);
      DataCurr           = Coder->ER.DataCurr;

      INTERNAL_ERROR_HANDLER_EXP((Coder->ER.BitCurr != 7),
                                 Coder,
                                 return ec_INT_InternalError,
                                 ec_INT_InternalError,
                                 ERR_ARG(__FILE__) ERR_ARG(__LINE__));

      if (!(Coder->ER.Rule & er_BER))
        Coder->ER.Rule = er_BER;

      VMSGetValue(Coder, Val, Type, DecVal);
      BERDecVal(Coder, tk_Explicit, Type, DecVal, NULL);
      VMSSetValue(Coder, Val, Type, DecVal);

      BufSetDataCurr(Coder, Coder->ER.DataCurr - DataCurr, 7);
      Coder->ER.ValueBitLength = (Coder->ER.DataCurr - DataCurr) << 3;

      retCode = ec_SUCCESS;
    }
  else
    {
      retCode = Coder->EMS.ErrorCode;
    }
  Coder->EMS.IsAssigned = 0;

  return retCode;
}

#endif /* !CODER_REMOVE_BER */
