/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef CODER_REMOVE_BER

#include "cucf.h"
#include "er/ber/ber_content.h"

/*************************************************/
/******************* ENCODE **********************/
/*************************************************/

/**************************************************
 * NAME: BEREncode
 *       
 *
 */

int
BEREncode(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  int retCode;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "BEREncode\n");
#endif

  if ((retCode = BufGetErrorCode(Coder)) != ec_SUCCESS)
    return retCode;

  CUCFSetErrorCatcher(Coder, retCode);
  if (retCode == 0)
    {
      tVMSULong Length;

      Coder->ER.MemStart = BufGetMemory(Coder, &Length);
      Coder->ER.MemEnd   = Coder->ER.MemStart + Length;
      Coder->ER.DataEnd  = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
      Coder->ER.DataCurr = Coder->ER.MemEnd - 1;

      if (!(Coder->ER.Rule & er_BER))
        Coder->ER.Rule = er_BER;

      BEREncVal(Coder, tk_Explicit, Type, Val);

      Length = Coder->ER.MemEnd - (Coder->ER.DataCurr + 1);
      memmove(Coder->ER.DataEnd, Coder->ER.DataCurr + 1, Length);

      BufSetDataEnd(Coder, Length, 7);
      Coder->ER.ValueBitLength = Length << 3;

      retCode = ec_SUCCESS;
    }
  else
    {
      retCode = Coder->EMS.ErrorCode;
    }
  Coder->EMS.IsAssigned = 0;

  return retCode;
}

#endif /* !CODER_REMOVE_BER */
