/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef CODER_REMOVE_PER

#include "er/per/per_base.h"

/**************************************************/
/**************************************************/
/**************************************************/

/**************************************************
 * NAME: PERAppendBufMemory
 *       
 *
 */

void
PERAppendBufMemory(tCoder* Coder, tVMSULong Len)
{
  tVMSULong DataEnd = Coder->ER.DataEnd - Coder->ER.MemStart;
  tVMSULong DataCurr = Coder->ER.DataCurr - Coder->ER.MemStart;
  tVMSULong MemEnd = Coder->ER.MemEnd - Coder->ER.MemStart;
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERAppendBufMemory\n");
#endif

  Coder->ER.MemStart = BufAppendMemory(Coder, Len);
  Coder->ER.MemEnd = Coder->ER.MemStart + MemEnd + Len;
  Coder->ER.DataEnd = Coder->ER.MemStart + DataEnd;
  Coder->ER.DataCurr = Coder->ER.MemStart + DataCurr;
}

/**************************************************
 * NAME: PERAppendBufMemory
 *       
 *
 */

void
PERBufErrorHandlerFunc(tCoder* Coder, tVMSULong Length, int ErrorCode)
{
  tBufAppendBufFunc AppendFunc = BufGetAppendBufFunc(Coder);

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERBufErrorHandlerFunc\n");
#endif

  if (AppendFunc)
    {
      AppendFunc(Coder, Length - (Coder->ER.DataEnd - Coder->ER.DataCurr));
      Coder->ER.DataEnd = BufGetDataEnd(Coder, &(Coder)->ER.BitEnd);
    }
  if ((long)(Coder->ER.DataEnd - Coder->ER.DataCurr) < (long)Length)
    {
      CUCFErrorOutput(stderr, ErrorCode);
      Coder->EMS.ErrorCode = ErrorCode;
      if (Coder->EMS.IsAssigned) longjmp(Coder->EMS.ReturnPoint, ErrorCode);
    }
}

/**************************************************
 * NAME: PERPutBit
 *       
 *
 */

void
PERPutBit(tCoder* Coder, unsigned char Bit)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERPutBit\n");
#endif

  if (Coder->ER.DataCurr == Coder->ER.MemEnd)
    PERAppendBufMemory(Coder, 1);

  if (Coder->ER.BitCurr == 7)
    {
      *(Coder->ER.DataCurr) = (unsigned char)(Bit << Coder->ER.BitCurr);
      Coder->ER.BitCurr--;
    }
  else
    {
      *(Coder->ER.DataCurr) |= (unsigned char)(Bit << Coder->ER.BitCurr);
      if (Coder->ER.BitCurr == 0)
        {
          Coder->ER.DataCurr++;
          Coder->ER.BitCurr = 7;
        }
      else
        Coder->ER.BitCurr--;
    }
}

/**************************************************
 * NAME: PERGetBit
 *       
 *
 */

unsigned char
PERGetBit(tCoder* Coder)
{
  unsigned char Bit;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERGetBit\n");
#endif
  
  PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 1, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);

  Bit = (unsigned char)((*(Coder->ER.DataCurr) >> Coder->ER.BitCurr) & 0x1);
  if (Coder->ER.BitCurr == 0)
    {
      Coder->ER.DataCurr++;
      Coder->ER.BitCurr = 7;
    }
  else
    Coder->ER.BitCurr--;

  return Bit;
}

/**************************************************
 * NAME: PERPutBits
 *       
 *
 */

void
PERPutBits(tCoder* Coder, unsigned long Bits, unsigned char Num)
{
  unsigned char NOB = (unsigned char)(Num + (7 - Coder->ER.BitCurr));
  unsigned char RB = (unsigned char)(NOB & 0x7);
  unsigned char *CurrByte;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERPutBits\n");
#endif

  if (Num == 0) return;

  if (Num > 32)
    PERBUF_ERROR_HANDLER(Coder, ec_BUF_TooBigNumberOfBits, NO_ARGS);

  NOB >>= 3;
  
  if (Coder->ER.DataCurr + NOB + (RB > 0 ? 1 : 0) > Coder->ER.MemEnd)
    PERAppendBufMemory(Coder, NOB + (RB > 0 ? 1 : 0) - (Coder->ER.MemEnd - Coder->ER.DataCurr));

  if (Coder->ER.BitCurr == 7)
    *(Coder->ER.DataCurr) = 0;

  Coder->ER.BitCurr = (unsigned char)(7 - RB);

  if (NOB > 0)
    {
      Coder->ER.DataCurr += NOB;
      if (RB)
        {
          *(Coder->ER.DataCurr) = (unsigned char)(Bits << (Coder->ER.BitCurr + 1));
          Bits >>= RB;
        }

      for (CurrByte = Coder->ER.DataCurr - 1; NOB > 1; NOB--, CurrByte--, Bits >>= 8)
        *CurrByte = (unsigned char)Bits;

      *CurrByte |= (unsigned char)Bits;
    }
  else
    *(Coder->ER.DataCurr) |= (unsigned char)(Bits << (Coder->ER.BitCurr + 1));
}

/**************************************************
 * NAME: PERGetBits
 *       
 *
 */

unsigned long
PERGetBits(tCoder* Coder, unsigned char Num)
{
  unsigned long Bits = 0;

#ifdef CODER_DEBUG_BMS
  fprintf(stdout, "SmallBufGetBits\n");
#endif
  
  if (Num == 0) return 0;

  if (Num > 32)
    PERBUF_ERROR_HANDLER(Coder, ec_BUF_TooBigNumberOfBits, NO_ARGS);

  if (((Coder->ER.DataEnd - Coder->ER.DataCurr) << 3) + (Coder->ER.BitCurr - Coder->ER.BitEnd) < Num)
    {
      tBufAppendBufFunc AppendFunc = BufGetAppendBufFunc(Coder);
      if (AppendFunc)
        {
          AppendFunc(Coder, (Num - (((Coder->ER.DataEnd - Coder->ER.DataCurr) << 3) + (Coder->ER.BitCurr - Coder->ER.BitEnd))) >> 3);
          Coder->ER.DataEnd = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
        }

      if (((Coder->ER.DataEnd - Coder->ER.DataCurr) << 3) + (Coder->ER.BitCurr - Coder->ER.BitEnd) < Num)
        PERBUF_ERROR_HANDLER(Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
    }

  if (Coder->ER.BitCurr != 7)
    {
      Bits = (unsigned char)(*(Coder->ER.DataCurr) << (7 - Coder->ER.BitCurr));
      if (Num <= Coder->ER.BitCurr + 1)
        {
          Bits >>= (8 - Num);
          if (Coder->ER.BitCurr + 1 == Num)
            {
              Coder->ER.BitCurr = 7;
              Coder->ER.DataCurr++;
            }
          else
            Coder->ER.BitCurr = (unsigned char)(Coder->ER.BitCurr - Num);

          return Bits;
        }

      Bits >>= (7 - Coder->ER.BitCurr);
      Num = (unsigned char)(Num - Coder->ER.BitCurr - 1);
      Coder->ER.DataCurr++;
    }

  for (; Num > 7; Num = (unsigned char)(Num - 8), Coder->ER.DataCurr++)
    {
      Bits <<= 8;
      Bits |= *(Coder->ER.DataCurr);
    }

  if (Num > 0)
    {
      Bits <<= Num;
      Coder->ER.BitCurr = (unsigned char)(7 - Num);
      Bits |= (*(Coder->ER.DataCurr) >> (8 - Num));
    }
  else
    Coder->ER.BitCurr = 7;

  return Bits;
}

/**************************************************
 * NAME: PERPutByte
 *       
 *
 */

void
PERPutByte(tCoder* Coder, unsigned char Byte)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERPutByte\n");
#endif


  if (Coder->ER.BitCurr != 7)
    {
      if (Coder->ER.DataCurr + 1 == Coder->ER.MemEnd)
        PERAppendBufMemory(Coder, 1);

      *(Coder->ER.DataCurr) |= (unsigned char)(Byte >> (7 - Coder->ER.BitCurr));
      Coder->ER.DataCurr++;
      *(Coder->ER.DataCurr) = (unsigned char)(Byte << (Coder->ER.BitCurr + 1));
    }
  else
    {
      if (Coder->ER.DataCurr == Coder->ER.MemEnd)
        PERAppendBufMemory(Coder, 1);

      *(Coder->ER.DataCurr) = Byte;
      Coder->ER.DataCurr++;
    }
}


/**************************************************
 * NAME: PERGetByte
 *       
 *
 */

unsigned char
PERGetByte(tCoder* Coder)
{
  unsigned char Byte;
  
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERGetByte\n");
#endif
  
  if (Coder->ER.BitCurr != 7)
    {
      PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 2, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
      
      Byte = (unsigned char)((*(Coder->ER.DataCurr) << (7 - Coder->ER.BitCurr)));
      Coder->ER.DataCurr++;
      Byte |= (unsigned char)(*(Coder->ER.DataCurr) >> (Coder->ER.BitCurr + 1));
    }
  else
    {
      PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 1, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);

      Byte = *(Coder->ER.DataCurr);
      Coder->ER.DataCurr++;
    }

  return Byte;
}

/**************************************************
 *
 * NAME: PERSkipBytes
 *
 *
 */

void
PERSkipBytes(tCoder* Coder, tVMSULong NumOfBytes)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERSkipBytes\n");
#endif

  if (Coder->ER.BitCurr != 7)
    {
      if (Coder->ER.DataCurr + NumOfBytes + 1 >= Coder->ER.MemEnd)
        PERAppendBufMemory(Coder, NumOfBytes + 1 - (Coder->ER.MemEnd - Coder->ER.DataCurr));
      
      *(Coder->ER.DataCurr) &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
      memset(Coder->ER.DataCurr + 1, 0, NumOfBytes);
    }
  else
    {
      if (Coder->ER.DataCurr + NumOfBytes >= Coder->ER.MemEnd)
        PERAppendBufMemory(Coder, NumOfBytes - (Coder->ER.MemEnd - Coder->ER.DataCurr));

      memset(Coder->ER.DataCurr, 0, NumOfBytes);
    }
  Coder->ER.DataCurr += NumOfBytes;
}

/**************************************************
 *
 * NAME: PERPutSeg
 *
 *
 */

void
PERPutSeg(tCoder* Coder, unsigned char* Seg, unsigned long Len)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERPutSeg\n");
#endif

  if (Len == 0) return;

  if (Coder->ER.BitCurr != 7)
    {
      tVMSULong i;
      unsigned char* Byte;

      if (Coder->ER.DataCurr + Len + 1 > Coder->ER.MemEnd)
        PERAppendBufMemory(Coder, Len + 1 - (Coder->ER.MemEnd - Coder->ER.DataCurr));

      for (i = 0, Byte = Seg; i < Len; i++, Byte++)
        {
          *(Coder->ER.DataCurr) |= (unsigned char)(*Byte >> (7 - Coder->ER.BitCurr));
          Coder->ER.DataCurr++;
          *(Coder->ER.DataCurr) = (unsigned char)(*Byte << (Coder->ER.BitCurr + 1));
        }      
    }
  else
    {
      if (Coder->ER.DataCurr + Len > Coder->ER.MemEnd)
        PERAppendBufMemory(Coder, Len - (Coder->ER.MemEnd - Coder->ER.DataCurr));

      memcpy(Coder->ER.DataCurr, Seg, Len);
      Coder->ER.DataCurr += Len;
    }
}

/**************************************************/
/**************************************************/
/**************************************************/

/**************************************************
 * NAME: PEROctetsFragmentation
 *       
 *
 */

void 
PEROctetsFragmentation(tCoder* Coder, tVMSULong Length)
{
  unsigned char* From;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEROctetsFragmentation\n");
#endif

  if (Length < 0x4000)
    {
      PERSkipBytes(Coder, 1);

      From = Coder->ER.DataCurr - (Length + 1);
      
      memmove(From + 1, From, Length);
     
      Length |= 0x8000;
      *From = (unsigned char)Length;
      From--;
      *From = (unsigned char)(Length >> 8);
    }
  else
    {
      tVMSULong Bytes = 0;
      unsigned char NOK = 0; 

      while (Length >= 0x10000)
        {
          Length -= 0x10000;
          Bytes++;
        }

      if (Length >= 0xC000)
        {
          Length -= 0xC000;
          Bytes++;
          NOK |= 0x4;
        }

      if (Length >= 0x8000)
        {
          Length -= 0x8000;
          Bytes++;
          NOK |= 0x2;
        }

      if (Length >= 0x4000)
        {
          Length -= 0x4000;
          Bytes++;
          NOK |= 0x1;
        }

      if (Length > 0)
        {
          if (Length > 0x7F)
            {
              PERSkipBytes(Coder, Bytes + 1);
              From = Coder->ER.DataCurr - (Length + Bytes + 1);
              memmove(From + Bytes + 1, From, Length);
              From--;
              Length |= 0x8000;
              *From = (unsigned char)Length;
              From--;
              *From = (unsigned char)(Length >> 8);
            }
          else
            {
              PERSkipBytes(Coder, Bytes);
              From = Coder->ER.DataCurr - (Length + Bytes);
              memmove(From + Bytes, From, Length);
              From--;
              *From = (unsigned char)Length;
            }
          Bytes--;              
          From -= Bytes;
        }
      else
        {
          Bytes--;
          PERSkipBytes(Coder, Bytes);
          From = Coder->ER.DataCurr - Bytes;
        }     
      
      while ((Bytes > 0) && (NOK != 0))
        {
          if (NOK & 0x1)
            {
              From -= 0x4000;
              memmove(From + Bytes, From, 0x4000);
              *(From + Bytes - 1) = 0xC1;
              NOK &= 0x6;
            }
          else
          if (NOK & 0x2)
            {
              From -= 0x8000;
              memmove(From + Bytes, From, 0x8000);
              *(From + Bytes - 1) = 0xC2;
              NOK &= 0x4;
            }
          else
          if (NOK & 0x4)
            {
              From -= 0xC000;
              memmove(From + Bytes, From, 0xC000);
              *(From + Bytes - 1) = 0xC3;
              NOK = 0;
            }
          Bytes--;
        }
      
      if (Bytes == 0)
        {
          switch (NOK)
            {
            case 0x1:
              From -= 0x4000 + 1;
              *From = 0xC1;
              break;
            case 0x2:
              From -= 0x8000 + 1;
              *From = 0xC2;
              break;
            case 0x3:
              From -= 0xC000 + 1;
              *From = 0xC3;
            default:
              break;
            }          
        }
      else
        {
          while (Bytes > 0)
            {
              From -= 0x10000;
              memmove(From + Bytes, From, 0x10000);
              *(From + Bytes - 1) = 0xC4;
              Bytes--;
            }
          From -= 0x10000 + 1;
          *From = 0xC4;
        }
    }
}

/**************************************************
 * NAME: PEROctetsDefragmentation
 *       
 *
 */

tVMSULong
PEROctetsDefragmentation(tCoder* Coder)
{
  unsigned char* CurrByte = Coder->ER.DataCurr, *To, Byte;
  tVMSULong Length = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEROctetsDefragmentation\n");
#endif
  
  Byte = PERGetByte(Coder);

  switch (Byte)
    {
    case 0xC4:
      Length += 0x10000;
      Coder->ER.DataCurr += 0x10000;
      break;
    case 0xC3:
      Length += 0xC000;
      Coder->ER.DataCurr += 0xC000;
      break;
    case 0xC2:
      Length += 0x8000;
      Coder->ER.DataCurr += 0x8000;
      break;
    case 0xC1:
      Length += 0x4000;
      Coder->ER.DataCurr += 0x4000;
      break;
    default:
      DECODING_ERROR_HANDLER(Coder, return 0, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }

  PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 1, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);

  To = CurrByte;

  Byte = PERGetByte(Coder);
  while (Byte >= 0xC1)
    {
      switch (Byte)
        {
        case 0xC4:
          Length += 0x10000;
          PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 0x10000, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
          memmove(To, Coder->ER.DataCurr, 0x10000);
          To += 0x10000;
          Coder->ER.DataCurr += 0x10000;
          break;
        case 0xC3:
          Length += 0xC000;
          PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 0xC000, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
          memmove(To, Coder->ER.DataCurr, 0xC000);
          To += 0xC000;
          CurrByte += 0xC000;
          break;
        case 0xC2:
          Length += 0x8000;
          PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 0x8000, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
          memmove(To, Coder->ER.DataCurr, 0x8000);
          To += 0x8000;
          Coder->ER.DataCurr += 0x8000;
          break;
        case 0xC1:
          Length += 0x4000;
          PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 0x4000, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
          memmove(To, Coder->ER.DataCurr, 0x4000);
          To += 0x4000;
          Coder->ER.DataCurr += 0x4000;
          break;
        default:
          DECODING_ERROR_HANDLER(Coder, return 0, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
        }
      Byte = PERGetByte(Coder);
    }

  if ((Byte & 0xC0) == 0x80)
    {
      tVMSULong TmpLength = (((Byte & 0x7F) << 8) | PERGetByte(Coder));
      Length += TmpLength;
      PERBUF_ERROR_HANDLER_EXP((tVMSULong)(Coder->ER.DataEnd - Coder->ER.DataCurr), TmpLength, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
      memmove(To, Coder->ER.DataCurr, TmpLength);
    }
  else
  if((Byte & 0x80) == 0x00)
    {
      Length += (Byte & 0x7F);
      PERBUF_ERROR_HANDLER_EXP((tVMSULong)(Coder->ER.DataEnd - Coder->ER.DataCurr), (Byte & 0x7F), Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
      memmove(To, Coder->ER.DataCurr, (Byte & 0x7F));
    }
  else
    {
      DECODING_ERROR_HANDLER(Coder, return 0, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }

  Coder->ER.DataCurr = CurrByte + 1;
  
  return Length;
}

/**************************************************
 * NAME: PEROctetsFragmentationWithOffset
 *       
 *
 */

void 
PEROctetsFragmentationWithOffset(tCoder* Coder, tVMSULong Length)
{
  unsigned char* From;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEROctetsFragmentationWithOffset\n");
#endif

  if (Length < 0x4000)
    {
      PERSkipBytes(Coder, 1);

      From = Coder->ER.DataCurr - (Length + 1);
      memmove(From + 1, From, Length + 1);

      Length |= 0x8000;     
      From--;
      *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
      *From |= (unsigned char)(Length >> (15 - Coder->ER.BitCurr));
      From++;
      *From = (unsigned char)(Length >> (7 - Coder->ER.BitCurr));
      From++;
      *From &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
      *From |= (unsigned char)(Length << (Coder->ER.BitCurr + 1));
    }
  else
    {
      tVMSULong Bytes = 0, LengthCpy = Length;
      unsigned char NOK = 0; 

      while (Length >= 0x10000)
        {
          Length -= 0x10000;
          Bytes++;
        }

      if (Length >= 0xC000)
        {
          Length -= 0xC000;
          Bytes++;
          NOK |= 0x4;
        }

      if (Length >= 0x8000)
        {
          Length -= 0x8000;
          Bytes++;
          NOK |= 0x2;
        }

      if (Length >= 0x4000)
        {
          Length -= 0x4000;
          Bytes++;
          NOK |= 0x1;
        }

      if (Length > 0)
        {
          if (Length > 0x7F)
            {
              PERSkipBytes(Coder, Bytes + 1);
              From = Coder->ER.DataCurr - (Length + Bytes + 1);
              memmove(From + Bytes + 1, From, Length + 1);
            }
          else
            {
              PERSkipBytes(Coder, Bytes);
              Coder->ER.DataCurr += Bytes;
              From = Coder->ER.DataCurr - (Length + Bytes);
              memmove(From + Bytes, From, Length + 1);
            }
          Bytes--;
        }
      else
        {
          Bytes--;
          PERSkipBytes(Coder, Bytes);
          Coder->ER.DataCurr += Bytes;
          From = Coder->ER.DataCurr - (Length + Bytes);
        }

      while ((Bytes > 0) && (NOK != 0))
        {          
          if (NOK & 0x1)
            {
              From -= 0x4000;
              memmove(From + Bytes, From, 0x4001);
              NOK &= 0x6;
            }
          else
          if (NOK & 0x2)
            {
              From -= 0x8000;
              memmove(From + Bytes, From, 0x8001);
              NOK &= 0x4;
            }
          else
          if (NOK & 0x4)
            {
              From -= 0xC000;
              memmove(From + Bytes, From, 0xC001);
              NOK = 0;
            }

          Bytes--;
        }

      if (Bytes == 0)
        {
          switch (NOK)
            {
            case 0x1:
              From -= 0x4001;
              break;
            case 0x2:
              From -= 0x8001;
              break;
            case 0x3:
              From -= 0xC001;
            default:
              break;
            }
        }
      else
        {
          while (Bytes > 0)
            {
              From -= 0x10000;
              memmove(From + Bytes, From, 0x10001);
              Bytes--;
            }

          From -= 0x10001;
        }

      while (LengthCpy >= 0x10000)
        {
          *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *From |= (unsigned char)(0xC4 >> (7 - Coder->ER.BitCurr));
          From++;
          *From &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *From |= (unsigned char)(0xC4 << (Coder->ER.BitCurr + 1));      
          LengthCpy -= 0x10000;
          From += 0x10000;
        }

      if (LengthCpy >= 0xC000)
        {
          *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *From |= (unsigned char)(0xC3 >> (7 - Coder->ER.BitCurr));
          From++;
          *From &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *From |= (unsigned char)(0xC3 << (Coder->ER.BitCurr + 1));      
          LengthCpy -= 0xC000;
          From += 0xC000;
        }

      if (LengthCpy >= 0x8000)
        {
          *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *From |= (unsigned char)(0xC2 >> (7 - Coder->ER.BitCurr));
          From++;
          *From &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *From |= (unsigned char)(0xC2 << (Coder->ER.BitCurr + 1));      
          LengthCpy -= 0x8000;
          From += 0x8000;
        }

      if (LengthCpy >= 0x4000)
        {
          *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *From |= (unsigned char)(0xC1 >> (7 - Coder->ER.BitCurr));
          From++;
          *From &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *From |= (unsigned char)(0xC1 << (Coder->ER.BitCurr + 1));      
          LengthCpy -= 0x4000;
          From += 0x4000;
        }

      if (LengthCpy > 0)
        {
          if (LengthCpy > 0x7F)
            {
              LengthCpy |= 0x8000;
              *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
              *From |= (unsigned char)(LengthCpy >> (15 - Coder->ER.BitCurr));
              From++;
              *From = (unsigned char)(LengthCpy >> (7 - Coder->ER.BitCurr));
              From++;
              *From &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
              *From |= (unsigned char)(LengthCpy << (Coder->ER.BitCurr + 1));
            }
          else
            {
              *From &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
              *From |= (unsigned char)(LengthCpy >> (7 - Coder->ER.BitCurr));
              From++;
              *From &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
              *From |= (unsigned char)(LengthCpy << (Coder->ER.BitCurr + 1));
            }
        }
    }
}

/**************************************************
 * NAME: PEROctetsDefragmentationWithOffset
 *       
 *
 */

tVMSULong
PEROctetsDefragmentationWithOffset(tCoder* Coder)
{
  unsigned char* CurrByte = Coder->ER.DataCurr, *To, Byte;
  tVMSULong Length = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEROctetsDefragmentationWithOffset\n");
#endif
  
  Byte = PERGetByte(Coder);

  switch (Byte)
    {
    case 0xC4:
      Length += 0x10000;
      Coder->ER.DataCurr += 0x10000;
      break;
    case 0xC3:
      Length += 0xC000;
      Coder->ER.DataCurr += 0xC000;
      break;
    case 0xC2:
      Length += 0x8000;
      Coder->ER.DataCurr += 0x8000;
      break;
    case 0xC1:
      Length += 0x4000;
      Coder->ER.DataCurr += 0x4000;
      break;
    default:
      DECODING_ERROR_HANDLER(Coder, return 0, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }

  PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 1, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);

  To = CurrByte;

  Byte = PERGetByte(Coder);
  while (Byte >= 0xC1)
    {
      switch (Byte)
        {
        case 0xC4:
          Length += 0x10000;
          PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 0x10001, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
          *To &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *(Coder->ER.DataCurr) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *To |= *(Coder->ER.DataCurr);
          To++;
          Coder->ER.DataCurr++;
          memmove(To, Coder->ER.DataCurr, 0x10000);
          To += 0x10000;
          Coder->ER.DataCurr += 0x10000;
          break;
        case 0xC3:
          Length += 0xC000;
          PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 0xC001, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
          *To &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *(Coder->ER.DataCurr) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *To |= *(Coder->ER.DataCurr);
          To++;
          Coder->ER.DataCurr++;
          memmove(To, Coder->ER.DataCurr, 0xC000);
          To += 0xC000;
          CurrByte += 0xC000;
          break;
        case 0xC2:
          Length += 0x8000;
          PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 0x8001, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
          *To &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *(Coder->ER.DataCurr) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *To |= *(Coder->ER.DataCurr);
          To++;
          Coder->ER.DataCurr++;
          memmove(To, Coder->ER.DataCurr, 0x8000);
          To += 0x8000;
          Coder->ER.DataCurr += 0x8000;
          break;
        case 0xC1:
          Length += 0x4000;
          PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, 0x4001, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
          *To &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
          *(Coder->ER.DataCurr) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
          *To |= *(Coder->ER.DataCurr);
          To++;
          Coder->ER.DataCurr++;
          memmove(To, Coder->ER.DataCurr, 0x4000);
          To += 0x4000;
          Coder->ER.DataCurr += 0x4000;
          break;
        default:
          DECODING_ERROR_HANDLER(Coder, return 0, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
        }
      Byte = PERGetByte(Coder);
    }

  if ((Byte & 0xC0) == 0x80)
    {
      tVMSULong TmpLength = (((Byte & 0x7F) << 8) | PERGetByte(Coder));
      Length += TmpLength;
      PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, TmpLength, Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
      *To &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
      *(Coder->ER.DataCurr) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
      *To |= *(Coder->ER.DataCurr);
      To++;
      Coder->ER.DataCurr++;
      memmove(To, Coder->ER.DataCurr, TmpLength);
    }
  else
  if((Byte & 0x80) == 0x00)
    {
      Length += (Byte & 0x7F);
      PERBUF_ERROR_HANDLER_EXP(Coder->ER.DataEnd - Coder->ER.DataCurr, (Byte & 0x7F), Coder, ec_BUF_NoMoreDataForRead, NO_ARGS);
      *To &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1));
      *(Coder->ER.DataCurr) &= (unsigned char)(0xFF >> (7 - Coder->ER.BitCurr));
      *To |= *(Coder->ER.DataCurr);
      To++;
      Coder->ER.DataCurr++;
      memmove(To, Coder->ER.DataCurr, (Byte & 0x7F));
    }
  else
    {
      DECODING_ERROR_HANDLER(Coder, return 0, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
    }

  Coder->ER.DataCurr = CurrByte + 1;
  
  return Length;
}

/**************************************************/
/**************************************************/
/**************************************************/

/**************************************************
 * NAME: PERConstructedEncode
 *       
 *
 */

void
PERConstructedEncode(tCoder* Coder, tPERConstructedInfo* Info)
{
#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERConstructedEncode\n");
#endif

  if (Info->Length >= 0x4000)
    {
      while (Info->Length >= 0x10000)
        {
          if (Coder->ER.Rule & er_Aligned)
            PERAlign(Coder);

          /* 8 bits: 11000100 */
          PERPutByte(Coder, 0xC4);
          Info->PrimOp(Coder, 0x10000, Info);
        }

      if (Info->Length >= 0xC000)
        {
          if (Coder->ER.Rule & er_Aligned)
            PERAlign(Coder);

          /* 8 bits: 11000011 */
          PERPutByte(Coder, 0xC3);
          Info->PrimOp(Coder, 0xC000, Info);
        }
  
      if (Info->Length >= 0x8000)
        {
          if (Coder->ER.Rule & er_Aligned)
            PERAlign(Coder);

          /* 8 bits: 11000010 */
          PERPutByte(Coder, 0xC2);
          Info->PrimOp(Coder, 0x8000, Info);
        }

      if (Info->Length >= 0x4000)
        {
          if (Coder->ER.Rule & er_Aligned)
            PERAlign(Coder);

          /* 8 bits: 11000001 */
          PERPutByte(Coder, 0xC1);
          Info->PrimOp(Coder, 0x4000, Info);
        }
    }

  if (Coder->ER.Rule & er_Aligned)
    PERAlign(Coder);
      
  if (Info->Length <= 0x7F)
    /* 1 bit: 0, 6 bits: number */
    PERPutByte(Coder, (unsigned char)(Info->Length));
  else
    /* 2 bits: 10, 14 bits: number */
    PERPutBits(Coder, (Info->Length | 0x8000), 16);
  
  Info->PrimOp(Coder, Info->Length, Info);
}

/**************************************************
 * NAME: PERConstructedDecode
 *       
 *
 */

void
PERConstructedDecode(tCoder* Coder, tPERConstructedInfo* Info)
{
  unsigned char Byte;
  tVMSULong DecLen = 0;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERConstructedDecode\n");
#endif

  do
    {
      if (Coder->ER.Rule & er_Aligned)
        PERAlign(Coder);

      Byte = PERGetByte(Coder);

      if (Byte == 0xC4)
        DecLen = 0x10000;
      else
      if (Byte == 0xC3)
        DecLen = 0xC000;
      else
      if (Byte == 0xC2)
        DecLen = 0x8000;
      else
      if (Byte == 0xC1)
        DecLen = 0x4000;
      else
      if((Byte & 0xC0) == 0x80)
        DecLen = (((Byte & 0x7F) << 8) | PERGetByte(Coder));
      else
      if((Byte & 0x80) == 0x00)
        DecLen = (Byte & 0x7F);
      else
        {
          DECODING_ERROR_HANDLER(Coder, return, ec_DEC_WrongConstructedLengthPrefix, NO_ARGS);
        }
      Info->PrimOp(Coder, DecLen, Info);
    }
  while(DecLen >= 0x4000);
}

#endif /* !CODER_REMOVE_PER */
