/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __per_base_h
#define __per_base_h

#ifndef CODER_REMOVE_PER

#include "cucf.h"

/***********************************************/
/************* Buffers operations **************/
/***********************************************/

void PERAppendBufMemory(tCoder* Coder, tVMSULong Len);
void PERBufErrorHandlerFunc(tCoder* Coder, tVMSULong Length, int ErrorCode);

#if !defined(CODER_CHECK_NONE) && !defined(CODER_CHECK_NONE_BUFFER)
#define PERBUF_ERROR_HANDLER_EXP(exp, len, coder, errorcode, args) \
if ((long)(exp) < (long)(len)) \
  PERBufErrorHandlerFunc(coder, len, errorcode);

#define PERBUF_ERROR_HANDLER(coder, errorcode, args) \
{ \
  CUCFErrorOutput(stderr, errorcode args); \
  (coder)->EMS.ErrorCode = errorcode; \
  if ((coder)->EMS.IsAssigned) longjmp((coder)->EMS.ReturnPoint, errorcode); \
  else { NO_ACTION ; } \
}
#else
#define PERBUF_ERROR_HANDLER_EXP(exp, len, coder, errorcode, args)
#define PERBUF_ERROR_HANDLER(coder, errorcode, args)
#endif

/***********************************************/

void          PERPutBit(tCoder* Coder, unsigned char Bit);
unsigned char PERGetBit(tCoder* Coder);

void          PERPutBits(tCoder* Coder, unsigned long Bits, unsigned char Num);
unsigned long PERGetBits(tCoder* Coder, unsigned char Num);

/***********************************************/

void          PERPutByte(tCoder* Coder, unsigned char Byte);
unsigned char PERGetByte(tCoder* Coder);
void          PERSkipBytes(tCoder* Coder, tVMSULong NumOfBytes);

/***********************************************/

void          PERPutSeg(tCoder* Coder, unsigned char* Seg, unsigned long Len);

/***********************************************/

#define PERAlign(Coder) \
if (Coder->ER.BitCurr != 7) \
{ \
  *(Coder->ER.DataCurr) &= (unsigned char)(0xFF << (Coder->ER.BitCurr + 1)); \
  Coder->ER.DataCurr++; \
  Coder->ER.BitCurr = 7; \
}

/***********************************************/
/***********************************************/
/***********************************************/

void      PEROctetsFragmentation(tCoder* Coder, tVMSULong Length);
void      PEROctetsFragmentationWithOffset(tCoder* Coder, tVMSULong Length);
tVMSULong PEROctetsDefragmentation(tCoder* Coder);
tVMSULong PEROctetsDefragmentationWithOffset(tCoder* Coder);

/***********************************************/
/***********************************************/
/***********************************************/

#if !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET)

typedef struct
{
  tVMSULong     CByte;
  unsigned char CBit;
} tPERCurrPos;

typedef struct
{
  tVMSULong     CByte;
  unsigned char CBit;
  tVMSULong     CLength;
} tPEREncBitField;

typedef struct
{
  unsigned char* CByte;
  unsigned char  CBit;
  tVMSULong      CLength;
} tPERDecBitField;

#endif /* !defined(CODER_NOUSE_SEQUENCE) || !defined(CODER_NOUSE_SET) */

/***********************************************/
/***********************************************/
/***********************************************/

struct sPERConstructedInfo;
typedef struct sPERConstructedInfo tPERConstructedInfo;

typedef void (*tPERPrimFunc)(tCoder* Coder, tVMSULong Length, tPERConstructedInfo* Info);

/* BASE */
struct sPERConstructedInfo
{
  unsigned char* Value;      /* Pointer to value */
  tVMSULong      Length;     /* Length of value */
  tPERPrimFunc   PrimOp;     /* Pointer to Encode/Decode function */
};

void PERConstructedEncode(tCoder* Coder, tPERConstructedInfo* Val);
void PERConstructedDecode(tCoder* Coder, tPERConstructedInfo* Val);

typedef struct
{
  unsigned char* Value;       /* Pointer to value */
  tVMSULong      Length;      /* Length of value */
  tPERPrimFunc   PrimOp;      /* Pointer to Encode/Decode function */

  unsigned char  BitsLength;  /* Length in bits */
  unsigned char  ValMask;     /* Code or number */
  unsigned char* Alphabet;    /* Alphabet */
  tVMSULong      AlphabetLen; /* Alphabet length */
} tPERCharStringInfo;

/***********************************************/
/*************** STRUCT OF *********************/
/***********************************************/

struct sPERStructOfInfo;
typedef struct sPERStructOfInfo tPERStructOfInfo;

typedef void (*tPERStructOfFunc)(tCoder* Coder, tVMSULong Length, tPERStructOfInfo* Info);

struct sPERStructOfInfo
{
  void*             Value;      /* Pointer to value */
  tVMSULong         Length;     /* Length of value */
  tPERStructOfFunc  PrimOp;     /* Pointer to Encode/Decode function */

  tVMSULong         CurrElem;   /* Current element */
  tASN1StructOf*    Type;       /* StructOf type */
  tVMSOpenTypeList* List;       /* Open type list */
};

#ifndef CODER_NOUSE_OPEN
/***********************************************/
/***************** OPEN ************************/
/***********************************************/

#define PERPutOpenId(Coder, List, Type, Val) CUCFPutOpenId(Coder, List, Type, Val)
#define PERPutOpenBody(Coder, List, OTInfo, Type, Val) CUCFPutOpenBody(Coder, List, OTInfo, Type, Val)

/***********************************************/

#define PERGetOpenTypeObject(Coder, Type, ObjIndex, Val) CUCFGetOpenTypeObject(Coder, Type, ObjIndex, Val)

/***********************************************/

#endif /* CODER_NOUSE_OPEN  */ 
/***********************************************/
/***************** SHARED **********************/
/***********************************************/

#define PERGetLengthValueOfInteger(InVal, OutLength) CUCFGetLengthValueOfInteger(InVal, OutLength)

/***********************************************/
/***********************************************/
/***********************************************/

#endif /* !CODER_REMOVE_PER */

#endif /* __per_base_h */

