/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef CODER_REMOVE_PER

#include "cucf.h"
#include "er/per/per_content.h"

/*************************************************/
/******************* DECODE **********************/
/*************************************************/

/**************************************************
 * NAME: PERDecode
 *       
 *
 */

int
PERDecode(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  int retCode;
  void* DecVal = NULL;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PERDecode\n");
#endif

  if ((retCode = BufGetErrorCode(Coder)) != ec_SUCCESS)
    return retCode;

  CUCFSetErrorCatcher(Coder, retCode);
  if (retCode == 0)
    {
      tVMSULong Length;
      unsigned char* DataCurr;
      unsigned char BitCurr;

      Coder->ER.MemStart = BufGetMemory(Coder, &Length);
      Coder->ER.MemEnd   = Coder->ER.MemStart + Length;
      Coder->ER.DataEnd  = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
      if (Coder->ER.BitEnd != 7)
        Coder->ER.DataEnd++;
      Coder->ER.DataCurr = BufGetDataCurr(Coder, &Coder->ER.BitCurr);
      DataCurr           = Coder->ER.DataCurr;
      BitCurr            = Coder->ER.BitCurr;

      if (!(Coder->ER.Rule & er_PER))
        Coder->ER.Rule = er_PER;

      VMSGetValue(Coder, Val, Type, DecVal);
      PERDecVal(Coder, Type, DecVal, NULL);
      VMSSetValue(Coder, Val, Type, DecVal);

      if ((Coder->ER.DataCurr == DataCurr) && (Coder->ER.BitCurr == BitCurr))
        PERGetByte(Coder);

      if (!(Coder->ER.Rule & er_NoEndPad))
        PERAlign(Coder);

      BufSetDataCurr(Coder, Coder->ER.DataCurr - DataCurr, Coder->ER.BitCurr);
      Coder->ER.ValueBitLength = ((Coder->ER.DataCurr - DataCurr) << 3) + (BitCurr - Coder->ER.BitCurr);

      retCode = ec_SUCCESS;
    }
  else
    {
      retCode = Coder->EMS.ErrorCode;
    }
  Coder->EMS.IsAssigned = 0;

  return retCode;
}

#endif /* !CODER_REMOVE_PER */
