/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef CODER_REMOVE_PER

#include "cucf.h"
#include "er/per/per_content.h"

/*************************************************/
/******************* ENCODE **********************/
/*************************************************/

/**************************************************
 * NAME: PEREncode
 *       
 *
 */

int
PEREncode(tCoder* Coder, tASN1TypeInfo* Type, void* Val)
{
  int retCode;

#ifdef CODER_DEBUG_PRINT
  fprintf(stdout, "PEREncode\n");
#endif

  if ((retCode = BufGetErrorCode(Coder)) != ec_SUCCESS)
    return retCode;

  CUCFSetErrorCatcher(Coder, retCode);
  if (retCode == 0)
    {
      tVMSULong Length;

      Coder->ER.MemStart = BufGetMemory(Coder, &Length);
      Coder->ER.MemEnd   = Coder->ER.MemStart + Length;
      Coder->ER.DataEnd  = BufGetDataEnd(Coder, &Coder->ER.BitEnd);
      Coder->ER.DataCurr = Coder->ER.DataEnd;
      Coder->ER.BitCurr  = Coder->ER.BitEnd;

      if (!(Coder->ER.Rule & er_PER))
        Coder->ER.Rule = er_PER;
      
      PEREncVal(Coder, Type, Val);

      if ((Coder->ER.DataCurr == Coder->ER.DataEnd) && (Coder->ER.BitCurr == Coder->ER.BitEnd))
        PERPutByte(Coder, 0);

      if (!(Coder->ER.Rule & er_NoEndPad))
        PERAlign(Coder);
      
      BufSetDataEnd(Coder, Coder->ER.DataCurr - Coder->ER.DataEnd, Coder->ER.BitCurr);
      Coder->ER.ValueBitLength = ((Coder->ER.DataCurr - Coder->ER.DataEnd) << 3) + (Coder->ER.BitEnd - Coder->ER.BitCurr);

      retCode = ec_SUCCESS;
    }
  else
    {
      retCode = Coder->EMS.ErrorCode;
    }
  Coder->EMS.IsAssigned = 0;

  return retCode;
}

#endif /* !CODER_REMOVE_PER */
