/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

#ifndef __vms_type_h
#define __vms_type_h

#include "cucf_cfg.h"
#include "vms/vms_internal.h"

enum
{
  type_ASN1_BOOLEAN           = 1,
  type_ASN1_NULL              = 5,
  type_ASN1_OBJECT_IDENTIFIER = 6,
  type_ASN1_REAL              = 9,
  type_ASN1_INTEGER           = 2,
  type_ASN1_BIT_STRING        = 3,
  type_ASN1_OCTET_STRING      = 4,
  type_ASN1_NumericString     = 18,
  type_ASN1_PrintableString   = 19,
  type_ASN1_IA5String         = 22,
  type_ASN1_VisibleString     = 26,
  type_ASN1_UTCTime           = 23,
  type_ASN1_GeneralizedTime   = 24,
  type_ASN1_ENUMERATED        = 10,
  type_ASN1_SEQUENCE          = 16,
  type_ASN1_SET               = 17,
  type_ASN1_SEQUENCE_OF       = 48,  /* Internal */
  type_ASN1_SET_OF            = 49,  /* Internal */
  type_ASN1_CHOICE            = 101, /* Internal */
  type_ASN1_DEFINED           = 51,  /* Internal */
  type_ASN1_TAGGED            = 103, /* Internal */
  type_ASN1_OPEN_ID           = 52,  /* Internal */
  type_ASN1_OPEN              = 102  /* Internal */
};

typedef unsigned char tCUCFTypeClass;

enum
{
  em_Absent = 0,
  em_Present = 1
};
typedef unsigned char tASN1ExtMarker;

enum 
{
  ct_Required,
  ct_Optional,
  ct_Default,
  ct_Present,
  ct_Absent,
  ct_Group,
  ct_Last
};
typedef unsigned char tASN1ComponentType;

enum
{
  rs_NonRoot = 0,
  rs_Root = 1
};
typedef unsigned char tASN1RootStruct;

enum
{
  tc_UT = 0,
  tc_AP = (1 << 6),
  tc_CS = (2 << 6),
  tc_PR = (3 << 6)
};
typedef unsigned char tASN1TagClass;

typedef CODER_TagNumber_TYPE tASN1TagClassNumber;

struct sASN1TypeInfo;
typedef const struct sASN1TypeInfo tASN1TypeInfo;

struct sASN1TypeInfo
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
};

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
} tASN1Predefined;

typedef tASN1Predefined tASN1Boolean;
typedef tASN1Predefined tASN1Null;
typedef tASN1Predefined tASN1ObjectIdentifier;
typedef tASN1Predefined tASN1Real;

typedef struct
{
  CODER_INTEGER_LBOUND_TYPE pLBound;
  CODER_INTEGER_UBOUND_TYPE pUBound;
  tASN1ExtMarker                  ExtMarker;
} tASN1IntegerConstraint;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
#ifndef CODER_REMOVE_CONSTRAINTS
  unsigned char          ConstraintMask;
  tASN1IntegerConstraint IntegerConstraint;
#endif
} tASN1Integer;

typedef struct
{
  CODER_SIZE_LBOUND_TYPE  LBound;
  CODER_SIZE_UBOUND_TYPE  pUBound;
  tASN1ExtMarker          ExtMarker;
} tASN1SizeConstraint;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
#ifndef CODER_REMOVE_CONSTRAINTS
  unsigned char         ConstraintMask;
  tASN1SizeConstraint   SizeConstraint;
#endif
} tASN1String;

typedef tASN1String tASN1BitString;
typedef tASN1String tASN1OctetString;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
#ifndef CODER_REMOVE_CONSTRAINTS
  unsigned char         ConstraintMask;
  tASN1SizeConstraint   SizeConstraint;
  unsigned char*        Alphabet;
  tVMSULong             AlphabetLen;
#endif
} tASN1CharString;

typedef tASN1CharString tASN1NumericString;
typedef tASN1CharString tASN1PrintableString;
typedef tASN1CharString tASN1IA5String;
typedef tASN1CharString tASN1VisibleString;

typedef tASN1VisibleString tASN1UTCTime;
typedef tASN1VisibleString tASN1GeneralizedTime;

typedef const struct
{
#ifdef CODER_VMS_TYPENAME
  char*                 Name;
#endif
  tVMSEnumerated_Value  Value;
} tASN1Item;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
#if !defined(CODER_NOUSE_ENUMERTAED_ITEMS) || defined(CODER_VMS_PRINT)
  tASN1Item*            Items;
  CODER_NumOf_TYPE      NumOfItems;
#endif
  long                  ExtMarker;
} tASN1Enumerated;

typedef const struct
{
  tASN1TypeInfo*        TypeInfo;
#ifdef CODER_VMS_TYPENAME
  char*                 Name;
#endif
  tASN1ComponentType    Type;
  CODER_NumOf_TYPE      Index;
} tASN1Component;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
  tASN1Component*       RootComps1;
  tASN1Component*       ExtAddComps;
  tASN1Component*       RootComps2;
  unsigned char         RootExtFlags;
  CODER_NumOf_TYPE      NumOfRC1;
  CODER_NumOf_TYPE      NumOfEAC;
  CODER_NumOf_TYPE      NumOfRC2;
#if defined(CODER_VMS_TTCN) || !defined(CODER_REMOVE_PER)
  CODER_NumOf_TYPE      NumOfOptDef;
  CODER_NumOf_TYPE      NumOfExtAdd;
#endif
} tASN1Struct;

typedef tASN1Struct tASN1Sequence;
typedef tASN1Struct tASN1Set;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
  tASN1TypeInfo*        BaseType;
#ifndef CODER_REMOVE_CONSTRAINTS
  unsigned char         ConstraintMask;
  tASN1SizeConstraint   SizeConstraint;
#endif
} tASN1StructOf;

typedef tASN1StructOf tASN1SequenceOf;
typedef tASN1StructOf tASN1SetOf;

typedef const struct
{
  tASN1TypeInfo*        TypeInfo;
#ifdef CODER_VMS_TYPENAME
  char*                 Name;
#endif
  tASN1ComponentType    Type;
  CODER_NumOf_TYPE      Index;
} tASN1Alternative;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
  long                  ExtMarker;
  tASN1Alternative*     Alternatives;
  CODER_NumOf_TYPE      NumOfAlts;
} tASN1Choice;

typedef const struct 
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
  tASN1TypeInfo*        BaseType;
} tASN1Defined;

typedef const struct
{
  tASN1TagClass         Class;
  tASN1TagClassNumber   Number;  
} tASN1Tag;

typedef const struct 
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
  tASN1TypeInfo*        BaseType;
#if defined(CODER_VMS_TTCN) || !defined(CODER_REMOVE_BER)
  tASN1Tag*             Tags;
  CODER_NumOf_TYPE      NumOfTags;
#endif
} tASN1Tagged;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
  tASN1TypeInfo*        BaseType;
} tASN1OpenId;

typedef void* (*tCUCFObjectInitFunc)(tCoder* Coder);

typedef const struct tASN1Object_t
{
  tASN1TypeInfo*        TypeInfo;
#ifdef CODER_VMS_TYPENAME
  char*                 Name;
#endif
  tCUCFObjectInitFunc   InitFunc;
  CODER_NumOf_TYPE      Index;
} tASN1Object;

typedef const struct
{
  tCUCFTypeClass        TypeClass;
#ifdef CODER_VMS_VRTYPE
  tVMSPointer           VRType;
#endif
#ifdef CODER_VMS_TYPENAME
  char*                 TypeName;
#endif
  tASN1TypeInfo*        OpenIdType;
  tASN1Object*          Objects;
  CODER_NumOf_TYPE      NumOfObjects;
} tASN1Open;

#endif /* __vms_type_h */


