/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:24 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/

/* 
FILE INDEX
00   Include Files
00   OS routines
*/

/****+***************************************************************
00   Include Files
********************************************************************/
#include "scttypes.h"


/****+***************************************************************
00   OS routines
********************************************************************/

#if !defined(XUSER_ALLOC_FUNC)

#ifdef XPRINTALLOC
#ifndef XCHECKALLOC
#define XCHECKALLOC
#endif
  static unsigned Total = 0;
  static unsigned TotalAllocs = 0;
#endif

/*---+---------------------------------------------------------------
     xAlloc
-------------------------------------------------------------------*/
void * xAlloc(xptrint Size) 
{
  if ( Size > (xptrint)0 )
#ifdef XCHECKALLOC
  {
    void  *Temp;
#ifdef XPRINTALLOC
    Temp = (void *)calloc((unsigned)1, (unsigned)Size + sizeof(unsigned));
    Total = Total + (unsigned)Size;
    TotalAllocs++;
    printf("Total memory usage: %u bytes, in %u allocs\n", Total, TotalAllocs);
#else
    Temp = (void *)calloc((unsigned)1, (unsigned)Size);
#endif
    if (Temp == (void *)0) {
      printf("Error in xAlloc: No more memory.  Exiting program\n");
      exit(1);
    }
#ifdef XPRINTALLOC
	*((unsigned*)Temp) = (unsigned)Size;
	Temp = (unsigned*)Temp + 1;
#endif
    return Temp;
  }
#else
    return (void *)calloc((unsigned)1, (unsigned)Size);
#endif
  else
    return (void *)0;
}
#endif   /* XUSER_ALLOC_FUNC */


#if !defined(XUSER_FREE_FUNC)
/*---+---------------------------------------------------------------
     xFree
-------------------------------------------------------------------*/
void xFree(void** P) 
{
#ifdef XPRINTALLOC
	*P = (unsigned*)*P - 1;
	Total = Total - *((unsigned*)*P);
    TotalAllocs--;
    printf("Total memory usage: %u bytes, in %u allocs\n", Total, TotalAllocs);
#endif
	free(*P);
	*P = (void *)0;
}
#endif   /* XUSER_FREE_FUNC */


#if !defined(XUSER_HALT_FUNC)
/*---+---------------------------------------------------------------
     xHalt
-------------------------------------------------------------------*/
void xHalt(void)
{
  exit(0);
}
#endif   /* XUSER_HALT_FUNC */


#if defined(XCLOCK) && !defined(XUSER_CLOCK_FUNC)
/*---+---------------------------------------------------------------
     SDL_Clock
-------------------------------------------------------------------*/

#if defined(SCT_WINDOWS)
#include <time.h>
#include <sys\timeb.h>

SDL_Time SDL_Clock(void)
{
  SDL_Time Result;
  #ifdef _MSC_VER
    struct _timeb CurrentTime;
    _ftime((struct _timeb *) &CurrentTime);
  #else
    struct timeb CurrentTime;
    ftime((struct timeb *) &CurrentTime);
  #endif
  Result.s  = (xint32)(CurrentTime.time);
  Result.ns = (xint32)(CurrentTime.millitm * 1000000);
  return Result;
}


#elif defined(SCT_POSIX)
#include <time.h>
#include <sys/time.h>

SDL_Time SDL_Clock(void)
{
  SDL_Time Result;
  struct timeval ts;
  gettimeofday(&ts, 0);
  Result.s  = ts.tv_sec;
  Result.ns = 1000*ts.tv_usec;
  return Result;
}

#else
/* If not known, always return 0 */
SDL_Time SDL_Clock(void)
{
  SDL_Time tmp;
  tmp.s = (xint32)0;
  tmp.ns = (xint32)0;
  return tmp;
}

#endif 
#endif  /* XCLOCK && !XUSER_CLOCK_FUNC */



#if defined(XCLOCK) && !defined(XENV) && !defined(XUSER_SLEEP_FUNC)
/*---+---------------------------------------------------------------
     xSleepUntil
-------------------------------------------------------------------*/

#if defined(SCT_POSIX)
#include <sys/time.h>

void xSleepUntil(SDL_Time  WakeUpTime) 
{
  struct timeval tv;
  SDL_Duration   wait;

  wait = xMinusT_SDL_Time(WakeUpTime, SDL_Now());
  tv.tv_sec  = wait.s;
  tv.tv_usec = wait.ns / 1000;

  (void)select(0, 0, 0, 0, &tv);
}

#elif defined(SCT_WINDOWS)
#include <time.h>

void xSleepUntil(SDL_Time  WakeUpTime) 
{
  SDL_Duration wait;
  clock_t temp, entry_time = clock();

  wait = xMinusD_SDL_Time(WakeUpTime, SDL_Now());
  temp = (wait.s * CLOCKS_PER_SEC) + 
          ((wait.ns / 1000000 ) * (CLOCKS_PER_SEC/100)/10) + entry_time;
  while ( temp >= clock() ){;}
}

#else
void xSleepUntil(SDL_Time  WakeUpTime)
{
  /* do nothing */
}
#endif
#endif   /*  XCLOCK && !XENV && !XUSER_SLEEP_FUNC */



#if defined(XMONITOR) && !defined(XNOSELECT) && !defined(XUSER_KEYBOARD_FUNC)
/*---+---------------------------------------------------------------
     xCheckForKeyboardInput
-------------------------------------------------------------------*/

 /*----------------------------------------------------------------------*/
 /* Insert your own implementation of Test_for_any_keyboard_input here.  */
 /* The procedure should return TRUE ((xbool)1) if a character has been  */
 /* input from the keybord, else it should return FALSE ((xbool)0). If   */
 /* no keyboard is attached to your system, this procedure should        */
 /* return FALSE.                                                        */
 /* It is adviced that the timeout parameter should be used if possible. */
 /* xKeyboardTimeout is given in micro seconds.                          */
 /*----------------------------------------------------------------------*/

#if defined(SCT_POSIX)
#include <sys/time.h>

xbool xCheckForKeyboardInput (long xKeyboardTimeout)
{
 /*----------------------------------------------------------------------*/
 /* This is the standard UNIX version, using 'select()'                  */
 /*----------------------------------------------------------------------*/
  struct timeval tv;
  long readfds;  /* fd_set is struct with one long component */
  int rt;

  readfds = (long)1;
  tv.tv_sec =  0;
  tv.tv_usec = xKeyboardTimeout;
  rt = select(1, (fd_set *)&readfds, 0, 0, &tv);
  if (rt > 0) return (xbool)1;
#if defined(XDEBUGSELECT)
  if (rt < 0) printf("Error in select\n");
#endif
  return (xbool)0;
}

#elif defined(__BORLANDC__) && !defined(__CONSOLE__)
xbool xCheckForKeyboardInput (long xKeyboardTimeout)
{
  /* No implementation, always return 0 */
  return (xbool)0;
}


#elif defined(SCT_WINDOWS)
 /*----------------------------------------------------------------------*/  
 /* This is a version for executing on a IBM compatible PC, using        */
 /*  Borland C++ 3.x or Microsoft C v6.x.                                */
 /*----------------------------------------------------------------------*/  
#include <time.h>
#ifdef __BORLANDC__
#pragma argsused
#endif
#if !defined(XNO_BIOS_H) && !defined(_MSC_VER) && !defined(_Windows)
#include <bios.h>
#define KBHIT _bios_keybrd(_KEYBRD_READY)
#else
#include <conio.h>
#define KBHIT kbhit()
#endif

xbool xCheckForKeyboardInput (long xKeyboardTimeout)
{
  clock_t xTimeoutTime, xEntryTime;
  static clock_t xCSignBitMask;
  xbool xOverflow;

 if (xKeyboardTimeout == 0) {
    if ( KBHIT ) return (xbool)1;
    return (xbool)0;
  }

  xEntryTime = clock();

   /* cnvrt micro sec to DOS ticks and handle clock()-overflow */
  xTimeoutTime = xEntryTime + (clock_t)(xKeyboardTimeout / 10000);
  xOverflow = (xTimeoutTime < xEntryTime ? (xbool)1 : (xbool)0 );
  if ( xOverflow ) {
    xCSignBitMask = ~( (~((clock_t)0)) >> 1 );
                                   /* create a sign-bit mask for clock_t */
    while ( (xCSignBitMask & clock()) ) {
      if ( KBHIT ) return (xbool)1;
    }
  }

  do {
    if ( KBHIT ) return (xbool)1;
  } while ( xTimeoutTime > clock() );

  return (xbool)0;
}

#else
xbool xCheckForKeyboardInput (long xKeyboardTimeout)
{
  /* No implementation, always return 0 */
  return (xbool)0;
}
#endif

#endif   /* XMONITOR && !XNOSELECT && !XUSER_KEYBOARD_FUNC */



#if defined(XMONITOR) && !defined(USER_GETSET_WORKDIR)
/*---+---------------------------------------------------------------
     xGetWorkdir and xSetWorkdir
-------------------------------------------------------------------*/
#if defined(SCT_POSIX)

#include <unistd.h>
#include <errno.h>
char *xGetWorkdir(char **d)
{
  if ((*d = getcwd(NULL, 1024)) == 0)
    return strerror(errno);
  return 0;
}
char *xSetWorkdir(char *d)
{
  if (chdir(d) == -1)
    return strerror(errno);
  return 0;
}

#elif defined(SCT_WINDOWS)

#include <windows.h>
#include <errno.h>
static char ErrMsg[1024];
HANDLE hInstance;           /* Needed? when linking on BORLAND */
char *winstrerror(int E)
{
  if (!FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS,
                     0, E, 0, ErrMsg, sizeof(ErrMsg), 0))
    (void) sprintf(ErrMsg, "Error %d", E);
  return ErrMsg;
}
char *xGetWorkdir(char **d)
{
  *d = (char *)malloc(1024);
  if (GetCurrentDirectory(1024, *d) == 0)
    return winstrerror(GetLastError());
  return 0;
}
char *xSetWorkdir(char *d)
{
  if(SetCurrentDirectory((d)) == FALSE)
    return winstrerror(GetLastError());
  return 0;
}

#else

char *xGetWorkdir(char **d)
{
  return "Not implemented";
}
char *xSetWorkdir(char *d)
{
  return "Not implemented";
}

#endif    /* defined(XMONITOR) && !defined(USER_GETSET_WORKDIR) */

#endif    /* XMONITOR */



#ifdef XRMTDBG
/*---+---------------------------------------------------------------
     xAddrIsReadable
       Tells wether addr can be dereferenced without "Segmentation Fault"
       Should be extended to predict "bus error" too (mis-alignment)
-------------------------------------------------------------------*/

#ifdef SCT_WINDOWS

/* we can not use AfxIsValidAddress(), because it belongs to MFC */

#include <windows.h> /* for EXCEPTION_ACCESS_VIOLATION */
#include <WINBASE.H> /* for EXCEPTION_ACCESS_VIOLATION */
#include <EXCPT.H>

xbool xAddrIsReadable(void *addr,int size) 
{ 
   char *charp = (char *)addr;
   char c;
   int i;

    __try 
    { 
        /* testing first and last bytes could be a reasonable estimation */
        for(i=0; i<size; ++i) {
          c = charp[i];
        }
        return xTrue;
    } 
    __except (GetExceptionCode() == EXCEPTION_ACCESS_VIOLATION ? 
                EXCEPTION_EXECUTE_HANDLER : 
                EXCEPTION_CONTINUE_SEARCH ) 
    { 
        return xFalse; 
    } 
} 

#else

xbool xAddrIsReadable(void *addr,int size) 
{ 
   /* Testing wether addr bellongs to [ end , sbrk(0) [ is not OK,
   as it would fail for addresses in the text segment (constants objects ?)
   and for addresses in the stack, and for data of DLLs.
   => Try to do the same as for Windows, using signal()
   */
   if (addr==NULL) return xFalse;
   return xTrue;
}

#endif

#endif    /* XRMTDBG */
