<!-- ***************************************** -->
<!-- XSLT transformation for converting from   -->
<!-- U2 XML storage format 3.0 (4) to 3.1 (4)  -->
<!-- ***************************************** -->

<xsl:transform version="1.1"
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:u2="http://www.telelogic.com/tau"
   exclude-result-prefixes='u2'>

<!-- Change file format version number to 3.1 -->
<xsl:template match="u2:u2">
  <xsl:copy>
    <xsl:for-each select="@*">
      <xsl:choose>
        <xsl:when test="local-name()='OMVersion'">
          <xsl:attribute name="OMVersion">3.1</xsl:attribute>
        </xsl:when>
        <xsl:when test="local-name()='StorageVersion'">
          <xsl:attribute name="StorageVersion">4</xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>


<!-- Default rule -->
<xsl:template match="*">
  <xsl:copy>
    <xsl:call-template name="copy-all-attributes"/>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template name="copy-all-attributes">
  <xsl:for-each select="@*">
    <xsl:copy/>
  </xsl:for-each>
</xsl:template>

<!-- ObjectNode transformation -->
<xsl:template match="u2:ObjectNode">
  <xsl:copy>
    <xsl:call-template name="copy-all-attributes"/>
    <u2:cInstance>
      <u2:NamedInstance>
        <u2:rInstanceOf>
          <xsl:for-each select="u2:rType">
            <xsl:call-template name="copy-all-attributes"/>
            <xsl:apply-templates/>
          </xsl:for-each>
        </u2:rInstanceOf>
      </u2:NamedInstance>
    </u2:cInstance>
  </xsl:copy>
</xsl:template>


</xsl:transform>
  
