<!-- ***************************************** -->
<!-- XSLT transformation for converting from   -->
<!-- U2 XML storage format 3.5 (4) to 3.6 (4)  -->
<!-- ***************************************** -->

<xsl:transform version="1.1"
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:u2="http://www.telelogic.com/tau"
   xmlns="http://www.telelogic.com/tau"
   exclude-result-prefixes='u2'>

<!-- Change file format version number to 3.7 -->
<xsl:template match="u2:u2|u2">
  <xsl:copy>
    <xsl:for-each select="@*">
      <xsl:choose>
        <xsl:when test="local-name()='OMVersion'">
          <xsl:attribute name="OMVersion">3.7</xsl:attribute>
        </xsl:when>
        <xsl:when test="local-name()='StorageVersion'">
          <xsl:attribute name="StorageVersion">4</xsl:attribute>
        </xsl:when>
        <xsl:otherwise>
          <xsl:copy/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:for-each>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>


<!-- Default rule -->
<xsl:template match="*">
  <xsl:copy>
    <xsl:call-template name="copy-all-attributes"/>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template name="copy-all-attributes">
  <xsl:for-each select="@*">
    <xsl:copy/>
  </xsl:for-each>
</xsl:template>

<xsl:template match="u2:rPerformance">
	<xsl:element name="rRelationship">
		<xsl:call-template name="copy-all-attributes"/>
	</xsl:element>
</xsl:template>
 
 <xsl:template match="u2:Operation">
    <xsl:copy>
    <xsl:call-template name="copy-all-attributes"/>
    <xsl:element name="cOwnedMember">
        <xsl:for-each select="u2:cFormalGate">
            <xsl:for-each select="*">
              <xsl:copy>
                <xsl:call-template name="copy-all-attributes"/>
                <xsl:apply-templates select="*"/>
              </xsl:copy>
            </xsl:for-each>
        </xsl:for-each>
        <xsl:for-each select="u2:cOwnedMember">
            <xsl:for-each select="*">
              <xsl:copy>
                <xsl:call-template name="copy-all-attributes"/>
                <xsl:apply-templates select="*"/>
              </xsl:copy>
            </xsl:for-each>
        </xsl:for-each>        
    </xsl:element>
    <xsl:for-each select="*">
      <xsl:if test="not(self::u2:cFormalGate or self::u2:cOwnedMember)">
        <xsl:copy>
          <xsl:call-template name="copy-all-attributes"/>
          <xsl:apply-templates/>
        </xsl:copy>
      </xsl:if>
    </xsl:for-each>    
    </xsl:copy>
</xsl:template>

</xsl:transform>
