<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/">
  <html>
  <body>
    <h2>TAU Test Log - <xsl:value-of select="testrun/executable"/></h2>
    <p><i>Test run started:	<xsl:value-of select="testrun/started"/><br></br></i></p>
    <table border="1">
      <tr bgcolor="#D8E0E8">
        <th>Test Case</th>
        <th>Verdict</th>
      </tr>
      <xsl:for-each select="testrun/testcase">
      <tr>
	<td><A><xsl:attribute name="href">tlog://&lt;<xsl:value-of select="../project"/>&gt;:u2:<xsl:value-of select="guid"/></xsl:attribute><xsl:value-of select="name"/></A></td>
	<xsl:choose>
          <xsl:when test="verdict='fail' or verdict='error'">
            <td bgcolor="#ff0000"><xsl:value-of select="verdict"/></td>
          </xsl:when>
          <xsl:when test="verdict='inconclusive'">
            <td bgcolor="#ffcc00"><xsl:value-of select="verdict"/></td>
          </xsl:when>
          <xsl:otherwise>
            <td bgcolor="#ffffff"><xsl:value-of select="verdict"/></td>
          </xsl:otherwise>
        </xsl:choose>
      </tr>
      </xsl:for-each>
    </table>
    <p>
        Passed: <xsl:value-of select="count(//testrun/testcase/verdict[text()='pass'])" />  
        Failed: <xsl:value-of select="count(//testrun/testcase/verdict[text()='fail'])" />
    </p>
    <p><i>Test run finished: <xsl:value-of select="testrun/finished"/></i></p>
  </body>
  </html>
</xsl:template>

</xsl:stylesheet>
