# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:31 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
set bOk "false"
set filelist ""
set forceVersion ""
set reviewDialog ""
set suppressSetup ""
set projfile ""
set argc [llength $argv]

proc make_path_absolute {file} {
  if {![regexp {^doors:} $file]} {
    if {[file pathtype $file] == "relative"} {
      return [file join [pwd] $file]
    }
  }
  return $file;
}

if { [expr $argc >= 6 && $argc <= 9] } {
  set forceVersion [lindex $argv 0]
  set reviewDialog [lindex $argv 1]
  set suppressSetup [lindex $argv 2]
  set bExitOnSuccess [lindex $argv 3]

  if { [string equal [file extension [lindex $argv 4]] ".ttp"] == 1 } {
    set projfile [make_path_absolute [lindex $argv 4]]
  } else {
    set firstfile [make_path_absolute [lindex $argv 4]]
    set filelist \{$firstfile\}
  }
  foreach f [lrange $argv 5 $argc] {
    set filelist [concat $filelist \{[make_path_absolute $f]\}]
  }

  if {([llength $filelist] >= 2) && ([llength $filelist] <= 4)} {
    set bOk "true"
  }
}

if {$bOk == "true"} {
  set bErrorInPath "false"
  if {$projfile != ""} {
    MessageBox off
    MessageBox answer IDIGNORE

    if { [file exists $projfile] == 0 } {
      set bErrorInPath "true"
    } else {
      catch {
        std::OpenDocument "$projfile"
        set curProject [std::GetActiveProject]
        set model [std::GetModels -kind U2 -project $curProject]
      }
    }
    MessageBox on
  } else {
    if { [file exists $firstfile] == 0 } {
      set bErrorInPath "true"
    } else {
      catch {
        std::OpenDocument [file join [std::GetInstallationDirectory] "etc" "u2typemngr.u2"]
        std::OutputTab clear -ident LOG
        set model [lindex $U2 0]
        u2::LoadFile $model "$firstfile"
      }
    }
  }

  if { $bErrorInPath == "true" } {
    set missedFile ""
    if { $projfile != "" } {
      set missedFile $projfile
    } else {
      set missedFile $firstfile
    }
    output "[info script]: Error: Could not find file [file nativename $missedFile].\n"
  } else {
    set result ""
    if {$model != ""} {
      catch {set result [u2::Compare $model "$filelist" "" $forceVersion $reviewDialog $suppressSetup]} log
      if {$result == 1} {
        output "[info script]: No differences found.\n"
        if {$bExitOnSuccess == "true"} {
  	  std::Quit
        }
      } elseif {$result == 0} {
        output "[info script]: Differences found or operation aborted by user.\n"
      } else {
        output "[info script]: Error: $log.\n"
      }
    } else {
      output "[info script]: no model was loaded.\n"
    }
  }
} else {
  output "usage [info nameofexecutable] -script [info script] ForceVersion ReviewDifferences SuppressSetup bExitOnSuccess \[project.ttp\] version1.u2 version2.u2 \[ancestor.u2 \[ancestor2.u2\]\]\n"
}
std::OutputTab activate -ident TCL
