package test;

import com.telelogic.tau.*;

public class DefinitionPrinter 
{
	// Class for handling callbacks from metaVisit used below.
	private static class DefinitionFinder implements ITtdMetaVisitCallback
	{
		@Override
		public boolean onVisitedEntity(ITtdEntity entity)  
		{			
			try
			{
				if (entity.isKindOf("Definition"))
				{
					System.out.println(entity.getValue("Name", 0));
				}
			}
			catch (APIError e)
			{
				System.out.println(e);
				return false;
			}
			
			return true;
		}
	
		@Override
		public void onAfterVisitedEntity(ITtdEntity arg0) 
		{}
	}
	
	public static void main(String[] args) 
	{
		if (args.length != 1)
		{
			System.out.println("Usage: java test.DefinitionPrinter <.u2 file>");
			return;
		}
			
		// First initialize the API
		TauModelAPI.intializeModelAccess();
		
		// Obtain ITtdModelAccess interface to start using the API
		ITtdModelAccess modelAccess = TauModelAPI.getModelAccess();

		try
		{
			ITtdModel model = modelAccess.loadFile(args[0], false /* library */);
			ITtdEntity entity = (ITtdEntity) model; // This cast is guaranteed to always work!
			entity.metaVisit(new DefinitionFinder(), false /* visitAll */);
		}
		catch (APIError e)
		{
			System.out.println(e);
		}
		
		// Finally, finalize the API
		TauModelAPI.finalizeModelAccess();
	}

}
