// Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:31 PM CET 2014
// Licensed Materials - Property of IBM 
// (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
// 
// U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#include "U2Agent.h"
#include "U2ModelAccess.h"

AGENT_IMPL(PrintCustomComment) 
{
    try 
    {
        if (pContext->IsKindOf(_T("Class"))) 
        {
            u2::ITtdEntity* pComment = pContext->GetEntity(_T("Comment"));
            if (pComment) 
            {
                // Obtain the ITtdCppAppGenServer interface from pServer
                u2::ITtdCppAppGenServer* pCppAppGenServer = u2::cast<u2::ITtdCppAppGenServer>(pServer);
                if (pCppAppGenServer) 
                {
                    tstring comment;
                    pComment->GetValue(_T("Text"), comment);

                    // Remove the comment! Note that the only safe way to do this is through
                    // ITtdCppAppGenServer::ScheduleForDeletion!
                    pCppAppGenServer->ScheduleForDeletion(pComment);

                    if (agentParameters.size() > 0) 
                    {
                        // Expect an ITtdSourceBuffer interface as first agent parameter
                        u2::ITtdSourceBuffer* pSB = u2::cast<u2::ITtdSourceBuffer>(agentParameters.front()->GetUnknownInterface());
                        if (pSB) 
                        {
                            tstring cppComment(_T("/****"));
                            cppComment += comment;
                            cppComment += _T("****/\n");
                            pSB->AddText(cppComment);

                            u2::ITtdModelAccess* pMA = u2::GetModelAccess();
                            if (pMA)
                            {
                                tstring name;
                                pContext->GetValue(_T("Name"), name);

                                u2::ITtdMessageList* msg = pMA->GetDefaultMessageList();
                                msg->AddMessage(_T("Comment has been customized for class ") + name, u2::ITtdMessageList::MS_WARNING, pContext);
                            }
                        }
                    }
                }
            }
        }
    }
    catch (u2::APIError& e) 
    {
        // An error occurred while using the U2ModelAccess API.
        u2::ITtdModelAccess* pMA = u2::GetModelAccess();
        if (pMA)
            pMA->WriteMessage(u2::GetAPIErrorMessage(e));
    }
}
