# Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:31 PM CET 2014
# Licensed Materials - Property of IBM 
# (c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
proc CollectAttribute { att } {  
    if { [u2::IsKindOf $att "Attribute"] && [u2::IsKindOf [u2::GetOwner $att] "Class" ] } {    
        ## Class attribute found. 
        
        global attributes
        lappend attributes $att
    }
} 

proc GenerateAccessors { triggeredBy timing context server agentParameters } {  
    upvar 1 $agentParameters ap  
    set messageList [lindex $ap 0]  
    set roots [lindex $ap 2]  
    set model [lindex $ap 3]  
    foreach r $roots {    
        if { $r == 0} {
            continue
        }

        u2::MetaVisit $r CollectAttribute

        global attributes
        foreach att $attributes {
            set class [u2::GetOwner $att]
            set attributeName [u2::GetValue $att Name]
            set typeRef [u2::GetReference $att "Type"]
            set originalAtt [u2::FindByGuid $model [u2::GetValue $att Guid] ]
            if {$originalAtt == 0} {
                ## Probably a synhesized attribute - skip it!
                continue 
            }

            ## Add getter method

            set getterName "get[string toupper $attributeName 0 0]"
            set getSyntax "[u2::GetValue $typeRef Name] $getterName (){return $attributeName;}"
            set getter [u2::Parse [u2::GetModel $class] $getSyntax ]
            u2::SetEntity $class "OwnedMember" $getter

            ## TODO: Check if already present

            u2::AddMessage $messageList "Added getter '$getterName' for public attribute" Information -subject $originalAtt

            ## Add setter method
            
            set setterName "set[string toupper $attributeName 0 0]"
            set setSyntax "void $setterName ([u2::GetValue $typeRef Name] $attributeName){this.$attributeName = $attributeName;}"
            set setter [u2::Parse [u2::GetModel $class] $setSyntax ]
            u2::SetEntity $class "OwnedMember" $setter

            ## TODO: Check if already present

            u2::AddMessage $messageList "Added setter '$setterName' for public attribute" Information -subject $originalAtt
        }
    }
}
