package Calculator;

import java.awt.GridLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Rectangle;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.SwingConstants;
import javax.swing.JTextPane;
import java.awt.ComponentOrientation;
import java.awt.event.WindowEvent;

import com.telelogic.tau.tor.*;

/**
 * Example of components laid out in a grid
 */
public class CalculatorDialog extends javax.swing.JDialog
{
	private javax.swing.JPanel ivjJFrameContentPane = null;

	private javax.swing.JTextField displayField = null;

	private JButton button0 = null;
	
	private JButton button1 = null;

	private JButton button2 = null;

	private JButton button3 = null;

	private JButton button4 = null;

	private JButton button5 = null;

	private JButton button6 = null;

	private JButton button7 = null;

	private JButton button8 = null;

	private JButton button9 = null;

	private JButton buttonClear = null;

	private JButton buttonSub = null;

	private JButton buttonAdd = null;

	private JButton buttonEqual = null;

	private KeypadEventHandler keypadEventHandler = null;
	
	public CalculatorDialog(KeypadEventHandler keypadEventHandler)
	{
		super();
		initialize();
		this.keypadEventHandler = keypadEventHandler;
	}


	/**
	 * Return the JFrameContentPane property value.
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJFrameContentPane()
	{
		if (ivjJFrameContentPane == null)
		{
			ivjJFrameContentPane = new javax.swing.JPanel();
			ivjJFrameContentPane.setLayout(null);
			ivjJFrameContentPane.setName("JFrameContentPane");
			ivjJFrameContentPane.add(getJTextField1(), null);
			ivjJFrameContentPane.add(getButton0(), null);
			ivjJFrameContentPane.add(getButton1(), null);
			ivjJFrameContentPane.add(getButton2(), null);
			ivjJFrameContentPane.add(getButton3(), null);
			ivjJFrameContentPane.add(getButton4(), null);
			ivjJFrameContentPane.add(getButton5(), null);
			ivjJFrameContentPane.add(getButton6(), null);
			ivjJFrameContentPane.add(getButton7(), null);
			ivjJFrameContentPane.add(getButton8(), null);
			ivjJFrameContentPane.add(getButton9(), null);
			ivjJFrameContentPane.add(getButtonClear(), null);
			ivjJFrameContentPane.add(getButtonSub(), null);
			ivjJFrameContentPane.add(getButtonAdd(), null);
			ivjJFrameContentPane.add(getButtonEqual(), null);
		}
		return ivjJFrameContentPane;
	}

	/**
	 * Return the JTextField1 property value.
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getJTextField1()
	{
		if (displayField == null)
		{
			displayField = new javax.swing.JTextField();
			displayField.setName("displayField");
			displayField.setBounds(new Rectangle(15, 15, 181, 31));
			displayField.setEditable(false);
			displayField.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
			displayField.setText("");
		}
		return displayField;
	}

	private class WindowEventListener implements java.awt.event.WindowListener
	{

		public void windowActivated(WindowEvent e)
		{			
		}

		public void windowClosed(WindowEvent e)
		{
			System.exit(0);
		}

		public void windowClosing(WindowEvent e)
		{
		}

		public void windowDeactivated(WindowEvent e)
		{
		}

		public void windowDeiconified(WindowEvent e)
		{
		}

		public void windowIconified(WindowEvent e)
		{
		}

		public void windowOpened(WindowEvent e)
		{
		}
		
	}
	
	/**
	 * Initialize the class.
	 */
	private void initialize()
	{
		this.setName("CalculatorFrame");
		this.setResizable(false);
		this.setDefaultCloseOperation( DISPOSE_ON_CLOSE );
		this.setBounds(45, 25, 213, 215);
		this.setTitle("Calculator");
		this.setContentPane(getJFrameContentPane());
		this.addWindowListener(new WindowEventListener());
	}

	private class ButtonEventListener implements java.awt.event.ActionListener
	{
		public ButtonEventListener(String id)
		{
			buttonId = id;
		}
		
		public void actionPerformed(java.awt.event.ActionEvent e)
		{
			if (buttonId == "C")
				Utilities.sendTo(new KeypadEventHandler.Clear(), keypadEventHandler);			
			else if (buttonId == "+")
				Utilities.sendTo(new KeypadEventHandler.Addition(), keypadEventHandler);
			else if (buttonId == "-")
				Utilities.sendTo(new KeypadEventHandler.Subtraction(), keypadEventHandler);
			else if (buttonId == "=")
				Utilities.sendTo(new KeypadEventHandler.Equals(), keypadEventHandler);
			else
				Utilities.sendTo(new KeypadEventHandler.Digit(Short.parseShort(buttonId)), keypadEventHandler);				
		}
		
		private String buttonId;
	}
	
	// Display the string in the display panel
	public void display(String s)
	{
		displayField.setText(s);
	}
	
	/**
	 * This method initializes button1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton0()
	{
		if (button0 == null)
		{
			button0 = new javax.swing.JButton();
			button0.setName("button0");
			button0.setBounds(new Rectangle(15, 150, 41, 26));
			button0.setText("0");
			button0.addActionListener(new ButtonEventListener("0"));
		}
		return button0;
	}

	/**
	 * This method initializes button1	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton1()
	{
		if (button1 == null)
		{
			button1 = new JButton();
			button1.setBounds(new Rectangle(15, 120, 41, 26));
			button1.setText("1");
			button1.setName("button1");
			button1.addActionListener(new ButtonEventListener("1"));
		}
		return button1;
	}

	/**
	 * This method initializes button2	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton2()
	{
		if (button2 == null)
		{
			button2 = new JButton();
			button2.setBounds(new Rectangle(60, 120, 41, 26));
			button2.setText("2");
			button2.setName("button2");
			button2.addActionListener(new ButtonEventListener("2"));
		}
		return button2;
	}

	/**
	 * This method initializes button3	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton3()
	{
		if (button3 == null)
		{
			button3 = new JButton();
			button3.setBounds(new Rectangle(105, 120, 41, 26));
			button3.setText("3");
			button3.setName("button3");
			button3.addActionListener(new ButtonEventListener("3"));
		}
		return button3;
	}

	/**
	 * This method initializes button4	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton4()
	{
		if (button4 == null)
		{
			button4 = new JButton();
			button4.setBounds(new Rectangle(15, 90, 41, 26));
			button4.setText("4");
			button4.setName("button4");
			button4.addActionListener(new ButtonEventListener("4"));
		}
		return button4;
	}

	/**
	 * This method initializes button5	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton5()
	{
		if (button5 == null)
		{
			button5 = new JButton();
			button5.setBounds(new Rectangle(60, 90, 41, 26));
			button5.setText("5");
			button5.setName("button5");
			button5.addActionListener(new ButtonEventListener("5"));
		}
		return button5;
	}

	/**
	 * This method initializes button6	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton6()
	{
		if (button6 == null)
		{
			button6 = new JButton();
			button6.setBounds(new Rectangle(105, 90, 41, 26));
			button6.setText("6");
			button6.setName("button6");
			button6.addActionListener(new ButtonEventListener("6"));
		}
		return button6;
	}

	/**
	 * This method initializes button7	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton7()
	{
		if (button7 == null)
		{
			button7 = new JButton();
			button7.setBounds(new Rectangle(15, 60, 41, 26));
			button7.setText("7");
			button7.setName("button7");
			button7.addActionListener(new ButtonEventListener("7"));
		}
		return button7;
	}

	/**
	 * This method initializes button8	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton8()
	{
		if (button8 == null)
		{
			button8 = new JButton();
			button8.setBounds(new Rectangle(60, 60, 41, 26));
			button8.setText("8");
			button8.setName("button8");
			button8.addActionListener(new ButtonEventListener("8"));
		}
		return button8;
	}

	/**
	 * This method initializes button9	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButton9()
	{
		if (button9 == null)
		{
			button9 = new JButton();
			button9.setBounds(new Rectangle(105, 60, 41, 26));
			button9.setText("9");
			button9.setName("button9");
			button9.addActionListener(new ButtonEventListener("9"));
		}
		return button9;
	}

	/**
	 * This method initializes buttonClear	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButtonClear()
	{
		if (buttonClear == null)
		{
			buttonClear = new JButton();
			buttonClear.setBounds(new Rectangle(150, 60, 42, 26));
			buttonClear.setText("C");
			buttonClear.setHorizontalTextPosition(SwingConstants.CENTER);
			buttonClear.setName("buttonClear");
			buttonClear.addActionListener(new ButtonEventListener("C"));
		}
		return buttonClear;
	}

	/**
	 * This method initializes buttonSub	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButtonSub()
	{
		if (buttonSub == null)
		{
			buttonSub = new JButton();
			buttonSub.setBounds(new Rectangle(150, 90, 42, 26));
			buttonSub.setHorizontalTextPosition(SwingConstants.CENTER);
			buttonSub.setText("-");
			buttonSub.setName("buttonSub");
			buttonSub.addActionListener(new ButtonEventListener("-"));
		}
		return buttonSub;
	}

	/**
	 * This method initializes buttonAdd	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButtonAdd()
	{
		if (buttonAdd == null)
		{
			buttonAdd = new JButton();
			buttonAdd.setBounds(new Rectangle(150, 120, 41, 26));
			buttonAdd.setHorizontalTextPosition(SwingConstants.CENTER);
			buttonAdd.setText("+");
			buttonAdd.setName("buttonAdd");
			buttonAdd.addActionListener(new ButtonEventListener("+"));
		}
		return buttonAdd;
	}

	/**
	 * This method initializes buttonEqual	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getButtonEqual()
	{
		if (buttonEqual == null)
		{
			buttonEqual = new JButton();
			buttonEqual.setBounds(new Rectangle(150, 150, 41, 26));
			buttonEqual.setHorizontalTextPosition(SwingConstants.CENTER);
			buttonEqual.setText("=");
			buttonEqual.setName("buttonEqual");
			buttonEqual.addActionListener(new ButtonEventListener("="));
		}
		return buttonEqual;
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
