/*************************************************************
Generated for IBM Rational Tau 4.3.0.6.24425 at Wed Nov 12 03:54:30 PM CET 2014
Licensed Materials - Property of IBM 
(c) Copyright IBM Corporation 2002,2014.  All Rights Reserved.

U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
*************************************************************/
// IBM Rational TAU Developer C++ Interfaces
// --------------------------------------

#include "U2Agent.h"

namespace u2dll {
    class Cu2Changer;
    extern _CU2_EXT_DATA Cu2Changer defaultChanger;

    class Cu2Session;
    class Cu2Entity;
    class Cu2Resource;
    class Cu2PresentationElement;
}

namespace u2 {
    class ITtdModel;
    class ITtdEntity;
    class ITtdResource;
    class ITtdMetaVisitCallback;

#if !defined(TTDREFERENCEKIND)
#define TTDREFERENCEKIND
    typedef enum { TTD_RK_GUID = 0, TTD_RK_NO_QUALIFIER = 1, TTD_RK_FULL_QUALIFIER = 2, TTD_RK_RELATIVE_QUALIFIER = 3, TTD_RK_MINIMAL_QUALIFIER = 4 } TtdReferenceKind;
#endif

#if !defined(IMAGEKIND)
#define IMAGEKIND
    typedef enum { IK_JPEG = 0, IK_BMP = 1, IK_GIF = 2, IK_TIFF = 3, IK_TARGA = 4, IK_DIB = 5, IK_PCX = 6, IK_EMF = 7, IK_SVG = 8} ImageKind;
#endif

    // Interface to a TAU UML2 model.
    class _CU2_EXT_DATA TTDINTERFACE(ITtdModel) : public IUnknown {
    public:

        // Returns the entity in the model with the specified GUID, or NULL if no such
        // entity exists.
        virtual ITtdEntity* TTDMETHOD(FindByGuid)(const tstring& strGuid) const = 0;

        // Creates a new instance of the specified metaclass.
        // If a metaclass with the specified name does not exist, an APIError exception is thrown.
        virtual ITtdEntity* TTDMETHOD(New)(const tstring& strMetaClass) const throw(APIError) = 0;

        // Parses the specified piece of concrete textual UML2 syntax. The optional trailing parameter strParseAs
        // specifies the grammar to use when parsing. By default, the definition grammar will be used, i.e. the
        // text should then specify one or many definitions. Other supported grammars are Expression and Action.
        // In case a non-existing grammar is specified or the text contains syntax errors, an APIError exception
        // will be thrown.
        // The result built by the parser will be inserted into the list.
        virtual void TTDMETHOD(Parse)(const tstring& strConcreteSyntax, 
            std::list<ITtdEntity*>& listEntities,
            const tstring& strParseAs = _T("Definition")) const throw(APIError) = 0;

        // Decodes the XML encoded string into a list of model entities.
        // If the decoding fails (e.g. because of a syntax error in the XML) an APIError will be thrown.
        virtual void TTDMETHOD(XMLDecode)(const tstring& strXMLEncoding,
            std::list<ITtdEntity*>& listEntities) const throw(APIError) = 0;

        // Saves the model into its resources. Note that if the model does not contain any resources, nothing will happen.
        virtual void TTDMETHOD(Save)() const throw(APIError) = 0;

        // Creates a new resource for the model. The resource will be a file with the specified file name.
        // If the creation fails an APIError will be thrown.
        // The model modification is performed using the changer.
        virtual ITtdResource* TTDMETHOD(CreateResource)(const tstring& strFile, 
            u2dll::Cu2Changer& changer = u2dll::defaultChanger) throw(APIError) = 0;

        // Loads the specified file into the model. A resource representing the file will be created and returned.
        // If bLibrary is true, the file will be loaded as a library.
        // In cases of error (e.g. load errors) an API error will be thrown.
        virtual ITtdResource* TTDMETHOD(LoadFile)(const tstring& strFile, bool bLibrary = false) throw(APIError) = 0;

        // Invokes the specified agent on the specified model context with the specified actual parameters.
        virtual void TTDMETHOD(InvokeAgent)(ITtdEntity* pAgent, ITtdEntity* pModelContext, AgentParameters& agentParameters) const throw(APIError) = 0;

        static const GUID guid;
    };

    // Interface to an entity in a TAU UML2 model
    class _CU2_EXT_DATA TTDINTERFACE(ITtdEntity) : public IUnknown {
    public:

        // Gets the value of the specified metafeature for the entity.
        // If no metafeature has the specified name, an APIError exception will be thrown.
        // The value is encoded as a string. Use it for metafeatures with single or multiple
        // multiplicity. In the case of multiple multiplicity use the index to specify which entity to get.
        // The value of metafeatures of non-value type is the string encoding of the untyped link
        // that represents the metafeature internally. In that case, the metafeature must not
        // be derived or an ownerlink (since such metafeatures have no internal representation that can
        // be encoded as a string).
        // N.B. index is an index starting at 1, and E_POSITION_END (==0) always specifies the last entity.
        virtual void TTDMETHOD(GetValue)(const tstring& strMetaFeature, 
            tstring& strValue, 
            u2dll::eposition index = E_POSITION_END) const throw(APIError) = 0;

        // Gets the value of the specified metafeature as an ITtdEntity pointer. Use it for metafeatures of metaclass 
        // type that have either single or multiple multiplicity. In the case of multiple multiplicity
        // use the index to specify which entity to get.
        // If no metafeature has the specified name, an APIError exception will be thrown.
        // N.B. If the metafeature is unbound, pValue will be NULL. You may then want to use the GetValue
        // function to get the value as a string representation instead, or GetReference to obtain the model
        // representation of the reference.
        // N.B. index is an index starting at 1, and E_POSITION_END (==0) always specifies the last entity.
        virtual ITtdEntity* TTDMETHOD(GetEntity)(const tstring& strMetaFeature, 
            u2dll::eposition index = E_POSITION_END) const throw(APIError) = 0;

        // Gets the value of the specified metafeature as a list of entities. Use it for metafeatures 
        // of metaclass type that have either single or multiple multiplicity. In the case of single multiplicity
        // the result list will contain one or zero entities.
        // If no metafeature has the specified name, an APIError exception will be thrown.
        virtual void TTDMETHOD(GetEntities)(const tstring& strMetaFeature, 
            std::list<u2::ITtdEntity*>& listEntities) const throw(APIError) = 0;

        // Returns the identifier representation of a metafeature reference. In the case of multiple 
        // multiplicity use the index to specify which entity to get.    
        // If no metafeature has the specified name, an APIError exception will be thrown.
        // N.B. index is an index starting at 1, and E_POSITION_END (==0) always specifies the last entity
        virtual ITtdEntity* TTDMETHOD(GetReference)(const tstring& strMetaFeature, 
            u2dll::eposition index = E_POSITION_END) const throw(APIError) = 0;

        // Returns the composition owner of the entity. If the entity has no owner NULL is returned.
        virtual ITtdEntity* TTDMETHOD(GetOwner)() const = 0;

        // Finds the name of the entity's metaclass and puts it in strMetaClassName.
        virtual void TTDMETHOD(GetMetaClassName)(tstring& strMetaClassName) const = 0;

        // Finds out what entities that refer to the entity through the specified metafeature.
        // A pointer to these refering entities will be put in the result list.	
        // If strMetaFeature is empty all refering entities will be found.
        virtual void TTDMETHOD(GetReferingEntities)(const tstring& strMetaFeature, 
            std::list<ITtdEntity*>& listReferee) const = 0;

        // Returns the expression representing the tagged value selected by the selector the entity.
        // The entity should be either an element (in which case the tagged value is looked for among the
        // applied stereotype instances of the element) or an instance expression (in which case the tagged
        // value is looked for in that particular instance only).
        // A selector is a pattern specifying the path from the entity to the tagged value using the textual
        // UML2 syntax of an instance expression. 
        // The function will check that the pattern matches both the instance tree (by structure) and the 
        // corresponding signatures (by name or GUID).
        // If bIdentsAreGuids is true, identifiers of the pattern will be interpreted as GUIDs. Otherwise
        // they will be interpreted as names.
        // If no tagged value is selected by the selector pattern, NULL is returned.
        //
        // Some selector pattern examples: 
        // "T1 (. .)"                  will return the first instance of the applied T1 stereotype.
        //                             (This pattern can thus be used to check if the T1 stereotype is applied,
        //                             but note that it will only return an instance if the stereotype is explicitly
        //                             applied. To cover also the case of auto-applied stereotypes, use 
        //                             the function HasAppliedStereotype instead.)
        // "T1 (. x .)"                will return the tagged value of the attribute x in the T1 stereotype
        // "T1 (. a1 = T2 (. a2 .) .)" will return the value of a2 in a T2 instance being the value of T1.a1.
        virtual ITtdEntity* TTDMETHOD(GetTaggedValue)(const tstring& strSelector,
            bool bIdentsAreGuids = false) const throw(APIError) = 0;

        // Returns true if the entity is of the specified metaclass.	
        virtual bool TTDMETHOD(IsKindOf)(const tstring& strMetaClass) const = 0;

        // Unparses the entity into strText using textual UML2 syntax.
        virtual void TTDMETHOD(Unparse)(tstring& strText) const throw(APIError) = 0;

        // Sets the value of a metafeature. The value is encoded as a string. Use it for all writable metafeatures.
        // The value of metafeatures of non-value type should be the string encoding of the untyped link
        // that represents the metafeature internally. In that case, the metafeature must not
        // be an ownerlink (since such a metafeature has no internal representation that can
        // be encoded as a string).
        // If the metafeature has non-single multiplicity, the index argument can be used to insert
        // the value before the value at the specified position.
        // If an error occurs (e.g. because of a non-existing metafeature) an APIError is thrown.
        virtual void TTDMETHOD(SetValue)(const tstring& strMetaFeature,
            const tstring& strValue,					 
            u2dll::eposition index = E_POSITION_END,
            u2dll::Cu2Changer& changer = u2dll::defaultChanger) throw(APIError) = 0;

        // Sets the value of a metafeature. The value is an entity pointer. Use it for all writable metafeatures
        // of metaclass type.
        // If the metafeature has non-single multiplicity, the index argument can be used to insert
        // the entity before the value at the specified position.
        // N.B. If pValue is NULL, the metafeature will be made unbound (doesn't apply for owner links).
        // If an error occurs (e.g. because of a non-existing metafeature) an APIError is thrown.
        virtual void TTDMETHOD(SetEntity)(const tstring& strMetaFeature,
            ITtdEntity* pValue,					  
            u2dll::eposition index = E_POSITION_END,
            u2dll::Cu2Changer& changer = u2dll::defaultChanger) throw(APIError) = 0;

        // Sets the tagged value of the attribute selected by the selector pattern. See GetTaggedValue
        // for the format of this pattern. The entity can either be an element with applied stereotypes
        // or any instance expression. In the latter case the pattern is matched against the instance
        // expression, while in the former case the first matching applied stereotype instance will
        // be used.
        // By default an existing value for the selected attribute will be overwritten, but if 
        // bOverwrite is false this will not be the case.
        // Note that, in order to be able to overwrite an existing value for the specified attribute, the
        // instance expression must be bound to the Signature of which it is an instance.
        // If that is not the case, an APIError exception will be thrown.
        // After the new value has been set all references in the entity is attempted to be bound,
        // so that the set value can be accessed by GetTaggedValue directly after the call to this 
        // function.
        // The model modification is performed using the changer.
        virtual void TTDMETHOD(SetTaggedValue)(const tstring& strSelector,
            const tstring& strValue,					       
            bool bOverwrite = true,
            u2dll::Cu2Changer& changer = u2dll::defaultChanger) throw(APIError) = 0;

        // Creates an entity of the specified metaclass as a child of this entity.
        // In the IDE execution environment this function is identical to ITtdEntity::Create of the COM API.
        // Otherwise it will just attempt to create an instance of the specified metaclass and insert it as
        // an immediate child of the entity in the specified metafeature. Model for presentation elements won't
        // be automatically created in that case.
        // The model modification is performed using the changer.
        virtual ITtdEntity* TTDMETHOD(Create)(const tstring& strMetaClass,					      
            bool bBuildModelForPresentations = true,
            const tstring& strMetaFeature = _T(""),
            u2dll::Cu2Changer& changer = u2dll::defaultChanger) throw(APIError) = 0;

        // Call this function on entities that are instantiable signatures, to create an instance of
        // the signature.
        // In case the creation fails an APIError will be thrown.
        virtual ITtdEntity* TTDMETHOD(CreateInstance)() const throw(APIError) = 0;

        // Deletes the entity. The model modification is performed using the changer.
        virtual void TTDMETHOD(Delete)(u2dll::Cu2Changer& changer = u2dll::defaultChanger) = 0;

        // Puts the XML encoding of the entity in strXMLEncoding. If an error occurs, an APIError
        // will be thrown.
        virtual void TTDMETHOD(XMLEncode)(tstring& strXMLEncoding) const throw(APIError) = 0;    

        // Performs a metamodel driven traversal of the model rooted at the entity.
        // If bVisitAll is false libraries and the predefined package will be excluded from the traversal.
        // If bVisitRefs is false, the identifier representations of references will be excluded from the traversal.
        // For each visited entity, the OnVisitedEntity operation will be called on the pCallback object.
        virtual void TTDMETHOD(MetaVisit)(ITtdMetaVisitCallback* pCallback,
            bool bVisitAll = false,
            bool bVisitRefs = false) const throw(APIError) = 0;

        // Attempts to bind the specified metafeature on the entity (or all metafeatures if strMetaFeature is empty).
        // If a non-existing metafeature is specified, an APIError will be thrown.
        virtual void TTDMETHOD(Bind)(const tstring& strMetaFeature = _T("")) throw(APIError) = 0;

        // Locates the entity in the ModelView and/or diagrams.
        // If this function is used when the IDE is not available, an APIError will be thrown.
        virtual void TTDMETHOD(Locate)() const throw(APIError) = 0;

        // Determines if the entity has a certain stereotype applied. The stereotype is by default specified by name
        // but if bGuid is true strStereotype should instead be the GUID of the stereotype.
        // The function supports both explicitly applied stereotypes, and stereotypes that are automatically
        // applied (due to a non-optional extension).
        virtual bool TTDMETHOD(HasAppliedStereotype)(const tstring& strStereotype, bool bGuid = false) const = 0;

        // Creates a clone of the entity. By default the clone will be unbound and have new unique
        // GUIDs. Be careful when cloning without changing GUIDs. Such a clone should not be inserted
        // into the same model as the original, or GUID conflicts will arise.
        // If the cloning fails (for example due to insufficient memory) an APIError will be thrown.
        virtual ITtdEntity* TTDMETHOD(Clone)(bool bPreserveBindings = false, 
            bool bPreserveGuids = false) const throw(APIError) = 0;

        // Moves the entity from its current location in the model into the context of pNewOwner.
        // If the entity would fit in more than one metafeature of the new owner, strMetaFeature
        // must be specified to disambiguate.
        // The index argument may be specified to control the position where to move the entity when
        // the target metafeature has non-single multiplicity.
        // If the move fails an APIError will be thrown.
        virtual void TTDMETHOD(Move)(ITtdEntity* pNewOwner, 
            const tstring& strMetaFeature = _T(""),
            u2dll::eposition index = E_POSITION_END,
            u2dll::Cu2Changer& changer = u2dll::defaultChanger) throw(APIError) = 0;

        // Returns the model to which the entity belongs. If the entity does not belong to a model, NULL is returned.
        virtual ITtdModel* TTDMETHOD(GetModel)() const = 0;

        // Applies the stereotype to the entity. The reference to the stereotype is by name and the method for calculating
        // the qualifier can be specified (TtdReferenceKind, GUID, noQualifier, minimalQualifier, fullQualifier, relativeQualifier).
        // If the stereotype instance is to be owned by an element other than the entity then the alternative element is given as pInsertElement.
        // If pStereotype is not a stereotype APIError is thrown, and if pInsertElement is not an Element, APIError is thrown.
        virtual ITtdEntity* TTDMETHOD(ApplyStereotype)(ITtdEntity* pStereotype, TtdReferenceKind referenceKind = TTD_RK_MINIMAL_QUALIFIER, ITtdEntity* pInsertElement = 0, u2dll::Cu2Changer& changer = u2dll::defaultChanger) throw(APIError) = 0;

        // Unlinks the entity from its current owner (without deleting it).
        virtual void TTDMETHOD(UnlinkFromOwner)(u2dll::Cu2Changer& changer = u2dll::defaultChanger) = 0;

        // Replaces the entity with another entity, without deleting the original entity.
        // If a replacement is not possible (for example because of incompatible metaclasses) an APIError will be thrown.
        virtual void TTDMETHOD(Replace)(ITtdEntity* pReplacementEntity, u2dll::Cu2Changer& changer = u2dll::defaultChanger) throw(APIError) = 0;

        // Returns (in strMetaFeature) the name of the metafeature in which the entity is contained.
        // If the entity is orphan an empty string is used.
        // 'index' is set up to the position where the entity is located within the container metafeature.
        virtual void TTDMETHOD(GetContainerMetaFeature)(tstring& strMetaFeature) const = 0;
        virtual void TTDMETHOD(GetContainerMetaFeature)(tstring& strMetaFeature, u2dll::eposition& index) const = 0;

        // Finds an entity by a (possibly qualified) name, from the context of this entity.
        // 'strName' should be a valid U2 identifier.
        virtual ITtdEntity* TTDMETHOD(FindByName)(const tstring& strName) const = 0;

        // Returns (in 'strDescription') a descriptive name of the entity.
        virtual void TTDMETHOD(GetDescriptiveName)(tstring& strDescription) const = 0;

        static const GUID guid;
    };

    // Interface to a resource where a TAU UML2 model is stored (for example a file). 
    class _CU2_EXT_DATA TTDINTERFACE(ITtdResource) : public IUnknown {
    public:

        // Saves the model entities that are associated with the resource. For the common case when the 
        // resource represents a .u2 file, this means that the file will be saved.
        virtual void TTDMETHOD(Save)() const throw(APIError) = 0;

        static const GUID guid;
    };

    // This interface contains functions that are specific to model entities being presentation elements
    // (diagrams, symbols, lines etc.).
    class _CU2_EXT_DATA TTDINTERFACE(ITtdPresentationElement) : public IUnknown {
    public:

        // This operation corresponds exactly to the ITtdPresentationElement::GenerateEMF of the COM API.
        // It is only available when the IDE is available. If it is used in other execution environments
        // an APIError will be thrown.
        virtual void TTDMETHOD(GenerateEMF)(const tstring& strFileName,
            long maxWidth = 0,
            long maxHeight = 0,
            bool bOptimizeForVectorGraphics = false,
            bool bIncludeFrame = false) const throw(APIError) = 0;

        // This operation corresponds exactly to the ITtdPresentationElement::GenerateEMFEx of the COM API.
        // It is only available when the IDE is available. If it is used in other execution environments
        // an APIError will be thrown.
        virtual void TTDMETHOD(GenerateEMFEx)(const tstring& strFileName,
            long maxWidth = 0,
            long maxHeight = 0,
            bool includeFrame = false, 
            long scaleFactor = 0) const throw(APIError) = 0;

        // Generate an image file of the specified kind from the presentation element.
        // It is only available when the IDE is available. If it is used in other execution environments
        // an APIError will be thrown.
        virtual void TTDMETHOD(GenerateImage)(ImageKind nKind,
            const tstring& strFileName) const throw(APIError) = 0;

        static const GUID guid;
    };

    // This interface contains functions that are specific to model entities being symbols (including text labels
    // which are a special kind of symbol).
    class _CU2_EXT_DATA TTDINTERFACE(ITtdSymbol) : public IUnknown {
    public:
        // Set a new size for the symbol. If the size specified by width and height is different from the present
        // size of the symbol, the symbol will be resized by changing its lower right coordinate.
        // The unit of the width and height is 1/10 millimeter.
        // N.B. This is the recommended function for setting the size of a symbol. Use this instead of directly
        // manipulating the size meta feature using the ITtdEntity::SetValue operation.
        virtual void TTDMETHOD(SetSize)(unsigned long width,
            unsigned long height,
            u2dll::Cu2Changer& changer = u2dll::defaultChanger) = 0;

        // Set a new position for the symbol. If the position specified by x and y is different from the present
        // position of the symbol, the symbol will be moved to a new position.
        // The unit of x and y is 1/10 millimeter.
        // N.B. This is the recommended function for setting the size of a symbol. Use this instead of directly
        // manipulating the position meta feature using the ITtdEntity::SetValue operation.
        virtual void TTDMETHOD(SetPosition)(long x,
            long y,
            u2dll::Cu2Changer& changer = u2dll::defaultChanger) = 0;

        static const GUID guid;
    };

    // This interface contains functions that are specific to model entities being expressions.
    class _CU2_EXT_DATA TTDINTERFACE(ITtdExpression) : public IUnknown {
    public:
        // Returns the type of the expression. If the type cannot be computed (for example because
        // the expression contains unbound references) NULL is returned.
        virtual ITtdEntity* TTDMETHOD(GetType)() const = 0;

        // Evaluates the value of the expression.
        // If evaluation fails (for example because the expression is not a constant integral expression)
        // an APIError will be thrown.
        virtual long TTDMETHOD(EvaluateConstantIntegralExpression)() const throw(APIError) = 0;

        // Returns a child expression of an instance (the right-hand side of an assignment contained in an instance),
        // matching 'strName' (which should be a valid U2 identifier).
        // If no matching child expression is found, NULL is returned.
        // In case of an erroneous usage, an APIError will be thrown.
        virtual ITtdExpression* TTDMETHOD(GetInstanceChildExpression)(const tstring& strName) const throw(APIError) = 0;

        static const GUID guid;
    };

#ifndef TTDINTERFACES_H
#define TTDINTERFACES_H

    // Callback interface for ITtdEntity::MetaVisit
    class _CU2_EXT_DATA ITtdMetaVisitCallback : public IUnknown {
    public:
        // Called when using ITtdEntity::MetaVisit to traverse a model.
        // pEntity is the currently visited entity in the model.
        // Entities owned by pEntity has not yet been visited when this callback is made.
        // If false is returned traversal will not continue with the composition children of pEntity.
        virtual bool OnVisitedEntity(ITtdEntity* pEntity) = 0;

        // Called when using ITtdEntity::MetaVisit to traverse a model.
        // pEntity is the currently visited entity in the model.
        // Entities owned by pEntity has already been visited when this callback is made.
        virtual void OnAfterVisitedEntity(ITtdEntity* pEntity) = 0;

        static const GUID guid;

        // The below functions are provided a default empty implementation to make this interface
        // compatible with a previous version where it did not inherit IUnknown...
        virtual unsigned long IncRef() {return 0;}
        virtual unsigned long DecRef() {return 0;}
        virtual void QueryInterface(const GUID& g, void** ppObject) {}
        virtual void* GetImplementingObject() {return 0;}
        virtual const void* GetImplementingObject() const {return 0;}
    };

    // Representation of a source code buffer. It can be used by agents that wish to add some additional
    // text to the source buffer used when generating C++ code.
    class _CU2_EXT_DATA ITtdSourceBuffer : public IUnknown {
    public:
        // Writes the specified text to the source buffer
        virtual void AddText(const tstring& strText) throw(APIError) = 0;

        static const GUID guid;
    };	

    // Representation of a message list used for example when loading, checking or building a UML2 model.
    class _CU2_EXT_DATA ITtdMessageList : public IUnknown {
    public:
        virtual ~ITtdMessageList() {}

        enum MessageSeverity {
            MS_INFORMATION, 
            MS_WARNING, 
            MS_ERROR, 
            MS_FATAL
        };

        // Adds a new message to the list with the specified severity and, optionally, a subject entity.
        virtual void AddMessage(const tstring& strMessage, 
            MessageSeverity severity, 
            ITtdEntity* pSubject = 0) throw(APIError) = 0;

        // Creates a description out of all messages in the list, and puts it in strMessage.
        // This string consists of all the messages separated with the specified separator string.
        virtual void GetDescription(tstring& strErrorMessage, const tstring& strSeparator) const = 0;

        // Returns the number of messages with a severity that is equal to 'severity'.
        virtual unsigned int GetCount(MessageSeverity severity) const = 0;

        static const GUID guid;
    };    

    // Representation of the Tau IDE as a server for an interactive API client.
    class _CU2_EXT_DATA ITtdInteractiveServer : public IUnknown {
    public:

        // Interprets the Tcl script in the IDE. Variables in the script are expanded against the entities.
        // The result of the script is put in strResult.
        virtual void InterpretTclScript(const tstring& strScript,
            std::list<ITtdEntity*>& entities,
            tstring& strResult) throw(APIError) = 0;

        static const GUID guid;
    };

    // Representation of the C++ Application Generator as a server for a non-interactive API client.  
    class _CU2_EXT_DATA ITtdCppAppGenServer : public IUnknown {
    public:

        // Schedules pEntity for deletion. This function is the recommended function for removing
        // an entity from a model that is generated code for.
        virtual void ScheduleForDeletion(ITtdEntity* pEntity) throw(APIError) = 0;

        static const GUID guid;
    };

#endif // TTDINTERFACES_H

}
